function [nusos]=redibuixar_nus(n,contbarra,barres,nusos,distnumnus,fontnusos,tamanyfontnusos,hg_nusos,ym,xm,vista)
        % Dibuixa el nus, elimina el dibuix anterior.
        % Gira el dibuix en funcio de les barres connectades o la posici
        % relativa.
        
        %disp(['Redibuixar nus ',num2str(n)])
        %tic_rn=tic;
        con=[]; % Llistat amb els angles de les barres connectades al nus.
        for i=1:contbarra
            if barres(i).nusinf==n % Si el nus est connectat a l'extrem inferior d'una barra...
                vec=nusos(barres(i).nussup).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            elseif barres(i).nussup==n % Si el nus est connectat a l'extrem superior d'una barra...
                vec=nusos(barres(i).nusinf).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            end
        end
        
        switch nusos(n).contorn % Discrimina segons el tipus de condicio de contorn.
            case 0 % Nus lliure
                ang=0; % No es gira.
            case 1 % Rodet
                ang=atan2(nusos(n).rodet(2),nusos(n).rodet(1))-pi/2; % Es gira segons el seu pla definit.
            case {2,4} % Recolzaments
                % Per defecte no es gira. Si t una barra que travesa el recolzament el gira per evitar l'efecte anti-est%tic.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else
                    alfa=ones(1,numel(con))*5*pi/6;
                    con2=con+alfa;
                    if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra sota el recolzament...
                        ang=0; % No es gira.
                    else
                        beta=ones(1,numel(con))*pi/2;
                        con2=con2-beta;
                        con2=con2+2*pi*(con2 < -pi);
                        if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a la dreta del recolzament...
                            ang=pi/2; % Es gira 90.
                        else
                            con2=con2+pi;
                            con2=con2-2*pi*(con2 > pi);
                            if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a l'esquerra del recolzament...
                                ang=3*pi/2; % Es gira 270.
                            else
                                con2=con2+beta;
                                con2=con2-2*pi*(con2 > pi);
                                if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra per sobre del recolzament...
                                    ang=pi; % Es gira 180.
                                else
                                    ang=0; % Si hi ha barres que interfereixen en totes direccions, no es gira.
                                end
                            end
                        end
                    end
                end
            case 3 % Encastaments
                if numel(con)==1 % Si nomes est connectat a una barra...
                    ang=con-pi/2; % Segueix la direcci de la barra.
                else % Si esta connectat a mes d'una barra...
                    ang=atan2(sum(sin(con)),sum(cos(con)))-pi/2; % Gira l'angle mig.
                    ang=round(ang*12/pi)*pi/12; % Arrodoneix l'angle.
                end
            case {5,6} % Girs els%tics amb desplaaments nuls, girs els%tics amb desplaaments els%tics
                if isempty(con) % si no hi han barres connectades...
                    ang=0; % No es gira.
                else % Si hi han connectades una barra o mes...
                    ang=con(1)-pi/2; % Segueix la direcci de la primera.
                end
            case 8 % Girs imposats i desplaaments lliures.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else % % Si hi han connectades una barra o mes...
                    ang=con(1); % Segueix la direcci de la primera.
                end
            otherwise
                ang=0; % En qualsevol altre cas no es gira.
        end
        
        nusos(n).gir=ang; % Apunta l'angle de gir.
        hg=dibuix_contorn(nusos(n).contorn,distnumnus,fontnusos,tamanyfontnusos); % Dibuixa el nus.
        set(hg,'ButtonDownFcn',@clic_nus,'UserData',n,'Parent',hg_nusos); % Assigna la funci que s'executar quan es cliqueji.
        ht=findobj(hg,'Type','text'); % Objecte que cont el texte de numeracio del nus dins de l'objecte grfic que representa el nus.
        pos=get(ht,'Position'); % N'obt la posici.
        angt=atan2(nusos(n).posicio(2)-ym,nusos(n).posicio(1)-xm); % Angle de situaci del texte al voltant del nus, segons la posici relativa del nus.
        angt=round((angt-pi/4)*2/pi)*pi/2+pi/4; % Arrodoneix l'angle.
        angt=angt-ang; % Resta l'angle de gir del nus per tal de que al girar-lo el texte vagi a la seva posici calculada.
        pos(1:2)=[cos(angt),sin(angt)]*distnumnus; % Calcula en coordenades la posicio del texte.
        set(ht,'String',num2str(n),'Position',pos,'HorizontalAlignment','center','VerticalAlignment','middle'); % Assigna la posici al texte.
        if strcmp(vista,'3d')
            set(get(hg,'Children'),'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(get(hg,'Children'),'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        delete(nusos(n).hg) % Esborra el dibuix an%tic.
        nusos(n).hg=hg; % Guarda el handle del nou objecte grafic a la llista de nusos.
        %disp(['/Redibuixar nus ',num2str(n),': ',num2str(toc(tic_rn))])
end

   