%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci modifica l'equaci d'una barra i la transforma en 
% dues equacions quan es divideix la barra
%
% Entrada: 
% - factor: Permet cambiar funcions dintre de la funci
% - longitudBarra: Longitud de la nova barra
% - vectorEquacioAntic: Vector antic de la barra a modificar
% - vectorEquacioM: Matriu amb els nous dos vectors que sustiueixen
%                   l'equaci antiga

% Sortida:
% + vectorEquacioM: Matriu amb els nous dos vectors que sustiueixen
%                   l'equaci antiga

function vectorEquacioM=adaptarEcuacion(factor,numBarra,numNovaBarra,longitudBarra,vectorEquacioAntic,vectorEquacioM)
 
       if factor==0 %Per la primera barra creada
          L0=longitudBarra;
          puntInicial=0;    
          
           %Definim 3 condicions de contorn per trobar la nova equaci,aquestes
           %seran, valor de l'antiga equaci al puntInicial, valor al final de
           %la barra i la derivada al puntFinal, que al ser un mxim es
           %igual a 0
           
           if length(vectorEquacioAntic)>4
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               y0=a*puntInicial.^2+b*puntInicial+c;
               y1=a*L0.^2+b*L0+c;
           else
               a=0;
               b=vectorEquacioAntic(1);
               c=vectorEquacioAntic(2);
               y0=b*puntInicial+c;
               y1=b*L0+c;
           end

            %Vigilem si es tracta d'una parabola, d'una recta o d'un valor
           %constant 
           if a==0 && b==0
               %Estracta d'un valor constant
               af=0;
               bf=0;
               cf=c;
           elseif a==0
               %Es tracta d'una recta
               cf=y0;
               bf=(y1-y0)/L0;
               af=0;
           else
               %Estracta d'una parabola
               %y0derivada=2*a*puntInicial+b;
               y1derivada=2*a*L0+b;  %En general tendr que ser 0 
               if y1derivada<0.0001
                   y1derivada=0;
               end
               cf=y0;
               af=((y1-y0)-y1derivada*L0)/(L0^2-2*L0^2);
               bf=y1derivada-2*af*L0;
           end

       end        
       
       if factor==1 %Per la segona barra formada
            %Longitud de la barra inicial sense dividir
           if length(vectorEquacioAntic)>4 
             L0=vectorEquacioAntic(5);
           else
             L0=vectorEquacioAntic(4);
           end
           %Longitud barra nova
           L1=longitudBarra;
           %Punt on comena la nostra nova ecuacio.
           puntInicial=abs(L0-L1); 

           %Definim 3 condicions de contorn per trobar la nova equacio,aquestes
           %seran, valor de l'antiga equaci al puntInicial, valor al final de
           %la barra i la derivada al puntInicial.
           if length(vectorEquacioAntic)>4
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               y0=a*puntInicial.^2+b*puntInicial+c;
               y1=a*L0.^2+b*L0+c;
           else
               a=0;
               b=vectorEquacioAntic(1);
               c=vectorEquacioAntic(2);
               y0=b*puntInicial+c;
               y1=b*L0+c;
           end

            %Vigilem si es tracta d'una parabola, d'una recta o d'un valor
           %constant 
           if a==0 && b==0
               %Estracta d'un valor constant
               af=0;
               bf=0;
               cf=c;
           elseif a==0
               %Es tracta d'una recta
               cf=y0;
               bf=(y1-y0)/L1;
               af=0;
           else
               %Estracta d'una parabola
               %y0derivada=2*a*L1+b;   
               y0derivada=2*a*puntInicial+b;
               if y0derivada<0.0001
                   y0derivada=0;
               end
               cf=y0;
               bf=y0derivada;
               af=(y1-y0-bf*L1)/(L1^2);
                            
           end
       end
           %Actualizamos el vector equacioMz y lo devolvemos
        if length(vectorEquacioAntic)>4 
           vectorEquacioM(factor+1,1)=af;
           vectorEquacioM(factor+1,2)=bf;
           vectorEquacioM(factor+1,3)=cf;
           vectorEquacioM(factor+1,4)=0;
           vectorEquacioM(factor+1,5)=longitudBarra;
        else
           vectorEquacioM(factor+1,1)=bf;
           vectorEquacioM(factor+1,2)=cf;
           vectorEquacioM(factor+1,3)=0;
           vectorEquacioM(factor+1,4)=longitudBarra;
            
        end
    end 