%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci modifica l'equaci de la deformada d'una barra i la transforma en 
% dues equacions quan es divideix la barra
%
% Entrada: 
% - factor: Permet cambiar funcions dintre de la funci
% - longitudBarra: Longitud de la nova barra
% - vectorEquacioAntic: Vector antic de la barra a modificar
% - vectorEquacioD: Matriu amb els nous dos vectors que sustiueixen
%                   l'equaci antiga

% Sortida:
% + vectorEquacioD: Matriu amb els nous dos vectors que sustiueixen
%                   l'equaci antiga


function vectorEquacioD=adaptarEcuacionDeformada(factor,longitudBarra,vectorEquacioAntic,vectorEquacioD)
 
       if factor==0 %Per la primera barra creada
          L0=longitudBarra;
          puntInicial=0;    
          
           %Definim 5 condicions de contorn per trobar la nova equaci,aquestes
           %seran, valor de l'antiga equaci al puntInicial, valor al final de
           %la barra, la derivada al puntFinal,la derivada al puntInicial i la segona derivada al puntFinal
           %igual a 0
           
           if length(vectorEquacioAntic)>6
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               d=vectorEquacioAntic(4);
               e=vectorEquacioAntic(5);
               
               y0=a*puntInicial.^4+b*puntInicial.^3+c*puntInicial.^2+d*puntInicial.^1+e;
               y1=a*L0.^4+b*L0.^3+c*L0.^2+d*L0.^1+e;
               
               y0d=4*a*puntInicial.^3+3*b*puntInicial.^2+2*c*puntInicial.^1+d;
               y1d=4*a*L0.^3+3*b*L0.^2+2*c*L0.^1+d;
               
               y1dd=12*a*L0.^2+6*b*L0.^1+2*c;
               
                %Calculem els nous coeficients
                 matrizC=zeros(5,5);
                 for i=1:1:5
                     matrizC(1,i)=0;           
                     matrizC(2,i)=L0.^(5-i);             
                     matrizC(4,i)=(5-i)*L0.^(4-i);           
                 end
                 matrizC(1,5)=1; 
                 matrizC(3,4)=1;
                 matrizC(3,5)=0;
                 matrizC(4,5)=0;
                 matrizC(5,1)=12*L0.^2;
                 matrizC(5,2)=6*L0;
                 matrizC(5,3)=2;

                 vectorR=[y0 y1 y0d y1d y1dd]';

                 %Resolem el sistema
                 sol=matrizC\vectorR;
           else
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               d=vectorEquacioAntic(4);
               
               y0=a*puntInicial.^3+b*puntInicial.^2+c*puntInicial.^1+d;
               y1=a*L0.^3+b*L0.^2+c*L0.^1+d;
               
               y0d=3*a*puntInicial.^2+2*b*puntInicial.^1+1*c;
               y1d=3*a*L0.^2+2*b*L0.^1+1*c;
               
               matrizC=zeros(4,4);
                 for i=1:1:4
                     matrizC(1,i)=0;           
                     matrizC(2,i)=L0.^(4-i);             
                     matrizC(4,i)=(4-i)*L0.^(3-i);
                 end
                 matrizC(1,4)=1;
                 matrizC(3,3)=1;
                 matrizC(3,4)=0;
                 matrizC(4,4)=0;
                 matrizC(4,3)=0;  
                 
                 vectorR=[y0 y1 y0d y1d]';

                 %Resolem el sistema
                 sol=matrizC\vectorR;
           end       
       end        
       
       if factor==1 %Per la segona barra formada
            %Longitud de la barra inicial sense dividir
           if length(vectorEquacioAntic)>6 
             L0=vectorEquacioAntic(7);
           else
             L0=vectorEquacioAntic(6);
           end
           %Longitud barra nova
           L1=longitudBarra;
           %Punt on comena la nostra nova equaci.
           puntInicial=abs(L0-L1); 

           if length(vectorEquacioAntic)>6
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               d=vectorEquacioAntic(4);
               e=vectorEquacioAntic(5);
               
               y0=a*puntInicial.^4+b*puntInicial.^3+c*puntInicial.^2+d*puntInicial.^1+e;
               y1=a*L0.^4+b*L0.^3+c*L0.^2+d*L0.^1+e;
               
               y0d=4*a*puntInicial.^3+3*b*puntInicial.^2+2*c*puntInicial.^1+d;
               y1d=4*a*L0.^3+3*b*L0.^2+2*c*L0.^1+d;
               
               y0dd=12*a*puntInicial.^2+6*b*puntInicial.^1+2*c;
               
                %Calculem els nous coeficients
                 matrizC=zeros(5,5);
                 for i=1:1:5
                     matrizC(1,i)=0;           
                     matrizC(2,i)=L1.^(5-i);             
                     matrizC(4,i)=(5-i)*L1.^(4-i);           
                 end
                 matrizC(1,5)=1;
                 matrizC(3,4)=1;
                 matrizC(3,5)=0;
                 matrizC(4,5)=0;
                 matrizC(5,1)=12*puntInicial.^2;
                 matrizC(5,2)=6*puntInicial;
                 matrizC(5,3)=2;

                 vectorR=[y0 y1 y0d y1d y0dd]';

                 %Resolem el sistema
                 sol=matrizC\vectorR;
            else
               a=vectorEquacioAntic(1);
               b=vectorEquacioAntic(2);
               c=vectorEquacioAntic(3);
               d=vectorEquacioAntic(4);
               
               y0=a*puntInicial.^3+b*puntInicial.^2+c*puntInicial.^1+d;
               y1=a*L0.^3+b*L0.^2+c*L0.^1+d;
               
               y0d=3*a*puntInicial.^2+2*b*puntInicial.^1+1*c;
               y1d=3*a*L0.^2+2*b*L0.^1+1*c;
               
               matrizC=zeros(4,4);
                 for i=1:1:4
                     matrizC(1,i)=0;           
                     matrizC(2,i)=L1.^(4-i);             
                     matrizC(4,i)=(4-i)*L1.^(3-i);
                 end
                 matrizC(1,4)=1;
                 matrizC(3,3)=1;
                 matrizC(3,4)=0;
                 matrizC(4,4)=0;
                 matrizC(4,3)=0;  
                 
                 vectorR=[y0 y1 y0d y1d]';

                 %Resolem el sistema
                 sol=matrizC\vectorR;      
           end 
           
       end
           %Actualizamos el vector equacioM y lo devolvemos
        if length(vectorEquacioAntic)>6 
           vectorEquacioD(factor+1,1:5)=sol(:);
           vectorEquacioD(factor+1,6)=0; 
            vectorEquacioD(factor+1,7)=longitudBarra;
        else
          vectorEquacioD(factor+1,1:4)=sol(:);
          vectorEquacioD(factor+1,5)=0;
          vectorEquacioD(factor+1,6)=longitudBarra;
            
        end
    end 