%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci es destina al clcul plstic de l'estructura, s'encarrega
% d'adaptar la geometria de l'estructura, trobar els factors de crrega fins
% al col.lapse de l'estructura i preparar els resultats per al procs de
% representaci de resultats.

% Entrada:
% + contBarra: Comptador de barres
% + contnus:   Comptador de nusos
% + barres:    Son els objectes barres de l'estructura
% + nusos:     Son els objectes nusos de l'estructura

% Sortida:
% -contnus:         Comptador de nusos
% -barres:          Nova llista d'objectes barra
% -contbarra:       Comptador de barres
% -nusos:           Nova llista d'objectes nus
% -dadesRotules:    Dades i resultats de  les rtules creades
% -contRotula:      Comptador de rtules creades
% -err:             Variable error

function [contnus,barres,contbarra,nusos,dadesRotules,contRotula,err]=calculPlastic(contbarra,contnus,barres,nusos,diagrames,hgreaccions,figPrincipal)


tic
if contbarra %Si hi han barres es procedeix al clcul
  %Realitzarem el clcul mentres la matriu no sigui singular, es a dir fins
  %que no es formi un mecanisme
  
  %Inicialitzem algunes variables
  singular=0;
  contRotula=0;
  dadesRotules=1;
  iteracio=-1;
  err=0;
  existeixMomentAplicat=0;
  factorCarregaAcumulat=0;
  ventanaCreada=0;
  ventanaInformacion=0;
  
  %Comprobo que s'hagi introdut alguna crrega
  cargas=0; 
  for n=1:1:contbarra % Es comproba a les barres
      if barres(n).puntual(1)~=0 || barres(n).repartida(1)~=0 || barres(n).projectada(1)~=0 || barres(n).moment(1)~=0
        cargas=1;
        if barres(n).moment(1)~=0
            %Es necessari enviar aquesta variable per detenir el bucle si
            %es supera el moment plstic al factoritzar el moment puntual
            existeixMomentAplicat=existeixMomentAplicat+1;
        end
      end    
  end
  
  if cargas==0 % Si no hi han crregues a les barres es comproba als nusos
      for n=1:1:contnus
          moment=nusos(n).moment;
          puntual=nusos(n).puntual;
          jm=find(moment==0);
          jp=find(puntual==0);
          if length(jp)<3 || length(jm)<3
             cargas=1; 
          end
      end      
  end
 %Si no hi ha ninguna crrega introduida envio un missatje al usuari i torno al mode edici. 
 if cargas==0
      h=msgbox('Introdueixi almenys una crrega','Informaci');
      uiwait(h);
      err=1;
      return;
 end
 %Guardo la estructura inicial, per tal de recuperarla desprs
 barres2=barres;
 nusos2=nusos;
 contnus2=contnus;
 contbarra2=contbarra;

  %Previ als clculs hem de preparar les dades, els moments aplicats sobre
  %barra i les crregues puntuals s'han de tractar amb especial atenci,
  %doncs generen equacions de moment separades, per tal d'evitar problemes,
  %crearem barres auxiliars als punts d'aplicaci
  
  [barres,nusos,contnus,contbarra]=preparacioPlastic(barres,nusos,contnus,contbarra);
  
  if contRotula==0
    FCmin=1;
    matrizEqMz=1;
    matrizEqMy=1;
    matrizEqMx=1;
    Retorn_moviments=0;
    Retorn_esforcos_barres=0;
    TL2G=0;
    contRotula=1; %El valor 1 es per l'estructura incial
    [dadesRotules]=guardarDades(1,barres,nusos,contbarra,contnus,contRotula,FCmin,Retorn_moviments,Retorn_esforcos_barres,TL2G,matrizEqMz,matrizEqMy,matrizEqMx);                                                               
    dadesRotules(contRotula).barresInicial=barres2;
    dadesRotules(contRotula).nusosInicial=nusos2;
    dadesRotules(contRotula).contnusInicial=contnus2;
    dadesRotules(contRotula).contbarraInicial=contbarra2;
  end
 
 %Creo la finestra amb informaci
 sortirPerMoment=0;
   while singular==0 
       iteracio=iteracio+1;
    % 1. El primer pas es realitzar el clcul esttic de l'estructura per
    % conixer els moments mxims a cada barra
        %1.1 Clcul esttic
             [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions); % Esborra els diagrames i les reaccions anteriors si n'hi han.
             [Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom]=prepara_dades_calcul(contnus,nusos,contbarra,barres);  
             [Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,TL2G,ierr] = cme2_calcul_estatic(contnus,contbarra,Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom); % Crida a la funci de clcul est%tic.
             
             %Si el temps de clcul es superior a 4 segons apareix una
             %finestra amb informaci del clcul per evitar que l'usuari
             %pensi que el programa s'ha penjat
             time1=toc;
             if time1>1 
                 if ventanaCreada==0 %Si encara no s'ha creat la finestra es crea
                     pause(0.001);
                     [textoR,ventanaInformacion]=dlgInfoCalcul(figPrincipal);
                     ventanaCreada=1;
                 else %Si la finestra ja ha sigut creada noms es modifica el missatje
                     pause(0.001);
                     try 
                        set(textoR,'String',strcat(['Nmero de rtules creades fins al moment: ', num2str(contRotula)])); 
                     catch
                         display('VENTANA INFO CERRADA');
                     end
                 end
             end
                                    
             jx=find(isnan(Retorn_reaccions));  %Si retorna un valor tenim valors NaN al vector i per tant el clcul no ha sigut correcte        
             
             tol=1*10^10;   %Hem permet tindre en compte errors numrics.
             jy=find(abs(Retorn_moviments)>tol);
             
      if ierr==1 || length(jx)>0 || ~isempty(Retorn_moviments(jy))%La matriu es singular o es dona algn error
               singular=1; 
            
      elseif sortirPerMoment==1
          %Aix indica que el moment aplicat no es pot seguir aumentant,
          %doncs la seva factoritzaci ja supera el moment plstic
          %Ho poso aqu per que si la ltima rtula es forma al punt
          %d'aplicaci del moment puntual no aparegui aquest missatje,
          %doncs abans d'apareixer, la matriu ja es singular i per tant
          %s'ha format un mecanisme.
          singular=1;
          h=msgbox({'El moment aplicat es igual al moment plstic i no es pot seguir aumentant el factor de crrega.','Pot ser que el factor de crrega no sigui el mxim perms.'},'Atenci');
          uiwait(h);
      else

        %1.2 Buscar moment mxim a cada barra, doncs podem tenir diferents
        %moments plstics a cada barra i per tant el moment mxim elstic de l'estructura
        %no t perque ser el punt ms critic. Es a dir, podem tindre un
        %MpBarra/MmaxBarra que pot ser + critic que MpBarra/MmaxEstructura
              
            %Ens retorna el factor de crrega a cada una de les barres  
             [factorsCarrega]=factorCarregaFun(Retorn_moviments,Retorn_esforcos_barres,TL2G,contbarra,barres,nusos,contRotula,1,dadesRotules,iteracio,1);
             
             %Elimino los posibles valores negativos
             factorsCarrega(find(factorsCarrega(:,5)<0),:)=[];
              
             [FCmin,indexFCmin]=min(factorsCarrega(:,5));
             factorCarregaMin=factorsCarrega(indexFCmin,:);  
            
            if iteracio==0 
             Retorn_moviments=Retorn_moviments*FCmin;
             Retorn_esforcos_barres=Retorn_esforcos_barres*FCmin;
            end

        %2.Un cop trobat el factor de carrega mnim hem d'aplicarlo i
        %comprobar si es donen els mxims
 
                partides=0; %Indica que en aquesta iteraci s'han produit barres partides si partides=1
                %Trobem tots els punts que tenen el factor de crrega mnim
                %calculat
                 [factorsCarrega,matrizEqMz,matrizEqMy,matrizEqMx,MzInicial,ecuacionesT]=factorCarregaFun(Retorn_moviments,Retorn_esforcos_barres,TL2G,contbarra,barres,nusos,contRotula,FCmin,dadesRotules,iteracio,2);
                
               
                x=(factorsCarrega(:,5));
                IDX = uint32(1:size(x,1)); 
                index = IDX(x(:,1) >= 1-0.001 & x(:,1) <= 1+0.001);
                
                if length(index)>0
                    Mmax=factorsCarrega(index(1),3);
                    Mp=factorsCarrega(index(1),4);
                else
                   Mp=1;
                   Mmax=0;
                end
                %Ens quedem amb el primer punt que te el factor de crrega
                %calculat, comprobem que es compleixi Mmax=Mp
               if abs(Mmax-Mp)<1*10^-3
                        
                    %Obtenim el nmero de la barra on es dona el factor de
                    %crrega, ens quedem amb el primer
                        r=factorsCarrega(index(1),1);     
                        %Creem una rtula
                        [barres,nusos,contbarra,contnus,contRotula,dadesRotules,partides] = crearRotula(factorsCarrega,r,barres,nusos,contbarra,contnus,contRotula,dadesRotules,partides);
                        factorsCarregaMod=factorsCarrega(r,:);                       
                        
                        %Guardem les dades per despres poder mostrar els
                        %resultats parcials i per sumar els diagrames i
                        %procedir el calcul dels moments plastics
                        barraNum=factorsCarrega(r,1);
                        [dadesRotules]=guardarDades(factorsCarregaMod,barres,nusos,contbarra,contnus,contRotula,FCmin,Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,TL2G,matrizEqMz,matrizEqMy,matrizEqMx,dadesRotules,partides,barraNum,ecuacionesT);                                              
               end
      
      
      %Si un moment aplicat, es factoritza i dona igual al moment plstic
      %es surt del bucle i es dona un misatje
       factorCarregaAcumulat=factorCarregaMin(5)+factorCarregaAcumulat;
      if existeixMomentAplicat>=1
         
          for n=1:1:contbarra
                 if barres(n).moment(1)~=0                   
                    if barres(n).moment(1)*factorCarregaAcumulat>=barres(n).Mp
                        %Si es dona aquest cas s'ha de sortir del bucle i
                        %donar un missatje
                        sortirPerMoment=1;                       
                    end
                 end
              
          end
      end  
      
      end
    
   end   
   if ventanaInformacion %Si s'ha creat la finestra amb informaci es tanca al acabar els clculs
       close(ventanaInformacion);
   end
   %En quan la matriu sigui singular donem un misatge informant que s'ha
   %produit un mecanisme i quantes rtules s'han format
 timeF = toc;
 display(timeF);
   if singular==1 && contRotula>1
       %Calculem el factor de crrega total
       FC=0;
       for d=2:1:contRotula
           FC=FC+dadesRotules(d).factorCarrega;
       end
       h=msgbox(strcat([num2str(contRotula-1),' rtules creades. Amb un factor de crrega total de: ', num2str(FC)]),'Informaci');
       uiwait(h);
   elseif singular==1 && contRotula<=1
       msgbox('La matriu de rigidesa es singular, revisi les condicions de contorn.','Atenci'); 
   end 
end
end

function [factorsCarrega,matrizEqMz,matrizEqMy,matrizEqMx,MzInicial,ecuacionesT]=factorCarregaFun(Retorn_moviments,Retorn_esforcos_barres,TL2G,contbarra,barres,nusos,contRotula,FCmin,dadesRotules,iteracio,modo)
        %Creem una matriu amb els factors de carrega de cada barra,5 termes, 
            %T.1 = numero de barra
            %T.2 = posici moment mxim
            %T.3 = moment mxim
            %T.4 = moment plstic
            %T.5 = factor crrega
            factorsCarrega=zeros(contbarra,5);
            MzInicial=0;
            ecuacionesT=struct;
    if iteracio==0
     %Si encara no s'ha produit ninguna rtula es fa per aquest procediment, doncs no s'han d'efetuar sumes de rotules previes   
      matrizEqMz = zeros(contbarra,5);
      matrizEqMx = zeros(contbarra,5);
      matrizEqMy = zeros(contbarra,5);
    
      for n=1:1:contbarra  
        %Preparem les dades  
            [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,FCmin,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);
            A=barres(n).A;
            E=barres(n).E;
        %Obtenim el maxim moment elastic a cada barra
        %Atencio, posem modo 2 per guardar el struct amb totes les
        %ecuaciones
        [Mmax,posicioMmax,equacioMz,equacioMx,equacioMy,ecuacionesT]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,2,0,0,0,barres,nusos,ecuacionesT);
        %Calculem el factor de crrega i  el guardem a la matriu
            Mp=barres(n).Mp;
            factorCarrega=Mp/Mmax;
            factorsCarrega(n,1)= n;
            factorsCarrega(n,2)= posicioMmax;
            factorsCarrega(n,3)= Mmax;
            factorsCarrega(n,4)= Mp;
            factorsCarrega(n,5)= factorCarrega;
            if ~isempty(equacioMz);
             matrizEqMz(n,:) = equacioMz;
            end
            if ~isempty(equacioMx);
             matrizEqMx(n,:) = equacioMx;
            end
            if ~isempty(equacioMy);
             matrizEqMy(n,:) = equacioMy;
            end
      end 
    elseif iteracio>0 && modo==1 %Si ja existeixen rotules
        %Obtinc la n-esima estructura creada i les equacions de moment
         equacioMzAntiga=dadesRotules(contRotula).equacioMz;
         equacioMxAntiga=dadesRotules(contRotula).equacioMx;
         equacioMyAntiga=dadesRotules(contRotula).equacioMy;
            
          matrizEqMz = zeros(contbarra,5);
          matrizEqMx = zeros(contbarra,5);
          matrizEqMy = zeros(contbarra,5);
         
         for n=1:1:contbarra  
             equacioMzAntigaBarra=equacioMzAntiga(n,:);
             equacioMxAntigaBarra=equacioMxAntiga(1,:);
             equacioMyAntigaBarra=equacioMyAntiga(1,:);
            
             %Fem servir el metode de la secant per resoldre el valor del
             %factor de crrega mnim
  
             Mp=barres(n).Mp;
             A=barres(n).A; 
             E=barres(n).E;
             Fcmin=0;
             Fcmax= 10000;
             biseccion=0; %Per lo general es far servir el mtode de la secant, tot i aix pot donarse el cas de que es fagi servir el mtodo de la bisecci com s'indica al informe 
             
%***********************************************************
%MTODE DE LA SECANT

             [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmax,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
             esforcos=esforcos*Fcmax;
             moviments=moviments*Fcmax;
             [Mmax,~,~,~,~]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);

             [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmin,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
             esforcos=esforcos*Fcmin;
             moviments=moviments*Fcmin;
             [Mmin,posicioMmax,equacioMz,equacioMx,equacioMy]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
             
             Mmax=(Mp-Mmax);
             Mmin=(Mp-Mmin);
                    
             Fc1=((Fcmax-((Fcmax-Fcmin)/(Mmax-Mmin))*Mmax)); 
             salir=0;
             if abs(Mmax)==Inf || abs(Mmin)==Inf || abs(Fc1)==Inf
                 salir=1;
                 Mmax=0;
                 posicioMmax=0;
             end
             
             while abs(Fcmax-Fcmin)>1*10^-6 && salir==0 %Mtode de la secant
    
                 Fcmax=Fcmin;
                 Fcmin=Fc1;
                       
                     [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmax,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                     esforcos=esforcos*Fcmax;
                     moviments=moviments*Fcmax;
                     [Mmax,~,~,~,~]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                     Mmax=(Mp-Mmax);
                               
                     [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmin,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                     esforcos=esforcos*Fcmin;
                     moviments=moviments*Fcmin;
                     [Mmin,posicioMmax,equacioMz,equacioMx,equacioMy,MzInicial]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                     Mmin=(Mp-Mmin);
                              
                    Fc1=((Fcmax-((Fcmax-Fcmin)/(Mmax-Mmin))*Mmax));
                    if Fc1<0
                       salir=1;
                       biseccion=1;
                       display('biseccion');
                    end                   
             end
             if biseccion==0
                display('secante'); 
             end
%***********************************************************************
%MTODE BISECCI
            if biseccion==1
                 Fcmin=0;
                 Fcmax=10000;
                 [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmax,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                 esforcos=esforcos*Fcmax;
                 moviments=moviments*Fcmax;
                [Mmax,~,~,~,~]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                 Mmax=Mp-Mmax;

                [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcmin,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                esforcos=esforcos*Fcmin;
                moviments=moviments*Fcmin;
                [Mmin,~,~,~,~]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                Mmin=Mp-Mmin;

                if Mmax*Mmin>0
                    display('error1');
                end
                i=0;
                salir=0;
                if Mmin<1*10^-6
                   Fcm=0.00000001;
                   salir=1;
                end

                while (abs(Fcmin-Fcmax))>1*10^-4 && salir==0
                    i=i+1;
                    Fcm=(Fcmin+Fcmax)/2;
                     [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcm,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                    esforcos=esforcos*Fcm;
                    moviments=moviments*Fcm;
                    [Mm,posicioMmax,equacioMz,equacioMx,equacioMy]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                    Mm=Mp-Mm;
                    if Mm==0
                        salir=1;
                    end
                    if Mm*Mmin>0
                        Fcmin=Fcm;
                        Mmin=Mm;
                    else
                        Fcmax=Fcm;
                    end
                end
                   [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,Fcm,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);   
                    esforcos=esforcos*Fcm;
                    moviments=moviments*Fcm;
                    [Mmax,posicioMmax,equacioMz,equacioMx,equacioMy]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,equacioMxAntigaBarra,equacioMyAntigaBarra,equacioMzAntigaBarra,barres,nusos);
                    Fcmax=Fcm;
            end
                  %Calculem el factor de crrega i  el guardem a la matriu
                Mp=barres(n).Mp;
                factorCarrega=Fcmax;
                factorsCarrega(n,1)= n;
                factorsCarrega(n,2)= posicioMmax;
                factorsCarrega(n,3)= Mmax;
                factorsCarrega(n,4)= Mp;
                factorsCarrega(n,5)= factorCarrega;
                if ~isempty(equacioMz);
                 matrizEqMz(n,:) = equacioMz;
                end
                if ~isempty(equacioMx)
                 matrizEqMx(n,:) = equacioMx;
                end
                if ~isempty(equacioMy)
                 matrizEqMy(n,:) = equacioMy;
                end   
          end
    else
     %Modo 2 es per quan ja conec el factor de crrega i nomes vuy comprobar la estructura, es a dir, trobar tots els punts on es dona aquest factor de crrega
         %Obtinc la n-esima estructura creada i les equacions de moment
         equacioMzAntiga=dadesRotules(contRotula).equacioMz;
         equacioMxAntiga=dadesRotules(contRotula).equacioMx;
         equacioMyAntiga=dadesRotules(contRotula).equacioMy;
         
          %Si encara no s'ha produit ninguna rtula es fa per aquest procediment, doncs no s'han d'efetuar sumes de rotules previes   
          matrizEqMz = zeros(contbarra,5);
          matrizEqMx = zeros(contbarra,5);
          matrizEqMy = zeros(contbarra,5);
            
           for n=1:1:contbarra  
             antigaMz=equacioMzAntiga(n,:);
             antigaMx=equacioMxAntiga(1,:);
             antigaMy=equacioMyAntiga(1,:);
       
             %Preparem les dades  
            [long,esforcos,moviments,repartida,projectada,puntual,moment,Iz,Iy]=dades(n,FCmin,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos);
            A=barres(n).A;
            E=barres(n).E;
            if FCmin==0
               FCmin=1*10^-15; 
            end
            esforcos=esforcos*FCmin;
            moviments=moviments*FCmin;
            %Obtenim el maxim moment elastic a cada barra
            [Mmax,posicioMmax,equacioMz,equacioMx,equacioMy,ecuacionesT]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,n,contRotula,dadesRotules,1,antigaMx,antigaMy,antigaMz,barres,nusos,ecuacionesT);
        
            %Calculem el factor de crrega i  el guardem a la matriu
            Mp=barres(n).Mp;
            factorCarrega=Mp/Mmax;
            factorsCarrega(n,1)= n;
            factorsCarrega(n,2)= posicioMmax;
            factorsCarrega(n,3)= Mmax;
            factorsCarrega(n,4)= Mp;
            factorsCarrega(n,5)= factorCarrega;
            if ~isempty(equacioMz);
             matrizEqMz(n,:) = equacioMz;
            end
            if ~isempty(equacioMx)
             matrizEqMx(n,:) = equacioMx;
            end
            if ~isempty(equacioMy)
             matrizEqMy(n,:) = equacioMy;
            end
           end
        
    end
end

