%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci s'encarrega de modificar la geometria de l'estructura
% inicial creant les rtules pertinents de cara a la segent iteraci
%
% Entrada:
% + factorsCarega: Matriu amb la informaci dels factors de crrega
%                  calculats
% + r:          Factor de crrega seleccionat
% + contBarra:  Comptador de barres
% + contnus:    Comptador de nusos
% + barres:     Son els objectes barres de l'estructura
% + nusos:      Son els objectes nusos de l'estructura
% + contRotula: Compatador de rtules creades
% + dadesRotules: Llista d'objectes rtula que conte tota la informaci
%                 pertienent a les rtules prvies
%
% Sortida:
% -contnus:         Comptador de nusos
% -barres:          Nova llista d'objectes barra
% -contbarra:       Comptador de barres
% -nusos:           Nova llista d'objectes nus
% -dadesRotules:    Dades i resultats de  les rtules creades
% -contRotula:      Comptador de rtules creades
% -partides:        Aquesta variable indica si la rtula s'ha creat a un
%                   punt intermig de la barra



function [barres,nusos,contbarra,contnus,contRotula,dadesRotules,partides]=crearRotula(factorsCarrega,r,barres,nusos,contbarra,contnus,contRotula,dadesRotules,partides)
  
     %1. Obtenim les dades de les rtules
        barraNum   = factorsCarrega(r,1);
        posicioR   = factorsCarrega(r,2);
        
     %2. Obtenim dades de la barra
        nusInferior = barres(barraNum).nusinf;
        nusSuperior = barres(barraNum).nussup;
        
        %2.1 Obtenim posicio dels nusos per trobar la longitud de la barra
            posNI = nusos(nusInferior).posicio;
            posNS = nusos(nusSuperior).posicio;
        %2.2 Calculem la longitud de la barra
            posCalcul=posNS-posNI;          %calcula el vector de posicio de la barra
            longB=(posCalcul(1)^2+posCalcul(2)^2+posCalcul(3)^2)^0.5;  %calcula el mdul del vector per poder calcular el vector unitari (Longitud barra)
        %2.3 Calculem les coordenades on va situada la rtula
            vectorUnitario=posCalcul/longB;                        %calcula el vector unitari 
            vectorPosicio=vectorUnitario*posicioR;                 %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
            coordenadesR=posNI+vectorPosicio;    
            contRotula=contRotula+1;

            dadesRotules(contRotula)=dadesRotula; % Nou objecte dades rotula a la lista dades rotules.
            dadesRotules(contRotula).numDades=contRotula; % Asigna numero de dades guardades a les dades. 
            dadesRotules(contRotula).coordenadesRotula=coordenadesR;
            if contRotula>2
                dadesRotules(contRotula).rotulesAcomulades=dadesRotules(contRotula-1).rotulesAcomulades;
            end
            
     %3.Comprobem en quina posici est la rtula
        %2.1 Si esta als laterals modifiquem les propietats de la barra
        if posicioR==0 %Si esta al nus inferior
             barres(barraNum).artinf=1;         %Definim una articulacio a la uni del punt amb la barra.         
             nusos(nusInferior).color=[0 1 0];  %Pinto el nus inferior de color verd per indicar la situaci de la nova rtula
                
             nus=barres(barraNum).nusinf;
             cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
             dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=barraNum;
             dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=posicioR;

            %Busco quina barra comparteix punt, per tal d'articularla tamb
            %(si el punt esta compartit nomes per dues barres, sino, no ho
            %podem fer
            compartit=0;
            for i=1:1:contbarra
                if i~=barraNum
                    if barres(i).nusinf==nus
                        compartit=compartit+1;
                    end
                    if barres(i).nussup==nus
                        compartit=compartit+1;                        
                    end
                end
            end
            if compartit==1
                for i=1:1:contbarra
                    if i~=barraNum                  
                        if barres(i).nusinf==nus
                            barres(i).artinf=1; 
                            cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=i;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=0;
                        end
                        if barres(i).nussup==nus
                            barres(i).artsup=1; 
                            cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=i;
                            nusinf=barres(i).nusinf;
                            nussup=barres(i).nussup;
                            nussup=nusos(nussup).posicio;
                            nusinf=nusos(nusinf).posicio;
                            pos=nusinf-nussup;
                            long=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=long;
                        end
                    end
                end
            end
        elseif posicioR==longB %Si esta al nus superior
            barres(barraNum).artsup=1; %Definim una articulacio a la uni del punt amb la barra si la longitud de la nova barra superior es menor a 0.1          
            nus=barres(barraNum).nussup;
            nusos(nusSuperior).color=[0 1 0]; %Pinto el nus superior de color verd per indicar la situaci d ela nova rtula  
            
            cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
             dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=barraNum;
             dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=posicioR;            
        
            %Busco quina barra comparteix punt, per tal d'articularla tambe
            compartit=0;
            for i=1:1:contbarra
                if i~=barraNum
                    if barres(i).nusinf==nus
                        compartit=compartit+1;
                        
                    end
                    if barres(i).nussup==nus
                        compartit=compartit+1;                        
                    end
                end
            end
            if compartit==1
                for i=1:1:contbarra
                    if i~=barraNum                  
                        if barres(i).nusinf==nus
                            barres(i).artinf=1;   
                            cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=i;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=0;
                        end
                        if barres(i).nussup==nus
                            barres(i).artsup=1;   
                            cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=i;
                            nusinf=barres(i).nusinf;
                            nussup=barres(i).nussup;
                            pos=nusinf-nussup;
                            long=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=long;
                        end
                    end
                end 
            end
            
        %2.2 Si no compleix ningun esta pel mig de la barra, per tant hem d'eliminar la barra i crear dues ms    
        else
            partides=1;
            %Calculem les longituds de les noves barres
            longNovaBarraInf=(vectorPosicio(1)^2+vectorPosicio(2)^2+vectorPosicio(3)^2)^0.5; %(modulVectorPosicio) Hem permet coneixer la longitud del punt inferior al punt o s'ha creat la rtula (Longitud nova barra inferior)
            longNovaBarraSup=longB-longNovaBarraInf;

            %Copiem les propietats de la barra antiga
                barraAntigaE=barres(barraNum).E;                        % Mdul de Young.
                barraAntigaA=barres(barraNum).A;                        % rea de la secci.
                barraAntigaIz=barres(barraNum).Iz;                       % Inrcia en eix z.
                barraAntigaIy=barres(barraNum).Iy;                       % Inrcia en eix y.
                barraAntigaVectorIz=barres(barraNum).vectorIz;           % Vector direcci de l'eix z de la secci.
                barraAntigaGIt=barres(barraNum).GIt;                      % Inrcia a torsi.
                barraAntigaMp=barres(barraNum).Mp;                       % Moment plstic
                barraAntigaPuntual=barres(barraNum).puntual;       % Crrega puntual: mdul, vector direcci x,y,z i  distncia al nus inferior.
                barraAntigaMoment=barres(barraNum).moment;         % Moment aplicat a la barra: mdul, vector direcci x,y,z i  distncia al nus inferior.
                barraAntigaRepartida=barres(barraNum).repartida;   % Crrega repartida: mdul, vector direcci x,y,z i distncia al nus inferior i superior.
                barraAntigaProjectada=barres(barraNum).projectada;  % Crrega repartida peojectada: mdul, vector direcci x,y,z i distncia al nus inferior i superior.
                barraAntigaArtInf=barres(barraNum).artinf;
                barraAntigaArtSup=barres(barraNum).artsup;
                compartit=0;
                if nusos(barres(barraNum).nusinf).contorn==2 || nusos(barres(barraNum).nusinf).contorn==2
                    %Comprobo que no sigui un punt compartit amb una altre
                    %barra, doncs llavors no seria articulat
                    for p=1:1:contbarra
                        if p~=barraNum
                           if barres(p).nussup == barres(barraNum).nusinf
                               compartit=compartit+1;
                           end
                           if barres(p).nusinf == barres(barraNum).nusinf
                               compartit=compartit+1;
                           end
                        end
                    end
                    if compartit==0
                        barraAntigaArtInf=1;
                    end
                end
                compartit=0;
                if nusos(barres(barraNum).nussup).contorn==2 || nusos(barres(barraNum).nussup).contorn==2
                    for p=1:1:contbarra
                        if p~=barraNum
                           if barres(p).nussup == barres(barraNum).nussup
                               compartit=compartit+1;
                           end
                           if barres(p).nusinf == barres(barraNum).nussup
                               compartit=compartit+1;
                           end
                        end
                    end
                    if compartit==0
                        barraAntigaArtSup=1;
                    end
                end
                
                %Eliminem la barra antiga
                [barres,contbarra]=esborrarbarraPlastic(barraNum,barres,contbarra);
                
                
            %Creem la rotula, en aquest cas ser un nou nus
            [nusos,contnus]=crearnus2(contnus,nusos,coordenadesR);
            
            %Creem les noves barres
                %Barra 1
                [barres,contbarra]=novabarra2(nusInferior,contnus,0,1,contbarra,barres);
                %Barra 2
                [barres,contbarra]=novabarra2(contnus,nusSuperior,1,0,contbarra,barres);
                
                 %Reordenamos la numeracion de las barras en rotulesAcomulades
                 rotulesAcomulades=dadesRotules(contRotula).rotulesAcomulades;
                 
                 for p=1:1:size(rotulesAcomulades,1)
                    if rotulesAcomulades(p,1)<barraNum
                        
                    elseif rotulesAcomulades(p,1)==barraNum && rotulesAcomulades(p,2)<longNovaBarraInf
                        rotulesAcomulades(p,1)=contbarra-1;
                    elseif rotulesAcomulades(p,1)==barraNum && rotulesAcomulades(p,2)>longNovaBarraInf
                        rotulesAcomulades(p,1)=contbarra-1;
                        rotulesAcomulades(p,2)=rotulesAcomulades(p,2)-longNovaBarraInf;
                    elseif rotulesAcomulades(p,1)>barraNum
                        rotulesAcomulades(p,1)=rotulesAcomulades(p,1)-1;
                    end
                 end
                 dadesRotules(contRotula).rotulesAcomulades=rotulesAcomulades;
                 
                 cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=contbarra-1;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=longNovaBarraInf;
                            
                  cont=size(dadesRotules(contRotula).rotulesAcomulades,1);
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,1)=contbarra;
                            dadesRotules(contRotula).rotulesAcomulades(cont+1,2)=0;   
      
                %Es necessari crear una matriu amb el reordenament de
                %barres, doncs ara la numeracio de les bares ha canviat
        
                if barraAntigaArtInf==1
                    barres(contbarra-1).artinf=1;
                end
                if barraAntigaArtSup==1
                    barres(contbarra).artsup=1;
                end               
                
            %Asignem les propietats de barra a cada una d'elles
                carregaSegonaBarraPuntual=0;
                carregaSegonaBarraMoment=0;
            
                for i=contbarra:-1:contbarra-1
                   barres(i).E=barraAntigaE;
                   barres(i).A=barraAntigaA;
                   barres(i).Iz=barraAntigaIz;
                   barres(i).Iy=barraAntigaIy;
                   barres(i).vectorIz=barraAntigaVectorIz;
                   barres(i).GIt=barraAntigaGIt;
                   barres(i).Mp=barraAntigaMp;   
                end  
                  %Les crregues s'han de guardar segons les distancies    
                  
                   if barraAntigaPuntual(5)<=longNovaBarraInf                      %Comprova si la distancia de la crrega al puntInferior, es menor a la longitud on s'ha produit la rtula
                        barres(contbarra-1).puntual=barraAntigaPuntual;       %Crrega puntual: mdul, vector direcci x,y,z i  distncia al nus inferior.
                   else
                        carregaSegonaBarraPuntual=1;                                 %Asignem 1 a la variable per tal de poder indicar, posteriorment, que es necessari introduir la carga puntual a la segona barra creada.
                   end    
                   
                   if barraAntigaMoment(5)<=longNovaBarraInf
                          barres(contbarra-1).moment=barraAntigaMoment;       %Moment aplicat a la barra: mdul, vector direcci x,y,z i  distncia al nus inferior.
                   else
                          carregaSegonaBarraMoment=1;
                   end   
                   
                   if barraAntigaRepartida(5)<=longNovaBarraInf
                         barres(contbarra-1).repartida=barraAntigaRepartida;                                 %Crrega repartida: mdul, vector direcci x,y,z i distncia al nus inferior i superior.
                            if barraAntigaRepartida(6)>longNovaBarraSup                                     %En aquest cas, si la longitud de la nova barra superior, es menor a la distancia de la crrega al punt superior de la antiga barra, s'ha d'asignar de nou la distancia entre: la carrega i el nou punt superior cret(rotula).
                               barres(contbarra-1).repartida(6)=barraAntigaRepartida(6)-longNovaBarraSup; 
                            else                                                                            %En cas contrari, tenim la carrega repartida fins al final de la nova barra inferior, per tant asignem una distancia de la carga al nus superior de 0;
                                barres(contbarra-1).repartida(6)=0;
                            end
                   end
                   
                   if barraAntigaProjectada(5)<=longNovaBarraInf
                          barres(contbarra-1).projectada=barraAntigaProjectada;                               %En aquest cas, si la longitud de la nova barra superior, es menor a la distancia de la crrega al punt superior de la antiga barra, s'ha d'asignar de nou la distancia entre: la carrega i el nou punt superior cret(rotula).
                            if barraAntigaProjectada(6)>longNovaBarraSup
                                barres(contbarra-1).projectada(6)=barraAntigaProjectada(6)-longNovaBarraSup;  %En cas contrari, tenim la carrega repartida fins al final de la nova barra inferior, per tant asignem una distancia de la carga al nus superior de 0;
                            else
                               barres(contbarra-1).projectada(6)=0;
                            end
                   end                  
                 
                      
                      if carregaSegonaBarraPuntual==1                         %En aquest cas, com la distancia a la crrega es media desde el punt inferior, hem de verificar, que la crrega ara queda situada pasada la rtula
                        barres(contbarra).puntual=barraAntigaPuntual;       %Crrega puntual: mdul, vector direcci x,y,z i  distncia al nus inferior.
                        barres(contbarra).puntual(5)=barraAntigaPuntual(5)-longNovaBarraInf; %La distancia del punt rtula a la posici de la crrega vindr donada per la diferencia ente la distancia inical menys la longitud de la nova barra inf

                      end           
                      if carregaSegonaBarraMoment==1  
                          barres(contbarra).moment=barraAntigaMoment;       %Moment aplicat a la barra: mdul, vector direcci x,y,z i  distncia al nus inferior.
                          barres(contbarra).moment(5)=barraAntigaPuntual(5)-longNovaBarraInf;

                      end      

                       if barraAntigaRepartida(6)<=longNovaBarraSup
                          barres(contbarra).repartida=barraAntigaRepartida;                                 %Crrega repartida: mdul, vector direcci x,y,z i distncia al nus inferior i superior.
                            if barraAntigaRepartida(5)>longNovaBarraInf                                     
                               barres(contbarra).repartida(5)=barraAntigaRepartida(5)-longNovaBarraInf; 
                            else                                                                            
                                barres(contbarra).repartida(5)=0;
                            end
                       end
                      if barraAntigaProjectada(6)<=longNovaBarraSup
                          barres(contbarra).projectada=barraAntigaProjectada;                               
                            if barraAntigaProjectada(5)>longNovaBarraInf
                                barres(contbarra).projectada(5)=barraAntigaProjectada(5)-longNovaBarraInf;  
                            else
                               barres(contbarra).projectada(5)=0;
                            end
                      end
                barres(contbarra-1).artsup=1; %Definim una articulacio a la unio del punt amb la barra.    
                barres(contbarra).artinf=1; %Definim una articulacio a la unio del punt amb la barra.    
                
                nusos(contnus).color=[0 1 0];                 
        end

end

