%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci prepara les dades pels clculs.
%
% Entrada: 
% - n: Nmero de barra
% - factorCarrega: factor de crrega que s'aplica per factoritzar les
%                  crregues
% - barres: Llista d'objectes barra
% - TL2G: Matriu transformaci de coordenades locals a globals
% - Retorn_esforcos_barres: Esforos a les barres
% - Retorn_moviments: Moviments a les barres
% - nusos: LLista d'objectes nusos
%
% Sortida:
% + long: Longitud de la barra
% + esforcos: Esforcos a la barra
% + moviments: Moviments a la barra
% + rep: Crrega repartida
% + proj: Crrega projectada
% + punt: Crrega puntual
% + mom: Moment puntual
% + Iz: Inercia en Z
% + Iy: Inercia en Y

function [long,esforcos,moviments,rep,proj,punt,mom,Iz,Iy]=dades(n,factorCarrega,barres,TL2G,Retorn_esforcos_barres,Retorn_moviments,nusos)
        
        %disp(['Prepara dades calcul diagrames barra n ',num2str(n)])
        %tic_dd=tic;
        n1=barres(n).nusinf;
        n2=barres(n).nussup;
        T=TL2G(:,:,n)'; % Matriu de canvi de base d'exos globals a locals.
        esforcos(1:12)=Retorn_esforcos_barres(n,1:12); % Esforos en extrems de barra en eixos locals.
        moviments=[T*Retorn_moviments(n1*6-5:n1*6-3);T*Retorn_moviments(n1*6-2:n1*6);T*Retorn_moviments(n2*6-5:n2*6-3);T*Retorn_moviments(n2*6-2:n2*6)]; % Moviments dels extrems de barra en eixos locals.
        mov_extrems(:,n)=moviments; % Guarda els moviments en extrems de barra en eixos locals per a la funcio que mostra l'informe de resultats.
        vbarra=nusos(n2).posicio-nusos(n1).posicio; % Vector barra.
        long=norm(vbarra); % Longitud de la barra.
        rep=[barres(n).repartida(1)*factorCarrega,(T*barres(n).repartida(2:4)')',barres(n).repartida(5:6)]; % Carrega repartida en eixos locals.
        proj=[barres(n).projectada(1)*factorCarrega,(T*barres(n).projectada(2:4)')',barres(n).projectada(5:6)]; % Crrega projectada en eixos locals.
        punt=[barres(n).puntual(1)*factorCarrega,(T*barres(n).puntual(2:4)')',barres(n).puntual(5)]; % Carrega en eixos locals.
        mom=[barres(n).moment(1)*factorCarrega,(T*barres(n).moment(2:4)')',barres(n).moment(5)]; % Moments en eixos locals.
        Iz=barres(n).Iz; % Inercia Iz.
        if all(barres(n).vectorIz==0) % Si no esta definit el vector direcci d'Iz, Iy=Iz.
            Iy=Iz;
        else
            Iy=barres(n).Iy;
        end
        %disp(['/Prepara dades calcul diagrames barra n ',num2str(n),': ',num2str(toc(tic_dd))])
    end