%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%

%Funci que s'encarrega de guardar totes les dades relacionades amb el
%clcul plstic
%
%Es crida la funci per a cada nova rtula creada.
%
%Entrada:
% -factorCarrega: Vector amb tota la informaci del factor de crrega mnim
% se.leccionat
% -contbarra: Comptador de barres
% -contnus:  Comptador de nusos
% -contRotula: Comptador de rtules
% -Fcmin:  Factor de crrega mnim
% -Retorn_reaccions: Reaccions al sistema
% -Retorn_moviments: Moviments al sistema
% -Retorn_esforcos_barres: Esforcos a cada una de les barres
% -TL2G
% -matrizEqMz: Matriu amb les equacions de moment en z
% -matrizEqMy: Matriu amb les equacions de moment en y
% -matrizEqMx: Matriu amb les equacions de moment en x
% -dadesRotules: Llista d'objectes amb tota la informaci de rtules prvies
% -partides: Informaci relativa a si s'han dividit barres
% -numBarra:Barra on s'ha generat la rtula
% -ecuacionesT: Structure amb totes les equacions de les barres

%Sortida:
% +dadesRotules: LLista actualitzada d'objectes dadesRotules

%% Funci principal

function [dadesRotules]=guardarDades(factorsCarrega,barres,nusos,contbarra,contnus,contRotula,FCmin,Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,TL2G,matrizEqMz,matrizEqMy,matrizEqMx,dadesRotules,partides,numBarra,ecuacionesT)
    
    if contRotula==1
        %Creem un nou objecte dadesRotula
        dadesRotules(contRotula)=dadesRotula; % Nou objecte dades rtula a la lista dades rotules.
        dadesRotules(contRotula).numDades=contRotula; % Asigna nmero de dades guardades 
   
        dadesRotules(contRotula).Retorn_reaccions=Retorn_reaccions*FCmin; % Guarda les reaccions del sistema
        dadesRotules(contRotula).Retorn_moviments=Retorn_moviments*FCmin; % Guarda els moviments del sistema
        dadesRotules(contRotula).Retorn_esforcos_barres=Retorn_esforcos_barres*FCmin; % Guarda els esforcos del sistema       
        dadesRotules(contRotula).TL2G=TL2G; 
        dadesRotules(contRotula).barres=barres;             %Guarda totes les barres existents
        dadesRotules(contRotula).nusos=nusos;               %Guarda tots els nusos existents
        dadesRotules(contRotula).contnus=contnus;           %Guarda el numero de nusos existents
        dadesRotules(contRotula).contbarra=contbarra;       %Guarda el numero de barres existents 
             
        for i=1:1:contbarra %Agafem les dades de les crregues de totes les barres
            puntual(i,:)=barres(i).puntual(:);
            moment(i,:)=barres(i).moment(:);
            repartida(i,:)=barres(i).repartida(:);
            projectada(i,:)=barres(i).projectada(:);
         end 
        dadesRotules(contRotula).puntual=puntual;   
        dadesRotules(contRotula).moment=moment;
        dadesRotules(contRotula).repartida=repartida;
        dadesRotules(contRotula).projectada=projectada;    
    else
  
       %Copiem les dades de la estructura que es vol guardar              
        dadesRotules(contRotula).Retorn_reaccions=Retorn_reaccions*FCmin; % Guarda les reaccions del sistema
        dadesRotules(contRotula).Retorn_moviments=Retorn_moviments*FCmin; % Guarda els moviments del sistema
        dadesRotules(contRotula).Retorn_esforcos_barres=Retorn_esforcos_barres; % Guarda els esforcos del sistema       
        dadesRotules(contRotula).TL2G=TL2G; 
        dadesRotules(contRotula).factorCarrega=FCmin;       % Guarda el factor de crrega que ha generat una rtula.
        dadesRotules(contRotula).contRotula=contRotula;     % Guarda el nmero de rotules
        dadesRotules(contRotula).ecuaciones=ecuacionesT;    % Guarde les ecuacions de les barres    
        
        dadesRotules(contRotula).barraNumRotula = factorsCarrega(1); % Guarda el nmero de barra on es genera la rtula
        dadesRotules(contRotula).posicio  = factorsCarrega(2);       % Guarda la posici on es genera la rtula
        dadesRotules(contRotula).Mmax1=factorsCarrega(3);            % Guarda el moment mxim 
        dadesRotules(contRotula).Mp=factorsCarrega(4);               %Guarda el moment plstic de la barra on es forma la rtula

        dadesRotules(contRotula).barres=barres;             %Guarda totes les barres existents
        dadesRotules(contRotula).nusos=nusos;               %Guarda tots els nusos existents
        dadesRotules(contRotula).contnus=contnus;           %Guarda el numero de nusos existents
        dadesRotules(contRotula).contbarra=contbarra;       %Guarda el numero de barres existents        
        
        for i=1:1:contbarra %Agafem les dades de le crregues de totes les barres
            puntual(i,:)=barres(i).puntual(:);
            moment(i,:)=barres(i).moment(:);
            repartida(i,:)=barres(i).repartida(:);
            projectada(i,:)=barres(i).projectada(:);
        end
        
        %Les crregues han d'anar multiplicades pel seu corresponent factor
        %de crrega
        puntual(:,1)    =   puntual(:,1)*FCmin;
        moment(:,1)     =   moment(:,1)*FCmin;
        repartida(:,1)  =   repartida(:,1)*FCmin;
        projectada(:,1) =   projectada(:,1)*FCmin;
              
        dadesRotules(contRotula).puntual=puntual;   
        dadesRotules(contRotula).moment=moment;
        dadesRotules(contRotula).repartida=repartida;
        dadesRotules(contRotula).projectada=projectada;
        
        dadesRotules(contRotula).equacioMz=matrizEqMz;
        dadesRotules(contRotula).equacioMy=matrizEqMy;
        dadesRotules(contRotula).equacioMx=matrizEqMx;
        
        matrizEqTy=zeros(size(ecuacionesT,2),4);
        matrizEqTz=zeros(size(ecuacionesT,2),4);
        
        for eq=1:size(ecuacionesT,2)
            if ~isempty(ecuacionesT(eq).cortante.Ty)
                matrizEqTy(eq,:)=ecuacionesT(eq).cortante.Ty;
            end
            if ~isempty(ecuacionesT(eq).cortante.Tz)
                matrizEqTz(eq,:)=ecuacionesT(eq).cortante.Tz;
            end
        end
        
        dadesRotules(contRotula).equacioTy=matrizEqTy;
        dadesRotules(contRotula).equacioTz=matrizEqTz;
        
        
        if partides==1
                
   
                  dadesRotules(contRotula).partides=1;
                 
  
                   %Es necessari adaptar el vector d'equacions, doncs l'equaci que
                   %abans valia per una sola barra, s'ha de transformar en
                   %dues equacions per les dues noves barres
                  [matrizEqMxMod]=adaptarEquacio(barres,matrizEqMx,numBarra,contbarra,nusos);
                  [matrizEqMyMod]=adaptarEquacio(barres,matrizEqMy,numBarra,contbarra,nusos);
                  [matrizEqMzMod]=adaptarEquacio(barres,matrizEqMz,numBarra,contbarra,nusos);
                  
                  %Guardo les noves dades
                  dadesRotules(contRotula).equacioMz=matrizEqMzMod;
                  dadesRotules(contRotula).equacioMy=matrizEqMyMod;
                  dadesRotules(contRotula).equacioMx=matrizEqMxMod;
                  
                  if ~isempty(matrizEqTy)
                    [matrizEqTyMod]=adaptarEquacio(barres,matrizEqTy,numBarra,contbarra,nusos);
                    dadesRotules(contRotula).equacioTy=matrizEqTyMod;
                  end
                  if ~isempty(matrizEqTz)
                   [matrizEqTzMod]=adaptarEquacio(barres,matrizEqTz,numBarra,contbarra,nusos);
                   dadesRotules(contRotula).equacioTz=matrizEqTzMod;
                  end
        end
    end
end

function [matrizEqMMod]=adaptarEquacio(barres,matrizEq,numBarra,contbarra,nusos)
                    
                  % Longitud nova barra inferior 
                  nusInf=barres(contbarra-1).nusinf;
                  nusSup=barres(contbarra-1).nussup;
                  posNI=nusos(nusInf).posicio;
                  posNS=nusos(nusSup).posicio;
                  pos=abs(posNI-posNS);
                  longNovaBarraInf=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
                  
                  % Lontitud nova barra inferior
                  nusInf=barres(contbarra).nusinf;
                  nusSup=barres(contbarra).nussup;
                  posNI=nusos(nusInf).posicio;
                  posNS=nusos(nusSup).posicio;
                  pos=abs(posNI-posNS);
                  longNovaBarraSup=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
                  len=size(matrizEq,2);
 
                 %Es readapta el vector 
                 if len==5 
                  vectorEquacioAntic=matrizEq(numBarra,:);
                  vectorEquacioM=0;
                  vectorEquacioM=adaptarEcuacion(0,numBarra,contbarra-1,longNovaBarraInf,vectorEquacioAntic,vectorEquacioM);
                  vectorEquacioM=adaptarEcuacion(1,numBarra,contbarra,longNovaBarraSup,vectorEquacioAntic,vectorEquacioM);
                 end   
                 
                 if len==4
                   vectorEquacioAntic=matrizEq(numBarra,:);  
                   vectorEquacioM=zeros(2,4);
                   vectorEquacioM=adaptarEcuacionCortante(0,longNovaBarraInf,vectorEquacioAntic,vectorEquacioM);
                   vectorEquacioM=adaptarEcuacionCortante(1,longNovaBarraSup,vectorEquacioAntic,vectorEquacioM);
                 end
                  %Guardo les noves equacions tenint en compte les
                  %equacions existents, per exemple si la barra eliminada
                  %es la 3, la 2 i la 1 conserven la seva numeracio, la
                  %4,5..n.. pasen a ser 4-1,5-1,n-1, les noves, son les
                  %ultimes
                  %Per tant:
                  
                  matrizEqMMod=zeros(contbarra,len);
                  
                  matrizEqMMod(1:numBarra-1,:)=matrizEq(1:numBarra-1,:);
                  
                  for x=numBarra+1:contbarra-1
                     nuevaEq=matrizEq(x,:); 
                     matrizEqMMod(x-1,:)=nuevaEq; 
                  end
                  
                  matrizEqMMod(contbarra-1,:)=vectorEquacioM(1,:);
                  matrizEqMMod(contbarra,:)=vectorEquacioM(2,:);  

end



