%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Aquesta funci calcula el mxim valor de moment flector a la barra i la
% seva posici tenint en compte l'existncia de rtules prvies.
%
% Entrada:
% - Long: longitud de la barra.
% - esforcos: esforos en extrems de barra, en format vector 1x12.
% - moviments: moviments dels nusos inferior i superior, en format vector 1x12.
% - repartida: crrega repartida, vector 1x6. [mdul,x,y,z,distncia a nus inferior,distncia a nus superior].
% - projectada: crrega repartida projectada, mateix format que la repartida.
% - puntual: crrega puntual, vector 1x5. [mdul,x,y,z,distancia nus inferior].
% - moment: crrega moment, vecotr 1x5, mateix format que puntual.
% - E,A,Iz,Iz: propietats mecniques de la barra.
% - barraNum: Barra analitzada
% - contRotula: Comptador de rtules creades
% - dadesRotules: Llista d'objectes rtula
% - modo: Permet seleccionar diferents funcions de la funci
% - antigaMx: Equaci de moment X dels sistemes previs
% - antigaMy: Equaci de moment Y dels sistemes previs
% - antigaMz: Equaci de moment Z dels sistemes previs
% - barres: Llista d'objectes barra
% - nusos: Llista d'objectes nus
% - ecuacionesT: Paquet d'equacions de la barra
%
% Sortida:
% + Mmax: Tallant mxim en valor absolut, per a escalar els diagrames de moments a la grafica.
% + posicioMmax: Posici del mxim a la barra
% + equacioMz: Equaci de moment Z
% + equacioMy: Equaci de moment Y
% + equacioMx: Equaci de moment X
% + ecuacionesT: Paquet d'equacions de la brra
%


%% FUNCI PRINCIPAL:

function [Mmax,posicioMmax,equacioMz,equacioMx,equacioMy,ecuacionesT]=momentsMaxims(long,esforcos,moviments,repartida,projectada,puntual,moment,E,A,Iz,Iy,barraNum,contRotula,dadesRotules,modo,antigaMx,antigaMy,antigaMz,barres,nusos,ecuacionesT)


sep=long/50; % Separaci entre punts per al dibuix dels diagrames, 'resoluci' del diagrama.
diag=diagrama; % Crea l'objecte de la classe diagrama.

[puntual,moment,repartida,projectada,dcx]=carregues(puntual,moment,repartida,projectada); % Normalitza les crregues per al clcul.


N=calcul_tallant(esforcos(1),[puntual(2),puntual(5)],[repartida(2),repartida(5),long-repartida(6)],[projectada(2),projectada(5),long-projectada(6)],long,dcx); % Expressi axils.
Ty=calcul_tallant(esforcos(2),[puntual(3),puntual(5)],[repartida(3),repartida(5),long-repartida(6)],[projectada(3),projectada(5),long-projectada(6)],long,dcx); % Expressi tallants en y.
Tz=calcul_tallant(esforcos(3),[puntual(4),puntual(5)],[repartida(4),repartida(5),long-repartida(6)],[projectada(4),projectada(5),long-projectada(6)],long,dcx); % Expressi tallants en z.

Mx=calcul_moment(0,esforcos(4),[moment(2),moment(5)],[0,0],[0,0,0],[0,0,0],long,dcx,1); % Expressi moment torsor.
My=calcul_moment(esforcos(3),esforcos(5),[moment(3),moment(5)],[puntual(4),puntual(5)],[repartida(4),repartida(5),long-repartida(6)],[projectada(4),projectada(5),long-projectada(6)],long,dcx,-1); % Expressi moment en y.
Mz=calcul_moment(esforcos(2),esforcos(6),[moment(4),moment(5)],[puntual(3),puntual(5)],[repartida(3),repartida(5),long-repartida(6)],[projectada(3),projectada(5),long-projectada(6)],long,dcx,1); % Expressi moment en z.

dx=calcul_dx(moviments(1),N,E*A,long); % Expressi deformaci longitudinal.
[dy,Oz,Ozini,Ozfin]=calcul_d([moviments(2),moviments(8)],Mz,E*Iz,long,1); % Expressions deformaci transversal en y i gir en z.
[dz,Oy,Oyini,Oyfin]=calcul_d([moviments(3),moviments(9)],My,E*Iy,long,-1); % Expressions deformaci transversal en z i gir en y.

% diag.Oini=[Oyini,Ozini];
% diag.Ofin=[Oyfin,Ozfin];

%Guardamos todos los datos y ecuaciones con la finalidad de recuperarlos
%posteriormente al mostrar resultados y para poder trabajar con ellos al
%partir barras y por lo tanto poder adaptarlas

%Son ecuaciones con factor de carga, pero no son acumuladas
    ecuacionesT(barraNum).axil.N=N;
    ecuacionesT(barraNum).cortante.Ty=Ty;
    ecuacionesT(barraNum).cortante.Tz=Tz;
    ecuacionesT(barraNum).momento.Mx=Mx;
    ecuacionesT(barraNum).momento.My=My;
    ecuacionesT(barraNum).momento.Mz=Mz;
    ecuacionesT(barraNum).deformada.Oz=Oz;
    ecuacionesT(barraNum).deformada.Oy=Oy;
    ecuacionesT(barraNum).deformada.Ozini=Ozini;
    ecuacionesT(barraNum).deformada.Oyini=Oyini;
    ecuacionesT(barraNum).deformada.Ozfin=Ozfin;
    ecuacionesT(barraNum).deformada.Oyfin=Oyfin;
    ecuacionesT(barraNum).deformada.dx=dx;
    ecuacionesT(barraNum).deformada.dy=dy;
    ecuacionesT(barraNum).deformada.dz=dz;    
%end

%Sumem les lleis anteriors


if modo==1 
  if ~isempty(Ty)
      antigaTy=dadesRotules(contRotula).equacioTy(barraNum,:);
      Ty(1:2)=Ty(1:2)+antigaTy(1:2);
  end
  if ~isempty(Tz)
      antigaTz=dadesRotules(contRotula).equacioTz(barraNum,:);
      Tz(1:2)=Tz(1:2)+antigaTz(1:2);
  end
    
  if ~isempty(Mx)  
   Mx(1:3)=Mx(1:3)+antigaMx(1:3);
  end
  if ~isempty(My)
   My(1:3)=My(1:3)+antigaMy(1:3);
  end
  if ~isempty(Mz)
   Mz(1:3)=Mz(1:3)+antigaMz(1:3);
  end
end


N0=zero(N); % Punts on N=0.
Ty0=zero(Ty); % Punts on Ty=0.
Tz0=zero(Tz); % Punts on Tz=0.
Mx0=zero(Mx); % Punts on Mx=0.
My0=zero(My); % Punts on My=0.
Mz0=zero(Mz); % Punts on Mz=0.

[Nmin,Nmax]=absoluts('N',N,N0,[],sep,long,1,1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts
[Tymin,Tymax]=absoluts('Ty',Ty,Ty0,[],sep,long,1,1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts
[Tzmin,Tzmax]=absoluts('Tz',Tz,Tz0,[],sep,long,1,1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts
[Mxmin,Mxmax]=absoluts('Mx',Mx,Mx0,[],sep,long,1,1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts.
[Mymin,Mymax]=absoluts('My',My,My0,Tz0,sep,long,1,-1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts
[Mzmin,Mzmax]=absoluts('Mz',Mz,Mz0,Ty0,sep,long,1,1,barraNum,contRotula,dadesRotules,barres,nusos); % Busca els maxims absoluts

diag.Tmax=max(abs([Nmin(2),Nmax(2),Tymin(2),Tymax(2),Tzmin(2),Tzmax(2)])); % Mxim tallant o axil en termes absoluts, per a determinar l'escala dels diagrames.
diag.Mmax=max(abs([Mxmin(2),Mxmax(2),Mymin(2),Mymax(2),Mzmin(2),Mzmax(2)])); % Mxim moment en termes absoluts, per a determinar l'escala dels diagrames.

equacioMx=Mx;
equacioMy=My;
equacioMz=(Mz);

Mmax=diag.Mmax;
posicioMmax=posicio(Mmax,Mxmin,Mxmax,Mymin,Mymax,Mzmin,Mzmax);

end

function [posicioMmax]= posicio(Mmax,MminEjex,MmaxEjex,MminEjey,MmaxEjey,MminEjez,MmaxEjez) %Compara el valor obtingut del moment maxim amb el minim i el maxim per tal de obtenir la posicio sobre la barra.

    posicioMmax=0;
    if Mmax==abs(MmaxEjex(2))
        posicioMmax=MmaxEjex(1);
    end
    
    if Mmax==abs(MminEjex(2))
       posicioMmax=MminEjex(1);
    end
     if Mmax==abs(MmaxEjey(2))
        posicioMmax=MmaxEjey(1);
    end
    
    if Mmax==abs(MminEjey(2))
       posicioMmax=MminEjey(1);
    end
     if Mmax==abs(MmaxEjez(2))
        posicioMmax=MmaxEjez(1);
    end
    
    if Mmax==abs(MminEjez(2))
       posicioMmax=MminEjez(1);
    end
    
end


%% NORMALITZACI DE LES CRREGUES.
%
% Multiplica el vector direcci de cada crrega pel seu mdul.
% Obt la rellaci entre longitud de la crrega projectada i de la barra.

function [puntual,moment,repartida,projectada,dcx]=carregues(puntual,moment,repartida,projectada)
    if ~isnan(puntual)
        if puntual(1) && any(puntual(2:4))
            puntual(2:4)=puntual(1)*puntual(2:4)/norm(puntual(2:4));
        else
            puntual(2:4)=[0,0,0];
        end
    end
    if ~isnan(moment)
        if moment(1) && any(moment(2:4))
            moment(2:4)=moment(1)*moment(2:4)/norm(moment(2:4));
        else
            moment(2:4)=[0,0,0];
        end
    end
    if ~isnan(repartida)
        if repartida(1) && any(repartida(2:4))
            repartida(2:4)=repartida(1)*repartida(2:4)/norm(repartida(2:4));
        else
            repartida(2:4)=[0,0,0];
        end
    end
    if ~isnan(projectada)
        if projectada(1) && any(projectada(2:4))
            projectada(2:4)=projectada(1)*projectada(2:4)/norm(projectada(2:4));
            vbarra=[1,0,0];
            vcarrega=projectada(2:4);
            vperp=cross(vbarra,vcarrega);
            vperp=cross(vperp,vcarrega);
            vperp=vperp/norm(vperp);
            dcx=abs(dot(vperp,vbarra));
        else
            projectada(2:4)=[0,0,0];
            dcx=0;
        end
    else
       dcx=0; 
    end
end

%% CLCUL DELS POLINOMIS QUE DEFINEIXEN ELS DIAGRAMES D'AXILS I TALLANTS.

function T=calcul_tallant(forextrem,fpuntual,frepartida,fprojectada,long,dcx)
if isnan(forextrem) || isnan(fpuntual(1)) || isnan(frepartida(1)) || isnan(fprojectada(1))
    display('hola');
    T=0;
    return;
end
if forextrem || fpuntual(1) || frepartida(1) || fprojectada(1) % Si hi ha tallant en crea el diagrama.
    xT=[];
    % Defineix els trams del diagrama:
    if fpuntual(1)
        xT=fpuntual(2);
    end
    if frepartida(1)
        xT=[xT,frepartida(2),frepartida(3)];
    end
    if fprojectada(1)
        xT=[xT,fprojectada(2),fprojectada(3)];
    end
    xT=unique([0,xT,long]);
    T=zeros(numel(xT)-1,4);
    
    % Per a cada tram calcula els coeficients de la expressi analtica
    % del diagrama de tallants en y:
    for i=2:numel(xT)
        x0=xT(i-1);
        x1=xT(i);
        T(i-1,3:4)=[x0,x1];
        if fpuntual(1) && x1>fpuntual(2)
            T(i-1,1:2)=[0,-forextrem-fpuntual(1)];
        else
            T(i-1,1:2)=[0,-forextrem];
        end
        if frepartida(1) && x1>frepartida(2) && x1<=frepartida(3)
            T(i-1,1:2)=T(i-1,1:2)+[-frepartida(1),frepartida(1)*frepartida(2)];
        elseif frepartida(1) && x1>frepartida(3)
            T(i-1,1:2)=T(i-1,1:2)+[0,-frepartida(1)*(frepartida(3)-frepartida(2))];
        end
        if fprojectada(1) && x1>fprojectada(2) && x1<=fprojectada(3)
            T(i-1,1:2)=T(i-1,1:2)+[-fprojectada(1)*dcx,fprojectada(1)*fprojectada(2)*dcx];
        elseif fprojectada(1) && x1>fprojectada(3)
            T(i-1,1:2)=T(i-1,1:2)+[0,-fprojectada(1)*(fprojectada(3)-fprojectada(2))*dcx];
        end
    end
else
    T=[];
end
end

%% CLCUL DELS POLINOMIS QUE DEFINEIXEN ELS DIAGRAMES DE MOMENTS.

function M=calcul_moment(forextrem,momextrem,fmoment,fpuntual,frepartida,fprojectada,long,dcx,signe)
    if forextrem || momextrem || fmoment(1) || fpuntual(1) || frepartida(1) || fprojectada(1) % Si hi ha moments en eix z en crea el diagrama.
        xM=[];
        if fmoment(1)
            xM=fmoment(2);
        end
        if fpuntual(1)
            xM=[xM,fpuntual(2)];
        end
        if frepartida(1)
            xM=[xM,frepartida(2),frepartida(3)];
        end
        if fprojectada(1)
            xM=[xM,fprojectada(2),fprojectada(3)];
        end
        xM=unique([0,xM,long]);
        M=zeros(numel(xM)-1,5);
        for i=2:numel(xM)
            x0=xM(i-1); % Valor X a l'inici del tram.
            x1=xM(i); % Valor X al final del tram.
            M(i-1,4:5)=[x0,x1]; % Afegeix les dades d'X inicial i final a cada expressi analtica.
        
            % Expressi analtica del diagrama de moments segons els esforos.
            % En forma de vector amb els valors dels factors.
            if fmoment(1) && xM(i)>fmoment(2)
                M(i-1,1:3)=[0,forextrem*signe,-momextrem-fmoment(1)];
            else
                M(i-1,1:3)=[0,forextrem*signe,-momextrem];
            end
            if fpuntual(1) && x1>fpuntual(2)
                M(i-1,1:3)=M(i-1,1:3)+[0,fpuntual(1),-fpuntual(1)*fpuntual(2)]*signe;
            end
            if frepartida(1) && x1>frepartida(2) && x1<=frepartida(3)
                M(i-1,1:3)=M(i-1,1:3)+[frepartida(1)/2,-frepartida(1)*frepartida(2),frepartida(1)*frepartida(2)^2/2]*signe;
            elseif frepartida(1) && x1>frepartida(3)
                M(i-1,1:3)=M(i-1,1:3)+[0,frepartida(1)*(frepartida(3)-frepartida(2)),-frepartida(1)*(frepartida(3)-frepartida(2))*(frepartida(3)+frepartida(2))/2]*signe;
            end
            if fprojectada(1) && x1>fprojectada(2) && x1<=fprojectada(3)
                M(i-1,1:3)=M(i-1,1:3)+[fprojectada(1)*dcx/2,-fprojectada(1)*fprojectada(2)*dcx,fprojectada(1)*dcx*(fprojectada(2))^2/2]*signe;
            elseif fprojectada(1) && x1>fprojectada(3)
                M(i-1,1:3)=M(i-1,1:3)+[0,fprojectada(1)*(fprojectada(3)-fprojectada(2))*dcx,-fprojectada(1)*dcx*(fprojectada(3)-fprojectada(2))*(fprojectada(3)+fprojectada(2))/2]*signe;
            end
        end
    else
        M=[];
    end
end

%% CLCUL DELS POLINOMIS QUE DEFINEIXEN LES DEFORMACIONS.

function dx=calcul_dx(d0,N,EA,long)
    n=size(N,1); % Nmero de trams.
    if n
        dx=zeros(n,5);
        dx(:,4:5)=N(:,3:4);
        for i=1:n
            dx(i,1:3)=polyint(N(i,1:2)/EA);
            dx(i,3)=polyval([-dx(i,1:2),d0],dx(i,4));
            d0=polyval(dx(i,1:3),dx(i,5));
        end
    else
        dx=[0,0,d0,0,long];
    end
end

function [d,O,Oini,Ofin]=calcul_d(moviment,M,EI,long,signe)
    n=size(M,1); % Nmero de trams.
    if n
        O=zeros(n,6);
        d=zeros(n,7);
        O(:,5:6)=M(:,4:5);
        d(:,6:7)=M(:,4:5);
        O0=(moviment(2)-moviment(1))/long; % Valors inicials de gir de slid rgid i desplaament vertical.
        d0=moviment(1);
        for i=1:n
            x0=M(i,4);
            x1=M(i,5);
            O(i,1:4)=polyint(M(i,1:3)*signe/EI); % Integraci del diagrama de moments per obtenir l'expressi del gir.
            O(i,4)=polyval([-O(i,1:3),O0],x0); % Terme independent, per continuitat.
            O0=polyval(O(i,1:4),x1); % Gir al final del tram, ser l'inicial del tram segent. 
    
            d(i,1:5)=polyint(O(i,1:4)); % Integraci del gir per obtenir el desplaament vertical.
            d(i,5)=polyval([-d(i,1:4),d0],x0); % Terme independent, per continuitat.
            d0=polyval(d(i,1:5),x1); % Desplaament vertical al final del tram, ser l'inicial al tram segent.
        end
        O1=(moviment(2)-d0)/long; % Calcula el gir a l'extrem inferior imponent la condicio de contorn del desplaament vertical conegut a l'extrem superior.
        O(:,4)=O(:,4)+ones(n,1)*O1; % Corregeix les expressions de gir i desplaaments afegint el gir inicial calculat.
        d(:,4)=d(:,4)+ones(n,1)*O1;
        Oini=polyval(O(i,1:4),0); % Gir inicial.
        Ofin=polyval(O(i,1:4),long); % Gir final.
    elseif any(moviment)
        Oini=(moviment(2)-moviment(1))/long;
        d=[0,0,0,Oini,moviment(1),0,long];
        O=[0,0,0,Oini,0,long];
        Ofin=Oini;
    else
        d=[];
        O=[];
        Oini=0;
        Ofin=0;
    end
end

%% RECERCA DE ZEROS ALS POLINOMIS.

function x0=zero(P)
    [n,l]=size(P);
    x0=[];
    for i=1:n % Per a tots els trams comproba les arrels dels polinomis.
        x=roots(P(i,1:l-2)); % Arrels dels polinomis que defineixen els trams.
        for j=1:size(x,1); % Per a totes les arrels calculades...
            if isreal(x(j)) && x(j)>=P(i,l-1) && x(j)<=P(i,l) % Si l'arrel s un nombre real i est compresa entre els lmits del tram.
                x0=[x0,x(j)]; % Afegeix l'arrel a la llista.
            end
        end
    end
    
    for i=2:n % Comproba els lmits entre trams.
        if polyval(P(i-1,1:l-2),P(i-1,l)) * polyval(P(i,1:l-2),P(i,l-1)) < 0 % Si el valor final del tram anterior i el valor incial del tram actual sn de signe diferent...
            x0=[x0,P(i,l-1)]; % Afegeix el lmit entre els trams a la llista.
        end
    end
    x0=unique(x0); % Ordena i elimina resultats repetits.
end

%% OBT EL MXIM I EL MNIM

function [miny,maxy]=absoluts(txt,P,P0,xm,sep,long,detall,signe,barraNum,contRotula,dadesRotules,barres,nusos)
    if ~isempty(P)
        miny=[0,Inf];
        maxy=[0,-Inf];
        [n,l]=size(P);
        xd=0;
        yd=0;
        for i=1:n % En cada tram on es defineix el diagrama...
            if l>4 && any(P(i,1:l-4)) % Si el diagrama s una corba defineix una srie de punts intermitjos per definirla.
                x=[P(i,l-1):sep:P(i,l)];
            else
                x=[P(i,l-1),P(i,l)]; % Si el diagrama s una recta en defineix els punts inicial i final del tram.
            end
            for j=1:size(xm,1) % Si dins del tram hi ha un candidat a mnim o mxim l'afegeix als punts perque sigui evaluat.
                if xm(j)>P(i,l-1) && xm(j)<P(i,l)
                    
                    x=[x,xm(j)];
                    
                end
            end
            
            x=unique(x); % Ordena els punts i en descarta els repetits.
            
            entra=0;
            if txt=='Mz'
                entra=1;
            elseif txt=='My'
                entra=1;
            elseif txt=='Mx'
                entra=1;
            end
            
           if entra==1 
               
               
        %Es comproba que el mxim no sigui una rtula ja creada, si es aix
        %s'elimina el mxim.
           if contRotula>1
           rotulesAcomulades=dadesRotules(contRotula).rotulesAcomulades;
           
               for p=1:1:size(rotulesAcomulades,1)
                  if rotulesAcomulades(p,1)==barraNum
                     posicio=rotulesAcomulades(p,2);
                     IDX = uint32(1:size(x,2)); 
                     ind = IDX(x(1,:) >= posicio-0.05 & x(1,:) <= posicio+0.05);
                     x(ind)=[];
                  end              
               end
           end

           end   
            
            y=polyval(P(i,1:l-2),x); % Evalua els punts.
            [miny(2),k]=min([miny(2),y]); % Comproba si el mnim i mxim del tram sn els absoluts.
            if k~=1
                miny(1)=x(k-1);
            end
            [maxy(2),k]=max([maxy(2),y]);
            if k~=1
                maxy(1)=x(k-1);
            end
        end
    else
        miny=[0,0];
        maxy=[0,0];
    end
end

function [x]=recta(posicio,posInf,posSup,vector,jx,x)
       
       id=jx(1);
       uno=id;
       if uno==1
           dos=2;
           tres=3;
       elseif uno==2
           dos=1;
           tres=3;
       else
           dos=1;
           tres=2;
       end
       l=posInf-posSup;
       long=(l(1)^2+l(2)^2+l(3)^2)^0.5;
       t=(posicio(uno)-posInf(uno))/vector(uno);
            A=((posInf(dos)-vector(dos)*t)-0.01);
            B=((posInf(dos)-vector(dos)*t)+0.01);
            C=((posInf(tres)-vector(tres)*t)-0.01);
            D=((posInf(tres)-vector(tres)*t)+0.01);
            
           if A<=posicio(dos) && B>=posicio(dos) && C<=posicio(tres) && D>=posicio(tres)
              %Si pertenece a la barra comprobamos si tmb esta en
              %el mimso sitio que la rotula y que pertenece al tamo de
              %barra (puede pertenecer a la recta, pero estar sobre otra
              %barra alineada a la de estudio              
              
              %Calculamos la distancia de la rotula al punto
              %inferior
             vectorD=posicio-posInf;
             dist1=(vectorD(1)^2+vectorD(2)^2+vectorD(3)^2)^0.5;
             
              %Calculamos la distancia de la rotula al punto
              %superior
              vectorD=posicio-posSup;
              dist2=(vectorD(1)^2+vectorD(2)^2+vectorD(3)^2)^0.5;
             
               posicio=dist1;
              %Comprobamos que la distancia a ambos puntos sea la longitud
              %de la barra
              if dist1+dist2<long+0.0001 && dist1+dist2>long-0.001 %&& dist1>0.005 && dist2>0.005
                 %Si se cumple nos encontramos sobre la barra,
                 %Eliminamos el punto de posicion del grupo de puntos de
                 %estudio.
                 x(find(x==posicio))=[];             
                 IDX = uint32(1:size(x,2)); 
                 ind = IDX(x(1,:) >= posicio-0.001 & x(1,:) <= posicio+0.001);
                 x(ind)=[];
              end
           end     
end
