%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
%Aquesta funci em permet modificar les barres amb la finalitat de noms
%tindre una ecuaci de moments a cada barra. Per exemple, una crrga
%puntual em genera dues equacions de moment, doncs hi ha un salt,
%d'aquesta forma, creem dues barres i obtenim una equaci per barra.
%Posteriorment es fa l'nalisis dels factors de crrega barra a barra i es
%te en compte noms una equaci per barra.
%s una forma de simplificar l'obtenci dels moments mxims i s ms clar
%tindre en compte la reordenaci de barres.
%
% Entrada:
% +barres: Llista d'objectes barra
% +nusos:  Llista d'objectes nus
% +contnus: Comptador nusos
% +contbarra: Comptador barres
%
% Sortida:
% -barres: Llista d'objectes barra modificada
% -nusos: Llista d'objectes nus modificada
% -contnus: Comptador nusos modificat
% -contbarra: Comptador barres modificat


function  [barres,nusos,contnus,contbarra]=preparacio(barres,nusos,contnus,contbarra)



%Comprobem a totes les barres si existeixen moments puntuals, crregues
%puntuals o crregues repartides per trossos
n=0;
nCambia=0;
while n<contbarra
    n=n+1;
    nusinf=barres(n).nusinf;
    nussup=barres(n).nussup;
    pos=nusos(nussup).posicio-nusos(nusinf).posicio;
    long=(pos(1).^2+pos(2).^2+pos(3).^2).^0.5;
    
   if barres(n).moment(1)~=0 && barres(n).moment(5)>0 && barres(n).moment(5)<long
       display('moment modificada');
       %Guardem les dades de la barra, doncs les propietats de les noves
       %barres han de ser les mateixes
       propietats=barres(n);
       
       %Calculem la posici de la crrega al espai, doncs ser la situaci
       %del nou punt;
       vectorUnitari=pos/long;                        %calcula el vector unitari 
       posicioP=barres(n).moment(5);
       vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
       coordenades=nusos(nusinf).posicio+vectorPosicio;    
        
       %Eliminem la barra
       [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);
         
       %Creem el nou punt
       [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
       nusos(contnus).contorn=0;
       %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
        %Primer comprovem si la barra anterior tenia els extrems articulats
        artinf=propietats.artinf;
        artsup=propietats.artsup;
        
          %Barra 1
          [barres,contbarra]=novabarra2(nusinf,contnus,artinf,0,contbarra,barres);
          %Barra 2
          [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);
           
          %Asignem les mateixes propietats que la barra eliminada
          for i=contbarra-1:contbarra
              barres(i).E=propietats.E;
              barres(i).color=propietats.color;
              barres(i).A=propietats.A;
              barres(i).Iz=propietats.Iz;
              barres(i).Iy=propietats.Iy;
              barres(i).vectorIz=propietats.vectorIz;
              barres(i).GIt=propietats.GIt;
              barres(i).Mp=propietats.Mp;
          end
          %Modifiquem les crregues per adaptarles a les noves barres i
          %colocarles a les posicions correctes
          longInf=longitud(barres,nusos,contbarra-1);
          longSup=longitud(barres,nusos,contbarra);
          
          barres(contbarra).moment=propietats.moment;
          barres(contbarra).moment(5)=0;
          
          if propietats.puntual(1)~=0 %Si existeix un moment aplicat
              if propietats.puntual(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).puntual=propietats.puntual;
                    barres(contbarra).puntual(5)=barres(contbarra).puntual(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).puntual=propietats.puntual;
              end
          elseif propietats.repartida(1)~=0 %Si existeix crrega repartida
              if propietats.repartida(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).repartida=propietats.repartida;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (repartida(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).repartida(5)=barres(contbarra).repartida(5)-longInf;
                    
              elseif propietats.repartida(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).repartida=propietats.repartida;
                    barres(contbarra-1).repartida(6)=barres(contbarra).repartida(6)-longSup;
              else
                  barres(contbarra-1).repartida=propietats.repartida;
                  barres(contbarra).repartida=propietats.repartida;
                  barres(contbarra-1).repartida(6)=0;
                  barres(contbarra).repartida(5)=0;
                  
              end   
          elseif propietats.projectada(1)~=0
               if propietats.projectada(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).projectada=propietats.projectada;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (repartida(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).projectada(5)=barres(contbarra).projectada(5)-longInf;
                    
              elseif propietats.projectada(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).projectada=propietats.projectada;
                    barres(contbarra-1).projectada(6)=barres(contbarra).projectada(6)-longSup;
              else
                  barres(contbarra-1).projectada=propietats.projectada;
                  barres(contbarra).projectada=propietats.projectada;
                  barres(contbarra-1).projectada(6)=0;
                  barres(contbarra).projectada(5)=0;
                  
              end         
          end
        nCambia=1;       
   elseif barres(n).puntual(1)~=0 && barres(n).puntual(5)>0 && barres(n).puntual(5)<long
       
       display('puntual modificada');
       %Guardem les dades de la barra, doncs les propietats de les noves
       %barres han de ser les mateixes
       propietats=barres(n);
       
       %Calculem la posici de la crrega al espai, doncs ser la situaci
       %del nou punt;
       vectorUnitari=pos/long;                        %calcula el vector unitari 
       posicioP=barres(n).puntual(5);
       vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
       coordenades=nusos(nusinf).posicio+vectorPosicio;    
        
       %Eliminem la barra
       [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);
         
       %Creem el nou punt
       [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
       nusos(contnus).contorn=0;
       %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
        %Primer comprovem si la barra anterior tenia els extrems articulats
        artinf=propietats.artinf;
        artsup=propietats.artsup;
        
          %Barra 1
          [barres,contbarra]=novabarra2(nusinf,contnus,artinf,0,contbarra,barres);
          %Barra 2
          [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);
           
          %Asignem les mateixes propietats que la barra eliminada
          for i=contbarra-1:contbarra
              barres(i).E=propietats.E;
              barres(i).color=propietats.color;
              barres(i).A=propietats.A;
              barres(i).Iz=propietats.Iz;
              barres(i).Iy=propietats.Iy;
              barres(i).vectorIz=propietats.vectorIz;
              barres(i).GIt=propietats.GIt;
              barres(i).Mp=propietats.Mp;
          end
          %Modifiquem les crregues per adaptarles a les noves barres i
          %colocarles a les posicions correctes
          longInf=longitud(barres,nusos,contbarra-1);
          longSup=longitud(barres,nusos,contbarra);
          
          barres(contbarra).puntual=propietats.puntual;
          barres(contbarra).puntual(5)=0;
          
          if propietats.moment(1)~=0 %Si existeix un moment aplicat
              if propietats.moment(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).moment=propietats.moment;
                    barres(contbarra).moment(5)=barres(contbarra).moment(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).moment=propietats.moment;
              end
          elseif propietats.repartida(1)~=0 %Si existeix crrega repartida
              if propietats.repartida(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).repartida=propietats.repartida;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (repartida(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).repartida(5)=barres(contbarra).repartida(5)-longInf;
                    
              elseif propietats.repartida(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).repartida=propietats.repartida;
                    barres(contbarra-1).repartida(6)=barres(contbarra).repartida(6)-longSup;
              else
                  barres(contbarra-1).repartida=propietats.repartida;
                  barres(contbarra).repartida=propietats.repartida;
                  barres(contbarra-1).repartida(6)=0;
                  barres(contbarra).repartida(5)=0;
                  
              end   
          elseif propietats.projectada(1)~=0
               if propietats.projectada(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).projectada=propietats.projectada;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (repartida(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).projectada(5)=barres(contbarra).projectada(5)-longInf;
                    
              elseif propietats.projectada(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).projectada=propietats.projectada;
                    barres(contbarra-1).projectada(6)=barres(contbarra).projectada(6)-longSup;
              else
                  barres(contbarra-1).projectada=propietats.projectada;
                  barres(contbarra).projectada=propietats.projectada;
                  barres(contbarra-1).projectada(6)=0;
                  barres(contbarra).projectada(5)=0;
                  
              end         
          end
        nCambia=1;        
   elseif (barres(n).repartida(1)~=0) && (barres(n).repartida(5)>0 || barres(n).repartida(6)>0)
       display('repartida modificada');
       %Guardem les dades de la barra, doncs les propietats de les noves
       %barres han de ser les mateixes
       propietats=barres(n);
       
       %EN aquest cas tindrem que crear 2 o 3 barres, depenen com estigui
       %disposada la ccrrega
            %Comprobem quantes barres s'han de crear
            if barres(n).repartida(5) && barres(n).repartida(6)>0
                numNoves=2;
            else
                numNoves=1; 
            end
       if numNoves==1
           %Es creen 2 barres noves
           %Calculem la posici del inici de la crrega al espai
           if barres(n).repartida(5)>0
               vectorUnitari=pos/long;                        %calcula el vector unitari 
               posicioP=barres(n).repartida(5);
               vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
               coordenades=nusos(nusinf).posicio+vectorPosicio;            
           end

           if barres(n).repartida(6)>0
               vectorUnitari=pos/long;                        %calcula el vector unitari 
               posicioP=barres(n).repartida(6);
               vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
               coordenades=nusos(nussup).posicio-vectorPosicio;    
           end

           %Eliminem la barra
           [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);

           %Creem el nou punt      
          
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
           nusos(contnus).contorn=0;           

           %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
            %Primer comprovem si la barra anterior tenia els extrems articulats
            artinf=propietats.artinf;
            artsup=propietats.artsup;

              %Barra 1
              [barres,contbarra]=novabarra2(nusinf,contnus,artinf,0,contbarra,barres);
              %Barra 2
              [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);

              %Asignem les mateixes propietats que la barra eliminada
              for i=contbarra-1:contbarra
                  barres(i).E=propietats.E;
                  barres(i).color=propietats.color;
                  barres(i).A=propietats.A;
                  barres(i).Iz=propietats.Iz;
                  barres(i).Iy=propietats.Iy;
                  barres(i).vectorIz=propietats.vectorIz;
                  barres(i).GIt=propietats.GIt;
                  barres(i).Mp=propietats.Mp;
              end
              
          %Modifiquem les crregues per adaptarles a les noves barres i
          %colocarles a les posicions correctes
          longInf=longitud(barres,nusos,contbarra-1);
          longSup=longitud(barres,nusos,contbarra);
       
          if propietats.repartida(5)>0
             barres(contbarra).repartida=propietats.repartida;
             barres(contbarra).repartida(5)=0;
             barres(contbarra).repartida(6)=0;
          else
             barres(contbarra-1).repartida=propietats.repartida;
             barres(contbarra).repartida(5)=0;
             barres(contbarra-1).repartida(6)=0;
          end
             
           if propietats.moment(1)~=0 %Si existeix un moment aplicat
              if propietats.moment(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).moment=propietats.moment;
                    barres(contbarra).moment(5)=barres(contbarra).moment(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).moment=propietats.moment;
              end
           elseif propietats.puntual(1)~=0 %Si existeix un moment aplicat
              if propietats.puntual(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).puntual=propietats.puntual;
                    barres(contbarra).puntual(5)=barres(contbarra).puntual(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).puntual=propietats.puntual;
              end
          elseif propietats.projectada(1)~=0
               if propietats.projectada(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).projectada=propietats.projectada;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (repartida(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).projectada(5)=barres(contbarra).projectada(5)-longInf;
                    
              elseif propietats.projectada(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).projectada=propietats.projectada;
                    barres(contbarra-1).projectada(6)=barres(contbarra).projectada(6)-longSup;
              else
                  barres(contbarra-1).projectada=propietats.projectada;
                  barres(contbarra).projectada=propietats.projectada;
                  barres(contbarra-1).projectada(6)=0;
                  barres(contbarra).projectada(5)=0;
                  
              end         
          end
        nCambia=1;  
              
       else
           %Es creen 3 barres noves
           vectorUnitari=pos/long;                        %calcula el vector unitari 
           posicioP=barres(n).repartida(5);
           vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
           coordenades=nusos(nusinf).posicio+vectorPosicio;       
           
           vectorUnitari=pos/long;                        %calcula el vector unitari 
           posicioP=barres(n).repartida(6);
           vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
           coordenades1=nusos(nussup).posicio-vectorPosicio;       
           
           %Eliminem la barra
           [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);

           %Creem els nous punts      
          
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
           nusos(contnus).contorn=0;           
            
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades1);
           nusos(contnus).contorn=0;  
           
           %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
            %Primer comprovem si la barra anterior tenia els extrems articulats
            artinf=propietats.artinf;
            artsup=propietats.artsup;

              %Barra 1
              [barres,contbarra]=novabarra2(nusinf,contnus-1,artinf,0,contbarra,barres);
              %Barra 2
              [barres,contbarra]=novabarra2(contnus-1,contnus,0,0,contbarra,barres);
              %Barra 3
              [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);

              %Asignem les mateixes propietats que la barra eliminada
              for i=contbarra-2:contbarra
                  barres(i).E=propietats.E;
                  barres(i).color=propietats.color;
                  barres(i).A=propietats.A;
                  barres(i).Iz=propietats.Iz;
                  barres(i).Iy=propietats.Iy;
                  barres(i).vectorIz=propietats.vectorIz;
                  barres(i).GIt=propietats.GIt;
                  barres(i).Mp=propietats.Mp;
              end
              
              %Modifiquem les crregues per adaptarles a les noves barres i
              %colocarles a les posicions correctes
              longInf=longitud(barres,nusos,contbarra-2);
              longMed=longitud(barres,nusos,contbarra-1);
              longSup=longitud(barres,nusos,contbarra);
              
             %Es copien les propietats de la crrega a la barra central, doncs es la que t crrega. 
             barres(contbarra-1).repartida=propietats.repartida;
             barres(contbarra-1).repartida(5)=0;
             barres(contbarra-1).repartida(6)=0;
              
           if propietats.moment(1)~=0 %Si existeix un moment aplicat
              if propietats.moment(5)>longInf; %Si es troba a la barra mitja
                    barres(contbarra-1).moment=propietats.moment;
                    barres(contbarra-1).moment(5)=barres(contbarra-1).moment(5)-longInf;
              elseif propietats.moment(5)>longMed %Si es troba a la ultima barra
                    barres(contbarra).moment=propietats.moment;
                    barres(contbarra).moment(5)=barres(contbarra).moment(5)-longInf-longMed;
              else %Si es troba a la ultima barra
                    barres(contbarra-2).moment=propietats.moment;
              end
           elseif propietats.puntual(1)~=0 %Si existeix un moment aplicat
              if propietats.puntual(5)>longInf; %Si es troba a la barra mitja
                    barres(contbarra-1).puntual=propietats.puntual;
                    barres(contbarra-1).puntual(5)=barres(contbarra-1).puntual(5)-longInf;
              elseif propietats.moment(5)>longMed %Si es troba a la ultima barra
                    barres(contbarra).puntual=propietats.puntual;
                    barres(contbarra).puntual(5)=barres(contbarra).puntual(5)-longInf-longMed;
              else %Si es troba a la ultima barra
                    barres(contbarra-2).puntual=propietats.puntual;
              end
          elseif propietats.projectada(1)~=0
              %Busquem si les 3 noves barres tenen crrega projectada
                 if propietats.projectada(5)==0 && propietats.projectada(6)==0
                     %Les tres tenen crrega projectada
                     barres(contbarra-2).projectada=propietats.projectada;
                     barres(contbarra-1).projectada=propietats.projectada;
                     barres(contbarra).projectada=propietats.projectada;
                 else
                    longCarga=long-propietats.projectada(5)-propietats.projectada(6);
                    
                     if propietats.projectada(5)>longInf && propietats.projectada(5)<longInf+longMed
                         %No hay carga en la primera barra creada, pero si
                         %en la media y quizas en la superior
                         barres(contbarra-1).projectada=propietats.projectada;
                         barres(contbarra-1).projectada(5)= barres(contbarra-1).projectada(5)-longInf;
                         
                         if barres(contbarra-1).projectada(5)+longCarga>longMed
                             %Existe carga en la superior tambien
                             barres(contbarra).projectada=propietats.projectada;
                             barres(contbarra).projectada(5)=0;
                             result=barres(contbarra-1).projectada(5)+longCarga-longMed-longSup;
                             if result<1*10^-3
                                 result=0;
                             end
                             barres(contbarra).projectada(6)=result;
                         else
                             %Como no existe carga en la superior vemos
                             %donde acaba en la barra media
                             result=longMed-longCarga-barres(contbarra-1).projectada(5);
                             barres(contbarra-1).projectada(6)=result;
                         end
                        
                     elseif propietats.projectada(5)>longInf+longMed
                         %No hay carga en la barra media ni en la inferior
                         barres(contbarra).projectada=propietats.projectada;
                         barres(contbarra).projectada(5)=propietats.projectada(5)-longInf-longMed;
                     elseif propietats.projectada(5)<longInf
                         %Existe carga en la inferior y quizas en las otras
                         %dos
                         barres(contbarra-2).projectada=propietats.projectada;
                         
                         if propietats.projectada(5)+longCarga>longInf && propietats.projectada(5)+longCarga<=longInf+longMed
                             %Existe carga en la media pero no en la
                             %superior
                             barres(contbarra-2).projectada(6)=0;
                             barres(contbarra-1).projectada=propietats.projectada;
                             barres(contbarra-1).projectada(5)=0;
                             barres(contbarra-1).projectada(6)=abs(longCarga-longInf-longMed);
                             
                         elseif propietats.projectada(5)+longCarga>longInf
                             barres(contbarra-2).projectada(6)=0;
                             %Existe carga en la media y en la superior
                             barres(contbarra-1).projectada=propietats.projectada;
                             barres(contbarra-1).projectada(5)=0;
                             barres(contbarra-1).projectada(6)=0;
                             
                             barres(contbarra).projectada=propietats.projectada;
                             barres(contbarra).projectada(5)=0;
                             barres(contbarra).projectada(6)=abs(longCarga-longInf-longMed-longSup);                            
                         else
                             %Solo carga en la inferior, veamos hasta donde
                             %llega
                             barres(contbarra-2).projectada(6)=barres(contbarra-2).projectada(6)-longMed-longSup;
                             
                         end
                         
                     end
                     
                 end                         
          end
        nCambia=1;  
       end
       
       
   elseif (barres(n).projectada(1)~=0) && (barres(n).projectada(5)>0 || barres(n).projectada(6)>0)
        display('projctada modificada');
       %Guardem les dades de la barra, doncs les propietats de les noves
       %barres han de ser les mateixes
       propietats=barres(n);
       
       %EN aquest cas tindrem que crear 2 o 3 barres, depenen com estigui
       %disposada la ccrrega
            %Comprobem quantes barres s'han de crear
            if barres(n).projectada(5) && barres(n).projectada(6)>0
                numNoves=2;
            else
                numNoves=1; 
            end
       if numNoves==1
           %Es creen 2 barres noves
           %Calculem la posici del inici de la crrega al espai
           if barres(n).projectada(5)>0
               vectorUnitari=pos/long;                        %calcula el vector unitari 
               posicioP=barres(n).projectada(5);
               vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
               coordenades=nusos(nusinf).posicio+vectorPosicio;            
           end

           if barres(n).projectada(6)>0
               vectorUnitari=pos/long;                        %calcula el vector unitari 
               posicioP=barres(n).projectada(6);
               vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
               coordenades=nusos(nussup).posicio-vectorPosicio;    
           end

           %Eliminem la barra
           [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);

           %Creem el nou punt      
          
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
           nusos(contnus).contorn=0;           

           %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
            %Primer comprovem si la barra anterior tenia els extrems articulats
            artinf=propietats.artinf;
            artsup=propietats.artsup;

              %Barra 1
              [barres,contbarra]=novabarra2(nusinf,contnus,artinf,0,contbarra,barres);
              %Barra 2
              [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);

              %Asignem les mateixes propietats que la barra eliminada
              for i=contbarra-1:contbarra
                  barres(i).E=propietats.E;
                  barres(i).color=propietats.color;
                  barres(i).A=propietats.A;
                  barres(i).Iz=propietats.Iz;
                  barres(i).Iy=propietats.Iy;
                  barres(i).vectorIz=propietats.vectorIz;
                  barres(i).GIt=propietats.GIt;
                  barres(i).Mp=propietats.Mp;
              end
              
          %Modifiquem les crregues per adaptarles a les noves barres i
          %colocarles a les posicions correctes
          longInf=longitud(barres,nusos,contbarra-1);
          longSup=longitud(barres,nusos,contbarra);
       
          if propietats.projectada(5)>0
             barres(contbarra).projectada=propietats.projectada;
             barres(contbarra).projectada(5)=0;
             barres(contbarra).projectada(6)=0;
          else
             barres(contbarra-1).projectada=propietats.projectada;
             barres(contbarra).projectada(5)=0;
             barres(contbarra-1).projectada(6)=0;
          end
             
           if propietats.moment(1)~=0 %Si existeix un moment aplicat
              if propietats.moment(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).moment=propietats.moment;
                    barres(contbarra).moment(5)=barres(contbarra).moment(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).moment=propietats.moment;
              end
           elseif propietats.puntual(1)~=0 %Si existeix un moment aplicat
              if propietats.puntual(5)>longInf; %Si es troba a la segona barra creada 
                    barres(contbarra).puntual=propietats.puntual;
                    barres(contbarra).puntual(5)=barres(contbarra).puntual(5)-longInf;
              else %Si es troba a la primera barra creada
                    barres(contbarra-1).puntual=propietats.puntual;
              end
          elseif propietats.repartida(1)~=0
               if propietats.repartida(5)>longInf %Si es dona aquesta condicio indica que no existeix crrega a la nova barra inferior
                    barres(contbarra).repartida=propietats.repartida;
                    %Noms existeix crrega a la barra superior, la
                    %distancia al nus superior es mante (projectada(6)), la
                    %distancia al nus inferior s'ha de modificar
                    barres(contbarra).repartida(5)=barres(contbarra).repartida(5)-longInf;
                    
              elseif propietats.repartida(6)>longSup %Si es dona aquesta condicio indica que no existeix crrega
                    barres(contbarra-1).repartida=propietats.repartida;
                    barres(contbarra-1).repartida(6)=barres(contbarra).repartida(6)-longSup;
              else
                  barres(contbarra-1).repartida=propietats.repartida;
                  barres(contbarra).repartida=propietats.repartida;
                  barres(contbarra-1).repartida(6)=0;
                  barres(contbarra).repartida(5)=0;
                  
              end         
          end
        nCambia=1;  
              
       else
           %Es creen 3 barres noves
           vectorUnitari=pos/long;                        %calcula el vector unitari 
           posicioP=barres(n).projectada(5);
           vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
           coordenades=nusos(nusinf).posicio+vectorPosicio;       
           
           vectorUnitari=pos/long;                        %calcula el vector unitari 
           posicioP=barres(n).projectada(6);
           vectorPosicio=vectorUnitari*posicioP;           %a partir del vector unitari, multiplican aquest per la distancia al nus inferior obtenim el vector posici del nou nus      
           coordenades1=nusos(nussup).posicio-vectorPosicio;       
           
           %Eliminem la barra
           [barres,contbarra]=esborrarbarraPlastic(n,barres,contbarra);

           %Creem els nous punts      
          
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades);
           nusos(contnus).contorn=0;           
            
           [nusos,contnus]=crearnus2(contnus,nusos,coordenades1);
           nusos(contnus).contorn=0;  
           
           %Creem les noves barres (nusinf,nussup,artinf,artsup,contbarra,barres)
            %Primer comprovem si la barra anterior tenia els extrems articulats
            artinf=propietats.artinf;
            artsup=propietats.artsup;

              %Barra 1
              [barres,contbarra]=novabarra2(nusinf,contnus-1,artinf,0,contbarra,barres);
              %Barra 2
              [barres,contbarra]=novabarra2(contnus-1,contnus,0,0,contbarra,barres);
              %Barra 3
              [barres,contbarra]=novabarra2(contnus,nussup,0,artsup,contbarra,barres);

              %Asignem les mateixes propietats que la barra eliminada
              for i=contbarra-2:contbarra
                  barres(i).E=propietats.E;
                  barres(i).color=propietats.color;
                  barres(i).A=propietats.A;
                  barres(i).Iz=propietats.Iz;
                  barres(i).Iy=propietats.Iy;
                  barres(i).vectorIz=propietats.vectorIz;
                  barres(i).GIt=propietats.GIt;
                  barres(i).Mp=propietats.Mp;
              end
              
              %Modifiquem les crregues per adaptarles a les noves barres i
              %colocarles a les posicions correctes
              longInf=longitud(barres,nusos,contbarra-2);
              longMed=longitud(barres,nusos,contbarra-1);
              longSup=longitud(barres,nusos,contbarra);
              
             %Es copien les propietats de la crrega a la barra central, doncs es la que t crrega. 
             barres(contbarra-1).projectada=propietats.projectada;
             barres(contbarra-1).projectada(5)=0;
             barres(contbarra-1).projectada(6)=0;
    end
   end    
   if nCambia==1
      n=0; 
      nCambia=0;
   end
end
end

function [long]=longitud(barres,nusos,num)
        nusInf=barres(num).nusinf;
        nusSup=barres(num).nussup;
        posI=nusos(nusInf).posicio-nusos(nusSup).posicio;
        long=(posI(1).^2+posI(2).^2+posI(3.)^2).^0.5;
end

















