%% CLCUL PLSTIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% NGEL GUASCH DURAN
% ENGINYERIA CAMINS, CANALS I PORTS
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 23/10/2.013
%
% Funci que adapta i reordena la matriu d'equacions quan existeixen barres
% dividides

% Entrada:
% +matriz: Es la matriu a modificar
% +numBarraPartida: Es la barra que es divideix
% +barres: Llista d'objectes barra a la estructura
% +nusos: Llista d'objectes nusos a la estructura
% +contbarra: Comptador de barres
%
% Sortida:
% -matrizF: Matriu reordenada amb equacions adaptades


%% Funci principal:
function [matrizF]=reordenarMatriz(matriz,numBarraPartida,barres,nusos,contbarra)

%Primer de tot es necessari adaptar l'equaci de la barra que es divideix,
%hem d'obtenir dues equacions noves amb les seves respectives longituds a
%partir de la equaci de la barra que es divideix

%Seleccionem el vector a modificar
    
    longitudMatriz=size(matriz,1); %Obtenim el tamany de la matriu inicial
    
    %Es calcula la longitud de la nova barra inferior
    nusInf=barres(contbarra-1).nusinf;
    nusSup=barres(contbarra-1).nussup;
    posNI=nusos(nusInf).posicio;
    posNS=nusos(nusSup).posicio;
    pos=abs(posNI-posNS);
    longNovaBarraInf=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
    
    %Es calcula la longitud de la nova barra superior
    nusInf=barres(contbarra).nusinf;
    nusSup=barres(contbarra).nussup;
    posNI=nusos(nusInf).posicio;
    posNS=nusos(nusSup).posicio;
    pos=abs(posNI-posNS);
    longNovaBarraSup=(pos(1)^2+pos(2)^2+pos(3)^2)^0.5;
    
   %Es readapta el vector seleccionat
   vectorEquacioAntic=matriz(numBarraPartida,:);
   vectorEquacio=0;
   if length(vectorEquacioAntic)<6
       vectorEquacio=adaptarEcuacion(0,0,contbarra-1,longNovaBarraInf,vectorEquacioAntic,vectorEquacio);
       vectorEquacio=adaptarEcuacion(1,0,contbarra,longNovaBarraSup,vectorEquacioAntic,vectorEquacio);
   else
       vectorEquacio=adaptarEcuacionDeformada(0,longNovaBarraInf,vectorEquacioAntic,vectorEquacio);
       vectorEquacio=adaptarEcuacionDeformada(1,longNovaBarraSup,vectorEquacioAntic,vectorEquacio);
   end   

%Ordenem la matriu i col.loquem tots els vectors a la nova posici que els
%hi correspon
for i=1:1:size(matriz,1)
    if i<numBarraPartida
        matrizF(i,:)=matriz(i,:);
    elseif i>numBarraPartida
        matrizF(i-1,:)=matriz(i,:);
    end
end

matrizF(contbarra-1,:)=vectorEquacio(1,:);
matrizF(contbarra,:)=vectorEquacio(2,:);

for n=contbarra+1:1:longitudMatriz
    matrizF(n,:)=0;
end

end