%% CLCUL ESTATIC PER A ESTRUCTURES BI O TRIDIMENSIONALS.
%
% SERGIO GUERRERO MIRALLES 2.011-2.012
% ENGINYERIA TCNICA D'OBRES PBLIQUES
% UNIVERSITAT POLITCNICA DE CATALUNYA
%
% Versi data 13/10/2.012
%
% Entrada:
% n = sencer nombre de nusos de l'estructura.
% N = sencer nombre de barres de l'estructura.
% Ncoord = matriu n*3 amb les coordenades x, y i z dels nusos.
% Ncond = condicions de contorn dels nusos: nus lliure =0; rodet inclinat
% =1; recolzament simple =2; encastament =3; desplaaments elstics i girs
% lliures =4; girs elstics i desplaaments nuls =5; desplaaments i girs
% elstics =6; desplaaments imposats i girs lliures =7; girs imposats i
% desplaaments lliures =8; desplaaments i girs imposats =9.
% Nextfor = vector n*6 de forces aplicades als nusos.
% Lnods = matriu N*2 amb nombre de nus inferior i superior de cada barra.
% Lartyp = matriu N*2 amb tipus d'extrem de barra inferior i superior,
% rgid =0; articulat =1.
% Lmecp = matriu N*9 de propietats mecaniques de cada barra: E, G, A, Iz,
% Iy, zx, zy, zz, J.
% barra_carrega_rep = matriu N*6 amb la crrega repartida sobre les barres,
% mdul, direcci x, y i z, distancia a extrem inferior i superior.
% barra_carrega_rep_proj = matriu N*6 amb la crrega repartida projectada
% sobre les barres (longitut de la crrega = longitut de la barra), mdul,
% direcci x, y i z, distncia a extrem inferior i superior.
% barra_carrega_punt = matriu N*5 amb la crrega puntual sobre les barres,
% mdul, direcci x, y i z i distncia al nus inferior.
% barra_carrega_mom = matriu N*5 amb el moment aplicat sobre les barres,
% mdul, direcci x, y i z i distncia al nus inferior.
%
% Sortida:
% Retorn_reaccions = vector n*6 amb les reaccions als nusos.
% Retorn_moviments = vector n*6 amb desplaaments i girs.
% Retorn_esforcos_barres = matriu N*12 amb els esforos als extrems de les
% bares.
% TL2G = matriu 3*3*N amb les matrius de canvi de base local a global de
% cada barra.
%
% Discrimina si el sistema s en 2 o 3 dimensions, eliminant dirctament
% els moviments que no hi intervenen en vigues continues, engraellats
% plans, girs de rtula, etc.
% Reordena els nusos de manera que els recolzaments quedin al final,
% d'aquesta manera la matriu reduda queda inscrita dins de la matriu
% completa i no cal duplicar-la a la memria.
% sistema: llista amb l'ordre dels nusos a la matriu de rigidesa global.
% ns: dimensi de la matriu del sistema.
% nn: dimensi de la matriu reduda. nn<ns.

function [Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,TL2G,ierr,K_Glob,Vector_esforcos,Vector_esforcos_prescrits,sistema,ns,nn] = cme2_calcul_estatic(n,N,Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom)
ierr = 1;
[sistema,ns,nn,contorn]=reordenacio_nusos(Lnods,Lartyp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom,Nextfor,Ncoord,Ncond,N,n); % Reordenaci dels nusos per inscriure la Matriu Reduda dins de la Matriu de Rigidesa.
Matriu_Rigidesa_G=zeros(ns,ns); % Dimensiona la matriu de rigidesa global.
K_Glob=zeros(n*6,n*6);
Nintfor=zeros(n*6,1); % Dimensiona vector d'esforos transmesos als nusos per les crregues aplicades a les barres.
Nepfor=zeros(N,12); % Matriu amb esforos en extrems de barra deguts a les carregues, per a cada barra.
TL2G=zeros(3,3,N);
for i=1:N % Per a cada barra...
    n1=Lnods(i,1); % node inferior
    n2=Lnods(i,2); % node superior
    extrems=Lartyp(i,1)*2+Lartyp(i,2); % rgid-rgid =0, rgid-articulat =1, articulat-rgid =2, articulat-articulat =3.
    vector_barra=Ncoord(n2,1:3)-Ncoord(n1,1:3); % Vector de la barra.
    L=norm(vector_barra); % Longitut de la barra.
    vector_Iz=Lmecp(i,6:8); % Vector inrcia de la barra.
    TL2G(:,:,i)=calcul_canvi_base(vector_barra,vector_Iz); % Clcul i enmagatzematge de la matriu de canvi de base d'eixos locals a globals.
    T=[TL2G(:,:,i),zeros(3);zeros(3),TL2G(:,:,i)]; % Matriu canvi de base completa 6x6
    KL=calcul_submatrius_rigidesa(Lmecp(i,:),extrems,L); % Clcul de la submatriu de rigidesa en eixos locals.
    KG=[T*KL(1:6,1:6)*T',T*KL(1:6,7:12)*T';T*KL(7:12,1:6)*T',T*KL(7:12,7:12)*T']; % Submatriu de rigidesa en eixos globals.
    KG=contorn_rodet_inclinat(KG,n1,n2,Ncond); % Aplicaci de la condici de contorn de rodet inclinat a la submatriu de rigidesa, si s'escau.
    Matriu_Rigidesa_G=Matriu_Rigidesa_G+ensamblatge_matriu_rigidesa(KG,ns,sistema,n1,n2); % Ensamblatge de la submatriu dins de la Matriu de Rigidesa.
    %K_Glob=K_Glob+ensamblatge(n1,n2,KG,n);
    Nepfor(i,:)=calcul_carregues_barra_local(barra_carrega_rep(i,:),barra_carrega_rep_proj(i,:),barra_carrega_punt(i,:),barra_carrega_mom(i,:),TL2G(:,:,i),L,extrems); % Trasllat de les carregues a les barres als extrems de barra, en eixos locals.
    Nintfor(n1*6-5:n1*6)=Nintfor(n1*6-5:n1*6)+T*Nepfor(i,1:6)'; % Clcul de l'estat de forces al nus inferior provocades per les crregues a les barres, en eixos globals.
    Nintfor(n2*6-5:n2*6)=Nintfor(n2*6-5:n2*6)+T*Nepfor(i,7:12)'; % Clcul de l'estat de forces al nus superior provocades per les crregues a les barres, en eixos globals.
end
Ntotfor=Nextfor+Nintfor; % Total de forces aplicades als nusos.
[Vector_esforcos_prescrits,Vector_esforcos,Vector_moviments]=contorn_prescrits_i_rodet(Matriu_Rigidesa_G,n,ns,sistema,Ncond,Ntotfor); % Crea els vectors d'esforos i moviments aplicant les condicions de contorn de moviments prescrits i rodet.
Matriu_Rigidesa_G=contorn_elastic(Matriu_Rigidesa_G,n,sistema,Ncond(:,1),Ncond(:,2:7)); % Modifica la Matriu de Rigidesa amb les rigideses dels contorns elstics.
warning('error','MATLAB:singularMatrix');
warning('error','MATLAB:illConditionedMatrix');
warning('error','MATLAB:nearlySingularMatrix');
K_Glob=Matriu_Rigidesa_G;
try
  Vector_moviments(1:nn,1)=Matriu_Rigidesa_G(1:nn,1:nn)\Vector_esforcos_prescrits(1:nn,1); % Resol el sistema amb la matriu reduda amb els esforos calculats per als contorns prescrits sumats. 
catch mwarning
    Retorn_reaccions=[];
    Retorn_moviments=[];
    Retorn_esforcos_barres=[];
    TL2G=[];
  return
end    

Matriu_Rigidesa_G=contorn_elastic(Matriu_Rigidesa_G,n,sistema,Ncond(:,1),-Ncond(:,2:7)); % Desf la modificaci de la Matriu de Rigidesa amb les rigideses dels contorns elstics.
Vector_reaccions=Matriu_Rigidesa_G*Vector_moviments-Vector_esforcos; % Calcula les reaccions als recolzaments de l'estructura.
[Retorn_reaccions,Retorn_moviments]=ordre_inicial_nusos(sistema,Vector_reaccions,Vector_moviments,n,Ncond); % Retorn de reaccions i moviments en l'ordre original dels nusos i eixos globals.
Retorn_esforcos_barres=zeros(N,12); % Clcul dels esforos en extrems de barra.
for i=1:N
    n1=Lnods(i,1); % node inferior
    n2=Lnods(i,2); % node superior
    extrems=Lartyp(i,1)*2+Lartyp(i,2); % rgid-rgid =0, rgid-articulat =1, articulat-rgid =2, articulat-articulat =3.
    vector_barra=Ncoord(n2,1:3)-Ncoord(n1,1:3); % Vector de la barra.
    L=norm(vector_barra); % Longitut de la barra.
    T=[TL2G(:,:,i),zeros(3);zeros(3),TL2G(:,:,i)]; % Matriu canvi de base completa 6x6
    KL=calcul_submatrius_rigidesa(Lmecp(i,:),extrems,L); % Clcul de la submatriu de rigidesa en eixos locals.
    vector_mov_local=[T'*Retorn_moviments(n1*6-5:n1*6);T'*Retorn_moviments(n2*6-5:n2*6)]; % Vector moviments en eixos locals.
    Retorn_esforcos_barres(i,:)=KL*vector_mov_local-Nepfor(i,:)'; % Esforos en extrems de cada barra en eixos locals.
end
ierr = 0;
end

%% SUBMATRIUS DE REGIDESA EN EIXOS LOCALS.

function KL=calcul_submatrius_rigidesa(Lmecp,extrems,L)
E=Lmecp(1); % Mdul de Young
Iz=Lmecp(4); % Inrcia eix z
if any(Lmecp(6:8)) % Si existeix vector direcci d'Iz
    Iy=Lmecp(5); % Inrcia eix y    
else
    Iy=Iz;
end
GItL=Lmecp(9)/L; % Inrcia a torsi
A=Lmecp(3); % rea de la secci
EAL=E*A/L;
EIzL=E*Iz/L;
EIyL=E*Iy/L;
EIzL2=E*Iz/L^2;
EIyL2=E*Iy/L^2;
EIzL3=E*Iz/L^3;
EIyL3=E*Iy/L^3;
% Sub-matrius de rigidesa segons els extrems siguin rgids o articulats.
switch extrems
    case 0 % rgid-rgid
        KL(1:6,1:6)=[EAL,0,0,0,0,0;0,12*EIzL3,0,0,0,6*EIzL2;0,0,12*EIyL3,0,-6*EIyL2,0;0,0,0,GItL,0,0;0,0,-6*EIyL2,0,4*EIyL,0;0,6*EIzL2,0,0,0,4*EIzL];
        KL(1:6,7:12)=[-EAL,0,0,0,0,0;0,-12*EIzL3,0,0,0,6*EIzL2;0,0,-12*EIyL3,0,-6*EIyL2,0;0,0,0,-GItL,0,0;0,0,6*EIyL2,0,2*EIyL,0;0,-6*EIzL2,0,0,0,2*EIzL];
        KL(7:12,1:6)=KL(1:6,7:12)';
        KL(7:12,7:12)=[EAL,0,0,0,0,0;0,12*EIzL3,0,0,0,-6*EIzL2;0,0,12*EIyL3,0,6*EIyL2,0;0,0,0,GItL,0,0;0,0,6*EIyL2,0,4*EIyL,0;0,-6*EIzL2,0,0,0,4*EIzL];
        %KL(1:6,1:6)=[EAL,0,0,0,0,0;0,12*EIzL3,0,0,0,6*EIzL2;0,0,12*EIyL3,0,6*EIyL2,0;0,0,0,GItL,0,0;0,0,6*EIyL2,0,4*EIyL,0;0,6*EIzL2,0,0,0,4*EIzL];
        %KL(1:6,7:12)=[-EAL,0,0,0,0,0;0,-12*EIzL3,0,0,0,6*EIzL2;0,0,-12*EIyL3,0,6*EIyL2,0;0,0,0,-GItL,0,0;0,0,-6*EIyL2,0,2*EIyL,0;0,-6*EIzL2,0,0,0,2*EIzL];
        %KL(7:12,1:6)=KL(1:6,7:12)';
        %KL(7:12,7:12)=[EAL,0,0,0,0,0;0,12*EIzL3,0,0,0,-6*EIzL2;0,0,12*EIyL3,0,-6*EIyL2,0;0,0,0,GItL,0,0;0,0,-6*EIyL2,0,4*EIyL,0;0,-6*EIzL2,0,0,0,4*EIzL];
    case 1 % rgid-articulat
        KL(1:6,1:6)=[EAL,0,0,0,0,0;0,3*EIzL3,0,0,0,3*EIzL2;0,0,3*EIyL3,0,-3*EIyL2,0;0,0,0,0,0,0;0,0,-3*EIyL2,0,3*EIyL,0;0,3*EIzL2,0,0,0,3*EIzL];
        KL(1:6,7:12)=[[-EAL,0,0;0,-3*EIzL3,0;0,0,-3*EIyL3;0,0,0;0,0,3*EIyL2;0,-3*EIzL2,0],zeros(6,3)];
        KL(7:12,1:6)=KL(1:6,7:12)';
        KL(7:12,7:12)=[[EAL,0,0;0,3*EIzL3,0;0,0,3*EIyL3],zeros(3,3);zeros(3,6)];
    case 2 % articulat-rgid
        KL(1:6,1:6)=[[EAL,0,0;0,3*EIzL3,0;0,0,3*EIyL3],zeros(3);zeros(3,6)];
        KL(1:6,7:12)=[[-EAL,0,0,0,0,0;0,-3*EIzL3,0,0,0,3*EIzL2;0,0,-3*EIyL3,0,-3*EIyL2,0];zeros(3,6)];
        KL(7:12,1:6)=KL(1:6,7:12)';
        KL(7:12,7:12)=[EAL,0,0,0,0,0;0,3*EIzL3,0,0,0,-3*EIzL2;0,0,3*EIyL3,0,3*EIyL2,0;0,0,0,0,0,0;0,0,3*EIyL2,0,3*EIyL,0;0,-3*EIzL2,0,0,0,3*EIzL];
    case 3 % articulat-articulat
        KL(1:6,1:6)=[EAL,0,0,0,0,0;zeros(5,6)];
        KL(1:6,7:12)=[-EAL,0,0,0,0,0;zeros(5,6)];
        KL(7:12,1:6)=KL(1:6,7:12);
        KL(7:12,7:12)=KL(1:6,1:6);
end
end


%% APLICACI CONDICI DE CONTORN RODET INCLINAT A LES SUBMATRIUS DE RIGIDESA.

% Condici de contorn rodet inclinat.
% Si algn dels extrems connecta amb un rodet inclinat, multiplica les submatrius per la matriu de canvi de base als eixos del rodet, els moviments i esforos del nus corresponent queden en eixos locals del rodet.

function KG=contorn_rodet_inclinat(KG,n1,n2,Ncond)
if Ncond(n1,1)==1 % Si el nus inferior s un rodet inclinat
    Tr=calcul_canvi_base(Ncond(n1,2:4)); % Calcula matriu canvi de base del rodet.
    T=[Tr,zeros(3);zeros(3),Tr];
    KG(1:6,1:6)=T'*KG(1:6,1:6)*T; % Sub-matriu en la base del rodet.
    KG(1:6,7:12)=T'*KG(1:6,7:12); % Sub-matriu en la base del rodet.
    KG(7:12,1:6)=KG(7:12,1:6)*T; % Sub-matriu en la base del rodet.
end
if Ncond(n2,1)==1 % Si el nus superior s un rodet inclinat
    Tr=calcul_canvi_base(Ncond(n2,2:4)); % Calcula matriu canvi de base del rodet.
    T=[Tr,zeros(3);zeros(3),Tr];
    KG(1:6,7:12)=KG(1:6,7:12)*T; % Sub-matriu en la base del rodet.
    KG(7:12,1:6)=T'*KG(7:12,1:6); % Sub-matriu en la base del rodet.
    KG(7:12,7:12)=T'*KG(7:12,7:12)*T; % Sub-matriu en la base del rodet.
end
end

%% CLCUL DE LES SOLLICITACIONS ALS NUSOS PER CRREGUES A LES BARRES.

%  Per a cada tipus d'extrem de barra, rgid o articulat, en calcula els
%  esforos d'empotrament perfecte, per a crregues repartides projectades
%  (longitut de la crrega = longitut de la barra) o no sobre la barra,
%  crregues puntuals i moments aplicats a la bara. Per a crregues
%  repartides permet definir distncies al nus inferior i superior per
%  delimitar la zona de la barra que rep la crrega. Igualment amb la
%  distncia al nus inferior es situa la crrega puntual i el moment a la
%  barra. Totes les crregues s'introdueixen, i els resultats es retornen,
%  en eixos globals, per es calculen en eixos locals (eix de la barra
%  coincideix amb l'eix X local).


function reaccions=calcul_carregues_barra_local(carrega_rep,carrega_rep_proj,carrega_punt,carrega_mom,TL2G,L,extrems)
reaccions=[0,0,0,0,0,0,0,0,0,0,0,0];
if carrega_rep_proj(1) % Clcul de les forces equivalents als nusos a la crrega repartida projectada sobre la barra.
    vbarra=[L,0,0]; % Vector barra en eixos locals;
    carrega=TL2G'*carrega_rep_proj(2:4)'; % Vector direcci de la crrega en eixos locals.
    carrega=carrega_rep_proj(1)*carrega/norm(carrega); % Vector crrega en eixos locals.
    vperp=cross(vbarra,carrega);
    vperp=cross(vperp,carrega);
    vperp=vperp/norm(vperp);
    Lc=abs(dot(vperp,vbarra)); % Longitut de la crrega.
    reaccions=-calcul_repartida(carrega,carrega_rep_proj(5),carrega_rep_proj(6),L,Lc,extrems);
end
if carrega_rep(1) % Clcul de les forces equivalents als nusos a la crrega repartida a la barra.
    carrega=TL2G'*carrega_rep(2:4)'; % Vector direcci de la crrega repartida en eixos locals.
    carrega=carrega_rep(1)*carrega'/norm(carrega); % Vector crrega
    reaccions=reaccions-calcul_repartida(carrega,carrega_rep(5),carrega_rep(6),L,L,extrems);
end
if carrega_punt(1) % Clcul de les forces equivalents als nusos a la crrega puntual a la barra.
    carrega=TL2G'*carrega_punt(2:4)'; % Vector direcci de la carrega puntual
    carrega=carrega'*carrega_punt(1)/norm(carrega); % Vector carrega.
    reaccions=reaccions-calcul_puntual(carrega,carrega_punt(5),L,extrems);
end
if carrega_mom(1) % Clcul de les forces equivalents als nusos al moment aplicat a la barra.
    carrega=TL2G'*carrega_mom(2:4)'; % Vector direcci del moment.
    carrega=carrega'*carrega_mom(1)/norm(carrega); % Vector moment.
    reaccions=reaccions-calcul_moment(carrega,carrega_mom(5),L,extrems);
end
end

% FUNCI DE CLCUL DE LES REACCIONS PER CRREGA REPARTIDA EN EIXOS LOCALS

function reaccions=calcul_repartida(carrega,dist1,dist2,L,Lc,extrems)
c=(L-dist1-dist2)*Lc/(2*L);
a=dist1*Lc/L+c;
b=dist2*Lc/L+c;
switch extrems
    case 0 % rgid-rigid
        reaccions(1:3)=-carrega*2*c*(1-(3*a^2+c^2)/Lc^2+2*a*((a^2+c^2)/Lc^3)); % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,[carrega(3),-carrega(2)]*L*2*c*(a*b^2/Lc^3-c^2*(3*b-Lc)/(3*Lc^3))]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*2*c*((3*a^2+c^2)/Lc^2-2*a*(a^2+c^2)/Lc^3); % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,[-carrega(3),carrega(2)]*L*2*c*(b*a^2/Lc^3-c^2*(3*a-Lc)/(3*Lc^3))]; % Moments d'empotrament al nus superior.
    case 1 % rgid-articulat
        reaccions(1:3)=-carrega*c*(2-(3*a^2+c^2)/Lc^2+a*(a^2+c^2)/Lc^3); % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,[carrega(3),-carrega(2)]*L*b*c*(a*(Lc+b)-c^2)/Lc^3]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*c*((3*a^2+c^2)/Lc^2-a*(a^2+c^2)/Lc^3); % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
    case 2 % articulat-rgid
        reaccions(1:3)=-carrega*c*((3*b^2+c^2)/Lc^2-b*(b^2+c^2)/Lc^3); % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*c*(2-(3*b^2+c^2)/Lc^2+b*(b^2+c^2)/Lc^3); % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,[-carrega(3),carrega(2)]*L*a*c*(b*(Lc+a)-c^2)/Lc^3]; % Moments d'empotrament al nus superior.
    case 3 % articulat_articulat
        reaccions(1:3)=-carrega*2*c*(Lc-a)/Lc; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*2*c*(Lc-b)/Lc; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
end
end


% FUNCI DE CLCUL DE LES REACCIONS PER CRREGA PUNTUAL EN EIXOS LOCALS

function reaccions=calcul_puntual(carrega,dist1,L,extrems)
dist2=L-dist1;
switch extrems
    case 0 % rgid-rgid
        reaccions(1:3)=-carrega*dist2^2*(3-2*dist2/L)/L^2; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,[carrega(3),-carrega(2)]*dist1*dist2^2/L^2]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*dist1^2*(3-2*dist1/L)/L^2; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,[-carrega(3),carrega(2)]*dist1^2*dist2/L^2]; % Moments d'empotrament al nus superior.
    case 1 % rgid-articulat
        reaccions(1:3)=-carrega*dist2*(3-dist2^2/L^2)/(2*L); % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,[carrega(3),-carrega(2)]*dist1*dist2*(L+dist2)/(2*L^2)]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*dist1^2*(3-dist1/L)/(2*L^2); % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
    case 2 % articulat-rgid
        reaccions(1:3)=-carrega*dist2^2*(3-dist2/L)/(2*L^2); % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*dist1*(3-dist1^2/L^2)/(2*L); % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,[-carrega(3),carrega(2)]*dist1*dist2*(L+dist1)/(2*L^2)]; % Moments d'empotrament al nus superior.
    case 3 % articulat_articulat
        reaccions(1:3)=-carrega*dist2/L; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=-carrega*dist1/L; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
end
end


% FUNCI DE CLCUL DE LES REACCIONS PER MOMENT APLICAT A LA BARRA EN EIXOS LOCALS

function reaccions=calcul_moment(carrega,dist1,L,extrems)
dist2=L-dist1;
switch extrems
    case 0 % rgid-rgid
        reaccions(1:3)=[0,[carrega(3),-carrega(2)]*6*dist1*dist2/L^3]; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[-carrega(1)*dist2/L,[carrega(2),carrega(3)]*dist2*(2-3*dist2/L)/L]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=[0,[-carrega(3),carrega(2)]*6*dist1*dist2/L^3]; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[-carrega(1)*dist1/L,[carrega(2),carrega(3)]*dist1*(2-3*dist1/L)/L]; % Moments d'empotrament al nus superior.
    case 1 % rgid-articulat
        reaccions(1:3)=[0,[carrega(3),-carrega(2)]*3*dist1*(2-dist1/L)/(2*L^2)]; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[-carrega(1),[carrega(2),carrega(3)]*(1-3*dist2^2/L^2)/2]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=[0,[-carrega(3),carrega(2)]*3*dist1*(2-dist1/L)/(2*L^2)]; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
    case 2 % articulat-rgid
        reaccions(1:3)=[0,[carrega(3),-carrega(2)]*3*dist2*(2-dist2/L)/(2*L^2)]; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)= [0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=[0,[-carrega(3),carrega(2)]*3*dist2*(2-dist2/L)/(2*L^2)]; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[-carrega(1),[carrega(2),carrega(3)]*(1-3*dist1^2/L^2)/2]; % Moments d'empotrament al nus superior.
    case 3 % articulat_articulat
        reaccions(1:3)=[0,[carrega(3),-carrega(2)]/L]; % Reaccions d'empotrament als nus inferior.
        reaccions(4:6)=[0,0,0]; % Moments d'empotrament al nus inferior.
        reaccions(7:9)=[0,[-carrega(3),carrega(2)]/L]; % Reaccions d'empotrament als nus superior.
        reaccions(10:12)=[0,0,0]; % Moments d'empotrament al nus superior.
end
end


%% CREACI DELS VECTORS D'ESFOROS I MOVIMENTS DE L'ESTRUCTURA INTRODUNT MOVIMENTS I GIRS IMPOSATS I RODET INCLINAT.

function [Vector_esforcos_prescrits,Vector_esforcos,Vector_moviments]=contorn_prescrits_i_rodet(Matriu_Rigidesa_G,n,ns,sistema,Ncond,Ntotfor)
Vector_esforcos=zeros(ns,1);
Vector_esforcos_prescrits=Vector_esforcos;
Vector_moviments=zeros(ns,1);
for i=1:n
    sumafor=Ntotfor(6*i-5:6*i);
    if Ncond(i,1)==1 % Si s rodet inclinat canvia esforos al sistema d'eixos locals del rodet
        Tr=calcul_canvi_base(Ncond(i,2:4)); % Calcula matriu canvi de base plnol del rodet.
        T=[Tr,zeros(3);zeros(3),Tr];
        sumafor=T'*sumafor;
    end
    for j=1:6
        k=sistema(6*i+j-6);
        if k
            Vector_esforcos(k)=sumafor(j); % Colloca els esforos al vector d'esforos
            Vector_esforcos_prescrits(k)=sumafor(j);
        end
    end
    if Ncond(i,1)==7 || Ncond(i,1)==9 % Moviments imposats
        for j=1:3
            k=sistema(6*i+j-6);
            l=Ncond(i,j+1);
            if k && l
                Vector_esforcos_prescrits=Vector_esforcos_prescrits-l*Matriu_Rigidesa_G(1:ns,k);
                Vector_moviments(k,1)=l;
            end
        end
    end
    if Ncond(i,1)==8 || Ncond(i,1)==9 % Girs imposats
        for j=4:6
            k=sistema(6*i+j-6);
            l=Ncond(i,j+1);
            if k && l
                Vector_esforcos_prescrits=Vector_esforcos_prescrits-l*Matriu_Rigidesa_G(1:ns,k);
                Vector_moviments(k,1)=l;
            end
        end
    end
end
end

%% MODIFICACI DE LA MATRIU DE RIGIDESA GLOBAL PER INTRODUR CONTORNS ELSTICS.

function Matriu_Rigidesa_G=contorn_elastic(Matriu_Rigidesa_G,n,sistema,contorn,K)
for i=1:n
    if contorn(i)==4 || contorn(i)==6 % Moviments elstics
        for j=1:3
            k=sistema(6*i+j-6);
            if k
                Matriu_Rigidesa_G(k,k)=Matriu_Rigidesa_G(k,k)+K(i,j); %Afegeix la constant elstica a la diagonal de la matriu.
            end
        end
    end
    if contorn(i)==5 || contorn(i)==6 % Girs elstics
        for j=4:6
            k=sistema(6*i+j-6);
            if k
                Matriu_Rigidesa_G(k,k)=Matriu_Rigidesa_G(k,k)+K(i,j); %Afegeix la constant elstica a la diagonal de la matriu.
            end
        end
    end
end
end


