% Crea ojectes grfics del tipus 'hgtransform' amb el dibuix del rodet, encastament, etc..
% Retorna el handle, es poden rotar i moure a la grfica amb matriu creada amb la funci
% makehgtform.

function [contorn] = dibuix_contorn(tipus,distnum,fontnusos,tamanyfontnusos)
contorn=hgtransform;
text(-distnum,distnum,'0','FontName',fontnusos,'FontUnits','pixels','FontSize',tamanyfontnusos,'HorizontalAlignment','right','Parent',contorn,'Clipping','on');
switch tipus
    case {'nus',0}
        line([-.20,.20],[0,0],[0,0],'color','k','Parent',contorn,'Clipping','on','HitTest','off');
        line([0,0],[-.20,.20],[0,0],'color','k','Parent',contorn,'Clipping','on','HitTest','off');
        line([0,0],[0,0],[-.20,.20],'color','k','Parent',contorn,'Clipping','on','HitTest','off');
    case {'rodet',1}
        cercle(contorn,-.04,-.18,.04); % Cercle esquerra.
        cercle(contorn,.04,-.18,.04); % Cercle dreta.
        line([-.08,0,.08,-.08],[-.14,0,-.14,-.14],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Triangle.
        massis(contorn,-.14,.14,-.22);
    case {'simple',2}
        cercle(contorn,0,0,.030); % Cercle.
        line([-.08,0,.08],[-.170,-.030,-.170],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Triangle.
        massis(contorn,-.16,.16,-.170);
    case {'encastament',3}
        massis(contorn,-.16,.16,0);
    case {'despelastic',4}
        line([0,-.08,.08,-.08,.08,-.08,.08,-.08,.08,0],[-.46,-.44,-.40,-.36,-.32,-.28,-.24,-.20,-.16,-.14],'color','k','Linewidth',2,'Parent',contorn,'Clipping','on','HitTest','off') % Molla
        line([-.08,0,.08,-.08],[-.14,0,-.14,-.14],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Triangle.
        massis(contorn,-.16,.16,-.46);
    case {'girelastic',5}
        cercle(contorn,0,0,.030); % Cercle.
        line([-.08,0,.08],[-.170,-.030,-.170],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Triangle.
        massis(contorn,-.16,.32,-.170);
        line([.24,.242,.24,.2350,.2250,.2124,.20,.18,.16,.14,.12,.110,.10,.098,.1050,.12,.130,.1384,.14,.1350,.12,.10,.08,.04,0],[-.170,-.12,-.070,-.0350,0,.0250,.04,.054,.06,.058,.050,.0432,.030,.0150,0,-0.0050,0,0.0150,.030,.0550,.08,.094,.10,.10,.0950],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Molla.
    case {'despigirelastic',6}
        line([0,-.08,.08,-.08,.08,-.08,.08,-.08,.08,0],[-.46,-.44,-.40,-.36,-.32,-.28,-.24,-.20,-.16,-.14],'color','k','Linewidth',2,'Parent',contorn,'Clipping','on','HitTest','off') % Molla
        line([-.08,0,.08,-.08],[-.14,0,-.14,-.14],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Triangle.
        massis(contorn,-.16,.32,-.46);
        line([.24,.242,.24,.2350,.2250,.2124,.20,.18,.16,.14,.12,.110,.10,.098,.1050,.12,.130,.1384,.14,.1350,.12,.10,.08,.04,0],[-.46,-.36,-.26,-.190,-.12,-.070,-.04,-0.012,0,-0.004,-.02,-.0336,-.06,-.090,-.12,-.130,-.12,-.090,-.06,-0.010,.04,.068,.08,.08,.070],'color','k','Parent',contorn,'Clipping','on','HitTest','off'); % Molla.12
    case {'despimposat',7}
        cercle(contorn,0,0,.030)
        line([.20,0,0],[0,0,.20],'color','k','LineStyle','--','Parent',contorn,'Clipping','on','HitTest','off')
        line([.20,.20,0],[0,.20,.20],'color','k','Parent',contorn,'Clipping','on','HitTest','off')
        patch([.20,.22,.18,.20,.16,.16,.20],[.20,.16,.16,.20,.18,.22,.20],'k','Parent',contorn,'Clipping','on','HitTest','off')
    case {'girimposat',8}
        cercle(contorn,0,0,.030)
        line([-.40,0,-.3464],[0,0,-.20],'color','k','LineStyle','--','Parent',contorn,'Clipping','on','HitTest','off')
        a=0:pi/30:pi/6;
        line(-.30*cos(a),-.30*sin(a),'color','k','Parent',contorn,'Clipping','on','HitTest','off')
        patch([-.30*cos(pi/6),-.30*cos(pi/6)-sin(0.987)*.0448,-.30*cos(pi/6)-sin(0.06)*.0448],[-.30*sin(pi/6),-.30*sin(pi/6)+cos(0.987)*.0448,-.30*sin(pi/6)+cos(0.06)*.0448],'k','Parent',contorn,'Clipping','on','HitTest','off')
    case {'despigirimposats',9}
        cercle(contorn,0,0,.030)
        line([.20,0,0],[0,0,.20],'color','k','LineStyle','--','Parent',contorn,'Clipping','on','HitTest','off')
        line([.20,.20,0],[0,.20,.20],'color','k','Parent',contorn,'Clipping','on','HitTest','off')
        line([-.40,0,-.3464],[0,0,-.20],'color','k','LineStyle','--','Parent',contorn,'Clipping','on','HitTest','off')
        a=0:pi/30:pi/6;
        line(-.30*cos(a),-.30*sin(a),'color','k','Parent',contorn,'Clipping','on','HitTest','off')
        patch([.20,.22,.18,.20,.16,.16,.20],[.20,.16,.16,.20,.18,.22,.20],'k','Parent',contorn,'Clipping','on','HitTest','off')
        patch([-.30*cos(pi/6),-.30*cos(pi/6)-sin(0.987)*.0448,-.30*cos(pi/6)-sin(0.06)*.0448],[-.30*sin(pi/6),-.30*sin(pi/6)+cos(0.987)*.0448,-.30*sin(pi/6)+cos(0.06)*.0448],'k','Parent',contorn,'Clipping','on','HitTest','off')
end
set(contorn,'Clipping','on','HitTestArea','on','HitTest','off');

end

function [] = massis(h,xini,xfin,y)
line([xini,xfin],[y,y],'color','k','LineWidth',2,'Parent',h,'Clipping','on','HitTest','off'); % Lnia secci horitzontal.
line([xini,xini+.04],[y-.04,y],'color','k','Parent',h,'Clipping','on','HitTest','off');
line([xini,xini+.08],[y-.08,y],'color','k','Parent',h,'Clipping','on','HitTest','off');
for x=xini:.04:xfin-.12
    line([x,x+.12],[y-.12,y],'color','k','Parent',h,'Clipping','on','HitTest','off');
end
line([xfin-.08,xfin],[y-.12,y-.04],'color','k','Parent',h,'Clipping','on','HitTest','off');
line([xfin-.04,xfin],[y-.12,y-.08],'color','k','Parent',h,'Clipping','on','HitTest','off');
end

function [] = cercle(h,x,y,r)
c=0:pi/12:2*pi;
line(r*sin(c)-x,r*cos(c)+y,'color','k','Parent',h,'Clipping','on','HitTest','off');
end
