% Funci dlgbarra per a Clcul Matricial d'Estructures 2 (CME2).
%
% Per Sergio Guerrero Miralles, darrera versi 24 de maig de 2.012.
%
% Crea una finestra per introduir-hi o modificar les dades de les barres.
%
% Entrada:
% - n: nmero identificador de la barra.
% - numnus: nmero de nusos.
% - barres: llista d'objectes tipus barra on s'emmagatzemen les propietats de la barra als segents camps:
% + num: Nmero de barra.
% + nusinf: Nmero de nus inferior.
% + nussup: Nmero de nus superior.
% + artinf: Nus inferior articulat: 0=rgid, 1=articulat.
% + artsup: Nus superior articulat: 0=rgid, 1=articulat.
% + color: Color de la barra.
% + E: Mdul de Young.
% + A: rea de la secci.
% + Iz: Inrcia en eix z.
% + Iy: Inrcia en eix y.
% + vectorIz: Vector direcci de l'eix z de la secci.
% + GIt: Inrcia a torsi.
% + Mp: Moment plstic 
%
% Sortida:
% - barres: Igual que la entrada per convenientment modificades les dades de la barra editada.

function barres = dlgbarra(numnus,barres,n)
%% CREA LA FINESTRA, ELS PANELLS I ELS BOTONS.

tamanycme2=get(gcf,'Position'); % Obt el tamany i la posici de la finestra del programa principal.
tm=[255,450]; % Tamany de la finestra.
sc=(tamanycme2(3:4)-tm(1:2))/2+tamanycme2(1:2); % Posici de la finestra al centre de la finestra del programa principal.
bg=get(0,'defaultUicontrolBackgroundColor'); % Color per defecte del fons.

f = figure('Units','pixels','Position',[sc,tm],'NumberTitle','off','Name',['Barra n: ',num2str(barres(n).num),' (',num2str(barres(n).nusinf),'-',num2str(barres(n).nussup),')'],'Toolbar','none','Menubar','none','Resize','off','WindowStyle','modal','color',bg,'KeyPressFcn',@tecla); % Crea la finestra.
panelnus=uipanel(f,'Units','pixels','Position',[5 365 245 80],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Extrems de barra:'); % Crea el panell superior amb informaci dels extrems.
panelfis=uipanel(f,'Units','pixels','Position',[5 45 245 315],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Propietats:'); % Crea el panell inferior amb les propietats.
uicontrol(f,'Units','pixels','Position',[5,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Acceptar','Callback',@acceptar); % Crea el bot acceptar.
uicontrol(f,'Units','pixels','Position',[140,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Cancellar','Callback',@cancelar); % Crea el bot cancelar.

%% CREA ELS CONTROLS AL PANELL SUPERIOR AMB INFORMACI DELS EXTREMS.

uicontrol(panelnus,'Units','pixels','Position',[5,40,60,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Inferior:'); % Etiqueta.
uicontrol(panelnus,'Units','pixels','Position',[5,10,60,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Superior:'); % Etiqueta.

txtnusos=cellstr(num2str((1:numnus)')); % Llistat en texte dels nusos.
popupnusinf=uicontrol(panelnus,'Units','pixels','Position',[65,40,90,20],'Style','popupmenu','FontName','default','FontUnits','pixels','FontSize',14,'BackgroundColor','white','String',txtnusos,'Value',barres(n).nusinf,'KeyPressFcn',@tecla); % Control que fa apareixer llistat de nusos per seleccionar.
popupnussup=uicontrol(panelnus,'Units','pixels','Position',[65,10,90,20],'Style','popupmenu','FontName','default','FontUnits','pixels','FontSize',14,'BackgroundColor','white','String',txtnusos,'Value',barres(n).nussup,'KeyPressFcn',@tecla); % Control que fa apareixer llistat de nusos per seleccionar.
checkartinf=uicontrol(panelnus,'Units','pixels','Position',[160,40,80,20],'Style','checkbox','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Articulat','Value',barres(n).artinf,'KeyPressFcn',@tecla); % Control que permet marcar si l'extrem inferior s articulat.
checkartsup=uicontrol(panelnus,'Units','pixels','Position',[160,10,80,20],'Style','checkbox','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Articulat','Value',barres(n).artsup,'KeyPressFcn',@tecla); % Control que permet marcar si l'extrem superior s articulat.

%% CREA ELS CONTROLS AL PANELL INFERIOR AMB LES PROPIETATS DE LA BARRA.

uicontrol(panelfis,'Units','pixels','Position',[5,264,150,26],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Importar de barra','Callback',@importar,'KeyPressFcn',@tecla); % Bot per importar dades d'altres barres.
ns=zeros(length(barres),2);
for j=1:length(barres) % Crea una llista de les barres.
    ns(j,:)=[barres(j).nusinf,barres(j).nussup];
end
txtbarres=strcat(cellstr(num2str((1:length(barres))')),' (',cellstr(num2str(ns(:,1))),'-',cellstr(num2str(ns(:,2))),')');
popupperfil=uicontrol(panelfis,'Units','pixels','Position',[160,270,80,20],'Style','popupmenu','FontName','default','FontUnits','pixels','FontSize',14,'BackgroundColor','white','String',txtbarres,'KeyPressFcn',@tecla); % Control que permet seleccionar una barra per importar-hi les propietats.

uicontrol(panelfis,'Units','pixels','Position',[5,230,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Color:'); % Etiqueta.
buttoncolor=uicontrol(panelfis,'Units','pixels','Position',[130,230,110,26],'Style','pushbutton','Backgroundcolor',barres(n).color,'Callback',@color,'KeyPressFcn',@tecla); % Bot que presenta el color i permet cambiar-lo.

%Etiquetes:
uicontrol(panelfis,'Units','pixels','Position',[5,200,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Mdul de Young E:');
uicontrol(panelfis,'Units','pixels','Position',[5,170,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','rea de la secci:');
uicontrol(panelfis,'Units','pixels','Position',[5,140,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Inrcia Iz:');
uicontrol(panelfis,'Units','pixels','Position',[5,110,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Inrcia Iy:');
uicontrol(panelfis,'Units','pixels','Position',[5,80,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Rigidesa torsi GIt:');
uicontrol(panelfis,'Units','pixels','Position',[5,50,150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Moment plstic Mp:');
uicontrol(panelfis,'Units','pixels','Position',[5,25,235,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector direcci Iz en eixos globals:');
uicontrol(panelfis,'Units','pixels','Position',[5,5,25,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','x=');
uicontrol(panelfis,'Units','pixels','Position',[85,5,25,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','y=');
uicontrol(panelfis,'Units','pixels','Position',[165,5,25,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','z=');

% Caixes de texte:
editprop(1)=uicontrol(panelfis,'Units','pixels','Position',[130,200,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).E),'KeyPressFcn',@tecla);
editprop(2)=uicontrol(panelfis,'Units','pixels','Position',[130,170,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).A),'KeyPressFcn',@tecla);
editprop(3)=uicontrol(panelfis,'Units','pixels','Position',[130,140,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).Iz),'KeyPressFcn',@tecla);
editprop(4)=uicontrol(panelfis,'Units','pixels','Position',[130,110,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).Iy),'KeyPressFcn',@tecla);
editprop(5)=uicontrol(panelfis,'Units','pixels','Position',[130,80,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).GIt),'KeyPressFcn',@tecla);
editprop(6)=uicontrol(panelfis,'Units','pixels','Position',[30,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).vectorIz(1)),'KeyPressFcn',@tecla);
editprop(7)=uicontrol(panelfis,'Units','pixels','Position',[110,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).vectorIz(2)),'KeyPressFcn',@tecla);
editprop(8)=uicontrol(panelfis,'Units','pixels','Position',[190,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).vectorIz(3)),'KeyPressFcn',@tecla);
editprop(9)=uicontrol(panelfis,'Units','pixels','Position',[130,50,110,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(barres(n).Mp),'KeyPressFcn',@tecla);

uiwait(f) % Atura l'execuci de Matlab fins que es tanqui la finestra i es retornin les dades. Necesari per tal de que es retornin les dades corrctament.

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BUT ACCEPTAR.
% Llegeix les dades de les caixes de texte per retornarles i tanca la finestra.

    function acceptar(hObject, eventdata, handles)
        barres(n).nusinf=get(popupnusinf,'Value');
        barres(n).nussup=get(popupnussup,'Value');
        barres(n).artinf=get(checkartinf,'Value');
        barres(n).artsup=get(checkartsup,'Value');
        barres(n).E=str2double(get(editprop(1),'String'));
        barres(n).A=str2double(get(editprop(2),'String'));
        barres(n).Iz=str2double(get(editprop(3),'String'));
        barres(n).Iy=str2double(get(editprop(4),'String'));
        barres(n).GIt=str2double(get(editprop(5),'String'));
        barres(n).Mp=str2double(get(editprop(9),'String'));
        barres(n).vectorIz=[str2double(get(editprop(6),'String')),str2double(get(editprop(7),'String')),str2double(get(editprop(8),'String'))];
        barres(n).color=get(buttoncolor,'Backgroundcolor');
        
        close(f)
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BOT CANCELLAR.
% Tanca la finestra sense actualitzar les dades.

    function cancelar(hObject, eventdata, handles)
        close(f)
    end
    function importar(hObject,eventdata,handles)
        m=get(popupperfil,'Value');
        set(editprop(1),'String',num2str(barres(m).E));
        set(editprop(2),'String',num2str(barres(m).A));
        set(editprop(3),'String',num2str(barres(m).Iz));
        set(editprop(4),'String',num2str(barres(m).Iy));
        set(editprop(5),'String',num2str(barres(m).GIt));
        set(editprop(9),'String',num2str(barres(m).Mp));
        set(buttoncolor,'Backgroundcolor',barres(m).color);
    end

%% FUNCI QUE S'EXECUTA AL CLICAR EL BOT DE CANVI DE COLOR.

    function color(hObject,eventdata,handles)
        c=uisetcolor(barres(n).color); % Obre la finestra de Matlab per seleccionar color.
        set(buttoncolor,'Backgroundcolor',c); % Li dona el color seleccionat al bot.
    end

%% FUNCI QUE S'EXECUTA AL PREMER ALGUNA TECLA.
% Si es prem el retorn surt actualitzant les dades, si es prem escapament surt sense actualitzar.

    function tecla(hObject,eventdata,handles)
        switch eventdata.Key
            case 'escape'
                cancelar
            case 'return'
                uicontrol(hObject)
                acceptar
        end
    end
end
