% Funci dlgcarregabarra per a Clcul Matricial d'Estructures 2 (CME2).
%
% Per Sergio Guerrero Miralles, darrera versi 24 de maig de 2.012.
%
% Crea una finestra per introduir-hi o modificar les crregues sobre les barres.
%
% Entrada:
% - bar: objecte tipus barra on s'emmagatzemen les propietats i les crregues de la barra als segents camps:
% + num: Nmero de barra.
% + nusinf: Nmero de nus inferior.
% + nussup: Nmero de nus superior.
% + puntual: Crrega puntual: mdul, vector direcci x,y,z i  distncia al nus inferior.
% + moment: Moment aplicat a la barra: mdul, vector direcci x,y,z i  distncia al nus inferior.
% + repartida: Crrega repartida: mdul, vector direcci x,y,z i distncies al nus inferior i superior.
% + projectada: Crrega repartida peojectada: mdul, vector direcci x,y,z i distncies al nus inferior i superior.
%
% Sortida:
% - bar: Igual que la entrada per convenientment modificades les crregues de la barra editada.

function bar = dlgcarregabarra(bar)
%% CREA LA FINESTRA, ELS PANELLS I ELS BOTONS.

tamanycme2=get(gcf,'Position');
tm=[330,545];
sc=(tamanycme2(3:4)-tm(1:2))/2+tamanycme2(1:2);
bg=get(0,'defaultUicontrolBackgroundColor');
f = figure('Units','pixels','Position',[sc,tm],'NumberTitle','off','Name',['Crrega sobre la barra n: ',num2str(bar.num)],'Toolbar','none','Menubar','none','Resize','off','WindowStyle','modal','color',bg,'KeyPressFcn',@tecla);
panelpunt=uipanel(f,'Units','pixels','Position',[5 435 320 105],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Crrega puntual:'); % Panell crregues puntuals
panelmom=uipanel(f,'Units','pixels','Position',[5 325 320 105],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Moment:'); % Panell moments
panelrep=uipanel(f,'Units','pixels','Position',[5 185 320 135],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Crregues repartides sobre la barra:'); % Panell crregues repartides
panelproj=uipanel(f,'Units','pixels','Position',[5 45 320 135],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Crregues repartides projectades:'); % Panell crregues projectades
uicontrol(f,'Units','pixels','Position',[5,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Acceptar','Callback',@acceptar); % Bot acceptar
uicontrol(f,'Units','pixels','Position',[215,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Cancellar','Callback',@cancelar); % Bot cancelar

%% CREA ETIQUETES I CAIXES DE TEXTE ALS PANELLS

txti=['Distncia al nus n ',num2str(bar.nusinf),':'];
txts=['Distncia al nus n ',num2str(bar.nussup),':'];
strlabel={'Mdul:','x:','y:','z:',txti,txts};
poslabel=[5,35,70,20;115,5,15,20;185,5,15,20;255,5,15,20;5,65,150,20;5,95,150,20];
posedit=[200,35,115,20;130,5,45,20;200,5,45,20;270,5,45,20;200,65,115,20;200,95,115,20];

editpunt=zeros(1,5);
editmom=editpunt;
for i=1:5
    uicontrol(panelpunt,'Units','pixels','Position',poslabel(i,1:4),'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',strlabel(i));
    uicontrol(panelmom,'Units','pixels','Position',poslabel(i,1:4),'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',strlabel(i));
    editpunt(i)=uicontrol(panelpunt,'Units','pixels','Position',posedit(i,1:4),'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(bar.puntual(i)),'KeyPressFcn',@tecla);
    editmom(i)=uicontrol(panelmom,'Units','pixels','Position',posedit(i,1:4),'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(bar.moment(i)),'KeyPressFcn',@tecla);
end
uicontrol(panelpunt,'Units','pixels','Position',[5,5,110,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector direcci:');
uicontrol(panelmom,'Units','pixels','Position',[5,5,110,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector direcci:');

editrep=zeros(1,6);
editproj=editrep;
for i=1:6
    uicontrol(panelrep,'Units','pixels','Position',poslabel(i,1:4),'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',strlabel(i));
    uicontrol(panelproj,'Units','pixels','Position',poslabel(i,1:4),'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',strlabel(i));
    editrep(i)=uicontrol(panelrep,'Units','pixels','Position',posedit(i,1:4),'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(bar.repartida(i)),'KeyPressFcn',@tecla);
    editproj(i)=uicontrol(panelproj,'Units','pixels','Position',posedit(i,1:4),'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(bar.projectada(i)),'KeyPressFcn',@tecla);
end
uicontrol(panelrep,'Units','pixels','Position',[5,5,110,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector direcci:');
uicontrol(panelproj,'Units','pixels','Position',[5,5,110,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector direcci:');

uiwait(f) % Atura l'execuci de Matlab fins que es tanqui la finestra i es retornin les dades. Necesari per tal de que es retornin les dades corrctament.

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BOT ACCEPTAR.
% Llegeix les dades de les caixes de texte per retornarles i tanca la finestra.

    function acceptar(hObject, eventdata, handles)
        for j=1:5
            bar.puntual(j)=str2double(get(editpunt(j),'String'));
            bar.moment(j)=str2double(get(editmom(j),'String'));
            bar.repartida(j)=str2double(get(editrep(j),'String'));
            bar.projectada(j)=str2double(get(editproj(j),'String'));
        end
        bar.repartida(6)=str2double(get(editrep(6),'String'));
        bar.projectada(6)=str2double(get(editproj(6),'String'));
        
        close(f)
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BOT CANCELLAR.
% Tanca la finestra sense actualitzar les dades.

    function cancelar(hObject, eventdata, handles)
        close(f)
    end

%% FUNCI QUE S'EXECUTA AL PREMER ALGUNA TECLA.
% Si es prem el retorn surt actualitzant les dades, si es prem escapament surt sense actualitzar.

    function tecla(hObject,eventdata,handles)
        switch eventdata.Key
            case 'escape'
                cancelar
            case 'return'
                uicontrol(hObject)
                acceptar
        end
    end
end
