% Funci dlgcarreganus per a Clcul Matricial d'Estructures 2 (CME2).
%
% Per Sergio Guerrero Miralles, darrera versi 24 de maig de 2.012.
%
% Crea una finestra per introduir-hi o modificar les crregues sobre les barres.
%
% Entrada:
% - n: objecte tipus nus on s'emmagatzemen les propietats i les crregues del nus als segents camps:
% + num: Nmero de barra.
% + puntual: Crrega puntual aplicada al nus.
% + moment: Moments aplicats al nus.
%
% Sortida:
% - n: Igual que la entrada per convenientment modificades les crregues del nus editat.

function n = dlgcarreganus(n)
%% CREA LA FINESTRA, ELS PANELLS I ELS BOTONS.

tamanycme2=get(gcf,'Position');
tm=[255,265];
sc=(tamanycme2(3:4)-tm(1:2))/2+tamanycme2(1:2);
bg=get(0,'defaultUicontrolBackgroundColor');
f = figure('Units','pixels','Position',[sc,tm],'NumberTitle','off','Name',['Crrega al nus n: ',num2str(n.num)],'Toolbar','none','Menubar','none','Resize','off','WindowStyle','modal','color',bg,'KeyPressFcn',@tecla);
panelpunt=uipanel(f,'Units','pixels','Position',[5 155 245 105],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Crregues puntuals:'); % Panell per introdur forces.
panelmom=uipanel(f,'Units','pixels','Position',[5 45 245 105],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Moments:'); % Panell per introduir moments.
uicontrol(f,'Units','pixels','Position',[5,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Acceptar','Callback',@acceptar); % Bot acceptar.
uicontrol(f,'Units','pixels','Position',[140,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Cancellar','Callback',@cancelar); % Bot cancelar.

%% ETIQUETES I CAIXES DE TEXTE DEL PANELL PER INTRODUR MOMENTS

uicontrol(panelmom,'Units','pixels','Position',[5,65,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Mx=');
uicontrol(panelmom,'Units','pixels','Position',[5,35,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','My=');
uicontrol(panelmom,'Units','pixels','Position',[5,5,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Mz=');
editmom(1)=uicontrol(panelmom,'Units','pixels','Position',[40,65,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.moment(1)),'KeyPressFcn',@tecla);
editmom(2)=uicontrol(panelmom,'Units','pixels','Position',[40,35,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.moment(2)),'KeyPressFcn',@tecla);
editmom(3)=uicontrol(panelmom,'Units','pixels','Position',[40,5,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.moment(3)),'KeyPressFcn',@tecla);

%% ETIQUETES I CAIXES DE TEXTE DEL PANELL PER INTRODUR FORCES

uicontrol(panelpunt,'Units','pixels','Position',[5,65,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Fx=');
uicontrol(panelpunt,'Units','pixels','Position',[5,35,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Fy=');
uicontrol(panelpunt,'Units','pixels','Position',[5,5,35,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Fz=');
editpunt(1)=uicontrol(panelpunt,'Units','pixels','Position',[40,65,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.puntual(1)),'KeyPressFcn',@tecla);
editpunt(2)=uicontrol(panelpunt,'Units','pixels','Position',[40,35,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.puntual(2)),'KeyPressFcn',@tecla);
editpunt(3)=uicontrol(panelpunt,'Units','pixels','Position',[40,5,200,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.puntual(3)),'KeyPressFcn',@tecla);

uiwait(f) % Atura l'execuci de Matlab fins que es tanqui la finestra i es retornin les dades. Necesari per tal de que es retornin les dades corrctament.

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BUT ACCEPTAR.
% Llegeix les dades de les caixes de texte per retornarles i tanca la finestra.

    function acceptar(hObject, eventdata, handles)
        for j=1:3
            n.puntual(j)=str2double(get(editpunt(j),'String'));
            n.moment(j)=str2double(get(editmom(j),'String'));
        end
        
        close(f)
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BUT CANCELLAR.
% Tanca la finestra sense actualitzar les dades.

    function cancelar(hObject, eventdata, handles)
        close(f)
    end

%% FUNCI QUE S'EXECUTA AL PREMER ALGUNA TECLA.
% Si es prem el retorn surt actualitzant les dades, si es prem escapament surt sense actualitzar.

    function tecla(hObject,eventdata,handles)
        switch eventdata.Key
            case 'escape'
                cancelar
            case 'return'
                uicontrol(hObject)
                acceptar
        end
    end
end
