% Funci dlgnus per a Clcul Matricial d'Estructures 2 (CME2).
%
% Per Sergio Guerrero Miralles, darrera versi 24 de maig de 2.012.
%
% Crea una finestra per introduir-hi o modificar les dades dels nusos.
%
% Entrada:
% - n: objecte tipus nus on s'emmagatzemen les dades del nus als segents camps:
% + num: Nmero de nus.
% + posicio: Posici a l'espai.
% + contorn: Tipus de condici de contorn.
% + rodet: Vector normal al plnol de moviment del rodet, si n'hi ha.
% + desp: desplaaments forats si n'hi han.
% + rig: rigideses de contorn elstic si n'hi ha.
%
% Sortida:
% - n: Igual que l'entrada per convenientment modificades les dades del nus editat.

function n = dlgnus(n)
%% CREA LA FINESTRA, ELS PANELLS I ELS BOTONS.

tamanycme2=get(gcf,'Position');
tm=[255,205];
sc=(tamanycme2(3:4)-tm(1:2))/2+tamanycme2(1:2);
bg=get(0,'defaultUicontrolBackgroundColor');
f = figure('Units','pixels','Position',[sc,tm],'NumberTitle','off','Name',['Nus n: ',num2str(n.num)],'Toolbar','none','Menubar','none','Resize','off','WindowStyle','modal','color',bg,'KeyPressFcn',@tecla);
panelpos=uipanel(f,'Units','pixels','Position',[5 155 245 45],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Posici:');
panelcontorn=uipanel(f,'Units','pixels','Position',[5 45 245 105],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Condici de contorn:');
uicontrol(f,'Units','pixels','Position',[5,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Acceptar','Callback',@acceptar);
uicontrol(f,'Units','pixels','Position',[140,10,110,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Cancellar','Callback',@cancelar);

%% CREA ELS CONTROLS AL PANELL SUPERIOR AMB INFORMACI DE LA POSICI.

uicontrol(panelpos,'Units','pixels','Position',[5,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','X:'); % Etiqueta.
uicontrol(panelpos,'Units','pixels','Position',[85,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Y:'); % Etiqueta.
uicontrol(panelpos,'Units','pixels','Position',[165,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Z:'); % Etiqueta.
editpos(1)=uicontrol(panelpos,'Units','pixels','Position',[35,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.posicio(1)),'KeyPressFcn',@tecla); % Caixa de text coordenada x.
editpos(2)=uicontrol(panelpos,'Units','pixels','Position',[115,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.posicio(2)),'KeyPressFcn',@tecla); % Caixa de text coordenada y.
editpos(3)=uicontrol(panelpos,'Units','pixels','Position',[195,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.posicio(3)),'KeyPressFcn',@tecla); % Caixa de text coordenada z.

%% CREA ELS CONTROLS AL PANELL INFERIOR AMB INFORMACI DE LES CONDICIONS DE CONTORN.

popupcontorn=uicontrol(panelcontorn,'Units','pixels','Position',[5,65,235,20],'Style','popupmenu','FontName','default','FontUnits','pixels','FontSize',14,'BackgroundColor','white','Callback',@select_contorn,'Value',n.contorn+1,'String',{'Nus lliure','Rodet inclinat','Recolzament simple','Encastament','Desplaaments elstics i girs lliures','Girs elstics i desplaaments nuls','Desplaaments i girs elstics','Desplaaments imposats i girs lliures','Girs imposats i desplaaments lliures','Desplaaments i girs imposats'}); % Llista selecci condici de contorn.

labelrodet(1)=uicontrol(panelcontorn,'Units','pixels','Position',[5,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','x:','Visible','off');
labelrodet(2)=uicontrol(panelcontorn,'Units','pixels','Position',[85,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','y:','Visible','off');
labelrodet(3)=uicontrol(panelcontorn,'Units','pixels','Position',[165,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','z:','Visible','off');
labelrodet(4)=uicontrol(panelcontorn,'Units','pixels','Position',[5,27.5,236,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Vector perpendicular al pla del rodet:','Visible','off');
editrodet(1)=uicontrol(panelcontorn,'Units','pixels','Position',[35,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rodet(1)),'Visible','off','KeyPressFcn',@tecla);
editrodet(2)=uicontrol(panelcontorn,'Units','pixels','Position',[115,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rodet(2)),'Visible','off','KeyPressFcn',@tecla);
editrodet(3)=uicontrol(panelcontorn,'Units','pixels','Position',[195,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rodet(3)),'Visible','off','KeyPressFcn',@tecla);

labelrigdesp(1)=uicontrol(panelcontorn,'Units','pixels','Position',[5,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Kx:','Visible','off');
labelrigdesp(2)=uicontrol(panelcontorn,'Units','pixels','Position',[85,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Ky:','Visible','off');
labelrigdesp(3)=uicontrol(panelcontorn,'Units','pixels','Position',[165,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Kz:','Visible','off');
labelriggirs(1)=uicontrol(panelcontorn,'Units','pixels','Position',[5,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Kx:','Visible','off');
labelriggirs(2)=uicontrol(panelcontorn,'Units','pixels','Position',[85,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Ky:','Visible','off');
labelriggirs(3)=uicontrol(panelcontorn,'Units','pixels','Position',[165,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Kz:','Visible','off');

editrigdesp(1)=uicontrol(panelcontorn,'Units','pixels','Position',[35,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(1)),'Visible','off','KeyPressFcn',@tecla);
editrigdesp(2)=uicontrol(panelcontorn,'Units','pixels','Position',[115,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(2)),'Visible','off','KeyPressFcn',@tecla);
editrigdesp(3)=uicontrol(panelcontorn,'Units','pixels','Position',[195,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(3)),'Visible','off','KeyPressFcn',@tecla);
editriggirs(1)=uicontrol(panelcontorn,'Units','pixels','Position',[35,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(4)),'Visible','off','KeyPressFcn',@tecla);
editriggirs(2)=uicontrol(panelcontorn,'Units','pixels','Position',[115,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(5)),'Visible','off','KeyPressFcn',@tecla);
editriggirs(3)=uicontrol(panelcontorn,'Units','pixels','Position',[195,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.rig(6)),'Visible','off','KeyPressFcn',@tecla);

labeldesp(1)=uicontrol(panelcontorn,'Units','pixels','Position',[5,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','dx:','Visible','off');
labeldesp(2)=uicontrol(panelcontorn,'Units','pixels','Position',[85,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','dy:','Visible','off');
labeldesp(3)=uicontrol(panelcontorn,'Units','pixels','Position',[165,30,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','dz:','Visible','off');
labelgirs(1)=uicontrol(panelcontorn,'Units','pixels','Position',[5,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','x:','Visible','off');
labelgirs(2)=uicontrol(panelcontorn,'Units','pixels','Position',[85,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','y:','Visible','off');
labelgirs(3)=uicontrol(panelcontorn,'Units','pixels','Position',[165,5,30,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','z:','Visible','off');

editdesp(1)=uicontrol(panelcontorn,'Units','pixels','Position',[35,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(1)),'Visible','off','KeyPressFcn',@tecla);
editdesp(2)=uicontrol(panelcontorn,'Units','pixels','Position',[115,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(2)),'Visible','off','KeyPressFcn',@tecla);
editdesp(3)=uicontrol(panelcontorn,'Units','pixels','Position',[195,30,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(3)),'Visible','off','KeyPressFcn',@tecla);
editgirs(1)=uicontrol(panelcontorn,'Units','pixels','Position',[35,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(4)),'Visible','off','KeyPressFcn',@tecla);
editgirs(2)=uicontrol(panelcontorn,'Units','pixels','Position',[115,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(5)),'Visible','off','KeyPressFcn',@tecla);
editgirs(3)=uicontrol(panelcontorn,'Units','pixels','Position',[195,5,45,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(n.desp(6)),'Visible','off','KeyPressFcn',@tecla);

select_contorn

uiwait(f) % Atura l'execuci de Matlab fins que es tanqui la finestra i es retornin les dades. Necesari per tal de que es retornin les dades corrctament.


%% FUNCI QUE S'EXECUTAR QUAN ES SELECCIONI EL TIPUS DE CONTORN
% la condici de contorn. Fa visibles o invisibles les etiquetes i les
% caixes de texte segons la condici triada.

    function select_contorn(hObject,eventdata,handles)
    switch (get(popupcontorn,'Value')-1)
        case 1
            set([editrodet,labelrodet],'Visible','on')
            set([editdesp,editgirs,editrigdesp,editriggirs,labeldesp,labelgirs,labelrigdesp,labelriggirs],'Visible','off')
        case 4
            set([editrodet,editdesp,editgirs,labelrodet,labeldesp,labelgirs],'Visible','off')
            set([labelrigdesp,labelriggirs,editrigdesp,editriggirs],'Visible','on')
            set(editrigdesp,'Enable','on')
            set(editriggirs,'Enable','off')
        case 5
            set([editrodet,editdesp,editgirs,labelrodet,labeldesp,labelgirs],'Visible','off')
            set([labelrigdesp,labelriggirs,editrigdesp,editriggirs],'Visible','on')
            set(editrigdesp,'Enable','off')
            set(editriggirs,'Enable','on')
        case 6
            set([editrodet,editdesp,editgirs,labelrodet,labeldesp,labelgirs],'Visible','off')
            set([labelrigdesp,labelriggirs,editrigdesp,editriggirs],'Visible','on')
            set([editrigdesp,editriggirs],'Enable','on')
        case 7
            set([editrodet,editrigdesp,editriggirs,labelrodet,labelrigdesp,labelriggirs],'Visible','off')
            set([labeldesp,labelgirs,editdesp,editgirs],'Visible','on')
            set(editdesp,'Enable','on')
            set(editgirs,'Enable','off')
        case 8
            set([editrodet,editrigdesp,editriggirs,labelrodet,labelrigdesp,labelriggirs],'Visible','off')
            set([labeldesp,labelgirs,editdesp,editgirs],'Visible','on')
            set(editdesp,'Enable','off')
            set(editgirs,'Enable','on')
        case 9
            set([editrodet,editrigdesp,editriggirs,labelrodet,labelrigdesp,labelriggirs],'Visible','off')
            set([labeldesp,labelgirs,editdesp,editgirs],'Visible','on')
            set([editdesp,editgirs],'Enable','on')
        otherwise
            set([editrodet,editrigdesp,editriggirs,labelrodet,labelrigdesp,labelriggirs,labeldesp,labelgirs,editdesp,editgirs],'Visible','off')
    end
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BOT ACCEPTAR.
% Llegeix les dades de les caixes de texte per retornarles i tanca la finestra.

    function acceptar(hObject, eventdata, handles)
        for j=1:3
            n.posicio(j)=str2double(get(editpos(j),'String'));
            n.rodet(j)=str2double(get(editrodet(j),'String'));
            n.desp(j)=str2double(get(editdesp(j),'String'));
            n.desp(j+3)=str2double(get(editgirs(j),'String'));
            n.rig(j)=str2double(get(editrigdesp(j),'String'));
            n.rig(j+3)=str2double(get(editriggirs(j),'String'));
        end
        n.contorn=get(popupcontorn,'Value')-1;
        close(f)
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BOT CANCELLAR.
% Tanca la finestra sense actualitzar les dades.

    function cancelar(hObject, eventdata, handles)
        close(f)
    end

%% FUNCI QUE S'EXECUTA AL PREMER ALGUNA TECLA.
% Si es prem el retorn surt actualitzant les dades, si es prem escapament surt sense actualitzar.

    function tecla(hObject,eventdata,handles)
        switch eventdata.Key
            case 'escape'
                cancelar
            case 'return'
                uicontrol(hObject)
                acceptar
        end
    end
end
