% Funci dlgopcions per a Clcul Matricial d'Estructures 2 (CME2).
%
% Per Sergio Guerrero Miralles, darrera versi 24 de maig de 2.012.
%
% Crea una finestra per introduir-hi o modificar les opcions del programa.
%
% Carrega les opcions de l'arxiu opcions.mat, si no existeix fa servir per defecte.
% Al sortit guarda les opcions al mateix arxiu, no permet cancelar si l'arxiu no existeix.


function dlgopcions
%% CREA LA FINESTRA, ELS PANELLS I ELS BOTONS.
set(0,'Units','pixels') % Per obtenir el tamany de la pantalla en pixels i no en cap altre messura extraa.
sc=get(0,'ScreenSize'); % Obt el tamany de la pantalla.
tm=[500,565]; % Tamany de la finestra.
sc=(sc(3:4)-tm(1:2))/2+sc(1:2); % Posici de la finestra al centre de la pantalla.
bg=get(0,'defaultUicontrolBackgroundColor'); % Color de fons per defecte.

f=figure('Units','pixels','Position',[sc,tm],'NumberTitle','off','Name','Opcions','WindowStyle','modal','color',bg,'CloseRequestFcn',@tancar,'KeyPressFcn',@tecla); % Crea la finestra principal del programa.
panelopcions=uipanel(f,'Units','pixels','Position',[5 485 490 75],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Opcions:');
paneldir=uipanel(f,'Units','pixels','Position',[5 430 490 50],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Carpeta on guardar i carregar:');
panelfonts=uipanel(f,'Units','pixels','Position',[5 350 490 75],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Fonts:');
panelcolors=uipanel(f,'Units','pixels','Position',[5 45 240 300],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Colors:');
panelescala=uipanel(f,'Units','pixels','Position',[255 45 240 300],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Escala:');
uicontrol(f,'Units','pixels','Position',[65,5,120,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Acceptar','Callback',@acceptar); % Bot acceptar.
uicontrol(f,'Units','pixels','Position',[315,5,120,30],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Cancellar','Callback',@cancelar); % Bot cancelar.

%% PANELL OPCIONS

checkedit=uicontrol(panelopcions,'Units','pixels','Position',[5,30,480,20],'Style','checkbox','FontName','default','FontUnits','pixels','FontSize',14,'String','Editar nusos i barres desprs de crear-los','KeyPressFcn',@tecla);
checkautobar=uicontrol(panelopcions,'Units','pixels','Position',[5,5,480,20],'Style','checkbox','FontName','default','FontUnits','pixels','FontSize',14,'String','Al crear un nus unir-lo automaticament amb l''anterior amb una barra','KeyPressFcn',@tecla);

%% PANELL CARPETA

editdir=uicontrol(paneldir,'Units','pixels','Position',[5,5,400,25],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','BackgroundColor','white','KeyPressFcn',@tecla);
uicontrol(paneldir,'Units','pixels','Position',[405,5,80,25],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Explorar','Callback',@dir,'KeyPressFcn',@tecla);

%% PANELL FONTS

uicontrol(panelfonts,'Units','pixels','Position',[5,30,100,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Font nusos:');
uicontrol(panelfonts,'Units','pixels','Position',[5,5,100,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Font forces:');
buttonfont(1)=uicontrol(panelfonts,'Units','pixels','Position',[105,30,380,25],'Style','pushbutton','HorizontalAlignment','right','Callback',@font,'KeyPressFcn',@tecla);
buttonfont(2)=uicontrol(panelfonts,'Units','pixels','Position',[105,5,380,25],'Style','pushbutton','HorizontalAlignment','right','Callback',@font,'KeyPressFcn',@tecla);

%% PANELL COLORS

txtcolor={'Crregues:','Reaccions:','Deformada:','Diagrama N:','Diagrama Ty:','Diagrama Tz:','Diagrama Mx:','Diagrama My:','Diagrama Mz:','Modificar:','Esborrar:'};
buttoncolor=zeros(1,11);
for i=1:11
    uicontrol(panelcolors,'Units','pixels','Position',[5,5+25*(11-i),100,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',txtcolor(i));
    buttoncolor(i)=uicontrol(panelcolors,'Units','pixels','Position',[105,5+25*(11-i),130,20],'Style','pushbutton','Callback',@color,'KeyPressFcn',@tecla);
end

%% PANELL ESCALA

txtescala={'Factor de zoom:','Escala nusos i forces:','Separaci n nus:','Precisi inicial:','X mnima inicial:','X mxima inicial:','Y mnima inicial:','Y mxima inicial:','Z mnima inicial:','Z mxima inicial:'};
editescala=zeros(1,10);
for i=1:10
    uicontrol(panelescala,'Units','pixels','Position',[5,5+25*(11-i),150,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String',txtescala(i));
    editescala(i)=uicontrol(panelescala,'Units','pixels','Position',[155,5+25*(11-i),80,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','KeyPressFcn',@tecla);
end

%% CRREGA DE DADES

if exist('opcions.mat','file')==2 % Si existeix l'arxiu opcions.mat el carrega.
    load('opcions.mat')
else % Valors per defecte si no troba l'arxiu amb les opcions guardades.
    editalcrear=0;
    barraalcrearnus=0;
    fontnusos='Times New Roman';
    tamanyfontnusos=20;
    fontcarregues='SansSerif';
    tamanyfontcarregues=16;
    factorzoom=10;
    tamanynus=100;
    distnumnus=0.35;
    precini=0.5;
    XLimini=[-5,5];
    YLimini=[-2.5,2.5];
    ZLimini=[-5,5];
    colormodificar=[0,1,1]; % Cian
    coloresborrar=[1,0,0]; % Vermell
    colorcarregues=[.5,0,0];
    colorreaccions=[0,.5,0];
    colordeformada=[0.078431372549020,0.168627450980392,0.549019607843137];
    colorN=[0.043137254901961,0.517647058823530,0.780392156862745];
    colorTy=[.5,0,1];
    colorTz=[1,.25,.5];
    colorMx=[1,1,0];
    colorMy=[.875,.625,.25];
    colorMz=[1,0,0];
    direst='Exemples';
end

if exist(direst,'dir')==7 % Comproba si existeix la carpeta.
    set(editdir,'String',direst);
else % Si no existeix el directori, el canvia pel directori per defecte de Matlab.
    direst=matlabroot;
    set(editdir,'String',direst);
end
colors=[colorcarregues;colorreaccions;colordeformada;colorN;colorTy;colorTz;colorMx;colorMy;colorMz;colormodificar;coloresborrar]; % Carrega els colors als botons.
for i=1:11
    set(buttoncolor(i),'Backgroundcolor',colors(i,:));
end

% Carrega les dades a les caixes i botons corresponents.
set(checkedit,'Value',editalcrear);
set(checkautobar,'Value',barraalcrearnus);
set(buttonfont(1),'String',[fontnusos,' ',num2str(tamanyfontnusos)],'UserData',tamanyfontnusos,'FontName',fontnusos,'FontUnits','pixels','FontSize',14);
set(buttonfont(2),'String',[fontcarregues,' ',num2str(tamanyfontcarregues)],'UserData',tamanyfontcarregues,'FontName',fontcarregues,'FontUnits','pixels','FontSize',14);
set(editescala(1),'String',factorzoom);
set(editescala(2),'String',tamanynus);
set(editescala(3),'String',distnumnus);
set(editescala(4),'String',precini);
set(editescala(5),'String',XLimini(1));
set(editescala(6),'String',XLimini(2));
set(editescala(7),'String',YLimini(1));
set(editescala(8),'String',YLimini(2));
set(editescala(9),'String',ZLimini(1));
set(editescala(10),'String',ZLimini(2));

uiwait(f) % Atura l'execuci de Matlab fins que es tanqui la finestra i es retornin les dades. Necesari per tal de que es retornin les dades corrctament.

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BUT ACCEPTAR.
% Llegeix les dades de les caixes de texte, les guarda a l'arxiu opcions.mat i tanca la finestra.

    function acceptar(hObject, eventdata, handles)
        editalcrear=get(checkedit,'Value');
        barraalcrearnus=get(checkautobar,'Value');
        direst=get(editdir,'String');
        colorcarregues=get(buttoncolor(1),'Backgroundcolor');
        colorreaccions=get(buttoncolor(2),'Backgroundcolor');
        colordeformada=get(buttoncolor(3),'Backgroundcolor');
        colorN=get(buttoncolor(4),'Backgroundcolor');
        colorTy=get(buttoncolor(5),'Backgroundcolor');
        colorTz=get(buttoncolor(6),'Backgroundcolor');
        colorMx=get(buttoncolor(7),'Backgroundcolor');
        colorMy=get(buttoncolor(8),'Backgroundcolor');
        colorMz=get(buttoncolor(9),'Backgroundcolor');
        colormodificar=get(buttoncolor(10),'Backgroundcolor');
        coloresborrar=get(buttoncolor(11),'Backgroundcolor');
        
        fontnusos=get(buttonfont(1),'FontName');
        tamanyfontnusos=get(buttonfont(1),'UserData');
        fontcarregues=get(buttonfont(2),'FontName');
        tamanyfontcarregues=get(buttonfont(2),'UserData');

        factorzoom=str2double(get(editescala(1),'String'));
        tamanynus=str2double(get(editescala(2),'String'));
        distnumnus=str2double(get(editescala(3),'String'));
        precini=str2double(get(editescala(4),'String'));

        XLimini=[str2double(get(editescala(5),'String')),str2double(get(editescala(6),'String'))];
        YLimini=[str2double(get(editescala(7),'String')),str2double(get(editescala(8),'String'))];
        ZLimini=[str2double(get(editescala(8),'String')),str2double(get(editescala(10),'String'))];
        
        save('opcions','editalcrear','barraalcrearnus','fontnusos','tamanyfontnusos','fontcarregues','tamanyfontcarregues','factorzoom','tamanynus','distnumnus','precini','XLimini','YLimini','ZLimini','colormodificar','coloresborrar','colorcarregues','colorreaccions','colordeformada','colorN','colorTy','colorTz','colorMx','colorMy','colorMz','direst')
        
        close(f)
    end

%% FUNCI QUE S'EXECUTAR QUAN ES PETJI EL BUT CANCELLAR.
% Tanca la finestra sense actualitzar les dades.
% No es permet si no existeix l'arxiu opcions.mat.

    function cancelar(hObject,eventdata,handles)
        close(f)
    end
    function tancar(hObject,eventdata,handles)
        if exist('opcions.mat','file')==2
            delete(f)
        else
            return
        end
    end
    function dir(hObject,eventdata,handles)
        d=uigetdir(get(editdir,'String'));
        set(editdir,'String',d);
    end
    function font(hObject,eventdata,handles)
        fo=uisetfont(hObject);
        set(hObject,'String',[fo.FontName,' ',num2str(fo.FontSize)],'UserData',fo.FontSize,'FontName',fo.FontName,'FontUnits','pixels','FontSize',14);
    end
    function color(hObject,eventdata,handles)
        set(hObject,'Backgroundcolo',uisetcolor(get(hObject,'Backgroundcolor')))
    end

%% FUNCI QUE S'EXECUTA AL PREMER ALGUNA TECLA.
% Si es prem el retorn surt actualitzant les dades, si es prem escapament surt sense actualitzar.

    function tecla(hObject,eventdata,handles)
        switch eventdata.Key
            case 'escape'
                cancelar
            case 'return'
                uicontrol(hObject)
                acceptar
        end
    end
end

