%% REORDENACI DE NUSOS.

% CRIVATGE I REORDENACI D'ESFOROS/MOVIMENTS ALS NUSOS PER A LA
% CONSTRUCCI DE LA MATRIU DE RIGIDESA GLOBAL.
% Elimina girs de rtula i la tercera dimensi si la estructura s plana,
% agrupa els moviments prescrits per les condicions de contorn per tenir
% inscrita la Matriu Reduda dins de la Global.
% Genera la llista 'sistema' amb dimensi 6 * nmero de nusos amb l'ordre a la
% matriu de rigidesa global.

function [sistema,ns,nn,contorn]=reordenacio_nusos(Lnods,Lartyp,carrega_rep,carrega_rep_proj,carrega_punt,carrega_mom,Nextfor,Ncoord,Ncond,N,n)
moviment_sistema=ones(6*n,1); % moviments per defecte tots permesos.
nus_rotula=zeros(6*n,1);
forces=[0,0,0];
moments=[0,0,0];
for i=1:N % Per a totes les barres...
    n1=6*Lnods(i,1);
    n2=6*Lnods(i,2);
    if Lartyp(i,1)==0 % Si l'extrem inferior s rgid...
        nus_rotula(n1-5:n1)=[1,1,1,1,1,1]; % es tindran en compte els girs en x, y i z del nus inferior.
    else
        nus_rotula(n1-5:n1-3)=[1,1,1]; %si tots els extrems que arriben al nus son articulats no es tindr en compte a la Matriu de Rigidesa.
    end
    if Lartyp(i,2)==0 % Si l'extrem superior s rgid...
        nus_rotula(n2-5:n2)=[1,1,1,1,1,1]; % es tindran en compte els girs en x, y i z del nus inferior.
    else
        nus_rotula(n2-5:n2-3)=[1,1,1]; %si tots els extrems que arriben al nus son articulats no es tindr en compte a la Matriu de Rigidesa.
    end
    forces=forces|(carrega_rep(i,1)*carrega_rep(i,2:4))|carrega_rep_proj(i,1)*carrega_rep_proj(i,2:4)|carrega_punt(i,1)*carrega_punt(i,2:4); % Direcci forces aplicades a les barres.
    moments=moments|carrega_mom(i,1)*carrega_mom(i,2:4); % Direcci moments aplicats a les barres.
end
for i=1:n % Per a tots els nusos...
    forces=forces|Nextfor(6*i-5:6*i-3)'; % Direcci forces a tota l'estructura.
    moments=moments|Nextfor(6*i-2:6*i)'; % Direcci moments a tota l'estructura.
    if Ncond(i,1)==1 % Rodet inclinat.
        forces=forces|Ncond(i,2:4); % El rodet inclinat introdueix reaccions normals al seu pla.
    end
    if Ncond(i,1)==7 || Ncond(i,1)==9 % Desplaaments imposats.
        forces=forces|Ncond(i,2:4);
    end
    if Ncond(i,1)==8 || Ncond(i,1)==9 % Girs imposats.
        moments=moments|Ncond(i,5:7);
    end
end
dimx=any(Ncoord(:,1)~=Ncoord(1,1)); % Si tots els nusos tenen la mateixa coordenada x dimx=0.
dimy=any(Ncoord(:,2)~=Ncoord(1,2)); % Si tots els nusos tenen la mateixa coordenada y dimy=0.
dimz=any(Ncoord(:,3)~=Ncoord(1,3)); % Si tots els nusos tenen la mateixa coordenada z dimz=0.
moviments=[0,0,0,0,0,0];
if dimx && ~dimy && ~dimz % Biga en eix X.
    if forces(1) % Forces en sentit longitudinal eix X.
        moviments=[1,0,0,0,0,0]; % Noms forces i moviments en eix X.
    end
    if moments(1) % Moments en eix X.
        moviments=[0,0,0,1,0,0];
    end
    if forces(2) || moments(3) % Forces transversals en eix Y.
        moviments=moviments | [0,1,0,0,0,1]; % Forces i moviments en eix Y i moments i girs en eix Z.
    end
    if forces(3) || moments(2) % Forces transversals en eix Z.
        moviments=moviments | [0,0,1,0,1,0]; % Forces i moviments en eix Z i moments i girs en eix Y.
    end
elseif ~dimx && dimy && ~dimz % Biga en eix Y.
    if forces(2) % Forces en sentit longitudinal eix Y.
        moviments=[0,1,0,0,0,0]; % Noms forces i moviments en eix Y.
    end
    if moments(2) % Moments en eix Y.
        moviments=[0,0,0,0,1,0];
    end
    if forces(1) || moments(3) % Forces transversals en eix X.
        moviments=moviments | [1,0,0,0,0,1]; % Forces i moviments en eix X i moments i girs en eix Z.
    end
    if forces(3) || moments(1) % Forces transversals en eix Z.
        moviments=moviments | [0,0,1,1,0,0]; % Forces i moviments en eix Z i moments i girs en eix X.
    end
elseif ~dimx && ~dimy && dimz % Biga en eix Z.
    if forces(3) % Forces en sentit longitudinal eix Z.
        moviments=[0,0,1,0,0,0]; % Noms forces i moviments en eix Z.
    end
    if moments(3) % Moments en eix Z.
        moviments=[0,0,0,0,0,1];
    end
    if forces(1) || moments(2) % Forces transversals en eix X.
        moviments=moviments | [1,0,0,0,1,0]; % Forces i moviments en eix X i moments i girs en eix Y.
    end
    if forces(2) || moments(1) % Forces transversals en eix Y.
        moviments=moviments | [0,1,0,1,0,0]; % Forces i moviments en eix Y i moments i girs en eix X.
    end
elseif dimx && dimy && ~dimz % Estructura plana XY.
    if ~forces(3) && ~moments(1) && ~moments(2) % Forces en el pla de l'estructura -> 2D.
        moviments=[1,1,0,0,0,1]; % Forces i moviments en eixos X i Y i moments i girs en eix Z.
    elseif ~forces(1) && ~forces(2) && ~moments(3) % Engraellat pla XY.
        moviments=[0,0,1,1,1,0]; % Forces i moviments en eix Z i moments i girs en eixos X i Y.
    else
        moviments=[1,1,1,1,1,1]; % Estructura 3D.
    end
elseif ~dimx && dimy && dimz % Estructura plana YZ.
    if ~forces(1) && ~moments(2) && ~moments(3) % Forces en el pla de l'estructura -> 2D.
        moviments=[0,1,1,1,0,0]; % Forces i moviments en eixos Y i Z i moments i girs en eix X.
    elseif ~forces(2) && ~forces(3) && ~moments(1) % Engraellat pla YZ.
        moviments=[1,0,0,0,1,1]; % Forces i moviments en eix X i moments i girs en eixos Y i Z.
    else
        moviments=[1,1,1,1,1,1]; % Estructura 3D.
    end
elseif dimx && ~dimy && dimz % Estructura plana XZ.
    if ~forces(2) && ~moments(1) && ~moments(3) % Forces en el pla de l'estructura -> 2D.
        moviments=[1,0,1,0,1,0]; % Forces i moviments en eixos X i Z i moments i girs en eix Y.
    elseif ~forces(1) && ~forces(3) && ~moments(2) % Engraellat pla XZ.
        moviments=[0,1,0,1,0,1]; % Forces i moviments en eix Y i moments i girs en eixos X i Z.
    else
        moviments=[1,1,1,1,1,1]; % Estructura 3D.
    end
else
    moviments=[1,1,1,1,1,1]; % Estructura 3D.
end
contorn=zeros(6*n,1);
for i=1:n % Per a tots els nusos, aplica les condicions de contorn.
    moviment_sistema(6*i-5:6*i)=moviments;
    switch Ncond(i,1)
        case 0 % Nus lliure
            contorn(6*i-5:6*i)=[1,1,1,1,1,1]; % No hi ha condici de contorn, no s'anula cap desplaament o gir.
        case 1 % Rodet inclinat
            contorn(6*i-5:6*i)=[0,1,1,1,1,1]; % S'anula el desplaament en x (correspon al vector perpendicular al pla del rodet als eixos locals del rodet).
            Tr=calcul_canvi_base(Ncond(i,2:4)); % Calcula matriu canvi de base del rodet.
            T=[Tr,zeros(3);zeros(3),Tr];
            %moviment_sistema(6*i-5:6*i)=T*moviment_sistema(6*i-5:6*i);
            %contorn(6*i-5:6*i)=T*contorn(6*i-5:6*i);
            
        case 2 % Recolzament simple
            contorn(6*i-5:6*i)=[0,0,0,1,1,1]; % S'anulen els moviments.
        case 3 % Encastament
            % contorn(6*i-5:6*i)=[0,0,0,0,0,0]; % S'anulen tots els moviments i girs.
        case 4 % Desplaaments elstics i girs lliures
            contorn(6*i-5:6*i)=[1,1,1,1,1,1]; % No s'anula cap desplaament o gir.
        case 5 % Girs elstics i desplaaments nuls
            contorn(6*i-5:6*i)=[0,0,0,1,1,1]; % S'anulen els desplaaments.
        case 6 % Desplaaments i girs elstics
            contorn(6*i-5:6*i)=[1,1,1,1,1,1]; % No s'anula cap desplaament o gir.
        case 7 % Desplaaments imposats i girs lliures
            contorn(6*i-5:6*i)=[0,0,0,1,1,1]; % S'anulen els desplaaments.
        case 8 % Girs imposats i desplaaments lliures
            contorn(6*i-5:6*i)=[1,1,1,0,0,0]; % S'anulen els girs.
        case 9 % Desplaaments i girs imposats
            %contorn(6*i-5:6*i)=[0,0,0,0,0,0]; % S'anulen tots els moviments i girs.
    end
end
moviment_sistema=moviment_sistema & nus_rotula; % Vector on per a cada moviment o gir s'indica si es tindra en compte o no en la construcci de la Matriu de Rigidesa.
contorn=contorn & moviment_sistema; % Vector on per a cada moviment o gir s'indica si s'anula per les condicions de contorn.
ns=sum(moviment_sistema);
nn=sum(contorn);
sistema=zeros(6*n,1);
j=1;
k=nn+1;
for i=1:6*n % Crea el vector sistema on s'enmagatzema en cada posici el nus corresponent ordenats per construr la Matriu de Rigidesa.
    if moviment_sistema(i)
        if contorn(i)
            sistema(i)=j;
            j=j+1;
        else
            sistema(i)=k;
            k=k+1;
        end
    end
end
end
