%               CLCUL MATRICIAL D'ESTRUCTURES 2.0 "AKA CME2"
%
% *************************************************************************
%                      CLCUL ESTTIC D'ESTRUCTURES
%                      PER SERGIO GUERRERO MIRALLES
% 
%     TREBALL DE FINAL DE CARRERA D'ENGINYERIA TCNICA D'OBRES PBLIQUES
%           UNIVERSITAT POLITCNICA DE CATALUNYA, CURS 2011-2012
%
% Creaci, edici, clcul esttic i mostra de resultats amb interfase
% grfica d'estructures de barres articulades i reticulades, 2D i 3D, amb
% carregues a les barres.
%
% *************************************************************************
%                    CLCUL PLSTIC D'ESTRUCTURES
%                       PER NGEL GUASCH DURAN
%
%     TESINA DE FINAL DE CARRERA D'ENGINYERIA DE CAMINS, CANALS I PORTS
%           UNIVERSITAT POLITCNICA DE CATALUNYA, CURS 2012-2013
%           
% Creaci del mdul de clcul plstic d'estructures de barres articulades
% i reticulades, 2D i 3D, modificaci de la interfase grfica per a la 
% correcta implementaci del mdul esttic i plstic. 
%    
% *************************************************************************
%               Darrera versi 23 d'octubre de 2013
       
function cme2()   
%% FUNCI QUE S'EXECUTA A L'INICI, DEFINICI DE L'ENTORN GRAFC:
clc;  
addpath ./Plastic % S'inclouen les carpetes on es troben els arxius corresponents al calcul plstic
addpath ./FuncionsComuns  % S'inclouen les carpetes on es troben els arxius compartits pel mdul esttic i el mdul plstic
addpath ./Info_met % S'inclouen la carpeta on es troben les funcions que s'executen al fer clic al bot d'informaci del panell d'inestabilitat
% Inicialitza variables del programa i carrega les opcions.
[nusos,contnus,barres,diagrames,hgreaccions,contbarra,vista,flagbarra,primernusbarra,artprimernusbarra,artnusant,hbarra,flagclic,flagmourenus,posini,flagcalculat,s,xmin,xmax,ymin,ymax,zmin,zmax,xm,ym,zm,xmed,ymed,zmed,angle3d,grafica,sD,mov_extrems,TL2G,Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,diag_presxy,diag_presxz,nom,fmax,qmax,contRotula,dadesRotules,numeroRotules,ecuacionesF,diagramesRotules,def2ord,deformada]=inicialitza_variables;
[editalcrear,barraalcrearnus,fontnusos,tamanyfontnusos,fontcarregues,tamanyfontcarregues,factorzoom,tamanynus,distnumnus,precini,XLimini,YLimini,ZLimini,colormodificar,coloresborrar,colorcarregues,colorreaccions,colordeformada,colorN,colorTy,colorTz,colorMx,colorMy,colorMz,direst]=loadopcions; % Carrega les opcions.

try
    actualpath=pwd;
    cd(direst);
    cd(actualpath);
catch
    direst=pwd;
end

[figcme2,tm,bg]=creacio_finestra; % Crea la finestra principal del programa.
[barraeines,botobarracrear,botobarramodificar,botobarraesborrar,botobarranus,botobarrabarra,botobarracarreganus,botobarracarregabarra,botobarrarotula,botobarramoure,botobarraapropar,botobarraallunyar,botoEdicio,botoCentrar,botoXY,botoXZ,botoYZ,boto3D]=creacio_barra_eines; % Crea la barra d'eines.
creacio_menus % Crea la barra de mens.
[panel1,logo,grafica_resxy,grafica_resxz,txtbox_res,grafica_est,editx,edity,editz,editprec]=creacio_panell_grafica; % Crea el panell amb les grafiques i les caixes amb les coordenades i la precisi.
%[panel2,botoedicio,botoxy,botoxz,botoyz,boto3d]=panell_botons_vista; % Crea el panel amb els botons que controlen les vistes i els modes d'edici/presentaci de resultats.
[panel3,botocarregues,botoreaccions,botodeformada,botoaxils,bototallantY,bototallantZ,botomomentX,botomomentY,botomomentZ]=panell_botons_grafica; % Panell amb els botons per seleccionar els elements que es mostrin en la presentaci de resultats.
[panelPlastic,panelResultats,factorTotalResultat,factorParcialResultat,numeroTotalRotula,numeroRotula,popupMenu,botoResultatsPlastics]=panell_botons_plastic(contRotula); %Crea el panell clcul plstic amb els corresponents botons.
[panelInest,text1Inest,popupInest,botoinformacio,text2Inest,numiter,text3Inest,numalpha1,text4Inest,numalpha2,text5Inest,nummu,panelres2ord,textsol2ord,popup2ord,botomodvincl]=panell_botons_inestabilitat; %Crea el panell clcul d'inestabilitat amb els corresponents botons.

def2ord=line(0,0,0,'Visible','off');

botocalcular1=boto_calcular; % Bot per executar el clcul.
[hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
[panel4,botoCalculEstatic,botoCalculDinamic,botoCalculPlastic,botoCalculInestabilitat]=panell_botons_calcul;



% Un cop creats els objectes, el programa espera la interacci amb l'usuari
% i executa les accions programades als diferents objectes.

%% CREACI I ACCIONS SOBRE LA FINESTRA PRINCIPAL, REDIMENSIONAMENT, CONTROL DEL RATOL I TECLAT, ETC:

    function [nusos,contnus,barres,diagrames,hgreaccions,contbarra,vista,flagbarra,primernusbarra,artprimernusbarra,artnusant,hbarra,flagclic,flagmourenus,posini,flagcalculat,s,xmin,xmax,ymin,ymax,zmin,zmax,xm,ym,zm,xmed,ymed,zmed,angle3d,grafica,sD,mov_extrems,TL2G,Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,diag_presxy,diag_presxz,nom,fmax,qmax,contRotula,dadesRotules,numeroRotules,ecuacionesF,diagramesRotules,def2ord,deformada]=inicialitza_variables
        % Funci que defineix les variables globals dels programa amb els
        % valors inicials. Aquestes variables sn accesibles dins de l'espai de
        % treball de la funci principal del programa i les seves sub-funcions.
        % Apareixen de color blau a l'editor de Matlab.
    
        nusos=nus.empty(1,0); % Llista de nusos.
        contnus=0; % Comptador de nusos.
        barres=barra.empty(1,0); % Llista de barres.
       
        dadesRotules=dadesRotula.empty(1,0); % Llista de dades asignada a cada rtula
        contRotula=0; % Comptador de rtules
        numeroRotules=0; % Variable per el popupmenu amb el numero de rotules
        ecuacionesF=struct; % Structure amb ecuacions generades ple clcul plstic
        diagramesRotules=[]; % Diagrames pertienents a les rtules, correspon al objecte grfic rtula
       
          
        contbarra=0; % Comptador de barres.
        diagrames=diagrama.empty(1,0); % Llista de diagrames (1 objecte diagrama per a cada barra).
        hgreaccions=[]; % Llista d'objectes grfics de reaccions.
        vista='xy'; % Mode de vista actual.
        flagbarra=0; % Flag que controla el proces de crear barres. S'activa quan s'ha clicat el primer nus a l'espera del segon.
        primernusbarra=0; % Primer nus clicat en el proces de crear barres.
        artprimernusbarra=0; % Estat del bot articulaci en el moment de clicar el primer nus d'una barra.
        artnusant=0; % Estat del bot articulaci en el moment de crear l'ultim nus creat.
        hbarra=0; % Linia temporal que representa la barra en construcci.
        flagclic=0; % Flag que indica si s'ha clicat un boto del ratoli i quin ha estat.
        flagmourenus=0; % Falg que indica a la funcio que detecta moviment del nus que s'ha clicat un nus amb el bot dret i s'ha de desplaar.
        posini=zeros(2,6); % Posicio inicial del ratoli al moure la pantalla.
        flagcalculat=0; % Flag que indica que hi ha una estructura calculada.
        s=0; % Factor d'escala per als objectes grfics que es mostren en pantalla: nusos, carregues, etc.
        xmin=[]; % Coordenada x minima de l'estructura.
        xmax=[]; % Coordenada x maxima de l'estructura.
        ymin=[]; % Coordenada y minima de l'estructura.
        ymax=[]; % Coordenada y maxima de l'estructura.
        zmin=[]; % Coordenada z minima de l'estructura.
        zmax=[]; % Coordenada z maxima de l'estructura.
        xmed=[]; % Mitjana de les coordenades x mnima i mxima de l'estructura.
        ymed=[]; % Mitjana de les coordenades y mnima i mxima de l'estructura.
        zmed=[]; % Mitjana de les coordenades z mnima i mxima de l'estructura.
        angle3d=0; % Angle de rotaci a la vista 3d.
        xm=0; % Mitjana de les coordenades x de l'estructura.
        ym=0; % Mitjana de les coordenades y de l'estructura.
        zm=0; % Mitjana de les coordenades z de l'estructura.
        grafica=0; % grafica que s'esta mostrant, grafica de l'estructura o grafiques de resultats detallats per barra.
        sD=1; % Escala de la deformada.
        mov_extrems=[]; % Moviments en extrems de barra en eixos locals.
        TL2G=[]; % Matrius de canvi de base de les barres.
        Retorn_reaccions=[]; % Reaccions en eixos globals.
        Retorn_moviments=[]; % Moviments en eixos locals.
        Retorn_esforcos_barres=[]; % Esforos en extrems de barra en eixos locals.
        diag_presxy=diagrama; % Objecte diagrama que conte els diagrames detallats per barra en xy.
        diag_presxz=diagrama; % Objecte diagrama que conte els diagrames detallats per barra en xz.
        nom=''; % Nom de l'estructura actual
        fmax=0; % Fora aplicada als nusos o puntual maxima.
        qmax=0; % Crrega repartida o projectada maxima.
        
        def2ord=[];
        deformada=[];
    end

    function [figcme2,tm,bg]=creacio_finestra
        % Creaci de la finestra:
        set(0,'Units','pixels') % Per obtenir el tamany de la pantalla en pixels i no en cap altre messura extraa.
        sc=get(0,'ScreenSize'); % Obt el tamany de la pantalla.
        tm=[1272 618]; % Tamany de la finestra a la pantalla.
        ps=(sc(3:4)-tm)/2-[0,18];% Posicio de la finestra, centrada a la pantalla.
        bg=get(0,'defaultUicontrolBackgroundColor'); % Obt el color de fons per defecte.
        figcme2=figure('Units','pixels','Position',[ps,tm],'NumberTitle','off','Name','Clcul Matricial dEstructures 2.0','Resize','on','color',bg,'Toolbar','figure','MenuBar','none','ResizeFcn',@figcme2_resize,'WindowButtonMotionFcn',@moviment_ratoli,'WindowButtonDownFcn',@clic_figure,'WindowButtonUpFcn',@unclic_figure,'WindowScrollWheelFcn',@roda_ratoli,'KeyPressFcn',@tecla,'CloseRequestFcn',@sortir); % Crea la finestra principal del programa.
    end

    function figcme2_rename
        if nom
            set(figcme2,'Name',['Clcul Matricial dEstructures 2.0 - ',nom])
        else
            set(figcme2,'Name','Clcul Matricial dEstructures 2.0')
        end 
    end
 
    function figcme2_resize(~,~,~)
    % Recoloca els panells quan es redimensiona la finestra principal del
    % programa.
        sc=get(figcme2,'Position'); % Posicio i tamany de la pantalla despres de redimensionar.
        tm=sc(3:4); % Tamany de la finestra a la pantalla.
        metres2ord=get(popupInest,'value');
        if tm(1)<500 % Limita el mnim horitzontal a 500 pxels.
            tm(1)=500;
            set(figcme2,'Position',[sc(1:2),tm]);
        end
        if tm(2)<425 % Limita el mnim Vertical a 425 pxels.
            sc(2)=sc(2)+tm(2)-425;
            tm(2)=425;
            set(figcme2,'Position',[sc(1:2),tm]);
        end
        if metres2ord==2
            if tm(2)<580
                sc(2)=sc(2)+tm(2)-580;
                tm(2)=580;
                set(figcme2,'Position',[sc(1:2),tm]);
            end
        end
        % Canvia posici i tamany dels panells i elements.
        set(panel1,'Position',[5,5,tm-[125,35]]); % Panell de la grafica.
        %set(panel2,'Position',[tm-[120,190],115,195]); % Panell dels botons de les vistes.
        set(panel3,'Position',[tm-[115,195],115,200]); % Panell dels botons de la grfica. 
        set(panelPlastic,'Position',[tm(1)-115,35,115,tm(2)-233]); % Panell de clcul plstic
            set(popupMenu,'Position',[5,tm(2)-458,100,200]); % Popup del panell de clcul plstic
            set(panelResultats,'Position',[5,tm(2)-423,105,130]); % Panell de resultats del calcul plstic
        set(panel4,'Position',[5,tm(2)-25,tm(1)-125,25]); % Panell dels botons de la grfica.
        set(botoCalculEstatic,'Position',[0,-1,(tm(1)-125)/4,25]); % Bot del Clcul Esttic
        set(botoCalculPlastic,'Position',[(tm(1)-125)/4,-1,(tm(1)-125)/4,25]); % Bot del Clcul Plstic
        set(botoCalculDinamic,'Position',[2*(tm(1)-125)/4,-1,(tm(1)-125)/4,25]); % Bot del Clcul Dinmic
        set(botoCalculInestabilitat,'Position',[3*(tm(1)-125)/4,-1,(tm(1)-125)/4,25]); % Bot del Clcul d'Inestabilitat
        set(panelInest,'Position',[tm(1)-115,235,115,tm(2)-233]); % Panell de clcul d'inestabilitat
            set(text1Inest,'Position',[5,tm(2)-330,100,70]); % Text 'Mtode de resoluci'
            set(popupInest,'Position',[5,tm(2)-340,100,35]); % Popup (selector) del mtode de resoluci
            set(botoinformacio,'Position',[5,tm(2)-355,100,25]); % Bot d'informaci pel mtode de resolucio
            set(text2Inest,'Position',[5,tm(2)-385,100,25]); % Text 'N d'iteracions
            set(numiter,'Position',[5,tm(2)-410,100,25]); % Editable pel nombre d'iteracions
            set(text3Inest,'Position',[5,tm(2)-440,100,25]); % Text Alpha 1
            set(numalpha1,'Position',[5,tm(2)-465,100,25]); % Editable amb el nombre Alpha 1
            set(text4Inest,'Position',[5,tm(2)-495,100,25]); % Text Alpha 2
            set(numalpha2,'Position',[5,tm(2)-520,100,25]); % Editable amb el nombre Alpha 2
            set(text5Inest,'Position',[5,tm(2)-550,100,25]); % Text Mu
            set(nummu,'Position',[5,tm(2)-575,100,25]); % Editable amb el nombre Mu
        set(panelres2ord,'Position',[tm(1)-115,75,115,150]);
        
        
            
        set(botocalcular1,'Position',[tm(1)-115,5,115,25]); % Boto calcular.
        set(grafica_est,'Position',[36,50,tm-[176,70]]);
        set(logo,'Position',[36,50,tm-[176,70]]);
        set(grafica_resxy,'Position',[36,(tm(2)+30)/2,(tm-[182,70])/2]);
        set(grafica_resxz,'Position',[36,50,(tm-[182,70])/2]);
        set(txtbox_res,'Position',[tm(1)/2-49,50,tm(1)/2-87,tm(2)-70]);
        centrar
    end

    function clic_figure(~,~,~)
        % S'executa sempre que es premi el bot del ratoli.
        % No confondre amb la funci clic_ratoli ni altres, clic_figure
        % s'executa sempre abans i es cliqueji sobre la grafica o qualsevol
        % altre objecte, s ms genrica i complementa les altres funcions.
        % Discrimina segons el tipus de pulsaci i l'enmagatzema a la
        % variable flagclic de manera que al pitjar sobre un element grfic
        % es puguin programar diferents efectes.
        
        switch get(figcme2,'SelectionType')
            case 'normal' % Bot esquerre
                flagclic=1;
                if strcmp(get(botobarramoure,'State'),'on')
                    posini=get(grafica_est,'currentpoint');
                end
            case 'open' % Doble clic
                flagclic=2;
            case 'alt'
                flagclic=3; % Control i bot esquerre o bot dret
            case 'extend'
                flagclic=4; % Shift i bot esquerre, bot central o ambds botons
                posini=get(grafica_est,'currentpoint');
                set(figcme2,'Pointer','hand');
        end
    end

    function unclic_figure(~,~,~)
        % S'executa a l'alliberar el bot del ratol.
        
        flagclic=0; % Restitueix la variable que defineix el tipus de clic.
        flagmourenus=0; % Si s'estava movent un nus, restitueix el flag perque no es mogui el nus amb el moviment del ratoli.
        
        % Per si estava movent la pantalla (cursor amb forma de ma) torna
        % al cursor de fletxa o al que correspongui.
        if strcmp(get(botobarramoure,'State'),'on')
            set(figcme2,'Pointer','hand');
        elseif strcmp(get(botobarraapropar,'State'),'on') || strcmp(get(botobarraallunyar,'State'),'on')
            set(figcme2,'Pointer','circle');
        else
            set(figcme2,'Pointer','arrow');
        end
    end

    function roda_ratoli(~,eventdata)
        % Amplia i redueix la grafica al fer rodar la rodeta del ratol.
        zom(eventdata.VerticalScrollCount/factorzoom)
    end

    function [] = zom(factor)
        % Amplia i redueix la grfica.
        
        %disp('Zoom')
        %tic_zom=tic;
        if grafica==grafica_est
            posbruta=get(grafica_est,'currentpoint'); % Posici del cursor.
            lim=[get(grafica_est,'XLim');get(grafica_est,'YLim');get(grafica_est,'ZLim')]; % Llegeix l'escala dels eixos.
            
            frac = (posbruta(1,:)'-lim(:,1))./(lim(:,2)-lim(:,1));
            an=(lim(:,2)-lim(:,1))*2^factor; % Amplada multiplicada per 2 elevat al factor d'ampliaci.
            lim(:,1) = posbruta(1,:)' - an.*frac;
            lim(:,2) = posbruta(1,:)' + an.*(1-frac);
            
            % med=(lim(:,2)+lim(:,1))/2; % Punt mig.
            % an=(lim(:,2)-lim(:,1))*2^factor; % Amplada multiplicada per 2 elevat al factor d'ampliaci.
            % lim=[med-an/2, med+an/2]; % Nova escala dels eixos.
            
            set(grafica_est,'XLim',lim(1,:),'YLim',lim(2,:),'ZLim',lim(3,:)); % Fixa la nova escala.
            escala % Calcula el factor d'escala s.
            escalar_nusos % Reescala els nusos i les seves carregues.
            redibuixar_carregues_barres % Redibuixa les crregues sobre les barres amb la nova escala.
            clicable % Estableix quins objectes responen al ratoli segons els botons de la barra.
        end
        %disp(['/Zoom: ',num2str(toc(tic_zom))])
    end    

    function moviment_ratoli(~,~,~)
        % S'executa quan es mou el ratol sobre la finestra de l'aplicaci.
        % Actualitza els valors de les caixes de texte que mostren la posici
        % del ratol.
        % Al crear una barra crea l'efecte de que la lnia segueix el cursor.
        % Si es prem la rodeta permet moure la grfica.
        % Si es prem el bot dret mou nusos.
        set(botoCentrar,'State','off');%Desactiva el botoCentrar kuan el ratoli ja no esta sobre el mateix
        posbruta=get(grafica_est,'currentpoint'); % Posici del cursor.
        precisio=str2double(get(editprec,'String')); % Precisi definida a la seva caixa de texte.
        posicio=round(posbruta(1,1:3)/precisio)*precisio; % Redondeja la posici a la precisi establerta.
        
        % Actualitza la posici a les caixes de texte.
        switch vista
            case 'xy'
                set(editx,'String',num2str(posicio(1))); % A la vista al plnol xy actualitza posicions x i y.
                set(edity,'String',num2str(posicio(2)));
                posicio(3)=str2double(get(editz,'String'));
            case 'xz'
                set(editx,'String',num2str(posicio(1))); % A la vista al plnol xz actualitza posicions x i z.
                posicio(2)=str2double(get(edity,'String'));
                set(editz,'String',num2str(posicio(3)));
            case 'yz'
                posicio(1)=str2double(get(editx,'String')); % A la vista al plnol yz actualitza posicions y i z.
                set(edity,'String',num2str(posicio(2)));
                set(editz,'String',num2str(posicio(3)));
            case '3d'
                set(editx,'String','');
                set(edity,'String','');          
                set(editz,'String','');
        end
        
        % Si s'est creant una bara actualitza les coordenades amb la posici del cursor.
        if flagbarra
            x=get(hbarra,'XData');
            y=get(hbarra,'YData');
            z=get(hbarra,'ZData');
            set(hbarra,'XData',[x(1) posbruta(1,1)],'YData',[y(1) posbruta(1,2)],'ZData',[z(1) posbruta(1,3)]);
        end
        
        % Si s'ha pres la rodeta del ratol o el bot moure modifica els
        % lmits de la grfica creant l'efecte de moviment.
        if flagclic ==4 || (flagclic ==1 && strcmp(get(botobarramoure,'State'),'on'))
            mov=posbruta-posini; % posini es la posici anterior.
            mov=mov(1,:);
            if ~strcmp(vista,'3d')
                xl=get(grafica_est,'XLim');
                xl=xl-[mov(1),mov(1)];
                yl=get(grafica_est,'YLim')-[mov(2),mov(2)];
                zl=get(grafica_est,'ZLim')-[mov(3),mov(3)];
                set(grafica_est,'XLim',xl,'YLim',yl,'ZLim',zl);
            end
        end
        
        % Amb el bot dret pres sobre un nus permet moure'l sobre la
        % grfica.
        if flagmourenus && ~get(boto3d,'Value')
            nusos(flagmourenus).posicio=posicio; % flagmourenus conte el handle del nus.
            escala % Calcula el factor d'escala s.
            redibuixar_nusos % Redibuixa els nusos per tal de que es reorientin segons els nous extrems.
            redibuixar_barres % Actualitza el dibuix de les barres.
            escalar_nusos % Reescala els nusos i les seves carregues.
            redibuixar_carregues_barres % Redibuixa les crregues sobre les barres amb la nova escala.
            clicable % Estableix quins objectes responen al ratoli segons els botons de la barra.
        end
    end

    function tecla(~,eventdata,~)
        % S'executa cada cop que es pitja una tecla.
        % Permet diferents accions en diferents moments.
        
        % Si s'est creant una barra permet abortar prement escapament.
        if flagbarra && strcmp(eventdata.Key,'escape')
            flagbarra=0; % Posa a 0 el flag de que s'est creant barra.
            delete(hbarra) % Esborra la lnia.
            hbarra=[];
        elseif strcmp(eventdata.Key,'escape') && grafica~=grafica_est
            if contRotula==0
             clic_grafica_res
            else
               clic_grafica_res
               set(popupMenu,'enable','on');
               val=get(popupMenu,'value');
               autopopupcallback(val);
            end
        else  %Si estem a grafica_est, cas general, desactiva els botons d'accio
            botons_accions('off','off','off','off','off','off')
        end

        
        % Amplia o redueix l'escala de la deformada prement '+' o '-'.
        if ~strcmp(get(botoEdicio,'State'),'on') && get(botodeformada,'Value') && flagcalculat
            if strcmp(eventdata.Character,'-')
                sD=sD/2^(1/4); % Divideix l'escala per l'arrel quarta de 2, amb 4 pulsacions es divideix l'escala per 2.
            elseif strcmp(eventdata.Character,'+')
                sD=sD*2^(1/4); % Multiplica l'escala per l'arrel quarta de 2, amb 4 pulsacions es duplica l'escala.
                def2ord=def2ord/2^(1/4);
            end
            for i=1:numel(diagrames)
                escala_deformada(TL2G(:,:,i),i,sD); % Actualitza la deformada a totes les barres.
            end
        end
        
        % Si es pitja return en qualsevol moment equival a pitjar el bot
        % calcular.
        if strcmp(eventdata.Key,'return')
            calcular
        end

        %Si es pitja C, bot crear
        if strcmp(eventdata.Key,'c')
             botocrear
        end
        %m modificar
        if strcmp(eventdata.Key,'m')
             botomodificar
        end        
        %e esborrar
        if strcmp(eventdata.Key,'e')
             botoesborrar
        end 
        %n nus
        if strcmp(eventdata.Key,'n')
             botonus
        end
        %b barra
        if strcmp(eventdata.Key,'b')
             botobarra
        end
        %p puntual
        if strcmp(eventdata.Key,'p')
             botocarreganus
        end
        %q distribuida
        if strcmp(eventdata.Key,'q')
             botocarregabarra
        end
        
        
        % Moviment dels cursor al mode de vista 3d per rotar, apropar i
        % allunyar l'estructura.
        if strcmp(vista,'3d')
            switch eventdata.Key
                case 'leftarrow' % Si es prem la tecla de fletxa esquerra.
                    mov=-pi/36; % Gira l'estructura 5.
                    angle3d=angle3d+mov; % angle de rotaci.
                    ct=[xm,ym,zm]; % Punt 'camera target' centre de l'estructura.
                    set(grafica_est,'CameraPosition',ct+[cos(angle3d),1,sin(angle3d)]); % Vista isomtrica.
                case 'rightarrow' % Si es prem la tecla de fletxa dreta.
                    mov=pi/36; % Gira l'estructura 5.
                    angle3d=angle3d+mov; % angle de rotaci.
                    ct=[xm,ym,zm]; % Punt 'camera target' centre de l'estructura.
                    set(grafica_est,'CameraPosition',ct+[cos(angle3d),1,sin(angle3d)]); % Vista isomtrica.
                case 'uparrow' % Si es prem la tecla de fletxa a dalt.
                    zom(-3/factorzoom); % Apropa l'estuctura.
                case 'downarrow' % Si es prem la tecla de fletxa a baix.
                    zom(3/factorzoom); % Allunya l'estructura.
            end
        end
        
    end

%% CREACI I ACCIONS DE LA BARRA D'EINES I ELS SEUS BOTONS:

    function [barraeines,botobarracrear,botobarramodificar,botobarraesborrar,botobarranus,botobarrabarra,botobarracarreganus,botobarracarregabarra,botobarrarotula,botobarramoure,botobarraapropar,botobarraallunyar,botoEdicio,botoCentrar,botoXY,botoXZ,botoYZ,boto3D]=creacio_barra_eines
        % Crea una nova barra d'eines i defineix els botons.
        % Per als botons de zoom i moviment en copia l'imatge de la barra
        % per defecte de Matlab, per noms la imatge, les accions estan
        % reprogramades per tal de tenir el control i que Matlab no faci
        % accions extraes.
        
        barraperdefecte=findall(figcme2,'Type','uitoolbar'); % Handle de la barra d'eines per defecte de Matlab, es mant activa mentre es copien alguns botons.
        barraeines=uitoolbar; % Creaci d'una barra d'eines prpia.
        botobarracrear=uitoggletool('TooltipString','Crear (C)','CData',imread('lapiz.png','BackgroundColor',bg),'State','on','ClickedCallback',@botocrear); % Defineix el bot crear.
        botobarramodificar=uitoggletool('TooltipString','Modificar (M)','Cdata',imread('editar.png','BackgroundColor',bg),'ClickedCallback',@botomodificar); % Defineix el bot modificar.
        botobarraesborrar=uitoggletool('TooltipString','Esborrar (E)','CData',imread('goma.png','BackgroundColor',bg),'ClickedCallback',@botoesborrar); % Defineix el boto esborrar.
        botobarranus=uitoggletool('Separator','on','TooltipString','Nus (N)','CData',imread('nudo.png','BackgroundColor',bg),'State','on','ClickedCallback',@botonus); % Defineix el bot nus.
        botobarrabarra=uitoggletool('TooltipString','Barra (B)','CData',imread('barra.png','BackgroundColor',bg),'ClickedCallback',@botobarra); % Defineix el bot barres.
        botobarracarreganus=uitoggletool('TooltipString','Crrega en nus (P)','CData',imread('carganudo.png','BackgroundColor',bg),'ClickedCallback',@botocarreganus); % Defineix el bot carrega als nusos.
        botobarracarregabarra=uitoggletool('TooltipString','Crrega en barra (Q)','CData',imread('cargabarra.png','BackgroundColor',bg),'ClickedCallback',@botocarregabarra); % Defineix el bot crrega a les barres.
        botobarrarotula=uitoggletool('Separator','on','TooltipString','Extrems de barra articulats','CData',imread('rotula.png','BackgroundColor',bg)); % Extrem de barra articulat.
        botobarramoure=uitoggletool('Separator','on','TooltipString','Moure''s','CData',get(findall(barraperdefecte,'TooltipString','Pan'),'CData'),'ClickedCallback',@botomoure); % Defineix el bot moure copiant l'aspecte de la barra d'eines original.
        botobarraapropar=uitoggletool('TooltipString','Apropar-se','CData',get(findall(barraperdefecte,'TooltipString','Zoom In'),'CData'),'ClickedCallback',@botoapropar); % Defineix el bot apropar copiant l'aspecte de la barra d'eines original.
        botobarraallunyar=uitoggletool('TooltipString','Allunyar-se','CData',get(findall(barraperdefecte,'TooltipString','Zoom Out'),'CData'),'ClickedCallback',@botoallunyar);% Defineix el bot allunyar copiant l'aspecte de la barra d'eines original.
        
        botoEdicio=uitoggletool('Separator','on','TooltipString','Edici','CData',imread('edit.png','BackgroundColor',bg),'State','on','ClickedCallback',@edicio); % Defineix el bot editar
        uitoggletool('TooltipString','Reixeta','CData',imread('grid.png','BackgroundColor',bg),'ClickedCallback',@reixeta); % Defineix el bot per crear la reixeta al model grfic
        botoCentrar=uitoggletool('TooltipString','Centrar','CData',imread('target.png','BackgroundColor',bg),'ClickedCallback',@centrar);% Defineix el bot per centrar els objectes grafics
      
        botoXY=uitoggletool('TooltipString','XY','CData',imread('XY.png','BackgroundColor',bg),'ClickedCallback',@vistaxy); % Defineix el bot vista xy
        botoXZ=uitoggletool('TooltipString','XZ','CData',imread('XZ.png','BackgroundColor',bg),'ClickedCallback',@vistaxz); % Defineix el bot vista xz
        botoYZ=uitoggletool('TooltipString','YZ','CData',imread('YZ.png','BackgroundColor',bg),'ClickedCallback',@vistayz); % Defineix el bot vista yz
        boto3D=uitoggletool('TooltipString','3D','CData',imread('3D.png','BackgroundColor',bg),'ClickedCallback',@vista3d); % Defineix el bot vista 3D
        set(figcme2,'Toolbar','none'); % Es desactiva la barra d'eines original.
    end

    function botocrear(~,~,~)
        % S'executa quan s'activa el bot crear.
        %disp('boto crear')
        botons_accions('on','off','off','off','off','off')
    end
    function botomodificar(~,~,~)
        % S'executa quan s'activa el bot modificar.
        %disp('boto modificar')
        botons_accions('off','on','off','off','off','off')
    end
    function botoesborrar(~,~,~)
        % S'executa quan s'activa el bot esborrar.
        %disp('boto esborrar')
        botons_accions('off','off','on','off','off','off')
    end
    function botomoure(~,~,~)
        % S'executa quan s'activa el bot moure.
        botons_accions('off','off','off','on','off','off')
    end
    function botoapropar(~,~,~)
        % S'executa quan s'activa el bot zoom apropar.
        botons_accions('off','off','off','off','on','off')
    end
    function botoallunyar(~,~,~)
        % S'executa quan s'activa el bot zoom allunyar.
        botons_accions('off','off','off','off','off','on')
    end
    function botonus(~,~,~)
        % S'executa quan s'activa el bot nus.
        botons_elements('on','off','off','off')
    end
    function botobarra(~,~,~)
        % S'executa quan s'activa el bot barra.
        botons_elements('off','on','off','off')
    end
    function botocarreganus(~,~,~)
        % S'executa quan s'activa el bot crrega sobre nus.
        botons_elements('off','off','on','off')
    end
    function botocarregabarra(~,~,~)
        % S'executa quan s'activa el bot crrega sobre barra.
        botons_elements('off','off','off','on')
    end
    function botons_accions(bcrear,bmodificar,besborrar,bmoure,bapropar,ballunyar)
        % Es desactiven la resta de botons del grup.
        set(botobarracrear,'State',bcrear);
        set(botobarramodificar,'State',bmodificar);
        set(botobarraesborrar,'State',besborrar);
        if strcmp('off',bmoure) 
            set(botobarramoure,'State',bmoure);
        end
        if strcmp('off',bapropar)
            set(botobarraapropar,'State',bapropar);
        end
        if strcmp('off',ballunyar)
            set(botobarraallunyar,'State',ballunyar);
        end
        colors
        clicable % Modifica colors dels elements grfics i hi defineix si es poden cliquejar, segons el cas.
    end
    function botons_elements(bnus,bbarra,bcarreganus,bcarregabarra)
        % Esdesactiven la resta de botons del grup.
        set(botobarranus,'State',bnus);
        set(botobarrabarra,'State',bbarra);
        set(botobarracarreganus,'State',bcarreganus);
        set(botobarracarregabarra,'State',bcarregabarra)
        colors
        clicable % Modifica colors dels elements grfics i hi defineix si es poden cliquejar, segons el cas.
    end
    function clicable(~,~,~)
        % Modifica l'estat dels objectes grfics que representen nusos,
        % barres i crregues, perque acceptin clic de ratol o no, de
        % manera que els que no s'hagin de clicar no interfereixin
        % entorpint el programa.
        
        %disp('Clicable')
        %tic_clicable=tic;
        if strcmp(get(botoEdicio,'State'),'on')
            if strcmp(get(botobarracrear,'State'),'on') % Si s'esta creant...
                if strcmp(get(botobarranus,'State'),'on') % nusos, es cliqueja directament sobre la grfica, es desactiven els clics als objectes grfics.
                    canviestat('off','off','off','off')
                    %canviestat('on','off','off','off')
                elseif strcmp(get(botobarrabarra,'State'),'on') % barres, s'activen els clics als nusos.
                    canviestat('on','off','off','off')
                    %canviestat('on','on','off','off')
                elseif strcmp(get(botobarracarreganus,'State'),'on') % carregues en nusos, s'activen els clics als nusos.
                    canviestat('on','off','off','off')
                elseif strcmp(get(botobarracarregabarra,'State'),'on')% crregues a les barres, s'activen clics a les barres.
                    canviestat('off','on','off','off')
                end
            elseif strcmp(get(botobarramodificar,'State'),'on') || strcmp(get(botobarraesborrar,'State'),'on') % Si s'est modificant o esborrant...
                if strcmp(get(botobarranus,'State'),'on') % nusos, s'activen els clics als nusos.
                    canviestat('on','off','off','off')
                elseif strcmp(get(botobarrabarra,'State'),'on') % barres, s'activen els clics a les barres.
                    canviestat('off','on','off','off')
                elseif strcmp(get(botobarracarreganus,'State'),'on') % crregues en nusos, s'activen els clics a les crregues als nusos.
                    canviestat('off','off','on','off')
                elseif strcmp(get(botobarracarregabarra,'State'),'on') % crregues a les barres, s'activen els clics a les crregues a les barres.
                   canviestat('off','off','off','on')
                end
            else
                canviestat('on','off','off','off') % Per defecte, que es pugui cliquejar als nusos per moure'ls.
            end
        else
            canviestat('off','on','off','on') % S'activen clics a les barres.
        end
        if strcmp(get(botobarramoure,'State'),'on') % Canvia el cursor.
            set(figcme2,'Pointer','hand')
        elseif strcmp(get(botobarraapropar,'State'),'on') || strcmp(get(botobarraallunyar,'State'),'on')
            set(figcme2,'Pointer','circle')
        else
            set(figcme2,'Pointer','arrow')
        end
        %set(grafica,'Children',sort(get(grafica,'Children'))); % Reordena els objectes de la grafica.
        %colors % Canvia els colors dels elements.
        %disp(['/Clicable: ',num2str(toc(tic_clicable))])
    end
    function canviestat(clicnus,clicbarra,cliccarreganus,cliccarregabarra)
        % Canvia l'estat de si es poden clicar o no els objectes grfics.
        for j=1:contnus
            set(nusos(j).hg,'HitTest',clicnus) % Objectes que representen els nusos.
            set(nusos(j).hgc,'HitTest',cliccarreganus) % Objectes que representen les carregues als nusos.
        end
        for j=1:contbarra
            set(barres(j).hg,'HitTest',clicbarra) % Objectes lnies que representen les barres.
            set(barres(j).hgpuntual,'HitTest',cliccarregabarra); % Objectes que representen les crregues puntuals sobre les barres.
            set(barres(j).hgmoment,'HitTest',cliccarregabarra); % Objectes que representen les crregues moment sobre les barres.
            set(barres(j).hgrepartida,'HitTest',cliccarregabarra); % Objectes que representen les crregues repartides sobre les barres.
            set(barres(j).hgprojectada,'HitTest',cliccarregabarra); % Objectes que representen les crregues projectades sobre les barres.
        end
    end
    function colornusos(~,~,~)
        % Actualitza el color dels nusos segons la situaci.        
        %disp('Color nusos')
        %tic_cn=tic;
        if strcmp(get(botobarranus,'State'),'on') && strcmp(get(botoEdicio,'State'),'on') % Si esta activat el bot nusos i el mode edici.
            if strcmp(get(botobarramodificar,'State'),'on') % Si est activat el bot modificar.
                color=colormodificar; % Assigna als nusos amb el color definit.
            elseif strcmp(get(botobarraesborrar,'State'),'on') % Si est activat el bot esborrar.
                color=coloresborrar; % Assigna als nusos amb el color definit.
            else
                color='k'; % Color d'edicio per defecte negre.
            end
        else
            color='k'; % Color presentacio per defecte negre.
        end
        for i=1:contnus
            chgcolor(nusos(i).hg,color) % Canvia el color. 
        end
        %disp(['/Color nusos: ',num2str(toc(tic_cn))])
    end
    function colorbarres(~,~,~)
        % Actualitza el color de les barres segons la situaci.
        
        %disp('Color barres')
        %tic_cb=tic;
        if strcmp(get(botobarrabarra,'State'),'on') && strcmp(get(botoEdicio,'State'),'on') % Si esta activat el bot barres i el mode edici.
            if strcmp(get(botobarramodificar,'State'),'on') % Si est activat el bot modificar.
                color=colormodificar; % Assigna a les barres el color definit.
            elseif strcmp(get(botobarraesborrar,'State'),'on') % Si est activat el bot esborrar.
                color=coloresborrar; % Assigna a les barres el color definit.
            else
                color='k'; % Color per defecte al mode d'edicio.
            end
        else
            color='k'; % Color per defecte al mode de presentaci.
        end
        if strcmp(color,'k') % Si s'ha assignat el color per defecte, el substitueix pel color definit a les propietats de la barra.
            for i=1:contbarra
                set(barres(i).hg,'color',barres(i).color) % Canvia el color.
            end
        else
            for i=1:contbarra
                set(barres(i).hg,'color',color) % Canvia el color pel negre.
            end
        end
        %disp(['/Color barres: ',num2str(toc(tic_cb))])
    end
    function colorcarreganusos(~,~,~)
        % Actualitza el color de les crregues sobre els nusos segons la
        % situaci.
        
        %disp('Color carrega nusos')
        %tic_cn=tic;
        if strcmp(get(botobarracarreganus,'State'),'on') && strcmp(get(botoEdicio,'State'),'on') % Si est activat el bot de crregues als nusos i el mode edici.
            if strcmp(get(botobarramodificar,'State'),'on') % Si est activat el bot modificar.
                color=colormodificar; % Assigna a les crregues el color definit.
            elseif strcmp(get(botobarraesborrar,'State'),'on') % Si est activat el bot esborrar.
                color=coloresborrar; % Assigna a les crregues el bot definit.
            else
                color='k'; % Color d'edicio per defecte negre.
            end
        elseif strcmp(get(botoEdicio,'State'),'on')
            color='k'; % Color d'edicio per defecte negre.
        else
            color=colorcarregues; % Color presentacio definit.
        end
        for i=1:contnus
            chgcolor(nusos(i).hgc,color) % Canvia el color.
        end
        %disp(['/Color carrega nusos: ',num2str(toc(tic_cn))])
    end
    function colorcarregabarres(~,~,~)
        % Actualitza el color de les crregues sobre les barres segons la
        % situaci.
        
        %disp('Color carrega barres')
        %tic_cb=tic;
        if strcmp(get(botobarracarregabarra,'State'),'on') && strcmp(get(botoEdicio,'State'),'on') % Si est activat el bot de crregues a les barres i el mode edici.
            if strcmp(get(botobarramodificar,'State'),'on') % Si est activat el bot modificar.
                color=colormodificar; % Assigna a les crregues el color definit.
            elseif strcmp(get(botobarraesborrar,'State'),'on') % Si est activat el bot esborrar.
                color=coloresborrar; % Assigna a les crregues el bot definit.
            else
                color='k'; % Color d'edicio per defecte negre.
            end
        elseif strcmp(get(botoEdicio,'State'),'on')
            color='k'; % Color d'edicio per defecte negre.
        else
            color=colorcarregues; % Color presentacio definit.
        end
        for i=1:contbarra
            chgcolor(barres(i).hgpuntual,color) % Canvia el color de les crregues puntuals.
            chgcolor(barres(i).hgmoment,color) % Canvia el color dels moments.
            chgcolor(barres(i).hgrepartida,color) % Canvia el color de les crregues repartides.
            chgcolor(barres(i).hgprojectada,color) % Canvia el color de les crregues projectades.
        end
        %disp(['/Color carrega barres: ',num2str(toc(tic_cb))])
    end
    function colors(~,~,~)
        % Actualitza color de nusos, barres i crregues.
        
        %disp('Colors')
        %tic_col=tic;
        colornusos
        colorbarres
        colorcarreganusos
        colorcarregabarres
        %disp(['/Colors: ',num2str(toc(tic_col))])
    end
    function chgcolor(h,color)
        % Funci que canvia els colors dels objectes continguts en un
        % objecte hgtransform.
        
        set(findobj(h,'Type','line'),'color',color) % Color de les lnines.
        set(findobj(h,'Type','text'),'color',color) % Color dels textos.
        set(findobj(h,'Type','patch'),'FaceColor',color,'EdgeColor',color) % Color dels patch.
    end

%% CREACI I ACCIONS DE LA BARRA DE MENS:

    function creacio_menus
        % Crea la barra de mens.
        
        menuarxiu=uimenu(figcme2,'Label','Arxiu'); % Men principal 'arxiu'.
        uimenu(menuarxiu,'Label','Nou','Callback',@menunou); % Sub-men 'nou'.
        uimenu(menuarxiu,'Label','Carregar','Callback',@menucarregar);% Sub-men 'carregar'.
        uimenu(menuarxiu,'Label','Guardar','Callback',@menuguardar,'Separator','on'); % Sub-men 'guardar'.
        uimenu(menuarxiu,'Label','Guardar com a...','Callback',@menuguardarcom); % Sub-menu 'guardar com'.
        uimenu(menuarxiu,'Label','Sortir','Callback',@sortir,'Separator','on'); % Sub-men 'sortir'.
        menuopcions=uimenu(figcme2,'Label','Opcions'); % Men princiapl 'opcions'.
        uimenu(menuopcions,'Label','Editar opcions','Callback',@opcions); % Sub-men 'editar opcions'.
        
        menuajuda=uimenu(figcme2,'Label','Ajuda'); % Men princiapl 'opcions'.
        uimenu(menuajuda,'Label','Acerca de...','Callback',@Acercade); % Sub-men 'editar opcions'.
    end
    function menunou(~,~,~)
        % S'executa amb el men 'nou'
        % Pregunta si es vol guardar i esborra l'estructura.
        
        resp=questdlg('Guardar abans d''esborrar l''estructura?','Nova estructura','Si','No','Cancelar','Si');
        switch resp
            case 'Si'
                menuguardar
                nou
            case 'No'
                nou
            end
    end
    function nou
        % Esborra les dades.
        
        %disp('Nou')
        %tic_nou=tic;
        if grafica~=grafica_est % Si s'esta presentant resultats de barra.
            clic_grafica_res
        end
      
        dadesRotules=dadesRotula.empty(1,0); % Nova llista d'objectes rtula
        numeroRotules=0; % Nova variable per el popupmenu que mostra el llistat de rtules
        contRotula=0; % Nou comptador del nmero de rtules creades
       
        nusos=nus.empty(1,0); % nova llista d'objectes nus.
        contnus=0; % comptador de nusos a zero.
        barres=barra.empty(1,0); % nova llista d'objectes barra.
        contbarra=0; % comptador de barres a zero.
        hgreaccions=[]; % esborra la llista de reaccions.
        diagrames=diagrama.empty(1,0); % nova llista d'objectes diagrama.
        delete(get(grafica,'Children')) % esborra tots els objectes grfics.
        %set(grafica_est,'XLim',XLimini,'YLim',YLimini,'ZLim',ZLimini) % Estableix els lmits originals.
        [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
        centrar
        set(botoEdicio,'State','on'); % Torna al mode edici.
        def2ord=line(0,0,0,'Visible','off');
        edicio % Esborra diagrames, etc..
  
        nom=''; % Esborra el nom de l'estructura. 
        figcme2_rename % Canvia el ttol.
        fmax=0;
        qmax=0;
        %disp(['/Nou: ',num2str(toc(tic_nou))])
        %Activo el boto de calcular, doncs pot estar apagat
        set(botocalcular1,'enable','on');
        
        %Amago el panell plastic i poso el popup en zero
        contRotula=0;
        set(popupMenu,'value',1);
        set(popupMenu, 'string', '0');
        set(panelResultats,'Visible','off');
        
    end
    function menucarregar(~,~,~)
        % Carrega una estructura previament guardada.
        
        carpetaactual=cd(direst); % Es coloca a la carpeta on es guarden els treballs i guarda la carpeta actual de Matlab.
        [arxiu,carpeta]=uigetfile('*.cme2','Carregar'); % Obre la finestra per seleccionar arxiu.
        cd(carpetaactual) % Un cop seleccionat l'arxiu torna a la carpeta de Matlab.
        
        %disp('Carregar')
        %tic_carregar=tic;
        if arxiu % Si s'ha seleccionat un arxiu...
            nou;
            
            %Torno a la vista xy per defecte
            vista='xy'; % Variable global vista controla el mode de vista actual del programa.
            set(botoYZ,'State','off');
            set(botoXZ,'State','off');
            set(boto3D,'State','off');
            
            
            set(grafica_est,'View',[0,90],'Box','on'); % Vista del plnol XY.
            set(editx,'Enable','off'); % Desactiva la caixa de text amb la coordenada en x perque no es pugui editar.
            set(edity,'Enable','off'); % Desactiva la caixa de text amb la coordenada en y perque no es pugui editar.
            set(editz,'Enable','on','String','0'); % Activa la caixa de text amb la coordenada z per editar la profunditat.
           
            direst = carpeta;  %emmagatzema l'ltima carpeta d'on s'ha carregat
            if grafica~=grafica_est % Si s'esta presentant resultats de barra.
                clic_grafica_res
            end
            [nusos,barres,contnus,contbarra,contRotula,dadesRotules]=carregararxiu(fullfile(carpeta,arxiu)); % Carrega les dades.
            
            %Depenent de si existeixen rtules efecta un procediment o un
            %altre
            if contRotula==0 %Si no existeixen rtules
                % Esborra les dades de treballs anteriors.
                delete(get(grafica,'Children'))
                hgreaccions=[];
                diagrames=diagrama;
                for i=1:contnus
                    nusos(i).hg=[]; 
                    nusos(i).hgc=[];
                end

                for i=1:contbarra
                    barres(i).hg=[];
                    barres(i).hgpuntual=[];
                    barres(i).hgmoment=[];
                    barres(i).hgrepartida=[];
                    barres(i).hgprojectada=[];
                end
                [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
                flagcalculat=0;
                maxpuntual % Calcula carrega puntual mxima.
                maxrepartida % Calcula carrega repartida o projectada maxima.
                redibuixar_nusos % Dibuixa els nusos.
                redibuixar_barres % Dibuixa les barres.
                redibuixa_carreganusos % Dibuixa les crregues als nusos.
                centrar % Centra l'estructura a la pantalla.
                set(botoEdicio,'State','on'); % Torna al mode edici.
                edicio
                nom=arxiu; % Nom de l'estructura.
                figcme2_rename % Canvia el ttol.
            else
                
                % Esborra les dades de treballs anteriors.
                delete(get(grafica,'Children'))
                hgreaccions=[];
                diagrames=diagrama;
                for i=1:contnus
                    nusos(i).hg=[]; 
                    nusos(i).hgc=[];
                end

                for i=1:contbarra
                    barres(i).hg=[];
                    barres(i).hgpuntual=[];
                    barres(i).hgmoment=[];
                    barres(i).hgrepartida=[];
                    barres(i).hgprojectada=[];
                end
                [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
                flagcalculat=0;
                maxpuntual % Calcula carrega puntual mxima.
                maxrepartida % Calcula carrega repartida o projectada mxima.
                redibuixar_nusos % Dibuixa els nusos.
                redibuixar_barres % Dibuixa les barres.
                redibuixa_carreganusos % Dibuixa les crregues als nusos.
                centrar % Centra l'estructura a la pantalla.
                
                %Hem situo a la pestaa de cclul plstic                
                set(botoCalculEstatic,'Value',0);
                set(botoCalculDinamic','Value',0);
                set(botoCalculInestabilitat,'Value',0); 
                set(botoCalculPlastic,'Value',1);
                
                %Activa el panell corresponent al clcul plstic
                set(panelPlastic,'Visible','on');
                
                %Crido al autopopupcallback per generar els resultats y
                %actualitzo el popup
                numeroRotules=zeros(contRotula-1,1); %Actualitza el vector del popup i el fa ms gran cada vegada que es crea una rtula
                 %Introdueixo totes les rotules a la matriu
                 for i=1:contRotula-1   %Afegeix el nmero de rtules a cada valor del vector.
                   numeroRotules(i,1)=i;
                 end  
                 
                %popupMenu = uicontrol(panelPlastic,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup
                set(popupMenu,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup    
                set(popupMenu,'value',(numeroRotules(contRotula-1,1))); %Poso el popup a la iltima posic

                %Cridem el autopopup per actualitzarlo automaticament
                autopopupcallback(contRotula-1);

                %Desactivo el boto calcular
                set(botocalcular1,'enable','off');
                
                set(botoEdicio,'State','off'); % Em coloco en mode vista de resultats               
                
                nom=arxiu; % Nom de l'estructura.
                figcme2_rename % Canvia el ttol.
            end
        end
        figure(figcme2) % Retorna el focus a la finestra del programa, si no es fa el programa no respondr fins que no es cliqueji sobre la finestra.
        %disp(['/Carregar: ',num2str(toc(tic_carregar))])
    end
    function menuguardar(~,~,~)
        % Guarda les dades sobre l'estructura actual per recuperar-la ms
        % endavant.
        
        %disp('Guardar')
        %tic_guardar=tic;
        if nom
            carpetaactual=cd(direst); % Es coloca a la carpeta on es guarden els treballs i guarda la carpeta actual de Matlab. 
            save(fullfile(direst,nom),'nusos','barres','-mat'); % Guarda les llistes de nusos i de barres que formen l'estructura.
            cd(carpetaactual) % Torna a la carpeta de Matlab.
            figure(figcme2) % Retorna el focus a la finestra del programa, si no es fa el programa no respondr fins que no es cliqueji sobre la finestra.
        else
            menuguardarcom
        end
        %disp(['/Guardar: ',num2str(toc(tic_guardar))])
    end
    function menuguardarcom(~,~,~) 
        % Guarda les dades sobre l'estructura actual per recuperar-la ms
        % endavant.
        
        %disp('Guardar com')
        %tic_guardar=tic;
        carpetaactual=cd(direst); % Es coloca a la carpeta on es guarden els treballs i guarda la carpeta actual de Matlab. 
        [arxiu,carpeta]=uiputfile('*.cme2','Guardar com a...',nom); % Obre el dileg per seleccionar o crear un arxiu.
        if arxiu % Si s'ha seleccionat un arxiu
            nom=arxiu; % N'assigna el nom a l'estructura
            figcme2_rename % Canvia el ttol.
            
            % Si existeixen rtules efecta un procediment o un altre
            if contRotula==0 % Si no existeixen rtules
                save(fullfile(carpeta,arxiu),'nusos','barres','-mat'); % Guarda les llistes de nusos i de barres que formen l'estructura.
            else % Si existeixen rotules
                 %Guardem les dades de nusos y barres originals sense
                 %efectuar el clcul plstic
                 nusos=dadesRotules(1).nusos;
                 barres=dadesRotules(1).barres;
                 save(fullfile(carpeta,arxiu),'nusos','barres','dadesRotules','contRotula','-mat');
            end
                direst = carpeta;
        end
        cd(carpetaactual) % Torna a la carpeta de Matlab.
        figure(figcme2) % Retorna el focus a la finestra del programa, si no es fa el programa no respondr fins que no es cliqueji sobre la finestra.
        %disp(['/Guardar com: ',num2str(toc(tic_guardar))])
    end
    function sortir(~,~,~)
        % Surt del programa.
        % S'executa al pitjar sobre l'aspa o al premer el men sortir.
        % Executa un msgbox per confirmar i guardar l'estructura.
        
        resp=questdlg('Guardar abans de sortir?','Sortir de CME2','Si','No','Cancelar','Si');
        switch resp
            case 'Si'
                menuguardar
                delete(figcme2) % Esborra la finestra.
            case 'No'
                delete(figcme2) % Esborra la finestra.
        end
        save('opcions','editalcrear','barraalcrearnus','fontnusos','tamanyfontnusos','fontcarregues','tamanyfontcarregues','factorzoom','tamanynus','distnumnus','precini','XLimini','YLimini','ZLimini','colormodificar','coloresborrar','colorcarregues','colorreaccions','colordeformada','colorN','colorTy','colorTz','colorMx','colorMy','colorMz','direst')
        
    end
    function opcions(~,~,~)
        % S'executa al seleccionar el men d'edici de les opcions del
        % programa.
        
        dlgopcions % Obre la finestra per modificar les opcions, que les guardara a l'arxiu opcions.mat.
        [editalcrear,barraalcrearnus,fontnusos,tamanyfontnusos,fontcarregues,tamanyfontcarregues,factorzoom,tamanynus,distnumnus,precini,XLimini,YLimini,ZLimini,colormodificar,coloresborrar,colorcarregues,colorreaccions,colordeformada,colorN,colorTy,colorTz,colorMx,colorMy,colorMz,direst]=loadopcions; % Carrega les opcions de l'arxiu opcions.mat.
        
        %disp('Opcions')
        %tic_opcions=tic;
        % Modifica els colors dels botons segons les opcions.
        set(botocarregues,'Foregroundcolor',colorcarregues);
        set(botoreaccions,'Foregroundcolor',colorreaccions);
        set(botodeformada,'Foregroundcolor',colordeformada);
        set(botoaxils,'Foregroundcolor',colorN);
        set(bototallantY,'Foregroundcolor',colorTy);
        set(bototallantZ,'Foregroundcolor',colorTz);
        set(botomomentX,'Foregroundcolor',colorMx);
        set(botomomentY,'Foregroundcolor',colorMy);
        set(botomomentZ,'Foregroundcolor',colorMz);

        for i=1:contnus
            set(findobj(nusos(i).hg,'type','text'),'FontName',fontnusos,'FontSize',tamanyfontnusos)
            set(findobj(nusos(i).hgc,'type','text'),'FontName',fontcarregues,'FontSize',tamanyfontcarregues)
            if flagcalculat
                set(findobj(hgreaccions(i),'type','text'),'FontName',fontcarregues,'FontSize',tamanyfontcarregues)
            end
        end
        
                colors 
        clicable % Estableix quins objectes responen al ratoli segons els botons de la barra.
        %disp(['/Opcions: ',num2str(toc(tic_opcions))])
    end


%% CREACI I ACCIONS SOBRE EL PANELL QUE CONT LES GRFIQUES, LES COORDENADES I LA PRECISI.

    function [panel1,logo,grafica_resxy,grafica_resxz,txtbox_res,grafica_est,editx,edity,editz,editprec]=creacio_panell_grafica
        % Creaci de la pantalla grfica:
        panel1=uipanel(figcme2,'Units','pixels','Position',[5,5,tm-[130,40]],'BorderType','etchedin','BorderWidth',1); % Creacio del panell.
        logo=axes('Parent',panel1,'Units','pixels','Position',[36,50,tm-[176,70]]); % Objecte axes on es carreguen els logos.
        imagesc(imread('logo.jpg'),'ButtonDownFcn',@clic_grafica_res); % Carrega dels logos.
        set(logo,'handlevisibility','off','Visible','off'); % S'oculten els marges i es fa inaccessible. Queda com a imatge de fons sense alterar al treballar amb l'estructura, ampliar, redur, moure, etc.
        grafica_resxy=axes('Parent',panel1,'Units','pixels','Position',[36,(tm(2)+30)/2,(tm-[182,50])/2],'Box','on','color','none','NextPlot','add','Visible','off','ButtonDownFcn',@clic_grafica_res); % Pantalla de presentaci de resultats de barra en eixos xy locals.
        grafica_resxz=axes('Parent',panel1,'View',[0,0],'Units','pixels','Position',[36,50,(tm-[182,50])/2],'Box','on','color','none','NextPlot','add','Visible','off','ButtonDownFcn',@clic_grafica_res); % Pantalla de presentaci de resultats de barra en eixos xz locals.
        txtbox_res=uicontrol(panel1,'Units','pixels','Position',[tm(1)/2-49,50,tm(1)/2-182,tm(2)-70],'Style','edit','max',2,'FontName','default','FontUnits','pixels','FontSize',12,'HorizontalAlignment','left','BackgroundColor','white','Visible','off'); % Editbox on es presenta l'informe de resultats.
        grafica_est=axes('Parent',panel1,'Units','pixels','Position',[36,50,tm-[176,10]],'color','none','MinorGridLineStyle',':','ButtonDownFcn',@clic_ratoli,'NextPlot','add','XLim',XLimini,'YLim',YLimini,'Box','on'); % Pantalla de treball amb la grfica de l'estructura.
        uicontrol(panel1,'Units','pixels','Position',[36,5,15,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','X:'); % Etiqueta.
        editx=uicontrol(panel1,'Units','pixels','Position',[51,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','Enable','off'); % Caixa on s'indica o introueix la coordenada x.
        uicontrol(panel1,'Units','pixels','Position',[111,5,15,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Y:'); % Etiqueta.
        edity=uicontrol(panel1,'Units','pixels','Position',[126,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','Enable','off'); % Caixa on s'indica o introdueix la coordenada y.
        uicontrol(panel1,'Units','pixels','Position',[186,5,15,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Z:'); % Etiqueta.
        editz=uicontrol(panel1,'Units','pixels','Position',[201,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String','0'); % Caixa on s'indica o introdueix la coordenada z.
        uicontrol(panel1,'Units','pixels','Position',[256,5,59,20],'Style','text','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','left','String','Precisi:'); % Etiqueta.
        editprec=uicontrol(panel1,'Units','pixels','Position',[315,5,50,20],'Style','edit','FontName','default','FontUnits','pixels','FontSize',14,'HorizontalAlignment','right','BackgroundColor','white','String',num2str(precini));  % Caixa on s'introdueix la precisi a l'introdur punts amb el ratol.
        grafica=grafica_est;
    end
   function clic_ratoli(~,~,~)
        % S'executa quan es cliqueja sobre la pantalla grfica.
        % flagclic es la variable que crea la funci clic_figure, que s'executa
        % just abans i indica el bot que s'ha pres.

        % Si es cliqueja el bot esquere sobre el planol amb els botons de
        % la barra crear i nus en mode edici crea un nus.
        if flagclic==1 &&strcmp(get(botoEdicio,'State'),'on') && strcmp(get(botobarracrear,'State'),'on') && strcmp(get(botobarranus,'State'),'on') && ~strcmp(vista,'3d')
            crearnus
        % Si s'est en mode zoom amplia o redueix segons el cas.
        elseif (flagclic==1 && strcmp(get(botobarraapropar,'State'),'on')) || (flagclic==3 && strcmp(get(botobarraallunyar,'State'),'on'))
            zom(-3/factorzoom);
        elseif (flagclic==1 && strcmp(get(botobarraallunyar,'State'),'on')) || (flagclic==3 && strcmp(get(botobarraapropar,'State'),'on'))
            zom(3/factorzoom);
        end
   end
    function clic_nus(gcbo,~,~)
        % S'executa quan es cliqueja sobre un nus.
        % Dins del camp 'UserData' de l'objecte grfic que representa al
        % nus hi ha enmagatzemat el seu nmero per tal d'identificar-lo.

        n=get(gcbo,'UserData'); % Nmero de nus.
        if flagclic==1 && strcmp(get(botoEdicio,'State'),'on') % Si s'ha pres el bot esquerre i s'est en mode d'edici, depenent dels botons de la barra s'excuta una acci o una altra.
            if strcmp(get(botobarraesborrar,'State'),'on') && strcmp(get(botobarranus,'State'),'on')
                esborrarnus(n)
            elseif strcmp(get(botobarramodificar,'State'),'on') && strcmp(get(botobarranus,'State'),'on')
                modificarnus(n)
            elseif strcmp(get(botobarracrear,'State'),'on') && strcmp(get(botobarrabarra,'State'),'on')
                crearbarra(n)
            elseif strcmp(get(botobarracrear,'State'),'on') && strcmp(get(botobarracarreganus,'State'),'on')
                crearmodificarcarreganus(n)
            end
        elseif flagclic==3 && ~flagbarra && strcmp(get(botoEdicio,'State'),'on') % Si s'ha pres el bot dret sobre el nus permet moure'l.
            flagmourenus=n; % Activa el flag que indica que es modifiqui la posici del nus amb el moviment del ratol, a mes el flag cont el handle de l'objecte grafic que representa el nus.
        end
    end    
    function clic_carreganus(gcbo,~,~)
        % S'executa quan es cliqueja sobre la carrega d'un nus.
        % Dins del camp 'UserData' de l'objecte grfic que representa la
        % carrega hi ha enmagatzemat el nmero de nus per tal
        % d'identificar-lo.
        
        n=get(gcbo,'UserData'); % Nmero de nus.
        if flagclic==1 && strcmp(get(botoEdicio,'State'),'on') && strcmp(get(botobarracarreganus,'State'),'on')% Si s'ha pres el bot esquerre i s'est en mode d'edici, depenent dels botons de la barra s'excuta una acci o una altra.
            if strcmp(get(botobarraesborrar,'State'),'on') 
                esborrarcarreganus(n)
            elseif strcmp(get(botobarramodificar,'State'),'on')
                crearmodificarcarreganus(n)
            end
        end
    end
    function clic_barra(gcbo,~,~)
        % S'executa quan es cliqueja sobre una barra.
        % Dins del camp 'UserData' de la lnia que representa la
        % barra hi ha enmagatzemat el seu nmero per tal d'identificar-la.
        
        n=get(gcbo,'UserData'); % Nmero de barra.
        if flagclic==1 && strcmp(get(botoEdicio,'State'),'on') % Si s'ha pres el bot esquerre i s'est en mode edici, depenent dels botons de la barra s'executa una acci o una altra.
            if strcmp(get(botobarraesborrar,'State'),'on') && strcmp(get(botobarrabarra,'State'),'on')
                esborrarbarra(n)
                redibuixar_nusos
                escalar_nusos
            elseif strcmp(get(botobarramodificar,'State'),'on') && strcmp(get(botobarrabarra,'State'),'on')
                modificarbarra(n)
            elseif strcmp(get(botobarracrear,'State'),'on') && strcmp(get(botobarracarregabarra,'State'),'on')
                crearmodificarcarregabarra(n)
            end
         elseif flagclic==1 && get(botoCalculEstatic,'value')==1 % Si es pren sobre la barra en el mode de presentacio de resultats, presenta els resultats per a la barra seleccionada.
            resultat_barra(n)
        elseif flagclic==1 && get(botoCalculPlastic,'value')==1
            resultat_barra_plastic(n)
        end
    end
    function clic_carregabarra(gcbo,~,~)
        % S'executa quan es cliqueja sobre la crrega d'una barra.
        % Dins del camp 'UserData' de l'objecte grafic que representa la
        % crrega hi ha enmagatzemat el seu nmero per tal d'identificar-la.

        n=get(gcbo,'UserData'); % Nmero de barra.
        if flagclic==1 && strcmp(get(botoEdicio,'State'),'on') % Si s'ha pres el bot esquerre i s'est en mode edici, depenent dels botons de la barra s'executa una acci o una altra.
            if strcmp(get(botobarraesborrar,'State'),'on') && strcmp(get(botobarracarregabarra,'State'),'on')
                esborrarcarregabarra(n)
            elseif strcmp(get(botobarramodificar,'State'),'on') && strcmp(get(botobarracarregabarra,'State'),'on')
                crearmodificarcarregabarra(n)
            end
        elseif flagclic==1 % Si s'ha pres el bot esquerre en la presentacio de resultats.
            resultat_barra(n)
        end
    end
    function [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(graficaest)
       hg_diagrames = hgtransform('Parent',graficaest);
       hg_carreguesbarres = hgtransform('Parent',graficaest);
       hg_carreganusos = hgtransform('Parent',graficaest);
       hg_barres = hgtransform('Parent',graficaest);
       hg_nusos = hgtransform('Parent',graficaest);
    end

%%CREACI I ACCIONS SOBRE EL PANELL QUE CONT ELS BOTONS DELS DIFERENTES
%%TIPUS DE CLCUL

    function  [panel4,botoCalculEstatic,botoCalculDinamic,botoCalculPlastic,botoCalculInestabilitat]=panell_botons_calcul
         panel4=uipanel(figcme2,'Units','pixels','Position',[5,tm(2)-25,tm(1)-125,25],'BorderType','etchedin','BorderWidth',0,'FontName','default','FontUnits','pixels','FontSize',14,'Title',''); % Creacio del panell.
         botoCalculEstatic=uicontrol(panel4,'Units','pixels','Position',[0,-1,(tm(1)-125)/4,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Clcul esttic','Value',1,'Callback',@calcul_estatic,'KeyPressFcn',@tecla); % Creaci bot calcul esttic
         botoCalculPlastic=uicontrol(panel4,'Units','pixels','Position',[(tm(1)-125)/4,-1,(tm(1)-125)/4,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Clcul plstic','Value',0,'Callback',@calcul_plastic,'KeyPressFcn',@tecla); % Creaci bot clcul dinmic
         botoCalculDinamic=uicontrol(panel4,'Units','pixels','Position',[2*(tm(1)-125)/4,-1,(tm(1)-125)/4,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Clcul dinmic','Value',0,'Callback',@calcul_dinamic,'KeyPressFcn',@tecla); % Creaci bot clcul plstic
         botoCalculInestabilitat=uicontrol(panel4,'Units','pixels','Position',[3*(tm(1)-125)/4,-1,(tm(1)-125)/4,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Clcul inestabilitat','Value',0,'Callback',@calcul_inestabilitat,'KeyPressFcn',@tecla); % Creaci bot clcul inestabilitat
            set(botoCalculDinamic,'enable','off'); % Desactivo el bot clcul dinmic, doncs el mdul encara no esta integrat
            %set(botoCalculInestabilitat,'enable','off'); % Desactivo el bot clcul inestabilitat, doncs el mdul encara no esta integrat
    end

    function calcul_estatic(hObject,~,~) %Opcions que s'activen al apretar el bot clcul esttic
        if get(hObject,'Value') 
             %Posa les altres pestanyes en off
             set(botoCalculPlastic,'Value',0);
             set(botoCalculDinamic','Value',0);
             set(botoCalculInestabilitat,'Value',0);
             %Desactiva els panells que no corresponguin al clcul esttic
             set(panelPlastic,'Visible','off');
             set(panel3,'Visible','on');
             set(panelInest,'Visible','off');
             set(panelres2ord,'Visible','off');
         end
    end
    function calcul_dinamic(hObject,~,~)%Opcions que s'activen al apretar el bot clcul dinmic
        if get(hObject,'Value') 
             %Posa les altres pestanyes en off
             set(botoCalculEstatic,'Value',0);
             set(botoCalculPlastic','Value',0);
             set(botoCalculInestabilitat,'Value',0);
             %Desactiva els panells que no corresponguin al clcul dinmic
             set(panelPlastic,'Visible','off');
             set(panel3,'Visible','on');
             set(panelInest,'Visible','off');
             set(panelres2ord,'Visible','off');
        end
    end
    function calcul_plastic(hObject,~,~)%Opcions que s'activen al apretar el bot clcul plstic    
        if get(hObject,'Value')
             %Posa les altres pestanyes en off
            set(botoCalculEstatic,'Value',0);
            set(botoCalculDinamic','Value',0);
            set(botoCalculInestabilitat,'Value',0);
            set(panel3,'Visible','on');
            set(panelInest,'Visible','off');
            set(panelres2ord,'Visible','off')
            %Desactiva els panells que no corresponguin al clcul plastic
            
            %Activa el panell corresponent al clcul plstic
            set(panelPlastic,'Visible','on');
            
%            [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions); %esborra reaccions i diagrames si n'hi han. 
        end
    end
    function calcul_inestabilitat(hObject,~,~)  %Opcions que s'activen al apretar el bot clcul inestabilitat
        if get(hObject,'Value')
             %Posa les altres pestanyes en off
             set(botoCalculPlastic,'Value',0);
             set(botoCalculDinamic','Value',0);
             set(botoCalculEstatic','Value',0);
             set(panel3,'Visible','off');
             set(panelInest,'Visible','on');
             try
             if strcmp(get(def2ord,'Visible'),'on');
                 set(panelres2ord,'Visible','on');
             end
             catch
                 def2ord=line(0,0,0,'Visible','off');
             end
             
             %Desactiva els panells que no corresponguin al clcul
             %inestabilitat
             set(panelPlastic,'Visible','off');
             
        end  
    end


%% CREACI I ACCIONS SOBRE EL PANELL QUE CONT ELS BOTONS QUE CONTROLEN LES VISTES I EL MODE EDICI/PRESENTACI DE RESULTATS.

    function edicio(~,~,~)
        % Mode edicio/presentaci
        % Si s'ha pitjat el bot edici esborra els diagrames, fa visibles
        % les carregues i torna als colors d'edici. 
        
        %disp('Edicio')
        %tic_edicio=tic;
        if strcmp(get(botoEdicio,'State'),'on') && contRotula==0 % Si el bot edici est pitjat i no existeixen rtules
           
            flagcalculat=0; % Es restableix el flag que indica que hi ha una estrucuctura ja calculada.
            set(get(panel3,'Children'),'Enable','off') % Es desactiven els botons que controlen els resultats.
            set(get(barraeines,'Children'),'Enable','on') % S'activen els botons de la barra d'eines.
            if ~isempty(diagrames) && diagrames(1).num>0
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions); % Esborra els diagrames
            end
            set(panelres2ord,'Visible','off');
            try
            if strcmp(get(def2ord,'visible'),'on')
            set(def2ord,'visible','off');
            end
            catch
                def2ord=line(0,0,0,'Visible','off');
            end
            maxpuntual % Calcula maxima fora puntual sense tenir en compte reaccions
            redibuixar_carregues_barres % Redibuixa les carregues a les barres
            redibuixa_carreganusos % Redibuixa les carregues als nusos
            escalar_nusos % Escala els nusos
             
        elseif strcmp(get(botoEdicio,'State'),'on') && contRotula>0 % Si el boto edici est pitjat i existeixen rtules
            [cerrar]=ventanaInfo(figcme2); %Es crea una finestra amb un missatge informatiu.
            
            if cerrar==0 %Si la resposta de l a funci s 0 torna a possar el bot en estat apagat i retorna.
                set(botoEdicio,'state','off'); 
                return;
            end
            
            flagcalculat=0; % Es restableix el flag que indica que hi ha una estrucuctura ja calculada.
            set(get(panel3,'Children'),'Enable','off') % Es desactiven els botons que controlen els resultats.
            set(get(barraeines,'Children'),'Enable','on') % S'activen els botons de la barra d'eines.
            set(panelResultats,'Visible','off');
              
            %Elimino les grfiques i el que hi ha dibuixat
            diagrames=diagrama.empty(1,0); % nova llista d'objectes diagrama.
            delete(get(grafica,'Children')) % esborra tots els objectes grfics.
            %set(grafica_est,'XLim',XLimini,'YLim',YLimini,'ZLim',ZLimini) % Estableix els lmits originals.
            [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
            numeroRotules=0; % Nova variable nmero rtules pel popuomenu
            
            %popupMenu = uicontrol(panelPlastic,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup    
            set(popupMenu,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup    

            %Recupero les barres i els nusos inicials, es a dir
            %l'estructura inicialment introduida per l'usuari
            barres=dadesRotules(1).barresInicial;
            nusos=dadesRotules(1).nusosInicial;
            contnus=dadesRotules(1).contnusInicial;
            contbarra=dadesRotules(1).contbarraInicial;
            contRotula=0;
            Retorn_reaccions=0;
            hgreaccions=0;
            
            %Redibuixo l'estructura
            redibuixar_nusos2 % Dibuixa i gira els nusos segons les barres connectades o la seva posici relativa.

            redibuixa_carreganusos2
            escalar_nusos % Reescala els nusos i les seves carregues.
            redibuixar_barres2
            redibuixar_carregues_barres2
            escala % Calcula el factor d'escala s.

            %Elimino les dades de les rtules
            dadesRotules=dadesRotula.empty(1,0);
            
            %Activo de nou el bot calcular
            set(botocalcular1,'enable','on');
            
            
            
        else % Si el bot edici no est pitjat...
            set(get(panel3,'Children'),'Enable','on') % Activa els botons que controlen la mostra de resultats.
            set(botobarracrear,'Enable','off') % Desactiven els botons de la barra d'eines.
            set(botobarramodificar,'Enable','off')
            set(botobarraesborrar,'Enable','off')
            set(botobarranus,'Enable','off')
            set(botobarrabarra,'Enable','off')
            set(botobarracarreganus,'Enable','off')
            set(botobarracarregabarra,'Enable','off')

            diagcarregues % Mostra les crregues si estan seleccionades.
            diagreaccions % Mostra les reaccions si estan seleccionades.
            visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
        end
        clicable % Estableix quins objectes son susceptibles de ser cliquejats segons l'estat de la bara d'eines
        colors
        %disp(['/Edicio: ',num2str(toc(tic_edicio))])
    end

    function reixeta(hObject,~,~)
        % Activa i desactiva la reixeta.       
        if  strcmp(get(hObject,'State'),'on')
            grid on
            %grid minor % Reixeta ms tupida.
        else
            grid off
        end
    end

    function centrar(~,~,~)
        % Centra l'estructura a la grfica i estableix els lmits.

        %disp('Centrar')
        %tic_centrar=tic;
        if grafica==grafica_est % Si s'estan mostrant els resultats en detall per barra no es fa res.
            calcul_cord_extrems % Clcul de les coordenades extremes de la estructura.

            tam=get(grafica_est,'Position'); % Posici i tamany de la grafica. Valors de tamany horitzontal en tam(3), i en Vertical en tam(4).
            
            switch vista
                case 'xy'
                    if (xmax-xmin)*tam(4)/tam(3)<(ymax-ymin) % Si la relaci alada/amplada de l'estructura es mes gran que la de la grfica...
                        ampx=(ymax-ymin)*tam(3)/tam(4); % Amplada horitzontal en funci de l'alada Vertical.
                        ampy=(ymax-ymin);
                        XL=[xmed-ampx/1.5,xmed+ampx/1.5];
                        YL=[ymed-ampy/1.5,ymed+ampy/1.5];
                    elseif xmax==xmin && ymax==ymin
                        XL=XLimini+[xmed,xmed];
                        YL=XLimini*tam(4)/tam(3)+[ymed,ymed];
                    else % Si la relaci alada/amplada s menor que la de la grfica...
                        ampx=(xmax-xmin);
                        ampy=(xmax-xmin)*tam(4)/tam(3); % Alada en funci de l'amplada
                        XL=[xmed-ampx/1.5,xmed+ampx/1.5];
                        YL=[ymed-ampy/1.5,ymed+ampy/1.5];
                    end
                    set(grafica_est,'XLim',XL,'YLim',YL,'ZLim',ZLimini); % Assigna els valors als eixos de la grfica.
                case 'xz'
                    if (xmax-xmin)*tam(4)/tam(3)<(zmax-zmin) % Si la relaci alada/amplada de l'estructura es mes gran que la de la grfica...
                        ampx=(zmax-zmin)*tam(3)/tam(4); % Amplada horitzontal en funci de l'alada Vertical.
                        ampz=zmax-zmin;
                        XL=[xmed-ampx/1.5,xmed+ampx/1.5];
                        ZL=[zmed-ampz/1.5,zmed+ampz/1.5];
                    elseif xmax==xmin && zmax==zmin
                        XL=XLimini+[xmed,xmed];
                        ZL=XLimini*tam(4)/tam(3)+[zmed,zmed];
                    else % Si la relaci alada/amplada s menor que la de la grfica...
                        ampx=xmax-xmin;
                        ampz=(xmax-xmin)*tam(4)/tam(3); % Alada en funci de l'amplada
                        XL=[xmed-ampx/1.5,xmed+ampx/1.5];
                        ZL=[zmed-ampz/1.5,zmed+ampz/1.5];
                    end
                    set(grafica_est,'XLim',XL,'YLim',YLimini,'ZLim',ZL); % Assigna els valors als eixos de la grfica.
                case 'yz'
                    if (ymax-ymin)*tam(4)/tam(3)<(zmax-zmin) % Si la relaci alada/amplada de l'estructura es mes gran que la de la grfica...
                        ampy=(zmax-zmin)*tam(3)/tam(4); % Amplada horitzontal en funci de l'alada Vertical.
                        ampz=zmax-zmin;
                        YL=[ymed-ampy/1.5,ymed+ampy/1.5];
                        ZL=[zmed-ampz/1.5,zmed+ampz/1.5];
                    elseif ymax==ymin && zmax==zmin
                        YL=YLimini+[ymed,ymed];
                        ZL=YLimini*tam(4)/tam(3)+[zmed,zmed];
                    else % Si la relaci alada/amplada s menor que la de la grfica...
                        ampy=ymax-ymin;
                        ampz=(ymax-ymin)*tam(4)/tam(3); % Alada en funci de l'amplada
                        YL=[ymed-ampy/1.5,ymed+ampy/1.5];
                        ZL=[zmed-ampz/1.5,zmed+ampz/1.5];
                    end
                    set(grafica_est,'XLim',XLimini,'YLim',YL,'ZLim',ZL); % Assigna els valors als eixos de la grfica.
                case '3d'
                    ct=[xm,ym,zm]; % Punt 'camera target' centre de l'estructura.
                    minlim=min([xmin,ymin,zmin]); % Mnim
                    maxlim=max([xmax,ymax,zmax]); % Mxim
                    angle3d=pi/4;
                    set(grafica_est,'XLim',[minlim,maxlim],'YLim',[minlim,maxlim],'ZLim',[minlim,maxlim],'CameraPosition',ct+[cos(angle3d),1,sin(angle3d)]); % Vista isomtrica.
            end
            escala % Calcula el factor d'escala s.
            escalar_nusos % Reescala els nusos i les seves carregues.
            redibuixar_carregues_barres % Redibuixa les crregues sobre les barres amb la nova escala.
            clicable % Estableix quins objectes responen al ratoli segons els botons de la barra.
        end
        %disp(['/Centrar: ',num2str(toc(tic_centrar))])
    end

    function calcul_cord_extrems
        % Calcula les coordenades extremes i mitjes de l'estructura.
        
        if contnus % Si hi ha nusos definits...
            xmin=nusos(1).posicio(1);
            xmax=nusos(1).posicio(1);
            ymin=nusos(1).posicio(2);
            ymax=nusos(1).posicio(2);
            zmin=nusos(1).posicio(3);
            zmax=nusos(1).posicio(3);
            xm=nusos(1).posicio(1);
            ym=nusos(1).posicio(2);
            zm=nusos(1).posicio(3);
            for i=2:contnus % Si hi ha ms d'un nus...
                xmin=min(xmin,nusos(i).posicio(1)); % x mnima
                xmax=max(xmax,nusos(i).posicio(1)); % x mxima
                xm=xm+nusos(i).posicio(1); % sumatori de x
                ymin=min(ymin,nusos(i).posicio(2));
                ymax=max(ymax,nusos(i).posicio(2));
                ym=ym+nusos(i).posicio(2);
                zmin=min(zmin,nusos(i).posicio(3));
                zmax=max(zmax,nusos(i).posicio(3));
                zm=zm+nusos(i).posicio(3);
            end
            xm=xm/contnus; % crea la mitja de x
            ym=ym/contnus;
            zm=zm/contnus;
        else % Si no hi ha nusos definits...
            xmin=XLimini(1)*0.75;
            xmax=XLimini(2)*0.75;
            ymin=YLimini(1)*0.75;
            ymax=YLimini(2)*0.75;
            zmin=ZLimini(1)*0.75;
            zmax=ZLimini(2)*0.75;
            xm=(XLimini(1)+XLimini(2))*0.75/2;
            ym=(YLimini(1)+YLimini(2))*0.75/2;
            zm=(ZLimini(1)+ZLimini(2))*0.75/2;
        end
        xmed=(xmin+xmax)/2; % mitja dels extrems de x
        ymed=(ymin+ymax)/2;
        zmed=(zmin+zmax)/2;
    end

    function vistaxy(hObject,~,~)
        % S'executa quan es selecciona la vista XY.
        
        %disp('Vista XY')
        %tic_xy=tic;
        if strcmp(get(hObject,'State'),'on') && grafica==grafica_est
            vista='xy'; % Variable global vista controla el mode de vista actual del programa.
            set(botoYZ,'State','off');
            set(botoXZ,'State','off');
            set(boto3D,'State','off');
            
            
            set(grafica_est,'View',[0,90],'Box','on'); % Vista del plnol XY.
            set(editx,'Enable','off'); % Desactiva la caixa de text amb la coordenada en x perque no es pugui editar.
            set(edity,'Enable','off'); % Desactiva la caixa de text amb la coordenada en y perque no es pugui editar.
            set(editz,'Enable','on','String','0'); % Activa la caixa de text amb la coordenada z per editar la profunditat.
           
            if flagcalculat && contRotula==0 % Si est activat el flagcalculat i no existeixen rtules
                redibuixar_nusos
                redibuixar_barres
                redibuixa_carreganusos
                redibuixar_carregues_barres
                esborra_diagramesireaccions
                dibuixa_reaccions
                dibuixa_diagramesideformada
                diagcarregues
                diagreaccions
                visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
            
            elseif flagcalculat && contRotula>0 % Si est activat el flagcalculat i no existeixen rtules
         
                %Esborro barres, nusos i crregues
                for n=1:1:contnus
                    esborrarcarreganus2(n);
                end
                for n=1:1:contbarra
                    esborrarcarregabarra(n);
                end
                delete(nusos(:).hg);
                delete(barres(:).hg);
                
                
                val=get(popupMenu,'value'); 
                barres=dadesRotules(val).barres;                                 %Recupera totes les barres existents a la rtula prvia
                nusos=dadesRotules(val).nusos;                                   %Recupera tots els nusos existents a la rtula prvia
                contnus=dadesRotules(val).contnus;                               %Recupera el num de nusos a la rtula prvia
                contbarra=dadesRotules(val).contbarra;                           %Recupera el num de barres a la rtula prvia
                TL2G=dadesRotules(val+1).TL2G;
                
                %Esborra els diagrames i les reaccions anteriors
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions);
                
                %Dibuja les reaccions i els diagrames
                dibuixa_reaccions
                dibuixa_diagramesideformadaPlastic(ecuacionesF)
                
                barres=dadesRotules(val+1).barres;                                 %Recupera totes les barres existents 
                nusos=dadesRotules(val+1).nusos;                                   %Recupera tots els nusos existents
                contnus=dadesRotules(val+1).contnus;                               %Recupera el num de nusos
                contbarra=dadesRotules(val+1).contbarra;                           %Recupera el num de barres
                
                %Es redibuixen els nusos, barres, crregues i reaccions
                redibuixar_nusos2
                %delete(diagramesRotules(:));
                contadorR=1;
                for i=1:contnus %Asigna color a les rtules
                   if nusos(i).color(2) ==1
                    chgcolor(nusos(i).hg,[0 1 0])
                    %Dibuixo esferes on es creen les rtules
                    posicio=nusos(i).posicio;
                    [x,y,z] = sphere();
                    %escala; 
                    r = 0.08*s;
                    diagramesRotules(contadorR)=surf((x)*r+posicio(1),(y)*r+posicio(2),(z)*r+posicio(3));
                    set(diagramesRotules(contadorR),'EdgeColor','none', ... 
                    'FaceColor','green'); 
                    contadorR=contadorR+1;
                   end  
                end
                redibuixar_barres2
                redibuixa_carreganusos2
                redibuixar_carregues_barres2
                diagcarregues
                diagreaccions
                
                %Activo y desactivo les opcions de dibuix dels diagrames
                set(bototallantY,'value',1);
                set(bototallantZ,'value',0);
                set(botomomentX,'value',0);
                set(botomomentY,'value',0);
                set(botomomentZ,'value',1);
       
                visibilitat_diagrames 
            end
            centrar % Centra l'estructura a la grfica.
        else
            set(hObject,'Value',abs(get(hObject,'Value')-1)); % Evita que es deseleccioni la vista, el que faria que no hi hagus cap seleccionada.
        end
        %disp(['/Vista XY: ',num2str(toc(tic_xy))])
    end

    function vistaxz(hObject,~,~)
        % S'executa quan es selecciona la vista XZ.
        
        %disp('Vista XZ')  
        %tic_xz=tic;
        if strcmp(get(hObject,'State'),'on') && grafica==grafica_est
            vista='xz'; % Variable global vista controla el mode de vista actual del programa.
            set(botoXY,'State','off'); % Deselecciona les altres vistes.
            set(botoYZ,'State','off');
            set(boto3D,'State','off');
           
            set(grafica_est,'View',[0,0],'Box','on'); % Vista del plnol XZ.
            set(editx,'Enable','off'); % Desactiva la caixa de text amb la coordenada en x perque no es pugui editar.
            set(edity,'Enable','on','String','0'); % Activa la caixa de text amb la coordenada y per editar la profunditat.
            set(editz,'Enable','off'); % Desactiva la caixa de text amb la coordenada en z perque no es pugui editar.
          
            if flagcalculat && contRotula==0 % Si est activat el flagcalculat i no existeixen rtules
                redibuixar_nusos
                redibuixar_barres
                redibuixa_carreganusos
                redibuixar_carregues_barres
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions);
                dibuixa_reaccions
                dibuixa_diagramesideformada
                diagcarregues
                diagreaccions
                visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
            elseif flagcalculat && contRotula>0 % Si est activat el flagcalculat i existeixen rtules
                
                %Esborro barres, nusos i crregues
                for n=1:1:contnus
                    esborrarcarreganus2(n);
                end
                for n=1:1:contbarra
                    esborrarcarregabarra(n);
                end
                delete(nusos(:).hg);
                delete(barres(:).hg);
                
                
                val=get(popupMenu,'value'); 
                barres=dadesRotules(val).barres;                                 %Recupera totes les barres existents a la rtula prvia
                nusos=dadesRotules(val).nusos;                                   %Recupera tots els nusos existents a la rtula prvia
                contnus=dadesRotules(val).contnus;                               %Recupera el num de nusos a la rtula prvia
                contbarra=dadesRotules(val).contbarra;                           %Recupera el num de barres a la rtula prvia
                TL2G=dadesRotules(val+1).TL2G;
                
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions);
                dibuixa_reaccions
                dibuixa_diagramesideformadaPlastic(ecuacionesF)
                
                barres=dadesRotules(val+1).barres;                                 %Recupera totes les barres existents
                nusos=dadesRotules(val+1).nusos;                                   %Recupera tots els nusos existents
                contnus=dadesRotules(val+1).contnus;                               %Recupera el num de nusos 
                contbarra=dadesRotules(val+1).contbarra;                           %Recupera el num de barres 
                
                %Es redibuixen els nusos, barres, crregues i reaccions
                redibuixar_nusos2
                %delete(diagramesRotules(:));
                
                contadorR=1;
                for i=1:contnus %Asigna color a les rtules
                   if nusos(i).color(2) ==1
                    chgcolor(nusos(i).hg,[0 1 0])
                    %Dibuixo esferes on es creen les rtules
                    posicio=nusos(i).posicio;
                    [x,y,z] = sphere();
                    %escala; 
                    r = 0.08*s;
                    diagramesRotules(contadorR)=surf((x)*r+posicio(1),(y)*r+posicio(2),(z)*r+posicio(3));
                    set(diagramesRotules(contadorR),'EdgeColor','none', ... 
                    'FaceColor','green'); 
                    contadorR=contadorR+1;
                   end  
                end
                redibuixar_barres2
                redibuixa_carreganusos2
                redibuixar_carregues_barres2
                diagcarregues
                diagreaccions
                
                set(bototallantY,'value',0);
                set(bototallantZ,'value',1);
                set(botomomentX,'value',0);
                set(botomomentY,'value',1);
                set(botomomentZ,'value',0);
                
                visibilitat_diagrames 
            end
                
            centrar % Centra l'estrcutura a la grafica.
        else
            set(hObject,'Value',abs(get(hObject,'Value')-1)); % Evita que es deseleccioni la vista, el que faria que no hi hagus cap seleccionada.
        end
        %disp(['/Vista XY: ',num2str(toc(tic_xz))])
    end

    function vistayz(hObject,~,~)
        % S'executa quan es selecciona la vista YZ.

        %disp('Vista YZ') 
        %tic_yz=tic; 
        if strcmp(get(hObject,'State'),'on') && grafica==grafica_est
            vista='yz'; % Variable global vista controla el mode de vista actual del programa.
            set(botoXY,'State','off'); % Deselecciona les altres vistes.
            set(botoXZ,'State','off');
            set(boto3D,'State','off');
            
            set(grafica_est,'View',[90,0],'Box','on'); % Vista del plnol YZ.
            set(editx,'Enable','on','String','0'); % Activa la caixa de text amb la coordenada x per editar la profunditat.
            set(edity,'Enable','off'); % Desactiva la caixa de text amb la coordenada en y perque no es pugui editar.
            set(editz,'Enable','off'); % Desactiva la caixa de text amb la coordenada en z perque no es pugui editar.
            
            if flagcalculat && contRotula==0 % Si est activat el flagcalculat i no existeixen rtules
                redibuixar_nusos
                redibuixar_barres
                redibuixa_carreganusos
                redibuixar_carregues_barres
                esborra_diagramesireaccions
                dibuixa_reaccions
                dibuixa_diagramesideformada
                diagcarregues
                diagreaccions
                visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
           
            elseif flagcalculat && contRotula>0 % Si est activat el flagcalculat i existeixen rtules
                
                %Esborro barres, nusos i crregues
                for n=1:1:contnus
                    esborrarcarreganus2(n);
                end
                for n=1:1:contbarra
                    esborrarcarregabarra(n);
                end
                delete(nusos(:).hg);
                delete(barres(:).hg);
                
                val=get(popupMenu,'value'); 
                barres=dadesRotules(val).barres;                                 %Recupera totes les barres existents a la rtula prvia
                nusos=dadesRotules(val).nusos;                                   %Recupera tots els nusos existents a la rtula prvia
                contnus=dadesRotules(val).contnus;                               %Recupera el num de nusos a la rtula prvia
                contbarra=dadesRotules(val).contbarra;                           %Recupera el num de barres a la rtula prvia
                TL2G=dadesRotules(val+1).TL2G;
                
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions);
                dibuixa_reaccions
                dibuixa_diagramesideformadaPlastic(ecuacionesF)
                
                barres=dadesRotules(val+1).barres;                                 %Recupera totes les barres existents 
                nusos=dadesRotules(val+1).nusos;                                   %Recupera tots els nusos existents 
                contnus=dadesRotules(val+1).contnus;                               %Recupera el num de nusos
                contbarra=dadesRotules(val+1).contbarra;                           %Recupera el num de barres 
                
                %Es redibuixen els nusos, barres, crregues i reaccions
                redibuixar_nusos2
                %delete(diagramesRotules(:));
                contadorR=1;
                for i=1:contnus %Asigna color a les rtules
                   if nusos(i).color(2) ==1
                    chgcolor(nusos(i).hg,[0 1 0])
                    %Dibuixo esferes on es creen les rtules
                    posicio=nusos(i).posicio;
                    [x,y,z] = sphere();
                    %escala; 
                    r = 0.08*s;
                    diagramesRotules(contadorR)=surf((x)*r+posicio(1),(y)*r+posicio(2),(z)*r+posicio(3));
                    set(diagramesRotules(contadorR),'EdgeColor','none', ... 
                    'FaceColor','green'); 
                    contadorR=contadorR+1;
                   end  
                end
                redibuixar_barres2
                redibuixa_carreganusos2
                redibuixar_carregues_barres2
                diagcarregues
                diagreaccions
                
                set(bototallantY,'value',1);
                set(bototallantZ,'value',1);
                set(botomomentX,'value',1);
                set(botomomentY,'value',0);
                set(botomomentZ,'value',0);
                
                visibilitat_diagrames 
              
            end
            centrar % Centra l'estrcutura a la grafica.
        else
            set(hObject,'Value',abs(get(hObject,'Value')-1)); % Evita que es deseleccioni la vista, el que faria que no hi hagus cap seleccionada.
        end
        %disp(['/Vista XY: ',num2str(toc(tic_yz))])
    end

    function vista3d(hObject,~,~)
        % S'executa quan es selecciona la vista 3D.        
        % Es defineix que la cmara apunti al punt mig de l'estructura, i el punt d'observaci a la mateixa distncia a tots els eixos per obtenir una vista isomtrica.
        % Es defineixen els limits iguals a tots els eixos.
        
        %disp('Vista 3D')
        %tic_3d=tic;
        if strcmp(get(hObject,'State'),'on') && grafica==grafica_est
            vista='3d'; % Variable global vista controla el mode de vista actual del programa.
            set(botoXY,'State','off'); % Deselecciona les altres vistes.
            set(botoXZ,'State','off');
            set(botoYZ,'State','off');
            
            set(editx,'Enable','off'); % Desactiva les caixes de text amb les coordenades.
            set(edity,'Enable','off');
            set(editz,'Enable','off');
            
            if flagcalculat && contRotula==0
                redibuixar_nusos
                redibuixar_barres
                redibuixa_carreganusos
                redibuixar_carregues_barres
                esborra_diagramesireaccions
                dibuixa_reaccions
                dibuixa_diagramesideformada
                diagcarregues
                diagreaccions
                visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
            elseif flagcalculat && contRotula>0
                
                %Esborro barres, nusos i crregues
                for n=1:1:contnus
                    esborrarcarreganus2(n);
                end
                for n=1:1:contbarra
                    esborrarcarregabarra(n);
                end
                delete(nusos(:).hg);
                delete(barres(:).hg);
               
                
                 val=get(popupMenu,'value'); 
                barres=dadesRotules(val).barres;                                 %Recupera totes les barres existents a la rtula prvia
                nusos=dadesRotules(val).nusos;                                   %Recupera tots els nusos existents a la rtula prvia
                contnus=dadesRotules(val).contnus;                               %Recupera el num de nusos a la rtula prvia
                contbarra=dadesRotules(val).contbarra;                           %Recupera el num de barres a la rtula prvia
                TL2G=dadesRotules(val+1).TL2G;
                
                [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions);
                dibuixa_reaccions
                dibuixa_diagramesideformadaPlastic(ecuacionesF)
                
                barres=dadesRotules(val+1).barres;                                 %Recupera totes les barres existents
                nusos=dadesRotules(val+1).nusos;                                   %Recupera tots els nusos existents 
                contnus=dadesRotules(val+1).contnus;                               %Recupera el num de nusos 
                contbarra=dadesRotules(val+1).contbarra;                           %Recupera el num de barres 
                
                %Es redibuixen els nusos, barres, crregues i reaccions
                redibuixar_nusos2
                %delete(diagramesRotules(:));
                contadorR=1;
                for i=1:contnus %Asigna color a les rtules
                   if nusos(i).color(2) ==1
                    chgcolor(nusos(i).hg,[0 1 0])
                    %Dibuixo esferes on es creen les rtules
                    posicio=nusos(i).posicio;
                    [x,y,z] = sphere();
                    %escala; 
                    r = 0.08*s;
                    diagramesRotules(contadorR)=surf((x)*r+posicio(1),(y)*r+posicio(2),(z)*r+posicio(3));
                    set(diagramesRotules(contadorR),'EdgeColor','none', ... 
                    'FaceColor','green'); 
                    contadorR=contadorR+1;
                   end  
                end
                redibuixar_barres2
                redibuixa_carreganusos2
                redibuixar_carregues_barres2
                diagcarregues
                diagreaccions
                
                set(bototallantY,'value',1);
                set(bototallantZ,'value',1);
                set(botomomentX,'value',1);
                set(botomomentY,'value',0);
                set(botomomentZ,'value',0);
                
                visibilitat_diagrames 
            end

            ct=[xm,ym,zm]; % Punt 'camera target' centre de l'estructura.
            minlim=min([xmin,ymin,zmin]); % Mnim
            maxlim=max([xmax,ymax,zmax]); % Mxim
            angle3d=pi/4;

            set(grafica_est,'XLim',[minlim,maxlim],'YLim',[minlim,maxlim],'ZLim',[minlim,maxlim],'CameraTarget',ct,'CameraPosition',ct+[cos(angle3d),1,sin(angle3d)],'CameraUpVector',[0,1,0],'Box','off'); % Vista isomtrica.
            axis equal % Mante la relaci entre els eixos.
            
            centrar
        else
            set(hObject,'Value',abs(get(hObject,'Value')-1)); % Evita que es deseleccioni la vista, el que faria que no hi hagus cap seleccionada.
        end
        %disp(['/Vista XY: ',num2str(toc(tic_3d))])
    end
%% CREACI I ACCIONS SOBRE EL PANELL QUE CONT ELS BOTONS QUE CONTROLEN EL CLCUL PLSTIC

    function [panelPlastic,panelResultats,factorTotalResultat,factorParcialResultat,numeroTotalRotula,numeroRotula,popupMenu,botoResultatsPlastics]=panell_botons_plastic(contRotula)
        contRotula1=contRotula+1;
        numeroRotules=zeros(contRotula1,1);
        
        panelPlastic=uipanel(figcme2,'Units','pixels','Position',[tm(1)-115,35,115,375],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Clcul Plstic:'); % Creaci del panell plstic. 
        popupMenu = uicontrol(panelPlastic,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); % Creaci del popupmenu amb el cas de rtula estudiat
        panelResultats=uipanel(panelPlastic,'Units','pixels','Position',[5,tm(2)-423,105,130],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',12,'Title','Resultats:'); % Creaci del panell amb resultats del panell plstic. 
        
        %Creem les etiquetes de resultats:
        numeroRotula=uicontrol(panelResultats,'style','text','String','Num Rtula:','Position',[0,90,70,15]); % Definici del text amb el cas de nmero de rtula estudiat
        numeroTotalRotula=uicontrol(panelResultats,'style','text','String','Total Rtules:','Position',[0,70,78,15]); % Definici del text amb el nmero total de rtules
        factorTotalResultat=uicontrol(panelResultats,'style','text','String','FC total: ','Position',[0,30,85,15]); % Definici del text amb el factor de crrega total de l'estructura
        factorParcialResultat=uicontrol(panelResultats,'style','text','String','FC Rtula: ','Position',[0,50,100,15]); % Definici del text amb el factor de crrega fins al cas estudiat
        
        botoResultatsPlastics=uicontrol(panelResultats,'Units','pixels','Position',[2,5,97,22],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',10,'String','Informaci Rtula','Enable','off','Callback',@resultatsRotula,'Value',0,'KeyPressFcn',@tecla); % Definici del bot per la mostra de resultats amb detall de la rtula
        
        %set(botoResultatsPlastics,'visible','off');% El bot est desactivat fins que no hi han resultats de rtula
        set(panelResultats,'Visible','off'); % El panell est desactivat fins que no hi han resultats per mostrar
        set(panelPlastic,'Visible','off'); % El panell esta desactivat fins que no es pitja la pestanya calcul plstic
    end

 %% CREACI I ACCIONS SOBRE EL PANELL QUE CONT ELS BOTONS QUE CONTROLEN EL CLCUL D'INESTABILITAT

    function [panelInest,text1Inest,popupInest,botoinformacio,text2Inest,numiter,text3Inest,numalpha1,text4Inest,numalpha2,text5Inest,nummu,panelres2ord,textsol2ord,popup2ord,botomodvincl]=panell_botons_inestabilitat
                
        panelInest=uipanel(figcme2,'Units','pixels','Position',[tm(1)-115,235,115,375],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','2on ordre:','Visible','off'); % Creaci del panell d'inestabilitat. 
        text1Inest=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-330,100,70],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','Mtode de resoluci'); % Creaci del text 'Metode de resolucio'
        popupInest=uicontrol(panelInest,'Units','pixels','Style','popupmenu','String','Euler|Runge-Kutta','Position',[5,tm(2)-340,100,35],'BackgroundColor','white','Callback',@metoderes,'KeyPressFcn',@tecla); % Creaci del popupmenu amb els mtodes de resoluci
        botoinformacio=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-355,100,25],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Informaci','Callback',@informaciometode,'KeyPressFcn',@tecla);
        text2Inest=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-385,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','N d''iteracions'); % Creaci del text 'n d'iteracions'
        numiter=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-410,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','edit','string',10,'Backgroundcolor','white'); % Creaci de l'editable n anirn el numero d'iteracions
        text3Inest=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-440,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','Alpha 1','visible','off');
        numalpha1=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-465,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','edit','string',0.5,'Backgroundcolor','white','visible','off'); % Creaci de l'editable n anira el numero alpha 1
        text4Inest=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-495,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','Alpha 2','visible','off');
        numalpha2=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-520,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','edit','string',0.5,'Backgroundcolor','white','visible','off'); % Creaci de l'editable n anira el numero alpha 2
        text5Inest=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-550,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','Mu','visible','off');
        nummu=uicontrol(panelInest,'Units','pixels','Position',[5,tm(2)-575,100,25],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','edit','string',0.5,'Backgroundcolor','white','visible','off'); % Creaci de l'editable n anira el numero "mu"
        panelres2ord=uipanel(figcme2,'Units','pixels','Position',[tm(1)-115,75,115,150],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Resultats:','Visible','off');
        textsol2ord=uicontrol(panelres2ord,'Units','pixels','Position',[5,70,100,50],'FontName','default','FontUnits','pixels','Fontsize',14,'Style','Text','String','Coeficient de vinclament');
        popup2ord=uicontrol(panelres2ord,'Style','popupmenu','String','0','Position',[5,40,100,35],'BackgroundColor','white','Callback',@dibres2ord,'KeyPressFcn',@tecla); 
        botomodvincl=uicontrol(panelres2ord,'Units','pixels','Position',[5,15,100,25],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Dibuix mode','Callback',@presentaciomodvincl,'KeyPressFcn',@tecla);
        
    end


%% CREACI I ACCIONS SOBRE EL PANELL QUE CONT ELS BOTONS QUE CONTROLEN ELS RESULTATS QUE ES MOSTREN.

    function [panel3,botocarregues,botoreaccions,botodeformada,botoaxils,bototallantY,bototallantZ,botomomentX,botomomentY,botomomentZ]=panell_botons_grafica
        % Creaci del panell amb els botons.
        panel3=uipanel(figcme2,'Units','pixels','Position',[tm-[300,390],115,200],'BorderType','etchedin','BorderWidth',1,'FontName','default','FontUnits','pixels','FontSize',14,'Title','Grfica:'); % Creacio del panell.
        
        botocarregues=uicontrol(panel3,'Units','pixels','Position',[5,155,105,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Crregues','Foregroundcolor',colorcarregues,'Enable','off','Callback',@diagcarregues,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de crregues.
        botoreaccions=uicontrol(panel3,'Units','pixels','Position',[5,125,105,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Reaccions','Foregroundcolor',colorreaccions,'Enable','off','Callback',@diagreaccions,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de reaccions.
        botodeformada=uicontrol(panel3,'Units','pixels','Position',[5,95,105,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Deformada','Foregroundcolor',colordeformada,'Enable','off','Callback',@diagdeformada,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de deformada.
        botoaxils=uicontrol(panel3,'Units','pixels','Position',[5,65,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','N','Foregroundcolor',colorN,'Enable','off','Callback',@diagN,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de diagrama d'axils.
        bototallantY=uicontrol(panel3,'Units','pixels','Position',[5,35,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Ty','Foregroundcolor',colorTy,'FontWeight','demi','Enable','off','Callback',@diagTy,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de diagrama de tallants en y.
        bototallantZ=uicontrol(panel3,'Units','pixels','Position',[5,5,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Tz','Foregroundcolor',colorTz,'FontWeight','demi','Enable','off','Callback',@diagTz,'KeyPressFcn',@tecla); % Creacio bot vista de diagrama de tallants en z.
        botomomentX=uicontrol(panel3,'Units','pixels','Position',[60,65,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Mx','Foregroundcolor',colorMx,'FontWeight','demi','Enable','off','Callback',@diagMx,'KeyPressFcn',@tecla); % Creacio bot vista de diagrama de moments en x.
        botomomentY=uicontrol(panel3,'Units','pixels','Position',[60,35,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','My','Foregroundcolor',colorMy,'FontWeight','demi','Enable','off','Callback',@diagMy,'KeyPressFcn',@tecla); % Creacio bot vista de diagrames de moments en Y.
        botomomentZ=uicontrol(panel3,'Units','pixels','Position',[60,5,50,25],'Style','togglebutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Mz','Foregroundcolor',colorMz,'FontWeight','demi','Enable','off','Callback',@diagMz,'Value',1,'KeyPressFcn',@tecla); % Creacio bot vista de diagrames de moments en z.
    end

    function diagcarregues(~,~,~)
        % Oculta o mostra les crregues a la representacio de resultats amb
        % el seu color corresponent.
        
        %disp('Oculta o mostra diagrames carregues')
        %tic_dc=tic;
        
        if ~strcmp(get(botoEdicio,'State'),'on')
            if get(botocarregues,'Value') % Si les crregues estan seleccinades...
                vis='on';
            else
                vis='off';
            end
            if grafica==grafica_est
                for i=1:contnus
                   % set(nusos(i).hgc,'Visible',vis) % Visibilitat de les crregues als nusos.
                end
        
                %redibuixar_carregues_barres % Redibuixa les crregues.
                for i=1:contbarra
                    set(barres(i).hgpuntual,'Visible',vis) % Visibilitat de les crregues a les barres.
                    set(barres(i).hgmoment,'Visible',vis)
                    set(barres(i).hgrepartida,'Visible',vis)
                    set(barres(i).hgprojectada,'Visible',vis)
                end
            end
        end
        %disp(['/Oculta o mostra diagrames carregues: ',num2str(toc(tic_dc))])
    end

    function diagreaccions(~,~,~)
        % Oculta o mostra les reaccions a la representaci de resultats.
        
        %disp('Oculta o mostra reaccions')
        %tic_r=tic;
        if grafica==grafica_est
            if get(botoreaccions,'Value')
                set(hgreaccions,'Visible','on')
            else
                set(hgreaccions,'Visible','off')
            end
        end
        %disp(['/Oculta o mostra reaccions: ',num2str(toc(tic_r))])
    end

    function diagdeformada(~,~,~)
        % Oculta o mostra la deformada a la representaci de resultats.
        
        %disp('Oculta o mostra la deformada')
        %tic_d=tic;
        if get(botodeformada,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est    
            for i=1:numel(diagrames)
                set(diagrames(i).hgdeformada,'Visible',vis)
            end
        else
            set(diag_presxy.hgdeformada,'Visible',vis)
            set(diag_presxz.hgdeformada,'Visible',vis)
        end
        %disp(['/Oculta o mostra la deformada: ',num2str(toc(tic_d))])
    end

    function diagN(~,~,~)
        % Oculta o mostra el diagrama d'axils a la representaci de
        % resultats.
        
        %disp('Oculta o mostra el diagrama d''axils')
        %tic_N=tic;
        if get(botoaxils,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgN,'Visible',vis)
            end
        else
            set(diag_presxy.hgN,'Visible',vis)
            set(diag_presxz.hgN,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama d''axils: ',num2str(toc(tic_N))])
    end

    function diagTy(~,~,~)
        % Oculta o mostra el diagrama de tallants en y a la representaci
        % de resultats.
        
        %disp('Oculta o mostra el diagrama de tallants en y')
        %tic_Ty=tic;
        if get(bototallantY,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgTy,'Visible',vis)
            end
        else
            set(diag_presxy.hgTy,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama de tallants en y: ',num2str(toc(tic_Ty))])
    end

    function diagTz(~,~,~)
        % Oculta o mostra el diagrama de tallants en z a la representaci
        % de resultats.
        
        %disp('Oculta o mostra el diagrama de tallants en z')
        %tic_Tz=tic;
        if get(bototallantZ,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgTz,'Visible',vis)
            end
        else
            set(diag_presxz.hgTz,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama de tallants en z: ',num2str(toc(tic_Tz))])
    end

    function diagMx(~,~,~)
        % Oculta o mostra el diagrama de moments en x a la representaci
        % de resultats.
        
        %disp('Oculta o mostra el diagrama de moments torsors')
        %tic_Mx=tic;
        if get(botomomentX,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgMx,'Visible',vis)
            end
        else
           set(diag_presxy.hgMx,'Visible',vis)
           set(diag_presxz.hgMx,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama de moments torsors: ',num2str(toc(tic_Mx))])
    end

    function diagMy(~,~,~)
        % Oculta o mostra el diagrama de moments en y a la representaci
        % de resultats.
        
        %disp('Oculta o mostra el diagrama de moments flectors en y')
        %tic_My=tic;
        if get(botomomentY,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgMy,'Visible',vis)
            end
        else
            set(diag_presxz.hgMy,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama de moments flectors en y: ',num2str(toc(tic_My))])
    end

    function diagMz(~,~,~)
        % Oculta o mostra el diagrama de moments en z a la representaci
        % de resultats.
        
        %disp('Oculta o mostra el diagrama de moments flectors en z')
        %tic_Mz=tic;
        if get(botomomentZ,'Value')
            vis='on';
        else
            vis='off';
        end
        if grafica==grafica_est
            for i=1:numel(diagrames)
                set(diagrames(i).hgMz,'Visible',vis)
            end
        else
            set(diag_presxy.hgMz,'Visible',vis)
        end
        %disp(['/Oculta o mostra el diagrama de moments flectors en z: ',num2str(toc(tic_Mz))])
    end

    function visibilitat_diagrames
        % Oculta o mostra el conjunt de diagrames i deformada.
        
        %disp('Visaibilitat diagrames')
        %tic_vd=tic;
        diagN
        diagTy
        diagTz
        diagMx
        diagMy
        diagMz
        diagdeformada
        %disp(['/Visibilitat diagrames: ',num2str(toc(tic_vd))])
    end
%% CREACI I ACCIONS QUE S'EXECUTEN AMB EL BOT CALCULAR.

    function botocalcular1=boto_calcular
        % Creaci del boto calcular.
        botocalcular1=uicontrol(figcme2,'Units','pixels','Position',[tm(1)-115,5,115,25],'Style','pushbutton','FontName','default','FontUnits','pixels','FontSize',14,'String','Calcular','Callback',@tipus_calcul,'KeyPressFcn',@tecla);
    end


    function tipus_calcul(~,~,~)%Hem serveix per veure a quina pestanya em trobo.
       if get(botoCalculEstatic,'Value') %Si esta seleccionada la pestanya de clcul esttic passa a la funci calcular
            calcular;
       end
       
     if get(botoCalculPlastic,'Value') % Si est seleccionada la pestanya del clcul plstic passa a la funci calcular2
           calcular2; 
     end
     
     if get (botoCalculInestabilitat,'Value') % Si est seleccionada la pestanya del clcul d'inestabilitat passa a la funci calcular3
         calcular3;
     end
     
    end

    function autopopupcallback(val) % Permet cridar a la mostra de resultats plstics automaticament
    tic
      %Activo el boto de detalls de rtula
      set(botoResultatsPlastics,'enable','on');
        
        nusos=nus.empty(1,0); % nova llista d'objectes nus.
        contnus=0; % comptador de nusos a zero.
        barres=barra.empty(1,0); % nova llista d'objectes barra.
        contbarra=0; % comptador de barres a zero.
        hgreaccions=[]; % esborra la llista de reaccions.
        diagrames=diagrama.empty(1,0); % nova llista d'objectes diagrama.
        delete(get(grafica,'Children')) % esborra tots els objectes grfics.
        %set(grafica_est,'XLim',XLimini,'YLim',YLimini,'ZLim',ZLimini) % Estableix els lmits originals.
        [hg_nusos,hg_barres,hg_carreguesbarres,hg_carreganusos,hg_diagrames]=inicialitza_hg(grafica_est);
        centrar
        set(botoEdicio,'State','off'); % Torna al mode edici.
        edicio % Esborra diagrames, etc..
        
        %Calculo el factor de crrega parcial
        factorCarrega=0;
        for x=2:val+1
            factorCarrega=factorCarrega+dadesRotules(x).factorCarrega;   %Recupera el factor de crrega total fins la rtula que es demana.
        end
        display(factorCarrega);
        
        %calculo el factor de crrega total
        factorCarregaTotal=factorCarrega;
        for x=val+2:contRotula
            factorCarregaTotal=factorCarregaTotal+dadesRotules(x).factorCarrega; %Recupera el factor de crrega total fins la ltima rtula.
        end
        
        
        %Mostra els resultats a les caixes de text
        set(panelResultats,'Visible','on');
        set(factorTotalResultat,'String',['FC total: ',num2str(factorCarregaTotal)]);
        set(factorTotalResultat,'position',[1,30,100,15],'HorizontalAlignment','left');
        set(factorParcialResultat,'position',[1,50,100,15],'HorizontalAlignment','left');
        set(factorParcialResultat,'String',['FC Rtula: ',num2str(factorCarrega)]);
        set(numeroTotalRotula,'String',['Total Rtules: ',num2str(contRotula-1)]);
        set(numeroRotula,'String',['Num Rtula: ',num2str(val)]);
        %set(botoResultatsPlastics,'Enable','on');

        barres=dadesRotules(val).barres;                                 %Recupera totes les barres existents a la rtula prvia
        nusos=dadesRotules(val).nusos;                                   %Recupera tots els nusos existents a la rtula prvia
        contnus=dadesRotules(val).contnus;                               %Recupera el num de nusos a la rtula prvia
        contbarra=dadesRotules(val).contbarra;                           %Recupera el num de barres a la rtula prvia
        TL2G=dadesRotules(val+1).TL2G;
        %1.Recupero les dades de la rtula prvia amb la finalitat de fer
        %correctament els clculs dels diagrames, per exemple, a la barra
        %es produeix una rtula al centre, si recupero les dades tenint en
        %compte la rtula al centre, no podre efectuar els clculs per tal
        %de dibuixar el diagrama, doncs tindre moviments, esforcos, etc de
        %n-1 barres i n barres dibuixades. D'aquesta forma faig els clculs
        %per dibuixar els diferents diagrames i desprs redibuixo
        %correctament les barres i punts de la rtula pertinent
        
        for i=1:1:contbarra % Multiplico les crregues de les barres pel factor de crrega pertinent
            barres(i).projectada(1)=barres(i).projectada(1)*factorCarrega;
            barres(i).moment(1)=barres(i).moment(1)*factorCarrega;
            barres(i).repartida(1)=barres(i).repartida(1)*factorCarrega;
            barres(i).puntual(1)=barres(i).puntual(1)*factorCarrega;           
        end
        reaccions=0; 
        for x=1:1:val+1 %Efectua una suma de les reaccions de tots els casos prvis.
            increment=dadesRotules(x).Retorn_reaccions;
            if length(increment)==reaccions;
                reaccions=reaccions'+increment;
            else
               reaccions(length(reaccions)+1:length(increment),1)=0; %Faif ms gran el vector per tal de poder sumar b les dades
               reaccions=reaccions+increment;
            end
        end
        Retorn_reaccions=reaccions;
        flagcalculat=1;
        if get(botoreaccions,'value')==1
            maxpuntual
            dibuixa_reaccions
        else
            maxpuntual
            dibuixa_reaccions
            set(hgreaccions,'Visible','off');
        end
        %Faig el mateix amb les ecuacions d'axil, tallant i moment, s'ha de
        %prestar especial atenci al fet de que les barres poden estar
        %reordenades pel fet de tindre rtules al mig de barres, i tindre
        %en compte de que si es aix tamb es tindran que readaptar les
        %ecuacions
        cont=0;
                   
            %Igual que en el cas anterior amb els esforcos recupero cada
            %una de les ecuacions i les sumo a les seves anteriores
            
               contbarra1=dadesRotules(val).contbarra; %Nmero de barres al cas anterior
                MatrizFN=zeros(contbarra1,4);          %Matrius de suport on guardarem totes les dades 
                MatrizFTy=zeros(contbarra1,4);
                MatrizFMz=zeros(contbarra1,5);
                MatrizFMx=zeros(contbarra1,5); 
                MatrizFMy=zeros(contbarra1,5);
                MatrizFTz=zeros(contbarra1,4);
                
                MatrizFDx=zeros(contbarra1,5);
                MatrizFDy=zeros(contbarra1,7);
                MatrizFDz=zeros(contbarra1,7);
                MatrizFOz=zeros(contbarra1,6);
                MatrizFOy=zeros(contbarra1,6);

            for x=2:1:val+1 %Itero cada una de les rtules prvies i vaig recuperant les ecuacions barra per barra
          
                    partides=dadesRotules(x).partides;
                    if partides==1
                        %Necessito saber tamb quines barres s'han dividit
                        numBarraPartida=dadesRotules(x).barraNumRotula;                  
                    end
                %Recupero les ecuacions de barra     
                ecuaciones=dadesRotules(x).ecuaciones;
               
                contbarra2=dadesRotules(x-1).contbarra;
                
                MatrizN=zeros(contbarra1,4);        %Matrius de suport parcials, si estan partides s'afegeix una, doncs es sumar una ms
                MatrizTy=zeros(contbarra1,4);
                MatrizMz=zeros(contbarra1,5); 
                MatrizMx=zeros(contbarra1,5);
                MatrizMy=zeros(contbarra1,5);
                MatrizTz=zeros(contbarra1,4);
                
                MatrizDx=zeros(contbarra1,5);
                MatrizDy=zeros(contbarra1,7);
                MatrizDz=zeros(contbarra1,7);
                MatrizOz=zeros(contbarra1,6);
                MatrizOy=zeros(contbarra1,6);

              %Es sumen les equacions tenint en compte si es tenen valors
              %vuits
               for i=1:1:contbarra2
                    N=ecuaciones(i).axil.N; 
                    if ~isempty(N)
                        MatrizN(i,:)=N(:);
                    end
                    Ty=ecuaciones(i).cortante.Ty;
                    if ~isempty(Ty)
                        MatrizTy(i,:)=Ty(:);
                    end
                    Tz=ecuaciones(i).cortante.Tz;
                    if ~isempty(Tz)
                        MatrizTz(i,:)=Tz(:);
                    end 
                    Mx=ecuaciones(i).momento.Mx;
                    if ~isempty(Mx)
                        MatrizMx(i,:)=Mx(:);
                    end
                     My=ecuaciones(i).momento.My;
                    if ~isempty(My)
                        MatrizMy(i,:)=My(:);
                    end
                     Mz=ecuaciones(i).momento.Mz;
                    if ~isempty(Mz)
                        MatrizMz(i,:)=Mz(:);
                    end
                    
                     dx=ecuaciones(i).deformada.dx;
                    if ~isempty(dx) && length(dx)==5
                        MatrizDx(i,:)=dx(:);
                    end
                     dy=ecuaciones(i).deformada.dy;
                    if ~isempty(dy) && length(dy)==7
                        MatrizDy(i,:)=dy(:);
                    end
                     dz=ecuaciones(i).deformada.dz;
                    if ~isempty(dz) && length(dz)==7
                        MatrizDz(i,:)=dz(:);
                    end
                     Oz=ecuaciones(i).deformada.Oz;
                    if ~isempty(Oz)
                        MatrizOz(i,:)=Oz(:);
                    end
                      Oy=ecuaciones(i).deformada.Oy;
                    if ~isempty(Oy)
                        MatrizOy(i,:)=Oy(:);
                    end
                    
               end
               if cont==0 % Si es tracta de la primera iteraci es sumen directament, doncs la matriu principal es 0
                   MatrizFN=MatrizFN+MatrizN;
                   MatrizFTy=MatrizFTy+MatrizTy;
                   MatrizFTz=MatrizFTz+MatrizTz;
                   MatrizFMx=MatrizFMx+MatrizMx;
                   MatrizFMy=MatrizFMy+MatrizMy;
                   MatrizFMz=MatrizFMz+MatrizMz;
                   
                   MatrizFDx=MatrizFDx+MatrizDx;
                   MatrizFDy=MatrizFDy+MatrizDy;
                   MatrizFDz=MatrizFDz+MatrizDz;
                   MatrizFOz=MatrizFOz+MatrizOz;
                   MatrizFOy=MatrizFOy+MatrizOy;
                   
                   cont=1;
               else % Si no es tracta de la primera iteraci es sumen els termes inicials, doncs els dos ltims corresponen a les longituds d'estudi
                  
                   MatrizFN(:,1:2)=MatrizFN(:,1:2)+MatrizN(:,1:2);
                   MatrizFTy(:,1:2)=MatrizFTy(:,1:2)+MatrizTy(:,1:2);
                   MatrizFTz(:,1:2)=MatrizFTz(:,1:2)+MatrizTz(:,1:2);
                   MatrizFMx(:,1:3)=MatrizFMx(:,1:3)+MatrizMx(:,1:3);
                   MatrizFMy(:,1:3)=MatrizFMy(:,1:3)+MatrizMy(:,1:3);
                   MatrizFMz(:,1:3)=MatrizFMz(:,1:3)+MatrizMz(:,1:3);
                   
                   MatrizFDx(:,1:3)=MatrizFDx(:,1:3)+MatrizDx(:,1:3);
                   MatrizFDy(:,1:5)=MatrizFDy(:,1:5)+MatrizDy(:,1:5);
                   MatrizFDz(:,1:5)=MatrizFDz(:,1:5)+MatrizDz(:,1:5);
                   MatrizFOz(:,1:4)=MatrizFOz(:,1:4)+MatrizOz(:,1:4);
                   MatrizFOy(:,1:4)=MatrizFOy(:,1:4)+MatrizOy(:,1:4);
                   
               end   
               if partides==1 && x<val+1
                   %Hem de tindre en compte com s'ahn reordenat les
                   %barres, per tant reordeno la matriu anterior segons
                   %les noves posicions
                   [MatrizFN]=reordenarMatriz(MatrizFN,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   [MatrizFTy]=reordenarMatriz(MatrizFTy,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra);     
                   [MatrizFTz]=reordenarMatriz(MatrizFTz,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra);     
                   [MatrizFMx]=reordenarMatriz(MatrizFMx,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra);     
                   [MatrizFMy]=reordenarMatriz(MatrizFMy,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra);     
                   [MatrizFMz]=reordenarMatriz(MatrizFMz,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   
                   [MatrizFDx]=reordenarMatriz(MatrizFDx,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   [MatrizFDy]=reordenarMatriz(MatrizFDy,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   [MatrizFDz]=reordenarMatriz(MatrizFDz,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   [MatrizFOz]=reordenarMatriz(MatrizFOz,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                   [MatrizFOy]=reordenarMatriz(MatrizFOy,numBarraPartida,dadesRotules(x).barres,dadesRotules(x).nusos,dadesRotules(x).contbarra); 
                  %partides=0;
               end
            end 
 
        %Guardo totes les dades en un struct per treballar amb ells de forma ms cmode
         ecuacionesF.MatrizFN=MatrizFN;
         ecuacionesF.MatrizFTy=MatrizFTy;
         ecuacionesF.MatrizFTz=MatrizFTz;
         ecuacionesF.MatrizFMx=MatrizFMx;
         ecuacionesF.MatrizFMy=MatrizFMy;
         ecuacionesF.MatrizFMz=MatrizFMz;        
         ecuacionesF.MatrizFDx=MatrizFDx;
         ecuacionesF.MatrizFDy=MatrizFDy;
         ecuacionesF.MatrizFDz=MatrizFDz;
         ecuacionesF.MatrizFOy=MatrizFOy;
         ecuacionesF.MatrizFOz=MatrizFOz;
              
        dibuixa_diagramesideformadaPlastic(ecuacionesF); % Dibuixa els diagrames i la deformada. 
       
        %Obtinc els moviments de tots els nodes amb la ultima rtula
        %formada, doncs sern dades necessaries al hora de mostrar els
        %resultats de rotula
        info=dadesRotules(contRotula).info;
        if val+1==contRotula && info==0
            dadesRotules(contRotula).info=1;
            matrizMovimientosNudos=zeros(2,contnus);
            for n=1:1:contbarra
                nusinf=barres(n).nusinf;
                nussup=barres(n).nussup;
               
                Oy=ecuacionesF.MatrizFOy(n,:);
                Oz=ecuacionesF.MatrizFOz(n,:);
                
                %Evaluamos las ecuaciones en el punto inciial i en el final  
               
                GiroYInf=Oy(1)*Oy(5).^3+Oy(2)*Oy(5).^2+Oy(3)*Oy(5)+Oy(4);
                GiroYSup=Oy(1)*Oy(6).^3+Oy(2)*Oy(6).^2+Oy(3)*Oy(6)+Oy(4);
    
                GiroZInf=Oz(1)*Oz(5).^3+Oz(2)*Oz(5).^2+Oz(3)*Oz(5)+Oz(4);
                GiroZSup=Oz(1)*Oz(6).^3+Oz(2)*Oz(6).^2+Oz(3)*Oz(6)+Oz(4);
               
                matrizMovimientosNudos(1,nusinf)=GiroYInf;
                matrizMovimientosNudos(2,nusinf)=GiroZInf;
                matrizMovimientosNudos(1,nussup)=GiroYSup;
                matrizMovimientosNudos(2,nussup)=GiroZSup;
            end
           dadesRotules(contRotula).giroNudos=matrizMovimientosNudos;
        end
        
        
        %2.Ara recupero les barres i les rtules totals, doncs ja s'han
        %dibuixat els diagrames
        
        barres=dadesRotules(val+1).barres;                                 %Recupera totes les barres existents
        nusos=dadesRotules(val+1).nusos;                                   %Recupera tots els nusos existents 
        contnus=dadesRotules(val+1).contnus;                               %Recupera el num de nusos 
        contbarra=dadesRotules(val+1).contbarra;                           %Recupera el num de barres 
        TL2G=dadesRotules(val+1).TL2G;

         for i=1:contnus
            redibuixar_nus2(i) % Redibuixa cada nus.         
         end
        
        for i=1:contbarra %Redibuixa les barres
            redibuixar_barra2(i);
        end
        colorbarres
       
        for i=1:contbarra %Redibuixa les crregues
            redibuixar_carregues_barra2(i)
        end
        colorcarregabarres
        diagcarregues

        for i=1:contnus
          redibuixa_carreganus2(i) % Redibuixa les crregues.
        end
        colorcarreganusos
        
        escala % Calcula el factor d'escala s.
        escalar_nusos
        centrar   
        visibilitat_diagrames

        contadorR=1;
      for i=1:contnus %Asigna color a les rtules          
               if nusos(i).color(2) ==1
                chgcolor(nusos(i).hg,[0 1 0])
                %Dibuixo esferes on es creen les rtules
                posicio=nusos(i).posicio;
                [x,y,z] = sphere();
                escala;
                r = 0.08*s;
                diagramesRotules(contadorR)=surf((x)*r+posicio(1),(y)*r+posicio(2),(z)*r+posicio(3));
                set(diagramesRotules(contadorR),'EdgeColor','none', ... 
                'FaceColor','green'); 
                contadorR=contadorR+1;
               end  
      end
      toc
    end

    function popupcallback(hObject,~,~) %Es la funci que es crida cuan es selecciona alguna opci del popup de clcul plstic
        val = get(hObject,'Value'); % Agafa el valor del popup que correspon al nmero de rtula que es vol estudiar       
         autopopupcallback(val); % Aquesta funci em permet actualitzar el popup i efectuar tots els clculs necessaris per mostrar els resultats            
    end

    function resultatsRotula(~,~,~)
        %Es crida la funcio al pitjar el bot informaci de la rotula
        %S'obre una nova finestra amnb informaci de la rtula, aquesta es:
        %Nmero de rtula
        %Factor de crrega que la produeix
        %Increment de carga amb la rtula prvia
        %Gir produit a la rtula
        %Deformaci total de la rtula?
        
        %Obtenim quina rtula estem visitant
        numRotula=get(popupMenu,'value'); 
        %Obtenim les dades de la rtula
        dades=dadesRotules(numRotula+1);
        
        %Obtenim a quina barra pertany
        barra=dades.barraNumRotula;
        E=barres(barra).E;
        %Obtenim els nusos de la barra
        nusinf=barres(barra).nusinf;
        nussup=barres(barra).nussup;
        
        %Coordenades al espai
        posicio=dades.posicio;
        if posicio>0 
            coordenades=nusos(nussup).posicio;
            nusRotula=nussup;
        else
            coordenades=nusos(nusinf).posicio;
            nusRotula=nusinf;
        end
        
        %Factor de carrega que la forma
        factorCarrega=dades.factorCarrega;
        %Factor de crrega previ
        factorCarregaPrevi=0;
        for i=1:1:numRotula+1
            factorCarregaPrevi=factorCarregaPrevi+dadesRotules(i).factorCarrega;
        end
        %Si ha dividit alguna barra
        partides=dades.partides;
        
        %Deformaci total al colapsar l'estructura
            %Seleccionem l'ltim cas de carrega.
            if numRotula+1 ~=contRotula %Dons la ultima rtula no tindr girs ja que l'estructura colapsa
                dadesUltim=dadesRotules(contRotula).giroNudos(:,nusRotula);
                 GirY=dadesUltim(1);
                 GirZ=dadesUltim(2);
            else
                GirY=Inf;
                GirZ=Inf;
            end
       
        %Creem una finestra amb tota la informacio
        ventanaInformacionRotulas(numRotula,nusRotula,coordenades,factorCarregaPrevi,factorCarrega,partides,GirY,GirZ,figcme2,E);
    end

    function calcular(~,~,~)
        % Surt del mode edici, elimina digrames anteriors.
        % Prepara les dades per cridar a la funcio de clcul est%tic.
        % Representa les reaccions.
        % Amb el resultats del clcul est%tic crida a la funci de clcul i
        % dibuix dels diagrames i la deformada, els escala i colloca al
        % seu lloc. 
        
       
        %disp('Calcular')
        %tic_calc=tic;
        if grafica~=grafica_est % Si no s'esta presentant resultats de barra.
            clic_grafica_res
        end   
        if contbarra % Si hi ha barres.
           [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions); % Esborra els diagrames i les reaccions anteriors si n'hi han.
           [Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom]=prepara_dades_calcul(contnus,nusos,contbarra,barres); % Adapta les dades al format de la funcio de clcul.
           [Retorn_reaccions,Retorn_moviments,Retorn_esforcos_barres,TL2G,ierr,K_Glob,Vector_esforcos,Vector_esforcos_prescrits] = cme2_calcul_estatic(contnus,contbarra,Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom); % Crida a la funci de clcul est%tic.
            if ierr == 0
                flagcalculat=1; % Flag que indica que s'ha calculat una estructura. Permet a la funci que controla l'escala de la deformada amb el teclat coneixer si hi ha deformada.
                maxpuntual % Calcula forces puntuals o reaccions maximes.
                dibuixa_reaccions % Dibuixa les reaccions.
                redibuixar_carregues_barres
                redibuixa_carreganusos
                escalar_nusos
                dibuixa_diagramesideformada % Dibuixa els diagrames i la deformada.
                set(botoEdicio,'State','off'); % Bot edici en mode presentacio.
                edicio % Desactiva botons de la barra d'eines per a l'edici, activa els de mostra de resultats, etc.
            else
                h = errordlg('La matriu de rigidesa s singular. Comproveu les condicions de contorn.','Matriu singular');
                uiwait(h);
            end    
        end
        %disp(['/Calcular: ',num2str(toc(tic_calc))])
    end

    function calcular2() %s la funci encarregada de cridar la funci de clcul plstic i mostrar els resultats finals
           
         if grafica~=grafica_est % Si no s'est presentant resultats de barra.
            clic_grafica_res 
         end
         
        [contnus,barres,contbarra,nusos,dadesRotules,contRotula,err]=calculPlastic(contbarra,contnus,barres,nusos,diagrames,hgreaccions,figcme2); % Funcio que efecta el anlisis de clcul plstic
        
        if err==0 % Si no es dona cap error
            %Ara ja tenim les dades de totes les rtules i les dades de la
            %estructura inicial(dadesRotules(1))             

            %Primer de tot actualitzem la llista de rtules    
            %Creem un string amb tots els punts              
            numeroRotules=zeros(contRotula-1,1); %Actualitza el vector del popup i el fa ms gran cada vegada que es crea una rtula

            %Introdueixo totes les rotules a la matriu
             for i=1:contRotula-1   %Afegeix el nmero de rtules a cada valor del vector.
               numeroRotules(i,1)=i;
             end    
             
            %popupMenu = uicontrol(panelPlastic,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup    
            set(popupMenu,'Style','popupmenu','String',numeroRotules,'Position',[5,tm(2)-458,100,200], 'callback', @popupcallback); %Actualitza el popup    
            set(popupMenu,'value',(numeroRotules(contRotula-1,1))); %Poso el popup a la ltima posic

          
            %Cridem el autopopup per actualitzarlo automticament
            autopopupcallback(contRotula-1);

            %Desactivo el boto calcular
            set(botocalcular1,'enable','off');
       elseif err==2
           %Si es cancela la operaci es tornen a dibuixar totes les dades
           %incials
           contRotula=1;
           edicio;
       end
    end                   
    
    function calcular3() %s la funci encarregada de cridar la funci de l'anlisi de 2on ordre
        
        if grafica~=grafica_est % Si no s'esta presentant resultats de barra.
            clic_grafica_res
        end   
         if contbarra % Si hi ha barres.
           [diagrames,hgreaccions]=esborra_diagramesireaccions(diagrames,hgreaccions); % Esborra els diagrames i les reaccions anteriors si n'hi han.
           [Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom]=prepara_dades_calcul(contnus,nusos,contbarra,barres); % Adapta les dades al format de la funcio de clcul.
           iteracions=str2num(get(numiter,'String'));
           alpha1=str2num(get(numalpha1,'String'));
           alpha2=str2num(get(numalpha2,'String'));
           mu=str2num(get(nummu,'String'));
           
           if isnan(iteracions)
               err1 = errordlg('Comproveu el numero d''iteracions, ha de ser un nombre positiu.','Comprovar iteracions');
               uiwait(err1);
               return;
           elseif isempty(iteracions)
               err2 = errordlg('Comproveu el numero d''iteracions, ha de ser un nombre positiu.','Comprovar iteracions');
               uiwait(err2);
               return;
           elseif iteracions<=0
               err3 = errordlg('Comproveu el numero d''iteracions, ha de ser un nombre positiu.','Comprovar iteracions');
               uiwait(err3);
               return;
           end
           
           metode=get(popupInest,'Value');
           
           if metode==2
           if isnan(alpha1)
               err1 = errordlg('Comproveu el numero alpha 1, ha de ser un nombre entre 0 i 1.','Comprovar alpha 1');
               uiwait(err1);
               return;
           elseif isempty(alpha1)
               err2 = errordlg('Comproveu el numero alpha 1, ha de ser un nombre entre 0 i 1.','Comprovar alpha 1');
               uiwait(err2);
               return;
           elseif alpha1<0|alpha1>1
               err3 = errordlg('Comproveu el numero alpha 1, ha de ser un nombre entre 0 i 1.','Comprovar alpha 1');
               uiwait(err3);
               return;
           end
           
           if isnan(alpha2)
               err1 = errordlg('Comproveu el numero alpha 2, ha de ser un nombre entre 0 i 1.','Comprovar alpha 2');
               uiwait(err1);
               return;
           elseif isempty(alpha2)
               err2 = errordlg('Comproveu el numero alpha 2, ha de ser un nombre entre 0 i 1.','Comprovar alpha 2');
               uiwait(err2);
               return;
           elseif alpha2<0|alpha2>1
               err3 = errordlg('Comproveu el numero alpha 2, ha de ser un nombre entre 0 i 1.','Comprovar alpha 2');
               uiwait(err3);
               return;
           end
           
           if isnan(mu)
               err1 = errordlg('Comproveu el numero mu, ha de ser un nombre entre 0 i 1 (superior a 0).','Comprovar mu');
               uiwait(err1);
               return;
           elseif isempty(mu)
               err2 = errordlg('Comproveu el numero mu, ha de ser un nombre entre 0 i 1 (superior a 0).','Comprovar mu');
               uiwait(err2);
               return;
           elseif mu<=0|mu>1
               err3 = errordlg('Comproveu el numero mu, ha de ser un nombre entre 0 i 1 (superior a 0).','Comprovar mu');
               uiwait(err3);
               return;
           end
           
            if alpha1+alpha2~=1
               err1 = errordlg('Comproveu els numeros alpha1 i alpha2, la seva suma ha de donar 1.','Comprovar alpha');
               uiwait(err1);
               return;
            end
           end
           
           [coef,mode_vincl,TL2G,ierr]=calculinestabilitat(contnus,contbarra,Ncoord,Ncond,Nextfor,Lnods,Lartyp,Lmecp,barra_carrega_rep,barra_carrega_rep_proj,barra_carrega_punt,barra_carrega_mom,iteracions,alpha1,alpha2,mu,metode); % Crida a la funci de clcul d'inestabilitat.
           
           switch ierr
               case 0
               esp1=[min(Ncoord(:,1)),min(Ncoord(:,2)),min(Ncoord(:,3))];
               esp2=[max(Ncoord(:,1)),max(Ncoord(:,2)),max(Ncoord(:,3))];
               vect_esp=esp2-esp1;
               norm_esp=norm(vect_esp);
               deformada=dibiuxmodevincl(contnus,contbarra,Lnods,Ncoord,mode_vincl,TL2G);
               t=size(coef);
               for i=1:t(2)
                   sol2ord(1,i)={num2str(coef(i))};
               end
               set(popup2ord,'string',sol2ord);
               set(popup2ord,'value',1);
               dibres2ord;
               set(panelres2ord,'Visible','on');
               set(botoEdicio,'State','off');
               edicio;
                              
               case 1
               h = errordlg('La matriu de rigidesa s singular. Comproveu les condicions de contorn.','Matriu singular');
               uiwait(h);
               case 2
               h = errordlg('Les carregues disposades generen un coeficient infinit. L''estructura no vinclar.','Coeficient infinit');
               uiwait(h);
               case 3
               h = errordlg('Comproveu els mduls de les crregues en barra. Les carregues han d''estar collocades als nussos.','Carregues en barra');
               uiwait(h);
               case 4
               h = errordlg('La rigidesa geometrica s massa gran. Comproveu les propietats de les barres. Si son correctes, minoreu les carregues per obtenir un resultat correcte.','Rigidesa negativa');
               uiwait(h);
               case 5
               h = errordlg('Pel calcul d''inestabilitat, les estructures unidimenisonals han d''anar collocades al plnol x-y','Error de plnol');
               uiwait(h);    
           end    
         end
       
    end

    function dibuixa_reaccions
        % Dibuixa les reaccions.
        
        %disp('Dibuixa reaccions')
        %tic_dr=tic;
        hgreaccions=zeros(contnus,1); % Guarda l'objecte grfic en una llista.
        for i=1:contnus % Repasa els nusos.
            if any(Retorn_reaccions(6*i-5:6*i)) % Si hi ha alguna reacci al nus...
                hgreaccions(i)=dibuix_carreganus(i,nusos(i).posicio,[xm,ym,zm],Retorn_reaccions(6*i-5:6*i-3)',Retorn_reaccions(6*i-2:6*i)',vista,fontcarregues,tamanyfontcarregues,fmax); % Dibuixa la reacci com una crrega al nus.
                m=makehgtform('translate',nusos(i).posicio,'scale',s); % Escala i colloca la crrega a la posici del nus.
                set(hgreaccions(i),'UserData',i,'Matrix',m);
                chgcolor(hgreaccions(i),colorreaccions) % Dna color a les reaccions.
                if strcmp(vista,'3d')
                    set(get(hgreaccions(i),'Children'),'Clipping','off') % Fa que els objectes grfics sobresurtin de la grafica.
                else
                    set(get(hgreaccions(i),'Children'),'Clipping','on') % Fa que els objectes grfics NO sobresurtin de la grafica.
                end
            end
        end
        %disp(['/Dibuixa reaccions: ',num2str(toc(tic_dr))])
    end

    function dibuixa_diagramesideformada
        % Dibuixa els diagrames i la deformada.
       
        %disp('Dibuixa diagrames i deformada')
        %tic_dd=tic;
        Tmax=0; % Tallant maxim.
        Mmax=0; % Moment maxim.
        Dmax=0; % Deformaci mxima.
        mov_extrems=zeros(12,contbarra);
        for i=1:contbarra % Per a toes les barres...
            [long,esforcos,moviments,rep,proj,punt,mom,Iz,Iy]=dades_diagrama(i);
            [diagrames(i)]=dibuix_diagrames(long,esforcos,moviments,rep,proj,punt,mom,barres(i).E,barres(i).A,Iz,Iy); % Calcula i dibuixa els diagrames.
           
            
            set(diagrames(i).hgN,'Parent',hg_diagrames)
            set(diagrames(i).hgTy,'Parent',hg_diagrames)
            set(diagrames(i).hgTz,'Parent',hg_diagrames)
            set(diagrames(i).hgMx,'Parent',hg_diagrames)
            set(diagrames(i).hgMy,'Parent',hg_diagrames)
            set(diagrames(i).hgMz,'Parent',hg_diagrames) 
            set(diagrames(i).hgdeformada,'Parent',hg_diagrames)
            
            diagrames(i).num=i; % Nmero de barra a la qual pertany el diagrama.
            Tmax=max([Tmax,diagrames(i).Tmax/long]); % Calcula la relaci tallant o axil/longitud mxima de totes les barres.
            Mmax=max([Mmax,diagrames(i).Mmax/long]); % Calcula la relaci moment/longitud mxim de totes les barres.
            Dmax=max([Dmax,diagrames(i).Dmax/long]); % Calcula la relaci deformaci/longitud mxima de totes les barres.
   
        end

        sT=1/(2*Tmax); % Clcul de l'escala dels diagrames d'axils i tallants.
        sM=1/(2*Mmax); % Clcul de l'escala dels diagrames de moments.
        sD=1/(5*Dmax); % Clcul de l'escala de la deformada.
        
        % Coloca, escala i coloreja els diagrames i la deformada.
        for i=1:numel(diagrames)
            pos=nusos(barres(i).nusinf).posicio; % El diagrama es colloca a la posicio del nus inferior.
            vector_barra=nusos(barres(i).nussup).posicio-pos; % Vector direcci de la barra, per a calcular la matriu de rotacio dels diagrames. No s'utilitzen els eixos locals, perque poden no coincidir l'eix z local i global.
            mT=matbarra(vector_barra,pos,sT); % Clcul de la matriu de rotaci, posici i escala dels diagrames de tallant.
            mM=matbarra(vector_barra,pos,sM); % Clcul de la matriu de rotaci, posicio i escala dels diagrames de moments.
            set(diagrames(i).hgN,'Matrix',mT); % Collocaci del diagrama d'axils.
            set(diagrames(i).hgTy,'Matrix',mT); % Collocaci del diagrama de tallants en y.
            set(diagrames(i).hgTz,'Matrix',mT); % Collocaci del diagrama de tallants en z.
            set(diagrames(i).hgMx,'Matrix',mM); % Collocaci del diagrama de moments en x.
            set(diagrames(i).hgMy,'Matrix',mM); % Collocaci del diagrama de moments en y.
            set(diagrames(i).hgMz,'Matrix',mM); % Collocaci del diagrama de moments en z.
            if strcmp(vista,'3d')
                clip3d='off'; % Fa que els objectes grfics sobresurtin de la grafica.
            else
                clip3d='on'; % Fa que els objectes grfics NO sobresurtin de la grafica.
            end
            set(get(diagrames(i).hgN,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgTy,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgTz,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgMx,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgMy,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgMz,'Children'),'Clipping',clip3d)
            set(get(diagrames(i).hgdeformada,'Children'),'Clipping',clip3d)
            
            escala_deformada(TL2G(:,:,i),i,sD) % Collocaci i rotaci de la deformada. Aqu SI que s'utilitzen els eixos locals, ja que la deformacio es calcula en eixos locals.
            colordiagrama(diagrames(i))
        end
        %disp(['/Dibuixa diagrames i deformada: ',num2str(toc(tic_dd))])
    end

function dibuixa_diagramesideformadaPlastic(ecuacionesF)
        % Dibuixa els diagrames i la deformada.
       
        %disp('Dibuixa diagrames i deformada')
        %tic_dd=tic;
        Tmax=0; % Tallant maxim.
        Mmax=0; % Moment maxim.
        Dmax=0; % Deformaci mxima.
        
        for i=1:contbarra % Per a totes les barres...
            % Es calcula la longitud de la barra analitzada
            posI=nusos(barres(i).nusinf).posicio;
            posS=nusos(barres(i).nussup).posicio;
            pos=posI-posS;
            long=(pos(1).^2+pos(2).^2+pos(3).^2).^0.5;
            [diagrames(i)]=dibuix_diagramesPlastic(long,ecuacionesF,i); % Calcula i dibuixa els diagrames.
           
            
            set(diagrames(i).hgN,'Parent',hg_diagrames);
            set(diagrames(i).hgTy,'Parent',hg_diagrames);
            set(diagrames(i).hgTz,'Parent',hg_diagrames);
            set(diagrames(i).hgMx,'Parent',hg_diagrames);
            set(diagrames(i).hgMy,'Parent',hg_diagrames);
            set(diagrames(i).hgMz,'Parent',hg_diagrames);
            set(diagrames(i).hgdeformada,'Parent',hg_diagrames);
            
            diagrames(i).num=i; % Nmero de barra a la qual pertany el diagrama.
            Tmax=max([Tmax,diagrames(i).Tmax/long]); % Calcula la relaci tallant o axil/longitud mxima de totes les barres.
            Mmax=max([Mmax,diagrames(i).Mmax/long]); % Calcula la relaci moment/longitud mxim de totes les barres.
            Dmax=max([Dmax,diagrames(i).Dmax/long]); % Calcula la relaci deformaci/longitud mxima de totes les barres.
   
        end

        sT=1/(2*Tmax); % Clcul de l'escala dels diagrames d'axils i tallants.
        sM=1/(2*Mmax); % Clcul de l'escala dels diagrames de moments.
        sD=1/(5*Dmax); % Clcul de l'escala de la deformada.
        
        % Coloca, escala i coloreja els diagrames i la deformada.
        for i=1:numel(diagrames)
            pos=nusos(barres(i).nusinf).posicio; % El diagrama es colloca a la posicio del nus inferior.
            vector_barra=nusos(barres(i).nussup).posicio-pos; % Vector direcci de la barra, per a calcular la matriu de rotacio dels diagrames. No s'utilitzen els eixos locals, perque poden no coincidir l'eix z local i global.
            mT=matbarra(vector_barra,pos,sT); % Clcul de la matriu de rotaci, posici i escala dels diagrames de tallant.
            mM=matbarra(vector_barra,pos,sM); % Clcul de la matriu de rotaci, posicio i escala dels diagrames de moments.
            set(diagrames(i).hgN,'Matrix',mT); % Collocaci del diagrama d'axils.
            set(diagrames(i).hgTy,'Matrix',mT); % Collocaci del diagrama de tallants en y.
            set(diagrames(i).hgTz,'Matrix',mT); % Collocaci del diagrama de tallants en z.
            set(diagrames(i).hgMx,'Matrix',mM); % Collocaci del diagrama de moments en x.
            set(diagrames(i).hgMy,'Matrix',mM); % Collocaci del diagrama de moments en y.
            set(diagrames(i).hgMz,'Matrix',mM); % Collocaci del diagrama de moments en z.
            if strcmp(vista,'3d')
                clip3d='off'; % Fa que els objectes grfics sobresurtin de la grafica.
            else
                clip3d='on'; % Fa que els objectes grfics NO sobresurtin de la grafica.
            end
            set(get(diagrames(i).hgN,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgTy,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgTz,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMx,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMy,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMz,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgdeformada,'Children'),'Clipping',clip3d)
            
            escala_deformada(TL2G(:,:,i),i,sD) % Collocaci i rotaci de la deformada. Aqu SI que s'utilitzen els eixos locals, ja que la deformacio es calcula en eixos locals.
            colordiagrama(diagrames(i));
        end
        %disp(['/Dibuixa diagrames i deformada: ',num2str(toc(tic_dd))])
end

    function [long,esforcos,moviments,rep,proj,punt,mom,Iz,Iy]=dades_diagrama(n)
        
        %disp(['Prepara dades calcul diagrames barra n ',num2str(n)])
        %tic_dd=tic;
        n1=barres(n).nusinf;
        n2=barres(n).nussup;
        T=TL2G(:,:,n)'; % Matriu de canvi de base d'exos globals a locals.
        esforcos(1:12)=Retorn_esforcos_barres(n,1:12); % Esforos en extrems de barra en eixos locals.
        moviments=[T*Retorn_moviments(n1*6-5:n1*6-3);T*Retorn_moviments(n1*6-2:n1*6);T*Retorn_moviments(n2*6-5:n2*6-3);T*Retorn_moviments(n2*6-2:n2*6)]; % Moviments dels extrems de barra en eixos locals.
        mov_extrems(:,n)=moviments; % Guarda els moviments en extrems de barra en eixos locals per a la funcio que mostra l'informe de resultats.
        vbarra=nusos(n2).posicio-nusos(n1).posicio; % Vector barra.
        long=norm(vbarra); % Longitud de la barra.
        rep=[barres(n).repartida(1),(T*barres(n).repartida(2:4)')',barres(n).repartida(5:6)]; % Carrega repartida en eixos locals.
        proj=[barres(n).projectada(1),(T*barres(n).projectada(2:4)')',barres(n).projectada(5:6)]; % Crrega projectada en eixos locals.
        punt=[barres(n).puntual(1),(T*barres(n).puntual(2:4)')',barres(n).puntual(5)]; % Carrega en eixos locals.
        mom=[barres(n).moment(1),(T*barres(n).moment(2:4)')',barres(n).moment(5)]; % Moments en eixos locals.
        Iz=barres(n).Iz; % Inercia Iz.
        if all(barres(n).vectorIz==0) % Si no esta definit el vector direcci d'Iz, Iy=Iz.
            Iy=Iz;
        else
            Iy=barres(n).Iy;
        end
        %disp(['/Prepara dades calcul diagrames barra n ',num2str(n),': ',num2str(toc(tic_dd))])
    end

    function colordiagrama(diag)
        % Coloreja els digramaes i la deformada de l'obecte diagrama.
        
        %disp(['Color diagrama ',num2str(diag.num)])
        %tic_cd=tic;
        chgcolor(diag.hgN,colorN); % Color diagrama d'axils.
        chgcolor(diag.hgTy,colorTy); % Color diagrama de tallants en y.
        chgcolor(diag.hgTz,colorTz); % Color diagrama de tallants en z.
        chgcolor(diag.hgMx,colorMx); % Color diagrama de moments en x.
        chgcolor(diag.hgMy,colorMy); % Color diagrama de moments en y.
        chgcolor(diag.hgMz,colorMz); % Color diagrama de moments en z.
        chgcolor(diag.hgdeformada,colordeformada); % Color deformada.
        %disp(['/Color diagrama ',num2str(diag.num),': ',num2str(toc(tic_cd))])
    end

    function mat=matbarra(vector_barra,posicio,escala)
        % Calcula la matriu de gir, escala i posici per a representar
        % els diagrames al plnol de la vista.
        % Calcula la matriu per tal que els diagrames es representin al
        % pl format per la barra i l'eix Vertical segons la vista.
        
        vector_barra=vector_barra/norm(vector_barra);
        if abs(vector_barra(3))==1
            vector3=[-vector_barra(3),0,0];
            vector2=[0,1,0];
        else
            vector2=cross([0,0,1],vector_barra); % Calcula dos vectors perpendiculars al primer i entre ells per crear la matriu de canvi de base.
            vector2=vector2/norm(vector2);
            vector3=cross(vector_barra,vector2);
            vector3=vector3/norm(vector3);
        end
        
        if strcmp(vista,'xz') || strcmp(vista,'yz') % Si s'esta a les vistes amb eix Vertical z, s'intercanvien els vectors per mostrar els diagrames adequadament.
            vector2_=vector3;
            vector3=vector2;
            vector2=vector2_;
        end
        mat(1:4,1)=[vector_barra';0]; % Matriu de gir, posici i escala.
        mat(1:4,2)=[vector2'*escala;0];
        mat(1:4,3)=[vector3'*escala;0];
        mat(1:4,4)=[posicio';1];
    end

    function escala_deformada(TL2G,n,escala)
        % Escala, gira  i colloca la deformada.
        % Afegeix els scatter3 que marquen la fletxa mxima.
        
        mat(1:4,1)=[TL2G(:,1);0]; % Direcci i escala x.
        mat(1:4,2)=[TL2G(:,2)*escala;0]; % Direcci i escala y.
        mat(1:4,3)=[TL2G(:,3)*escala;0]; % Direcci i escala z.
        mat(1:4,4)=[nusos(barres(n).nusinf).posicio';1]; % Posici.
           
        diag=findobj(diagrames(n).hgdeformada,'type','line'); % Lnia que representa la deformada.
        defx=get(diag,'UserData'); % Recupera els valors per al reclcul de la deformada en x escalada.
        x=defx.x+defx.e*escala; % Recalcula la deformada en x escalada.
        set(diag,'X',x) % Modifica el valors en x de la linia que representa la deformada, amb la nova deformaci calculada.
        set(diagrames(n).hgdeformada,'Matrix',mat) %  Colloca i escala la deformada a l'extrem inferior de la barra.
    end

    function resultat_barra(n)
        % S'executa quan es cliqueja sobre una barra a la presentaci de
        % resultats de tota l'estructura.
        % Mostra els resultats detallats per a la barra seleccionada.
        % Mostra dos grfiques amb la representaci dels eixos locals xy i
        % xz on es presenten els diagrames i la deformada amb valors
        % numerics a la meitat esquerra. A la meitat dreta mostra una caixa
        % de texte amb un informe de propietats de la barra, lleis
        % d'esforos i deformaci.
        
        grafica=grafica_resxy;
        long=norm(nusos(barres(n).nussup).posicio-nusos(barres(n).nusinf).posicio); % Longitud de la barra.
        
        set(grafica_est,'Visible','off')
        
        set(txtbox_res,'Visible','on') % Fa visible el textbox que cont l'informe.
        set(grafica_resxy,'XLim',[0-long/10,long*1.1],'YLim',[-1.1,1.4]) % Dimensiona la presentaci en xy perque hi capiga la barra, els diagrames es dimensionaran entre -1 i 1.
        set(grafica_resxz,'XLim',[0-long/10,long*1.1],'ZLim',[-1.1,1.4]) % Dimensiona la presentaci en xz perque hi capiga la barra, els diagrames es dimensionaran entre -1 i 1.
        set(get(grafica_est,'Children'),'Visible','off') % Oculta la grfica de l'estructura.
        
        txtnum=[num2str(barres(n).num),' (',num2str(barres(n).nusinf),'-',num2str(barres(n).nussup),')']; % Texte numero de barra i nusos.
        text(0-long/15,1.4,0,['X-Y local barra n',txtnum,':'],'VerticalAlignment','top','Parent',grafica_resxy) % Texte ttol vista xy.
        text(0-long/15,0,1.4,['X-Z local barra n',txtnum,':'],'VerticalAlignment','top','Parent',grafica_resxz) % Texte ttol vista xz.
        
        line([0,long],[0,0],[0,0],'color','k','LineWidth',2,'Parent',grafica_resxy) % Dibuixa la barra a la vista xy.
        line([0,long],[0,0],[0,0],'color','k','LineWidth',2,'Parent',grafica_resxz) % Dibuixa la barra a la vista xz.
        
        [long,esforcos,moviments,rep,proj,punt,mom,Iz,Iy]=dades_diagrama(n);
        [diag_presxy,informe]=dibuix_diagrames(long,esforcos,moviments,rep,proj,punt,mom,barres(n).E,barres(n).A,Iz,Iy); % Calcula i dibuixa els diagrames.
        diag_presxy.Mmax=diag_presxy.Mmax+(diag_presxy.Mmax==0); % Impedeix que Mmax sigui zero.
        diag_presxy.Tmax=diag_presxy.Tmax+(diag_presxy.Tmax==0); % Impedeix que Mmax sigui zero.
        diag_presxy.Dmax=diag_presxy.Dmax+(diag_presxy.Dmax==0); % Impedeix que Mmax sigui zero.
 
        colordiagrama(diag_presxy) % Coloreja els diagrames.
        diag_presxz=diag_presxy; % Copia els handles (no els objectes, nomes la referencia) dels dibuixos dels diagrames en representacio xy a la representacio xz.
        diag_presxz.hgdeformada=copyobj(diag_presxy.hgdeformada,grafica_resxz); % Copia la deformada (crea un objecte cpia independent) a la representaci xz.
        
        set(diag_presxy.hgN,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Tmax,1])); % Assigna el diagrama axils a la representaci xy i l'escala.
        set(diag_presxy.hgTy,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Tmax,1])); % Assigna el diagrama tallants en y a la representaci xy i l'escala.
        set(diag_presxy.hgMz,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Mmax,1])); % Assigna el diagrama moments en z a la reprensetaci xy i l'escala.
        set(diag_presxy.hgdeformada,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,.5/diag_presxy.Dmax,1],'zrotate',0)); % Assigna una de les cpies de la deformada a la representaci xy i l'escala.
        delete(findobj(diag_presxy.hgdeformada,'UserData','dz')) % Elimina les referncies a la deformada en z a la representacio xy.
        
        set(diag_presxz.hgTz,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Tmax,1])); % Assigna el diagrama de tallants en z a la representaci xz i l'escala.
        set(diag_presxz.hgMx,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Mmax,1])); % Assigna el diagrama de moments en x a la representaci xz i l'escala.
        set(diag_presxz.hgMy,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Mmax,1])); % Assigna el diagrama moments en y a la reprensetaci xz i l'escala.
        set(diag_presxz.hgdeformada,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1,.5/diag_presxz.Dmax])); % Assigna una de les cpies de la deformada a la representaci xz i l'escala.
        delete(findobj(diag_presxz.hgdeformada,'UserData','dy')) % Elimina les referncies a la deformada en y a la representacio xz.
        
        visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
        
        txtposinf=vector2txt(nusos(barres(n).nusinf).posicio); % Posici nus inferior.
        txtpossup=vector2txt(nusos(barres(n).nussup).posicio); % Posicio nus superior.
        if any(barres(n).vectorIz) % Si est definit el vector direccio Iz...
            txtinerciaIz=[num2str(barres(n).Iz),', direcci ',vector2txt(barres(n).vectorIz),' eix Z local']; % Texte vector direccio Iz..
            txtinerciaIy=num2str(barres(n).Iy); % Iz i Iy sn diferents.
        else
            txtinerciaIz=num2str(barres(n).Iz); % Texte Iz.
            txtinerciaIy=['Iz= ',num2str(barres(n).Iz)]; % Si no est definit el vector Iz Iy=Iz.
        end
        if barres(n).artinf % Si l'extrem inferior s articulat.
            txtartinf='articulat';
            txtgirs1={['Girs: ',vector2txt([0,diagrames(n).Oini]),' / ',vector2txt(TL2G(:,:,n)*[0;diagrames(n).Oini'])]}; % El gir de l'extrem de barra articulat no coincideix amb el gir del nus! Gir calculat amb la deformada.
        else
            txtartinf='rigid';
            txtgirs1={['Girs: ',vector2txt(mov_extrems(4:6,n)),' / ',vector2txt(TL2G(:,:,n)*mov_extrems(4:6,n))]}; % Si l'extrem s rgid el seu gir s el gir del nus.
        end
        if barres(n).artsup % Si l'extrem superior es articulat.
            txtartsup='articulat';
            txtgirs2={['Girs: ',vector2txt([0,diagrames(n).Ofin]),' / ',vector2txt(TL2G(:,:,n)*[0;diagrames(n).Ofin'])]}; % El gir de l'extrem de barra articulat no coincideix amb el gir del nus! Gir calculat amb la deformada.
        else
            txtartsup='rigid';
            txtgirs2={['Girs: ',vector2txt(mov_extrems(10:12,n)),' / ',vector2txt(TL2G(:,:,n)*mov_extrems(10:12,n))]}; % Si l'extrem s rgid el seu gir s el gir del nus.
        end
        txttitol={['INFORME DE RESULTATS PER A LA BARRA N: ',txtnum,':'];''}; % Texte del ttol.
        txtpropietats={['Longitud= ',num2str(long)];['Mdul de Young E= ',num2str(barres(n).E)];['rea de la secci= ',num2str(barres(n).A)];['Moment d''Inrcia Iz= ',txtinerciaIz];['Moment d''Inrcia Iy= ',txtinerciaIy];['Rigidesa a torsi GIt= ',num2str(barres(n).GIt)]}; % Texte propietats mecniques de la barra.
        txteixos={['x''=',vector2txt(TL2G(:,1,n)),'; y''=',vector2txt(TL2G(:,2,n)),'; z''=',vector2txt(TL2G(:,3,n))]};
        txtextrem1={['Extrem ',txtartinf,' al nus n ',num2str(barres(n).nusinf),', posici en eixos globals: ',txtposinf]}; % Texte extrem inferior.
        txtesf1={['Forces: ',vector2txt(Retorn_esforcos_barres(n,1:3)),' / ',vector2txt(TL2G(:,:,n)*Retorn_esforcos_barres(n,1:3)')]}; % Texte esforos a l'extrem inferior.
        txtmom1={['Moments: ',vector2txt(Retorn_esforcos_barres(n,4:6)),' / ',vector2txt(TL2G(:,:,n)*Retorn_esforcos_barres(n,4:6)')]}; % Texte moments a l'extrem inferior.
        txtdesp1={['Desplaaments: ',vector2txt(mov_extrems(1:3,n)),' / ',vector2txt(TL2G(:,:,n)*mov_extrems(1:3,n))]}; % Texte desplaaments a l'extrem inferior.
        txtextrem2={['Extrem ',txtartsup,' al nus n ',num2str(barres(n).nussup),', posici en eixos globals: ',txtpossup]}; % Texte extrem superior.
        txtesf2={['Forces: ',vector2txt(Retorn_esforcos_barres(n,7:9)),' / ',vector2txt(TL2G(:,:,n)*Retorn_esforcos_barres(n,7:9)')]}; % Texte esforos a l'extrem superior.
        txtmom2={['Moments: ',vector2txt(Retorn_esforcos_barres(n,10:12)),' / ',vector2txt(TL2G(:,:,n)*Retorn_esforcos_barres(n,10:12)')]}; % Texte moments a l'extrem superior.
        txtdesp2={['Desplaaments: ',vector2txt(mov_extrems(7:9,n)),' / ',vector2txt(TL2G(:,:,n)*mov_extrems(7:9,n))]}; % Texte desplaaments a l'extrem superior.
        
        txt=[txttitol;{'PROPIETATS:';''};txtpropietats;{'';'EIXOS LOCALS:';''};txteixos;{'';'ESFOROS I MOVIMENTS A L''EXTREM INFERIOR EN EIXOS LOCALS/GLOBALS:';''};txtextrem1;txtesf1;txtmom1;txtdesp1;txtgirs1;{'';'ESFOROS I MOVIMENTS A L''EXTREM SUPERIOR EN EIXOS LOCALS/GLOBALS:';''};txtextrem2;txtesf2;txtmom2;txtdesp2;txtgirs2;{'';'DIAGRAMES D''ESFOROS I DEFORMADA EN EIXOS LOCALS:';''};informe]; % Pega els textes.
        set(txtbox_res,'String',txt); % Mostra el texte.
    end


function resultat_barra_plastic(n)
        % S'executa quan es cliqueja sobre una barra a la presentaci de
        % resultats de tota l'estructura.
        % Mostra els resultats detallats per a la barra seleccionada.
        % Mostra dos grfiques amb la representaci dels eixos locals xy i
        % xz on es presenten els diagrames i la deformada amb valors
        % numerics a la meitat esquerra. A la meitat dreta mostra una caixa
        % de texte amb un informe de propietats de la barra, lleis
        % d'esforos i deformaci.
        
        grafica=grafica_resxy;
        valor=get(popupMenu,'value');
        set(popupMenu,'enable','off');
        barres2=dadesRotules(valor+1).barres;
        nusos2=dadesRotules(valor+1).nusos;
        long=norm(nusos2(barres2(n).nussup).posicio-nusos2(barres2(n).nusinf).posicio); % Longitud de la barra.
        
        set(grafica_est,'Visible','off')
        
        set(txtbox_res,'Visible','on') % Fa visible el textbox que cont l'informe.
        set(grafica_resxy,'XLim',[0-long/10,long*1.1],'YLim',[-1.1,1.4]) % Dimensiona la presentaci en xy perque hi capiga la barra, els diagrames es dimensionaran entre -1 i 1.
        set(grafica_resxz,'XLim',[0-long/10,long*1.1],'ZLim',[-1.1,1.4]) % Dimensiona la presentaci en xz perque hi capiga la barra, els diagrames es dimensionaran entre -1 i 1.
        set(get(grafica_est,'Children'),'Visible','off') % Oculta la grfica de l'estructura.
        
        txtnum=[num2str(barres(n).num),' (',num2str(barres(n).nusinf),'-',num2str(barres(n).nussup),')']; % Texte numero de barra i nusos.
        text(0-long/15,1.4,0,['X-Y local barra n',txtnum,':'],'VerticalAlignment','top','Parent',grafica_resxy) % Texte ttol vista xy.
        text(0-long/15,0,1.4,['X-Z local barra n',txtnum,':'],'VerticalAlignment','top','Parent',grafica_resxz) % Texte ttol vista xz.
        
        line([0,long],[0,0],[0,0],'color','k','LineWidth',2,'Parent',grafica_resxy) % Dibuixa la barra a la vista xy.
        line([0,long],[0,0],[0,0],'color','k','LineWidth',2,'Parent',grafica_resxz) % Dibuixa la barra a la vista xz.
        
       %Es necessari cridar als diagrames de la barra
       [diag_presxy,informe,ecuacionesFD]=detall_diagramesideformadaPlastic(ecuacionesF,n);
    
        diag_presxy.Mmax=diag_presxy.Mmax+(diag_presxy.Mmax==0); % Impedeix que Mmax sigui zero.
        diag_presxy.Tmax=diag_presxy.Tmax+(diag_presxy.Tmax==0); % Impedeix que Mmax sigui zero.
        diag_presxy.Dmax=diag_presxy.Dmax+(diag_presxy.Dmax==0); % Impedeix que Mmax sigui zero.

        colordiagrama(diag_presxy) % Coloreja els diagrames.
        diag_presxz=diag_presxy; % Copia els handles (no els objectes, nomes la referencia) dels dibuixos dels diagrames en representacio xy a la representacio xz.
        diag_presxz.hgdeformada=copyobj(diag_presxy.hgdeformada,grafica_resxz); % Copia la deformada (crea un objecte cpia independent) a la representaci xz.
        
        set(diag_presxy.hgN,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Tmax,1])); % Assigna el diagrama axils a la representaci xy i l'escala.
        set(diag_presxy.hgTy,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Tmax,1])); % Assigna el diagrama tallants en y a la representaci xy i l'escala.
        set(diag_presxy.hgMz,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,1/diag_presxy.Mmax,1])); % Assigna el diagrama moments en z a la reprensetaci xy i l'escala.
        set(diag_presxy.hgdeformada,'Parent',grafica_resxy,'Matrix',makehgtform('scale',[1,.5/diag_presxy.Dmax,1])); % Assigna una de les cpies de la deformada a la representaci xy i l'escala.
        delete(findobj(diag_presxy.hgdeformada,'UserData','dz')) % Elimina les referncies a la deformada en z a la representacio xy.
        
        set(diag_presxz.hgTz,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Tmax,1])); % Assigna el diagrama de tallants en z a la representaci xz i l'escala.
        set(diag_presxz.hgMx,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Mmax,1])); % Assigna el diagrama de moments en x a la representaci xz i l'escala.
        set(diag_presxz.hgMy,'Parent',grafica_resxz,'Matrix',makehgtform('xrotate',pi/2,'scale',[1,1/diag_presxz.Mmax,1])); % Assigna el diagrama moments en y a la reprensetaci xz i l'escala.
        set(diag_presxz.hgdeformada,'Parent',grafica_resxz,'Matrix',makehgtform('scale',[1,1,.5/diag_presxz.Dmax])); % Assigna una de les cpies de la deformada a la representaci xz i l'escala.
        delete(findobj(diag_presxz.hgdeformada,'UserData','dy')) % Elimina les referncies a la deformada en y a la representacio xz.
        
        visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
        
        txtposinf=vector2txt(nusos(barres(n).nusinf).posicio); % Posici nus inferior.
        txtpossup=vector2txt(nusos(barres(n).nussup).posicio); % Posicio nus superior.
        
        if any(barres(n).vectorIz) % Si est definit el vector direccio Iz...
            txtinerciaIz=[num2str(barres(n).Iz),', direcci ',vector2txt(barres(n).vectorIz),' eix Z local']; % Texte vector direccio Iz..
            txtinerciaIy=num2str(barres(n).Iy); % Iz i Iy sn diferents.
        else
            txtinerciaIz=num2str(barres(n).Iz); % Texte Iz.
            txtinerciaIy=['Iz= ',num2str(barres(n).Iz)]; % Si no est definit el vector Iz Iy=Iz.
        end
         if barres(n).artinf % Si l'extrem inferior s articulat.
             txtartinf='articulat';
             %Obtenim el gir mitjanant la deformada
             txtgirs1={['Girs: ','Oy: ',num2str(polyval(ecuacionesFD.MatrizFOy(1:4),ecuacionesFD.MatrizFOy(5))),', Oz: ',num2str(polyval(ecuacionesFD.MatrizFOz(1:4),ecuacionesFD.MatrizFOz(5)))]};           
         else
            txtartinf='rigid';
            txtgirs1={['Girs: ','Oy: ',num2str(polyval(ecuacionesFD.MatrizFOy(1:4),ecuacionesFD.MatrizFOy(5))),', Oz: ',num2str(polyval(ecuacionesFD.MatrizFOz(1:4),ecuacionesFD.MatrizFOz(5)))]};
         end
        if barres(n).artsup % Si l'extrem superior es articulat.
            txtartsup='articulat';
            txtgirs2={['Girs: ','Oy: ',num2str(polyval(ecuacionesFD.MatrizFOy(1:4),ecuacionesFD.MatrizFOy(6))),', Oz: ',num2str(polyval(ecuacionesFD.MatrizFOz(1:4),ecuacionesFD.MatrizFOz(6)))]};
        else
            txtartsup='rigid';
            txtgirs2={['Girs: ','Oy: ',num2str(polyval(ecuacionesFD.MatrizFOy(1:4),ecuacionesFD.MatrizFOy(6))),', Oz: ',num2str(polyval(ecuacionesFD.MatrizFOz(1:4),ecuacionesFD.MatrizFOz(6)))]};
        end
        
        %Obtinc els esforos a cada punt a partir de les ecuacions
        EsforcosInf(1)=polyval(ecuacionesFD.MatrizFN(1:2),ecuacionesFD.MatrizFN(3));
        EsforcosInf(2)=polyval(ecuacionesFD.MatrizFTy(1:2),ecuacionesFD.MatrizFTy(3));
        EsforcosInf(3)=polyval(ecuacionesFD.MatrizFTz(1:2),ecuacionesFD.MatrizFTz(3));
        EsforcosSup(4)=polyval(ecuacionesFD.MatrizFMx(1:3),ecuacionesFD.MatrizFMx(5));
        EsforcosInf(5)=polyval(ecuacionesFD.MatrizFMy(1:3),ecuacionesFD.MatrizFMy(4));
        EsforcosInf(6)=polyval(ecuacionesFD.MatrizFMz(1:3),ecuacionesFD.MatrizFMz(4));
        
        desInf(1)=polyval(ecuacionesFD.MatrizFDx(1:3),ecuacionesFD.MatrizFDx(4));
        desInf(2)=polyval(ecuacionesFD.MatrizFDy(1:5),ecuacionesFD.MatrizFDy(6));
        desInf(3)=polyval(ecuacionesFD.MatrizFDz(1:5),ecuacionesFD.MatrizFDz(6));
        
        EsforcosSup(1)=polyval(ecuacionesFD.MatrizFN(1:2),ecuacionesFD.MatrizFN(4));
        EsforcosSup(2)=polyval(ecuacionesFD.MatrizFTy(1:2),ecuacionesFD.MatrizFTy(4));
        EsforcosSup(3)=polyval(ecuacionesFD.MatrizFTz(1:2),ecuacionesFD.MatrizFTz(4));
        EsforcosSup(4)=polyval(ecuacionesFD.MatrizFMx(1:3),ecuacionesFD.MatrizFMx(5));
        EsforcosSup(5)=polyval(ecuacionesFD.MatrizFMy(1:3),ecuacionesFD.MatrizFMy(5));
        EsforcosSup(6)=polyval(ecuacionesFD.MatrizFMz(1:3),ecuacionesFD.MatrizFMz(5));
        
        desSup(1)=polyval(ecuacionesFD.MatrizFDx(1:3),ecuacionesFD.MatrizFDx(5));
        desSup(2)=polyval(ecuacionesFD.MatrizFDy(1:5),ecuacionesFD.MatrizFDy(7));
        desSup(3)=polyval(ecuacionesFD.MatrizFDz(1:5),ecuacionesFD.MatrizFDz(7));
        
        
        txttitol={['INFORME DE RESULTATS PER A LA BARRA N: ',txtnum,':'];''}; % Texte del ttol.
        txtpropietats={['Longitud= ',num2str(long)];['Mdul de Young E= ',num2str(barres2(n).E)];['rea de la secci= ',num2str(barres2(n).A)];['Moment d''Inrcia Iz= ',txtinerciaIz];['Moment d''Inrcia Iy= ',txtinerciaIy];['Rigidesa a torsi GIt= ',num2str(barres2(n).GIt)]}; % Texte propietats mecniques de la barra.
        
        txtextrem1={['Extrem ',txtartinf,' al nus n ',num2str(barres2(n).nusinf),', posici en eixos globals: ',txtposinf]}; % Texte extrem inferior.
        txtesf1={['Forces: ','Axil: ',num2str(EsforcosInf(1)),'; Tallant Ty: ',num2str(EsforcosInf(2)),'; Tallant Tz: ',num2str(EsforcosInf(3))]};
        txtmom1={['Moments: ','Mx: ',num2str(EsforcosInf(4)),'; My: ',num2str(EsforcosInf(5)),'; Mz: ',num2str(EsforcosInf(6))]};
        txtdesp1={['Desplaaments: ','dX: ',num2str(desInf(1)),'; dY: ',num2str(desInf(2)),'; dZ: ',num2str(desInf(3))]};
     
        txtextrem2={['Extrem ',txtartsup,' al nus n ',num2str(barres2(n).nussup),', posici en eixos globals: ',txtpossup]}; % Texte extrem inferior.
        txtesf2={['Forces: ','Axil: ',num2str(EsforcosSup(1)),'; Tallant Ty: ',num2str(EsforcosSup(2)),'; Tallant Tz: ',num2str(EsforcosSup(3))]};
        txtmom2={['Moments: ','Mx: ',num2str(EsforcosSup(4)),'; My: ',num2str(EsforcosSup(5)),'; Mz: ',num2str(EsforcosSup(6))]};
        txtdesp2={['Desplaaments: ','dX: ',num2str(desSup(1)),'; dY: ',num2str(desSup(2)),'; dZ: ',num2str(desSup(3))]};
             
        
        txt=[txttitol;{'PROPIETATS:';''};txtpropietats;{'';'ESFOROS I MOVIMENTS A L''EXTREM INFERIOR EN EIXOS LOCALS/GLOBALS:';''};txtextrem1;txtesf1;txtmom1;txtdesp1;txtgirs1;{'';'ESFOROS I MOVIMENTS A L''EXTREM SUPERIOR EN EIXOS LOCALS/GLOBALS:';''};txtextrem2;txtesf2;txtmom2;txtdesp2;txtgirs2;{'';'DIAGRAMES D''ESFOROS I DEFORMADA EN EIXOS LOCALS:';''};informe]; % Pega els textes.
        set(txtbox_res,'String',txt); % Mostra el texte.
end 
    function [diagrames,informe,ecuacionesFD]=detall_diagramesideformadaPlastic(ecuacionesF,n)
        % Dibuixa els diagrames i la deformada.
       
        %disp('Dibuixa diagrames i deformada')
        %tic_dd=tic;
        Tmax=0; % Tallant maxim.
        Mmax=0; % Moment maxim.
        Dmax=0; % Deformaci mxima.
        
        % Calcul longitud barra
        posI=nusos(barres(n).nusinf).posicio;
        posS=nusos(barres(n).nussup).posicio;
        pos=posI-posS;
        long=(pos(1).^2+pos(2.)^2+pos(3).^2).^0.5;
        
        %Comprobo si existeixen barres partides, si es aix, he de
        %modificar l'ecuaci
        num=get(popupMenu,'value');
        partides=dadesRotules(num+1).partides;
        numBarraAnterior=n;
        %Recupero quina barra ha estat dividida
        barraDiv=dadesRotules(num+1).barraNumRotula;
        
        %Comprobo a quina nova barra pertany la numeraci n (la que he
        %pitjat)
        if partides==1 % Si es tracta d'una barra partida
            matriuReordenament=zeros(contbarra,2);
            for x=1:1:contbarra 
                if x<barraDiv
                 matriuReordenament(x,2)=x;
                 matriuReordenament(x,1)=x;
                elseif x>barraDiv
                 matriuReordenament(x-1,2)=x;
                 matriuReordenament(x-1,1)=x-1;   
                end             
            end   
            matriuReordenament(contbarra-1,2)=barraDiv;
            matriuReordenament(contbarra-1,1)=contbarra-1;
            matriuReordenament(contbarra,2)=barraDiv;
            matriuReordenament(contbarra,1)=contbarra;
            
            %Busco la barra pitjada a la matriu
            indice=find(matriuReordenament(:,1)==n);
            
            %Ara sabem quina barra s la barra n al pas anterior
            numBarraAnterior=matriuReordenament(indice,2);
        end
         
            %Recuperem les seves ecuacions
             ecuacionesFD.MatrizFN=ecuacionesF.MatrizFN(numBarraAnterior,:);
             ecuacionesFD.MatrizFTy=ecuacionesF.MatrizFTy(numBarraAnterior,:);
             ecuacionesFD.MatrizFTz=ecuacionesF.MatrizFTz(numBarraAnterior,:);
             ecuacionesFD.MatrizFMx=ecuacionesF.MatrizFMx(numBarraAnterior,:);
             ecuacionesFD.MatrizFMy=ecuacionesF.MatrizFMy(numBarraAnterior,:);
             ecuacionesFD.MatrizFMz=ecuacionesF.MatrizFMz(numBarraAnterior,:);

             ecuacionesFD.MatrizFDx=ecuacionesF.MatrizFDx(numBarraAnterior,:);
             ecuacionesFD.MatrizFDy=ecuacionesF.MatrizFDy(numBarraAnterior,:);
             ecuacionesFD.MatrizFDz=ecuacionesF.MatrizFDz(numBarraAnterior,:);
             ecuacionesFD.MatrizFOy=ecuacionesF.MatrizFOy(numBarraAnterior,:);
             ecuacionesFD.MatrizFOz=ecuacionesF.MatrizFOz(numBarraAnterior,:);
             
             %Ara la modifiquem si la seva longitud ha variat, modifiquem
             %l'ecuaci
             if partides==1
                 jx=find(matriuReordenament(:,2)==numBarraAnterior);
                 if length(jx)>1 %Si es major a 1, vol dir que la barra s'ha dividit i per tant t longituds diferents
                     %He de trobar a quin tram pertany de l'ecuaci
                     barra1=matriuReordenament(jx(1),1);
                     barra2=matriuReordenament(jx(2),1);
                     
                     if n==barra1
                         %Aquesta s la barra que va de 0 a la longitud x
                         %de la ecuaci antiga que s'ha de dividir
                         mode=0;
                     elseif n==barra2
                         %Aquesta es la barra que va de x a la longitud
                         %final de la ecuaci antiga que s'ha de dividir.
                         mode=1;
                     end   
                        %Modifico les ecuacions
                        [ecuacionesFD.MatrizFN]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFN,mode);
                        [ecuacionesFD.MatrizFTz]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFTz,mode);
                        [ecuacionesFD.MatrizFTy]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFTy,mode);
                        [ecuacionesFD.MatrizFMx]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFMx,mode);
                        [ecuacionesF.MatrizFMy]=adaptarEcuacioDetall(long,ecuacionesF.MatrizFMy,mode);
                        [ecuacionesFD.MatrizFMz]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFMz,mode);
                        [ecuacionesFD.MatrizFDx]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFDx,mode);
                        [ecuacionesFD.MatrizFDy]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFDy,mode);
                        [ecuacionesFD.MatrizFDz]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFDz,mode);
                        [ecuacionesFD.MatrizFOy]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFOy,mode);
                        [ecuacionesFD.MatrizFOz]=adaptarEcuacioDetall(long,ecuacionesFD.MatrizFOz,mode);          
                 end
             end 
     
        [diagrames(1),informe]=dibuix_diagramesPlastic(long,ecuacionesFD,1); % Calcula i dibuixa els diagrames.
      
            set(diagrames(1).hgN,'Parent',hg_diagrames);
            set(diagrames(1).hgTy,'Parent',hg_diagrames);
            set(diagrames(1).hgTz,'Parent',hg_diagrames);
            set(diagrames(1).hgMx,'Parent',hg_diagrames);
            set(diagrames(1).hgMy,'Parent',hg_diagrames);
            set(diagrames(1).hgMz,'Parent',hg_diagrames);
            set(diagrames(1).hgdeformada,'Parent',hg_diagrames);
            
            diagrames(1).num=1; % Nmero de barra a la qual pertany el diagrama.
            Tmax=max([Tmax,diagrames(1).Tmax/long]); % Calcula la relaci tallant o axil/longitud mxima de totes les barres.
            Mmax=max([Mmax,diagrames(1).Mmax/long]); % Calcula la relaci moment/longitud mxim de totes les barres.
            Dmax=max([Dmax,diagrames(1).Dmax/long]); % Calcula la relaci deformaci/longitud mxima de totes les barres.

        sT=1/(2*Tmax); % Clcul de l'escala dels diagrames d'axils i tallants.
        sM=1/(2*Mmax); % Clcul de l'escala dels diagrames de moments.
        sD=1/(5*Dmax); % Clcul de l'escala de la deformada.
        
        % Coloca, escala i coloreja els diagrames i la deformada.
        for i=1:1
            pos=nusos(barres(i).nusinf).posicio; % El diagrama es colloca a la posicio del nus inferior.
            vector_barra=nusos(barres(i).nussup).posicio-pos; % Vector direcci de la barra, per a calcular la matriu de rotacio dels diagrames. No s'utilitzen els eixos locals, perque poden no coincidir l'eix z local i global.
            mT=matbarra(vector_barra,pos,sT); % Clcul de la matriu de rotaci, posici i escala dels diagrames de tallant.
            mM=matbarra(vector_barra,pos,sM); % Clcul de la matriu de rotaci, posicio i escala dels diagrames de moments.
            set(diagrames(i).hgN,'Matrix',mT); % Collocaci del diagrama d'axils.
            set(diagrames(i).hgTy,'Matrix',mT); % Collocaci del diagrama de tallants en y.
            set(diagrames(i).hgTz,'Matrix',mT); % Collocaci del diagrama de tallants en z.
            set(diagrames(i).hgMx,'Matrix',mM); % Collocaci del diagrama de moments en x.
            set(diagrames(i).hgMy,'Matrix',mM); % Collocaci del diagrama de moments en y.
            set(diagrames(i).hgMz,'Matrix',mM); % Collocaci del diagrama de moments en z.
            if strcmp(vista,'3d')
                clip3d='off'; % Fa que els objectes grfics sobresurtin de la grafica.
            else
                clip3d='on'; % Fa que els objectes grfics NO sobresurtin de la grafica.
            end
            set(get(diagrames(i).hgN,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgTy,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgTz,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMx,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMy,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgMz,'Children'),'Clipping',clip3d);
            set(get(diagrames(i).hgdeformada,'Children'),'Clipping',clip3d)
            
           % escala_deformada(TL2G(:,:,n),n,sD) % Collocaci i rotaci de la deformada. Aqu SI que s'utilitzen els eixos locals, ja que la deformacio es calcula en eixos locals.
            colordiagrama(diagrames(i));
        end
        %disp(['/Dibuixa diagrames i deformada: ',num2str(toc(tic_dd))])
end

    function txt=vector2txt(vector)
        % Converteix un vector en texte.       
        txt=['(',num2str(vector(1)),',',num2str(vector(2)),',',num2str(vector(3)),')'];
    end
    
    function clic_grafica_res(~,~,~)
        % S'executa quan es cliqueja sobre la representacio de resultats en
        % detall per una barra. Torna a mostrar els resultats per a tota
        % l'estructura.
        
        if grafica~=grafica_est
            grafica=grafica_est; % grfica de treball s la grfica de l'estrctura.
            axes(grafica_est) % grfica de treball.
            set(grafica_est,'Visible','on') % Fa visible la grfica de l'estructura.
            set(txtbox_res,'Visible','off') % Oculta el texte amb l'informe de resultats de la barra.
            %set(grafica_resxy,'Visible','off') % Oculta la grfica de la barra en xy.
            %set(grafica_resxz,'Visible','off') % Oculta la grfica de la barra en xz.
            delete(get(grafica_resxy,'Children')); % Elimina el contingut de les grfiques de les barres.
            delete(get(grafica_resxz,'Children'));
            diag_presxy=diagrama; % Esborra les referncies als diagrames mostrats en detall.
            diag_presxz=diagrama; % Esborra les referncies als diagrames mostrats en detall.
            %set(get(grafica_est,'Children'),'Visible','on') % Oculta la grfica de l'estructura.
            set(hg_barres,'Visible','on')
            set(hg_nusos,'Visible','on')
            set(hg_carreguesbarres,'Visible','on')
            set(hg_carreganusos,'Visible','on')
            set(hg_diagrames,'Visible','on')
            for i=1:contnus
                set(nusos(i).hg,'Visible','on') % Fa visibles els nusos.
            end
            for i=1:contbarra
                set(barres(i).hg,'Visible','on') % Fa visibles les barres.
            end
            diagcarregues % Fa visibles les crregues.
            diagreaccions % Fa visibles les reaccions.
            visibilitat_diagrames % Mostra els diagrames i la deformade si estan seleccionats.
        end
    end
    

%% CREACI I MODIFICACI DINMICA DE NUSOS
% Funcions relacionades amb la creaci, modificacio, eliminmaci, dibuix,
% orientaci dels nusos i les seves crregues.

    function crearnus
        % Crea i dibuixa un nou nus.
        
        %disp('Crear nus')
        %tic_cn=tic;
        posicio=[str2double(get(editx,'String')),str2double(get(edity,'String')),str2double(get(editz,'String'))]; % Obt les coordenades de la posici de les caixes de texte, ja arrodonides a la precisi.
        
        contnus=contnus+1; % Incrementa el comptador de nusos en un.
        nusos(contnus)=nus; % Nou objecte nus.
        nusos(contnus).num=contnus; % Una de les dades que conte l'estructura de la classe nus es el seu nmero.
        nusos(contnus).posicio=posicio; % posici del nus.
        calcul_cord_extrems % Recalcula mxims, mnims de les coordenades dels nusos per tal de que els nous nusos s'orientin corrctament.
        if editalcrear==0
            modificarnus(contnus) % Si est seleccionada l'opci, edita el nus desprs de crear-lo.
        end
        if barraalcrearnus && contnus > 1 % Si est seleccionada l'opci crea una barra al crear el nus connectada al nus anterior.
            novabarra(contnus-1,contnus,artnusant,strcmp(get(botobarrarotula,'State'),'on')) % Crea una barra des del nus anterior al nus creat.
        end
        artnusant=strcmp(get(botobarrarotula,'State'),'on'); % Apunta l'estat del bot rtula al crear l'ltim nus.
        redibuixar_nusos % Dibuixa i gira els nusos segons les barres connectades o la seva posici relativa.
        escala % Calcula el factor d'escala s.
        escalar_nusos % Reescala els nusos i les seves carregues.
        %disp(['/Crear nus: ',num2str(toc(tic_cn))])
    end

    function esborrarnus(n)
        % Elimina un nus i la seva representaci grfica.
        % Elimina les barres connectades al nus i actualitza la numeraci.
        
        %disp(['Esborrar nus ',num2str(n)])
        %tic_en=tic;
        
        esborrarcarreganus(n) % elimina la carrega al nus
        if contbarra>0 % Si hi han barres definides...
            for i=contbarra:-1:1 % Compte endarrera (endarrera per tal de que l'acci d'esborrar barres modifica la llista barres).
                if barres(i).nusinf==n || barres(i).nussup==n % Si algun dels extrems estava connectat al nus que s'ha eliminat...
                    esborrarbarra(i) % elimina tamb la barra
                end
            end
        end
        delete(nusos(n).hg) % Destruieix l'objecte grfic que representa el nus.
        nusos2=nus; % Crea una nova llista de nusos.
        if n>1 
            nusos2(1:n-1)=nusos(1:n-1); % Copia els nusos anterios a la nova llista.
        end
        if n<contnus
            nusos2(n:contnus-1)=nusos(n+1:contnus); % Copia els nusos posteriors a la nova llista.
            for i=n:contnus-1
                nusos2(i).num=i; % Actualitza nmero de nusos dels nusos posteriors a l'eliminat.
                set(nusos2(i).hg,'UserData',i); % Actualitza camp 'UserData' amb el nou nmero de nus.
                set(findobj(nusos2(i).hg,'Type','text'),'String',num2str(i)); % Actualitza el text.
            end
        end
        nusos=nusos2; % Substiitueix la llista antiga de nusos per la nova.
        contnus=contnus-1; % Actualitza el comptador de nusos.

        if contbarra>0 % Si hi han  definides...
            for i=1:contbarra
                if barres(i).nusinf>n % Si el nus inferior t nmero superior a l'elimitat...
                    barres(i).nusinf=barres(i).nusinf-1; % Actualitza el nmero.
                end
                if barres(i).nussup>n % Si el nus superior t nmero superior a l'eliminat...
                    barres(i).nussup=barres(i).nussup-1;  % Actualitza el nmero.
                end
            end
        end
        
        calcul_cord_extrems % Recalcula mxims, mnims de les coordenades dels nusos per tal de que els nous nusos s'orientin corrctament.
        escala % Calcula el factor d'escala s.
        redibuixar_nusos % Reorienta, gira, els nusos segons les barres connectades o la seva posici relativa.
        escalar_nusos % Adequa l'escala.
        clicable % Activa o desactiva la pulsaio dels elements grafics segons els botons de la barra.
        
        %disp(['/Esborrar nus ',num2str(n),': ',num2str(toc(tic_en))])
    end
    
    function modificarnus(n)
        % Modifica un nus.
        
        %disp(['Modificar nus ',num2str(n)])
        %tic_mn=tic;
        nusos(n)=dlgnus(nusos(n)); % Obre la finestra d'edici del nus.
        calcul_cord_extrems% Recalcula mxims, mnims de les coordenades dels nusos per si s'han modificat les coordenades.
        escala % Calcula el factor d'escala s.
        redibuixar_nusos % Reorienta, gira, els nusos segons les barres connectades o la seva posici relativa.
        redibuixar_barres % Redibuixa les barres, per si el nus te barres connectades i s'ha modificat la posici.
        redibuixar_carregues_barres % Redibuixa les carregues sobre les barres.
        escalar_nusos % Adequa l'escala.
        clicable % Activa o desactiva la pulsaio dels elements grafics segons els botons de la barra.
        %disp(['/Modificar nus ',num2str(n),': ',num2str(toc(tic_mn))])
    end

    function redibuixar_nus(n)
        % Dibuixa el nus, elimina el dibuix anterior.
        % Gira el dibuix en funcio de les barres connectades o la posici
        % relativa.
        
        %disp(['Redibuixar nus ',num2str(n)])
        %tic_rn=tic;
        con=[]; % Llistat amb els angles de les barres connectades al nus.
        for i=1:contbarra
            if barres(i).nusinf==n % Si el nus est connectat a l'extrem inferior d'una barra...
                vec=nusos(barres(i).nussup).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            elseif barres(i).nussup==n % Si el nus est connectat a l'extrem superior d'una barra...
                vec=nusos(barres(i).nusinf).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            end 
        end
        
        switch nusos(n).contorn % Discrimina segons el tipus de condicio de contorn.
            case 0 % Nus lliure
                ang=0; % No es gira.
            case 1 % Rodet
                ang=atan2(nusos(n).rodet(2),nusos(n).rodet(1))-pi/2; % Es gira segons el seu pla definit.
            case {2,4} % Recolzaments
                % Per defecte no es gira. Si t una barra que travesa el recolzament el gira per evitar l'efecte anti-est%tic.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else
                    alfa=ones(1,numel(con))*5*pi/6;
                    con2=con+alfa;
                    if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra sota el recolzament...
                        ang=0; % No es gira.
                    else
                        beta=ones(1,numel(con))*pi/2;
                        con2=con2-beta;
                        con2=con2+2*pi*(con2 < -pi);
                        if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a la dreta del recolzament...
                            ang=pi/2; % Es gira 90.
                        else
                            con2=con2+pi;
                            con2=con2-2*pi*(con2 > pi);
                            if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a l'esquerra del recolzament...
                                ang=3*pi/2; % Es gira 270.
                            else
                                con2=con2+beta;
                                con2=con2-2*pi*(con2 > pi);
                                if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra per sobre del recolzament...
                                    ang=pi; % Es gira 180.
                                else
                                    ang=0; % Si hi ha barres que interfereixen en totes direccions, no es gira.
                                end
                            end
                        end
                    end
                end
            case 3 % Encastaments
                if numel(con)==1 % Si nomes est connectat a una barra...
                    ang=con-pi/2; % Segueix la direcci de la barra.
                else % Si esta connectat a mes d'una barra...
                    ang=atan2(sum(sin(con)),sum(cos(con)))-pi/2; % Gira l'angle mig.
                    ang=round(ang*12/pi)*pi/12; % Arrodoneix l'angle.
                end
            case {5,6} % Girs els%tics amb desplaaments nuls, girs els%tics amb desplaaments els%tics
                if isempty(con) % si no hi han barres connectades...
                    ang=0; % No es gira.
                else % Si hi han connectades una barra o mes...
                    ang=con(1)-pi/2; % Segueix la direcci de la primera.
                end
            case 8 % Girs imposats i desplaaments lliures.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else % % Si hi han connectades una barra o mes...
                    ang=con(1); % Segueix la direcci de la primera.
                end
            otherwise
                ang=0; % En qualsevol altre cas no es gira.
        end
        
        nusos(n).gir=ang; % Apunta l'angle de gir.
        hg=dibuix_contorn(nusos(n).contorn,distnumnus,fontnusos,tamanyfontnusos); % Dibuixa el nus.
        set(hg,'ButtonDownFcn',@clic_nus,'UserData',n,'Parent',hg_nusos); % Assigna la funci que s'executar quan es cliqueji.
        ht=findobj(hg,'Type','text'); % Objecte que cont el texte de numeracio del nus dins de l'objecte grfic que representa el nus.
        pos=get(ht,'Position'); % N'obt la posici.
        angt=atan2(nusos(n).posicio(2)-ym,nusos(n).posicio(1)-xm); % Angle de situaci del texte al voltant del nus, segons la posici relativa del nus.
        angt=round((angt-pi/4)*2/pi)*pi/2+pi/4; % Arrodoneix l'angle.
        angt=angt-ang; % Resta l'angle de gir del nus per tal de que al girar-lo el texte vagi a la seva posici calculada.
        pos(1:2)=[cos(angt),sin(angt)]*distnumnus; % Calcula en coordenades la posicio del texte.
        set(ht,'String',num2str(n),'Position',pos,'HorizontalAlignment','center','VerticalAlignment','middle'); % Assigna la posici al texte.
        if strcmp(vista,'3d')
            set(get(hg,'Children'),'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(get(hg,'Children'),'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        delete(nusos(n).hg) % Esborra el dibuix an%tic.
        nusos(n).hg=hg; % Guarda el handle del nou objecte grafic a la llista de nusos.
        %disp(['/Redibuixar nus ',num2str(n),': ',num2str(toc(tic_rn))])
    end

function redibuixar_nus2(n) %Funci redibuixar nus pel clcul plstic
        % Dibuixa el nus, elimina el dibuix anterior.
        % Gira el dibuix en funcio de les barres connectades o la posici
        % relativa.
        
        %disp(['Redibuixar nus ',num2str(n)])
        %tic_rn=tic;
        con=[]; % Llistat amb els angles de les barres connectades al nus.
        for i=1:contbarra
            if barres(i).nusinf==n % Si el nus est connectat a l'extrem inferior d'una barra...
                vec=nusos(barres(i).nussup).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            elseif barres(i).nussup==n % Si el nus est connectat a l'extrem superior d'una barra...
                vec=nusos(barres(i).nusinf).posicio-nusos(n).posicio; % Vector direcci de la barra.
                con(length(con)+1)=atan2(vec(2),vec(1)); % Llistat amb els angles de les barres connectades al nus.
            end
        end
        
        switch nusos(n).contorn % Discrimina segons el tipus de condicio de contorn.
            case 0 % Nus lliure
                ang=0; % No es gira.
            case 1 % Rodet
                ang=atan2(nusos(n).rodet(2),nusos(n).rodet(1))-pi/2; % Es gira segons el seu pla definit.
            case {2,4} % Recolzaments
                % Per defecte no es gira. Si t una barra que travesa el recolzament el gira per evitar l'efecte anti-est%tic.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else
                    alfa=ones(1,numel(con))*5*pi/6;
                    con2=con+alfa;
                    if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra sota el recolzament...
                        ang=0; % No es gira.
                    else
                        beta=ones(1,numel(con))*pi/2;
                        con2=con2-beta;
                        con2=con2+2*pi*(con2 < -pi);
                        if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a la dreta del recolzament...
                            ang=pi/2; % Es gira 90.
                        else
                            con2=con2+pi;
                            con2=con2-2*pi*(con2 > pi);
                            if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra a l'esquerra del recolzament...
                                ang=3*pi/2; % Es gira 270.
                            else
                                con2=con2+beta;
                                con2=con2-2*pi*(con2 > pi);
                                if all(con2 > 2*pi/3 | con2 < 0) % Si no hi ha una barra per sobre del recolzament...
                                    ang=pi; % Es gira 180.
                                else
                                    ang=0; % Si hi ha barres que interfereixen en totes direccions, no es gira.
                                end
                            end
                        end
                    end
                end
            case 3 % Encastaments
                if numel(con)==1 % Si nomes est connectat a una barra...
                    ang=con-pi/2; % Segueix la direcci de la barra.
                else % Si esta connectat a mes d'una barra...
                    ang=atan2(sum(sin(con)),sum(cos(con)))-pi/2; % Gira l'angle mig.
                    ang=round(ang*12/pi)*pi/12; % Arrodoneix l'angle.
                end
            case {5,6} % Girs els%tics amb desplaaments nuls, girs els%tics amb desplaaments els%tics
                if isempty(con) % si no hi han barres connectades...
                    ang=0; % No es gira.
                else % Si hi han connectades una barra o mes...
                    ang=con(1)-pi/2; % Segueix la direcci de la primera.
                end
            case 8 % Girs imposats i desplaaments lliures.
                if isempty(con) % Si no hi han barres connectades...
                    ang=0; % No es gira.
                else % % Si hi han connectades una barra o mes...
                    ang=con(1); % Segueix la direcci de la primera.
                end
            otherwise
                ang=0; % En qualsevol altre cas no es gira.
        end
        
        nusos(n).gir=ang; % Apunta l'angle de gir.
        hg=dibuix_contorn(nusos(n).contorn,distnumnus,fontnusos,tamanyfontnusos); % Dibuixa el nus.
        set(hg,'ButtonDownFcn',@clic_nus,'UserData',n,'Parent',hg_nusos); % Assigna la funci que s'executar quan es cliqueji.
        ht=findobj(hg,'Type','text'); % Objecte que cont el texte de numeracio del nus dins de l'objecte grfic que representa el nus.
        pos=get(ht,'Position'); % N'obt la posici.
        angt=atan2(nusos(n).posicio(2)-ym,nusos(n).posicio(1)-xm); % Angle de situaci del texte al voltant del nus, segons la posici relativa del nus.
        angt=round((angt-pi/4)*2/pi)*pi/2+pi/4; % Arrodoneix l'angle.
        angt=angt-ang; % Resta l'angle de gir del nus per tal de que al girar-lo el texte vagi a la seva posici calculada.
        pos(1:2)=[cos(angt),sin(angt)]*distnumnus; % Calcula en coordenades la posicio del texte.
        set(ht,'String',num2str(n),'Position',pos,'HorizontalAlignment','center','VerticalAlignment','middle'); % Assigna la posici al texte.
        if strcmp(vista,'3d')
            set(get(hg,'Children'),'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(get(hg,'Children'),'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        %delete(nusos(n).hg) % Esborra el dibuix an%tic.
        nusos(n).hg=hg; % Guarda el handle del nou objecte grafic a la llista de nusos.
        %disp(['/Redibuixar nus ',num2str(n),': ',num2str(toc(tic_rn))])
end

    function redibuixar_nusos2 %Aquesta funci redibuixa els putns, i dibuixa els punts segons el codi de color que tenen assignat(es fa servir per diferenciar les rtules plstiques)
        % Redibuixa tots els nusos.
        %disp('Redibuixar nusos')
        %tic_rn=tic;
        for i=1:contnus
            redibuixar_nus2(i) % Redibuixa cada nus.
            
              if nusos(i).color(2) ==1
                chgcolor(nusos(i).hg,[0 1 0])                 
              end   
        end  
        %disp(['/Redibuixar nusos: ',num2str(toc(tic_rn))])
    end
    function redibuixar_nusos
        % Redibuixa tots els nusos.
        %disp('Redibuixar nusos')
        %tic_rn=tic;
        for i=1:contnus
            redibuixar_nus(i) % Redibuixa cada nus.
        end
        colornusos % Coloreja ls nusos.
        %disp(['/Redibuixar nusos: ',num2str(toc(tic_rn))])
    end

    function escala
        % Relaciona el tamany de la representaci dels objectes grfics amb
        % el tamany de la grfica, per tal de que sigui constant encara que
        % s'amplii i redueixi. Els objectes grfics sempre es mostraran del
        % mateix tamany.
        
        % Pren com a referncia l'eix horitzotal.
        %disp('Escala')
        %tic_s=tic;
        switch vista
            case 'yz'
                xl=get(grafica_est,'YLim'); % Al plnol yz l'eix horitzontal s l'eix y.
            case '3d'
                xl=get(grafica_est,'XLim')*3; % En 3D els eixos sn iguals, s'aplica un factor de multiplicaci per compensar que la proporcionalitat amb el tamany de la pantalla canvia.
            otherwise
                xl=get(grafica_est,'XLim'); % A la resta de vistes es pren l'eix x.
        end

        tam=get(grafica_est,'Position'); % tam(3) s el tamany horitzontal de la grafica, en pxels.
        s=(xl(2)-xl(1))*tamanynus/tam(3); % Calcul del factor escala s.
        %disp(['/Escala: ',num2str(toc(tic_s))])
    end

    function escalar_nusos
        % Ecala el nusos i les seves carregues i reaccions segons la varable d'escala s calculada.
        
        %disp('Escalar_nusos')
        %tic_en=tic;
        for i=1:contnus % Per a tots els nusos.
            t=makehgtform('translate',nusos(i).posicio,'zrotate',nusos(i).gir,'scale',s); % Matriu de gir, desplaament i escala.
            set(nusos(i).hg,'Matrix',t); % Assigna a l'objecte que representa el nus la matriu de gir, desplaament i escala.
            if any(nusos(i).puntual) || any(nusos(i).moment) % Si hi han forces aplicades al nus....
                t=makehgtform('translate',nusos(i).posicio,'scale',s); % Martiu de desplaament i escala.
                set(nusos(i).hgc,'Matrix',t); % Assigna a l'objecte que representa les forces la matriu de desplaament i escala.
            end
            if numel(hgreaccions) && size(hgreaccions,1)>=i % Si hi han reaccions...
                if hgreaccions(i)
                    t=makehgtform('translate',nusos(i).posicio,'scale',s); % Martiu de desplaament i escala.
                    set(hgreaccions(i),'Matrix',t); % Assigna a l'objecte que representa les reaccions la matriu de desplaament i escala.
                end
            end 
        end 
        
        %disp(['/Escalar nusos: ',num2str(toc(tic_en))])
    end

    function crearmodificarcarreganus(n)
        % Crea o modifica la carrega d'un nus.
        
        %disp(['Crea o modifica carrega en nus ',num2str(n)])
        %tic_cn=tic;
        nusos(n)=dlgcarreganus(nusos(n)); % Obre la finestra d'edici de les crregues dels nusos.
        maxpuntual % Recalcula la crrega maxima.
        redibuixa_carreganus(n); % Dibuixa de nou la crrega.
        escalar_nusos % Escala la carrega i la resta d'objectes grfics.
        colorcarreganusos
        %disp(['/Crea o modifica carrega en nus ',num2str(n),': ',num2str(toc(tic_cn))])
    end

    function redibuixa_carreganus(n)
        % Crea els objectes grfics que representen les carregues als
        % nusos.
        
        %disp(['Redibuixa carrega nus ',num2str(n)])
        %tic_rc=tic;
        delete(nusos(n).hgc); % Elimina l'objecte grafic que representa la crrega.
        nusos(n).hgc=dibuix_carreganus(n,nusos(n).posicio,[xm,ym,zm],nusos(n).puntual,nusos(n).moment,vista,fontcarregues,tamanyfontcarregues,fmax); % Crea l'objecte grfic.
        set(nusos(n).hgc,'ButtonDownFcn',@clic_carreganus,'UserData',n,'Parent',hg_carreganusos); % Assigna a l'objecte la funci que s'executara quan el cliqueji sobre la crrega i el nmero de nus per identificar-lo.
        if strcmp(vista,'3d')
            set(get(nusos(n).hgc,'Children'),'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(get(nusos(n).hgc,'Children'),'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        %clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Redibuixa carrega nus ',num2str(n),': ',num2str(toc(tic_rc))])
    end
  function redibuixa_carreganus2(n) %Redibuixa crrgues pel mdul plstic
        % Crea els objectes grfics que representen les carregues als
        % nusos.
        
        %disp(['Redibuixa carrega nus ',num2str(n)])
        %tic_rc=tic;
        %delete(nusos(n).hgc); % Elimina l'objecte grafic que representa la crrega.
        nusos(n).hgc=dibuix_carreganus(n,nusos(n).posicio,[xm,ym,zm],nusos(n).puntual,nusos(n).moment,vista,fontcarregues,tamanyfontcarregues,fmax); % Crea l'objecte grfic.
        set(nusos(n).hgc,'ButtonDownFcn',@clic_carreganus,'UserData',n,'Parent',hg_carreganusos); % Assigna a l'objecte la funci que s'executara quan el cliqueji sobre la crrega i el nmero de nus per identificar-lo.
        if strcmp(vista,'3d')
            set(get(nusos(n).hgc,'Children'),'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(get(nusos(n).hgc,'Children'),'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        %clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Redibuixa carrega nus ',num2str(n),': ',num2str(toc(tic_rc))])
    end
    function redibuixa_carreganusos
        % Redibuixa totes les crregues als nusos.
        
        %disp('Redibuixa carrega nusos')
        %tic_rc=tic;
        for i=1:contnus
            redibuixa_carreganus(i) % Redibuixa les crregues.
        end
        colorcarreganusos
        escalar_nusos
        %disp(['Redibuixar carrega nusos: ',num2str(toc(tic_rc))])
    end


    function redibuixa_carreganusos2 %Redibuixa crres pel mdul plstic
        % Redibuixa totes les crregues als nusos.
        
        %disp('Redibuixa carrega nusos')
        %tic_rc=tic;
        for i=1:contnus
            redibuixa_carreganus2(i) % Redibuixa les crregues.
        end
        colorcarreganusos
        escalar_nusos
        %disp(['Redibuixar carrega nusos: ',num2str(toc(tic_rc))])
    end
    function esborrarcarreganus(n)
        % Esborra la carrega d'un nus.
        
        %disp(['Esborrar carrega nus ',num2str(n)])
        %tic_ec=tic;
        %delete(nusos(n).hgc); % Elimina l'objecte grafic que representa la crrega.
        %nusos(n).hgc=[]; % Elimina la referncia a l'objecte eliminat.
        nusos(n).puntual=[0,0,0]; % Restableix a zeros els valors de la crrega.
        nusos(n).moment=[0,0,0]; % Restaleix a zero els valors del moment.
        maxpuntual % Recalcula la crrega maxima.
        redibuixa_carreganusos
        %disp(['/Esborrar carrega nus ',num2str(n),': ',num2str(toc(tic_ec))])
    end

    function esborrarcarreganus2(n) %Esborrar crregues crres pel mdul plstic
        % Esborra la carrega d'un nus.
        
        %disp(['Esborrar carrega nus ',num2str(n)])
        %tic_ec=tic;
        %delete(nusos(n).hgc); % Elimina l'objecte grafic que representa la crrega.
        %nusos(n).hgc=[]; % Elimina la referncia a l'objecte eliminat.
        nusos(n).puntual=[0,0,0]; % Restableix a zeros els valors de la crrega.
        nusos(n).moment=[0,0,0]; % Restaleix a zero els valors del moment.
        %maxpuntual % Recalcula la crrega maxima.
        %redibuixa_carreganusos
        %disp(['/Esborrar carrega nus ',num2str(n),': ',num2str(toc(tic_ec))])
    end

%% CREACI I MODIFICACI DINMICA DE BARRES
% Funcions relacionades amb la creaci, modificacio, eliminmaci, dibuix,
% de les barres i les seves crregues.

    function crearbarra(n)
        % Crea una barra a l'estructura.
        % Si es clica sobre el primer nus crea una lnia que segueix el
        % cursor fins clicar el segon nus, o es canceli amb la tecla
        % 'escape'.
        
        %disp('Crear barra')
        %tic_cb=tic;
        if flagbarra && primernusbarra == n  %Evita que es pugui crear una barra amb el mateix nus inferior i superior
        
        elseif flagbarra % Si ja s'ha iniciat el proces de crear la barra, s'ha clicat sobre el segon nus.
            novabarra(primernusbarra,n,artprimernusbarra,strcmp(get(botobarrarotula,'State'),'on')) % Crea la barra.
            flagbarra=0; % Reestableix a zero el flag.
            delete(hbarra); % Elimina la barra que segueix el cursor.
            hbarra=[]; 
        else % Si s'ha clicat sobre el primer nus.
            primernusbarra=n; % Apunta el nmero de nus.
            artprimernusbarra=strcmp(get(botobarrarotula,'State'),'on'); % Apunta si est seleccionat el bot articulaci.
            posicio=[str2double(get(editx,'String')),str2double(get(edity,'String')),str2double(get(editz,'String'))]; % Obt la posici del punter del ratoli.
            hbarra=line([nusos(n).posicio(1) posicio(1)],[nusos(n).posicio(2) posicio(2)],[nusos(n).posicio(3) posicio(3)],'color','k','LineWidth',2,'Clipping','off','HitTest','off','Parent',hg_barres); % Crea una linia des del nus clicat fins a la posici del ratol.
            flagbarra=1; % Activa el flag per tal de que al clicar sobre un altre nus es completi el procs de creaci de la barra.
        end
        %disp(['/Crear barra: ',num2str(toc(tic_cb))])
    end

    function novabarra(nusinf,nussup,artinf,artsup)
        % Crea una barra des del nus inferior al superior.
        
        %disp(['Nova barra ',num2str(nusinf),'-',num2str(nussup)])
        %tic_nb=tic;
        contbarra=contbarra+1; % Incrementa el comptador de barres.
        barres(contbarra)=barra; % Nou objecte barra a la llista de barres.
        barres(contbarra).nusinf=nusinf; % Nus inferior.
        barres(contbarra).nussup=nussup; % Nus superior.
        barres(contbarra).artinf=artinf; % articulaci a l'extrem inferior.
        barres(contbarra).artsup=artsup; % articulaci a l'extrem superior.
        barres(contbarra).num=contbarra; % Assigna nmero de barra a la barra.
        if editalcrear==0 % Si est seleccionada l'opci edita la barra desprs de crear-la.
            modificarbarra(contbarra) % Edita i dibuixa la barra.
        else
            redibuixar_barra(contbarra) % Dibuixa la barra.
            colorbarres
            clicable % Estableix quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        end
        %disp(['/Nova barra ',num2str(nusinf),'-',num2str(nussup),': ',num2str(toc(tic_nb))])
    end

    function redibuixar_barra(n)
        % Elimina el dibuix existent i el redibuixa.
        
        %disp(['Redibuixar barra ',num2str(n)])
        %tic_rb=tic;
        delete(barres(n).hg); % Esborra l'objecte grfic.
        posinf=nusos(barres(n).nusinf).posicio; % Posici nus inferior.
        possup=nusos(barres(n).nussup).posicio; % Posicio nus superior.
        barres(n).hg=line([posinf(1) possup(1)],[posinf(2) possup(2)],[posinf(3) possup(3)],'LineWidth',2,'UserData',n,'ButtonDownFcn',@clic_barra,'Parent',hg_barres); % Crea la lnia.
        if strcmp(vista,'3d')
            set(barres(n).hg,'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(barres(n).hg,'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        %disp(['/Redibuixar barra ',num2str(n),': ',num2str(toc(tic_rb))])
    end
    function redibuixar_barra2(n) %Redibuixa barra pel mdul plstic
        % Elimina el dibuix existent i el redibuixa.
        
        %disp(['Redibuixar barra ',num2str(n)])
        %tic_rb=tic;
       
        posinf=nusos(barres(n).nusinf).posicio; % Posici nus inferior.
        possup=nusos(barres(n).nussup).posicio; % Posicio nus superior.
        barres(n).hg=line([posinf(1) possup(1)],[posinf(2) possup(2)],[posinf(3) possup(3)],'LineWidth',2,'UserData',n,'ButtonDownFcn',@clic_barra,'Parent',hg_barres); % Crea la lnia.
        if strcmp(vista,'3d')
            set(barres(n).hg,'Clippin','off') % Permet que en 3d sobresurti de la grfica.
        else
            set(barres(n).hg,'Clippin','on') % NO permet que en 3d sobresurti de la grfica.
        end
        %disp(['/Redibuixar barra ',num2str(n),': ',num2str(toc(tic_rb))])
    end
    function redibuixar_barres
        % Elimina els objectes grafics que representen les barres i les
        % dibuixa de nou.
        %disp('Redibuixar barres')
        %tic_rb=tic;
        for i=1:contbarra % Per a totes les barres.
            redibuixar_barra(i);
        end
        %clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Redibuixar barres: ',num2str(toc(tic_rb))])
        colorbarres
    end

  function redibuixar_barres2 %Redibuixa barres pel mdul plstic
        % Elimina els objectes grafics que representen les barres i les
        % dibuixa de nou.
        %disp('Redibuixar barres')
        %tic_rb=tic;
        for i=1:contbarra % Per a totes les barres.
            redibuixar_barra2(i);
        end
        %clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Redibuixar barres: ',num2str(toc(tic_rb))])
        colorbarres
    end

    function esborrarbarra(n)
        % Esborra la barra indicada.
        % Elimina de la llista i elimina els objectes grfics que
        % representen la barra i les seves crregues.
        
        %disp(['Esborrar barra ',num2str(n)])
        %tic_eb=tic;
        nusinf=barres(n).nusinf; % Nus inferior.
        nussup=barres(n).nussup; % Nus superior.
        esborrarcarregabarra(n); % Esborra la carrega.
        delete(barres(n).hg) % Elimina l'objecte grfic que representa la barra.
        barres2=barra; % Crea una nova llista de barres.
        if n>1
            barres2(1:n-1)=barres(1:n-1); % Copia les barres amb nmero inferior a la nova llista.
        end
        if n<contbarra
            barres2(n:contbarra-1)=barres(n+1:contbarra); % Copia les barres amb nmero superior a la nova llista.
            for i=n:contbarra-1
                barres2(i).num=i; % Actualitza els nmeros de barra.
                set(barres2(i).hg,'UserData',i); % Actualitza els nmeros de barra al camp 'UserData' dels objectes grafics.
            end
        end
        barres=barres2; % Elimina la llista de barres antiga i la substitueix per la nova.
        contbarra=contbarra-1; % Actualitza el comptador de barres.
        redibuixar_nus(nusinf) % Actualitza el nus inferior, la seva orientaci por dependre de la barra.
        redibuixar_nus(nussup) % Actualitza el nus superior, la seva orientaci por dependre de la barra.
        %clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Esborrar barra ',num2str(n),': ',num2str(toc(tic_eb))])
    end

    function modificarbarra(n)
        % Edita la barra.
        
        barres=dlgbarra(contnus,barres,n); % Dileg de modifiaci de les barres.
        %disp(['Modificar barra ',num2str(n)])
        %tic_mb=tic;
        redibuixar_nus(barres(n).nusinf) % Redibuixa el nus inferior, modificacions de la barra poden afectar la seva orientacio.
        redibuixar_nus(barres(n).nussup) % Redibuixa el nus superior, modificacions de la barra poden afectar la seva orientacio.
        escalar_nusos
        redibuixar_barra(n) % Redibuixa la barra.
        colorbarres % Coloreja els elements grfics segons els botons de la barra.
        clicable % Activa o desactiva la pulsaio dels elements grafics segons els botons de la barra.
        %disp(['/Modificar barra ',num2str(n),': ',num2str(toc(tic_mb))])
    end

    function crearmodificarcarregabarra(n)
        % Crea i modifica crregues a les barres.
        
        barres(n)=dlgcarregabarra(barres(n)); % Crida al dileg d'edici de les crregues sobre la barra.
        %disp(['Crear o modificar carregues en barra ',num2str(n)])
        %tic_cc=tic;
        maxpuntual % Calcula carrega puntual maxima.
        maxrepartida % Calcula carrega repartida o projectada maxima.
        redibuixar_carregues_barra(n) % Dibuixa les crregues.
        colorcarregabarres
        clicable % Estableix els colors i quins objectes grfics responen als clics segons l'estat dels botons de la barra d'eines.
        %disp(['/Crear o modificar carregues en barra ',num2str(n),': ',num2str(toc(tic_cc))])
    end

    function redibuixar_carregues_barra(n)
        % Dibuixa les crregues a les barres.
        % Si existeixen objectes grfics els elimina i els crea de nou.
        
        %disp(['Redibuixar carregues en barra ',num2str(n)])
        %tic_rc=tic;
        delete(barres(n).hgpuntual) % Elimina objecte grfic fora puntual.
        barres(n).hgpuntual=[];
        delete(barres(n).hgmoment) % Elimina objecte grfic moment.
        barres(n).hgmoment=[];
        delete(barres(n).hgrepartida) % Elimina objecte grfic crrega repartida.
        barres(n).hgrepartida=[];
        delete(barres(n).hgprojectada) % Elimina objecte grfic crrega projectada.
        barres(n).hgprojectada=[];
        cordinf=nusos(barres(n).nusinf).posicio; % Coordenades nus inferior.
        cordsup=nusos(barres(n).nussup).posicio; % Coordenades nus superior.
        vectorbarra=cordsup-cordinf; % Vector direcci de la barra.
        vectorbarra=vectorbarra/norm(vectorbarra); % Vector direcci de la barra normalitzat.

        if barres(n).puntual(1) || barres(n).moment(1) % Si s'han introdut crregues puntuals o moments...
            [barres(n).hgpuntual,barres(n).hgmoment]=dibuix_carregabarra(barres(n),nusos(barres(n).nussup).posicio-nusos(barres(n).nusinf).posicio,vista,fontcarregues,tamanyfontcarregues,fmax); % Dibuixa carrega puntual i moment.
            if barres(n).puntual(1) % Si s'ha introdut crrega puntual...
                pos=barres(n).puntual(5)*vectorbarra+cordinf; % Posici en eixos globals de la crrega puntual.
                m=makehgtform('translate',pos,'scale',s); % Matriu de collocaci i escala de la crrega puntual.
                set(barres(n).hgpuntual,'ButtonDownFcn',@clic_carregabarra,'Matrix',m,'Parent',hg_carreguesbarres); % Aplica la matriu a l'objecte grfic que representa la crrega puntual.
            end
            if barres(n).moment(1) % Si s'ha introdut moment...
                pos=barres(n).moment(5)*vectorbarra+cordinf; % Posici en eixos globals del moment.
                m=makehgtform('translate',pos,'scale',s); % Matriu de collocaci i escala del moment.
                set(barres(n).hgmoment,'ButtonDownFcn',@clic_carregabarra,'Matrix',m,'Parent',hg_carreguesbarres); % Aplica la matriu a l'objecte grfic que representa el moment.
            end
        end
        
        if barres(n).repartida(1) && any(cordsup-cordinf) % Si s'ha introdut crrega repartida...
            puntinf=cordinf+vectorbarra*barres(n).repartida(5); % Punt inferior d'aplicaci de la crrega en eixos globals.
            puntsup=cordsup-vectorbarra*barres(n).repartida(6); % Punt superior d'aplicaci de la crrega en eixos globals.
            barres(n).hgrepartida=dibuix_repartida(n,puntinf,puntsup,barres(n).repartida,s,fontcarregues,tamanyfontcarregues,qmax); % Dibuixa la crrega repartida.
            set(barres(n).hgrepartida,'ButtonDownFcn',@clic_carregabarra,'Parent',hg_carreguesbarres); % Assigna la funci que s'executar quan es cliqueji sobre la crrega.
            if strcmp(vista,'3d')
                set(get(barres(n).hgrepartida,'Children'),'Clipping','off') % Fa que els objectes grfics sobresurtin de la grafica en vista 3d.
            else
                set(get(barres(n).hgrepartida,'Children'),'Clipping','on') % Fa que els objectes grfics NO sobresurtin de la grafica en vista 3d.
            end
        end
        
        if barres(n).projectada(1) && any(cordsup-cordinf) % Si s'ha introdut crrega projectada...
            puntinf=cordinf+vectorbarra*barres(n).projectada(5); % Punt inferior d'aplicaci de la crrega en eixos globals.
            puntsup=cordsup-vectorbarra*barres(n).projectada(6); % Punt superior d'aplicaci de la crrega en eixos globals.
            barres(n).hgprojectada=dibuix_projectada(n,puntinf,puntsup,barres(n).projectada,s,fontcarregues,tamanyfontcarregues,qmax); % Dibuixa la crrega projectada.
            set(barres(n).hgprojectada,'ButtonDownFcn',@clic_carregabarra,'Parent',hg_carreguesbarres); % Assigna la funci que s'executar quan es cliqueji sobre la crrega.
            if strcmp(vista,'3d')
                set(get(barres(n).hgprojectada,'Children'),'Clipping','off') % Fa que els objectes grfics sobresurtin de la grafica en vista 3d.
            end
        end
        %disp(['/Redibuixar carregues en barra ',num2str(n),': ',num2str(toc(tic_rc))])
    end
    function redibuixar_carregues_barra2(n) %Redibuixa crregues pel mdul plstic
        % Dibuixa les crregues a les barres.
        % Si existeixen objectes grfics els elimina i els crea de nou.
        
        %disp(['Redibuixar carregues en barra ',num2str(n)])
        %tic_rc=tic;
       % delete(barres(n).hgpuntual) % Elimina objecte grfic fora puntual.
        barres(n).hgpuntual=[];
        %delete(barres(n).hgmoment) % Elimina objecte grfic moment.
        barres(n).hgmoment=[];
        %delete(barres(n).hgrepartida) % Elimina objecte grfic crrega repartida.
        barres(n).hgrepartida=[];
        %delete(barres(n).hgprojectada) % Elimina objecte grfic crrega projectada.
        barres(n).hgprojectada=[];
        cordinf=nusos(barres(n).nusinf).posicio; % Coordenades nus inferior.
        cordsup=nusos(barres(n).nussup).posicio; % Coordenades nus superior.
        vectorbarra=cordsup-cordinf; % Vector direcci de la barra.
        vectorbarra=vectorbarra/norm(vectorbarra); % Vector direcci de la barra normalitzat.

        if barres(n).puntual(1) || barres(n).moment(1) % Si s'han introdut crregues puntuals o moments...
            [barres(n).hgpuntual,barres(n).hgmoment]=dibuix_carregabarra(barres(n),nusos(barres(n).nussup).posicio-nusos(barres(n).nusinf).posicio,vista,fontcarregues,tamanyfontcarregues,fmax); % Dibuixa carrega puntual i moment.
            if barres(n).puntual(1) % Si s'ha introdut crrega puntual...
                pos=barres(n).puntual(5)*vectorbarra+cordinf; % Posici en eixos globals de la crrega puntual.
                m=makehgtform('translate',pos,'scale',s); % Matriu de collocaci i escala de la crrega puntual.
                set(barres(n).hgpuntual,'ButtonDownFcn',@clic_carregabarra,'Matrix',m,'Parent',hg_carreguesbarres); % Aplica la matriu a l'objecte grfic que representa la crrega puntual.
            end
            if barres(n).moment(1) % Si s'ha introdut moment...
                pos=barres(n).moment(5)*vectorbarra+cordinf; % Posici en eixos globals del moment.
                m=makehgtform('translate',pos,'scale',s); % Matriu de collocaci i escala del moment.
                set(barres(n).hgmoment,'ButtonDownFcn',@clic_carregabarra,'Matrix',m,'Parent',hg_carreguesbarres); % Aplica la matriu a l'objecte grfic que representa el moment.
            end
        end
        
        if barres(n).repartida(1) && any(cordsup-cordinf) % Si s'ha introdut crrega repartida...
            puntinf=cordinf+vectorbarra*barres(n).repartida(5); % Punt inferior d'aplicaci de la crrega en eixos globals.
            puntsup=cordsup-vectorbarra*barres(n).repartida(6); % Punt superior d'aplicaci de la crrega en eixos globals.
            barres(n).hgrepartida=dibuix_repartida(n,puntinf,puntsup,barres(n).repartida,s,fontcarregues,tamanyfontcarregues,qmax); % Dibuixa la crrega repartida.
            set(barres(n).hgrepartida,'ButtonDownFcn',@clic_carregabarra,'Parent',hg_carreguesbarres); % Assigna la funci que s'executar quan es cliqueji sobre la crrega.
            if strcmp(vista,'3d')
                set(get(barres(n).hgrepartida,'Children'),'Clipping','off') % Fa que els objectes grfics sobresurtin de la grafica en vista 3d.
            else
                set(get(barres(n).hgrepartida,'Children'),'Clipping','on') % Fa que els objectes grfics NO sobresurtin de la grafica en vista 3d.
            end
        end
        
        if barres(n).projectada(1) && any(cordsup-cordinf) % Si s'ha introdut crrega projectada...
            puntinf=cordinf+vectorbarra*barres(n).projectada(5); % Punt inferior d'aplicaci de la crrega en eixos globals.
            puntsup=cordsup-vectorbarra*barres(n).projectada(6); % Punt superior d'aplicaci de la crrega en eixos globals.
            barres(n).hgprojectada=dibuix_projectada(n,puntinf,puntsup,barres(n).projectada,s,fontcarregues,tamanyfontcarregues,qmax); % Dibuixa la crrega projectada.
            set(barres(n).hgprojectada,'ButtonDownFcn',@clic_carregabarra,'Parent',hg_carreguesbarres); % Assigna la funci que s'executar quan es cliqueji sobre la crrega.
            if strcmp(vista,'3d')
                set(get(barres(n).hgprojectada,'Children'),'Clipping','off') % Fa que els objectes grfics sobresurtin de la grafica en vista 3d.
            end
        end
        %disp(['/Redibuixar carregues en barra ',num2str(n),': ',num2str(toc(tic_rc))])
    end
   
        
    function redibuixar_carregues_barres
        %disp('Redibuixar carrega barres')
        %tic_rcb=tic;
        for i=1:contbarra
            redibuixar_carregues_barra(i)
        end
        colorcarregabarres
        diagcarregues
        %disp(['/Redibuixar carrega barres: ',num2str(toc(tic_rcb))])
    end

   function redibuixar_carregues_barres2 %Redibuixa crregues pel mdul plstic
        %disp('Redibuixar carrega barres')
        %tic_rcb=tic;
        for i=1:contbarra
            redibuixar_carregues_barra2(i)
        end
        colorcarregabarres
        diagcarregues
        %disp(['/Redibuixar carrega barres: ',num2str(toc(tic_rcb))])
    end

    function esborrarcarregabarra(n)
        % Elimina els objectes grfics que representen les crregues sobre
        % la barra. Restableix els valors per defecte a la llista de
        % barres.
        
        %disp(['Esborrar carregues en barra ',num2str(n)])
        %tic_ec=tic;
        if barres(n).hgpuntual % Si hi ha un objecte que representa la fora puntual...
            delete(barres(n).hgpuntual) % Elimina l'objecte.
            barres(n).hgpuntual=[]; % Elimina la seva referncia.
            barres(n).puntual=[0,0,-1,0,0]; % Valor per defecte.
           % maxpuntual % Calcula carrega puntual maxima
        end
        
        if barres(n).hgmoment % Si hi ha un objecte que representa el moment...
            delete(barres(n).hgmoment) % Elimina l'objecte.
            barres(n).hgmoment=[]; % Elimina la seva referncia.
            barres(n).moment=[0,0,0,1,0]; % Valor per defecte.
        end
        
        if barres(n).hgrepartida % Si hi ha un objecte que representa la crrega repartida...
            delete(barres(n).hgrepartida) % Elimina l'objecte.
            barres(n).hgrepartida=[]; % Elimina la seva referncia.
            barres(n).repartida=[0,0,-1,0,0,0]; % Valor per defecte.
           % maxrepartida % Calcula carrega repartida o projectada maxima.
        end
        
        if barres(n).hgprojectada % Si hi ha un objecte que representa la crrega projectada...
            delete(barres(n).hgprojectada) % Elimina l'objecte.
            barres(n).hgprojectada=[]; % Elimina la seva referncia.
            barres(n).projectada=[0,0,-1,0,0,0]; % Valor per defecte.
            %maxrepartida % Calcula carrega repartida o projectada maxima.
        end
        
        %disp(['/Esborrar carregues en barra ',num2str(n),': ',num2str(toc(tic_ec))])
    end


    function maxpuntual
        % Calcula la mxima fora puntual o aplicada als nusos.
        
        fmax=0; % Valor per defecte cero.
        for i=1:contnus % Per a tots els nusos...
            fmax=max(abs([fmax,nusos(i).puntual])); % Mxim de les forces puntuals.
        end
        for i=1:contbarra % Per a totes les barres...
            fmax=max(abs([fmax,barres(i).puntual(1)])); % Maxim de les forces puntuals.
        end
        if flagcalculat % Si hi han reaccions...
            for i=1:contnus
                fmax=max(abs([fmax,Retorn_reaccions(i*6-5:i*6-3)']));
            end
        end
        
    end

    function maxrepartida
        % Calcula la maxima carrega repartida o projectada.
        
        qmax=0; % Valor inicial cero.
        for i=1:contbarra % Per a totes les barres.
            qmax=max(abs([qmax,barres(i).repartida(1),barres(i).projectada(1)])); % Mxim de les forces repartides i projectades.
        end
    end

%% FUNCI QUE GENERA EL PANELL D'INFORMACIO DEL MTODE DE RESOLUCI DE SEGON ORDRE

   function informaciometode(~,~,~)
       
       met=get(popupInest,'Value');
       
       switch met
           case 1
               Infmet1;
           case 2
               Infmet2;
       end

%         sc=get(0,'ScreenSize'); % Obt el tamany de la pantalla.
%         tminf=[804 705]; % Tamany de la finestra a la pantalla.
%         psinf=(sc(3:4)-tminf)/2-[0,18];% Posicio de la finestra, centrada a la pantalla.
%         figinformacio=figure('Units','pixels','Position',[psinf,tminf],'NumberTitle','off','Name','Informaci del mtode de resoluci','Resize','off','color','white','MenuBar','none');

    end

%% FUNCI QUE MOSTRA O AMAGA LES VARIABLES DE RUNGE-KUTTA

    function metoderes(~,~,~)
        
        figcme2_resize;

        val=get(popupInest,'value');
            switch val
                case 1
                set(text3Inest,'visible','off');
                set(numalpha1,'visible','off');
                set(text4Inest,'visible','off');
                set(numalpha2,'visible','off');
                set(text5Inest,'visible','off');
                set(nummu,'visible','off');
                case 2
                set(text3Inest,'visible','on');
                set(numalpha1,'visible','on');
                set(text4Inest,'visible','on');
                set(numalpha2,'visible','on');
                set(text5Inest,'visible','on');
                set(nummu,'visible','on');
            end
    end

 %% FUNCI QUE DIBUIXA ELS MODES DE VINCLAMENT
 
    function dibres2ord(~,~,~)
        try
            if strcmp(get(def2ord,'visible'),'on')
                set(def2ord,'visible','off');
            end
        catch
            def2ord=line(0,0,0,'visible','off')
        end
        N=contbarra;
        mode=get(popup2ord,'value');
        for i=1:N
            dib(:,:,i)=deformada(mode*3-2:mode*3,:,i);
            def2ord(i)=line(dib(1,:,i),dib(2,:,i),dib(3,:,i),...
                'linewidth',2,'color','blue');
        end
        
    end

%% FUNCI QUE EXECUTA EL BOT QUE MOSTRA EL MODE DE VINCLAMENT
% F apareixer o desapareixer el mode de vinclament

    function presentaciomodvincl(~,~,~)
        try
            if strcmp(get(def2ord,'visible'),'on')
                set(def2ord,'visible','off');
            elseif strcmp (get(def2ord,'visible'),'off')
                set(def2ord,'visible','on');
            end
        catch
            def2ord=line(0,0,0,'visible','off');
        end
    end

end

%% FUNCIONS DE CARREGA FORA DE LA FUNCIO PRINCIPAL

function [nusos,barres,contnus,contbarra,contRotula,dadesRotules]=carregararxiu(arxiu)
    % Carrega un arxiu amb dades de l'estructura i les retorna.
    % Aquesta funci no pot estar dins de la funci principal del programa,
    % Matlab no permet carregar les variables a l'espai de treball, ha
    % d'estar aillada.
    
    %Els poso a 0 per evitar que m'indiqui un error al carregar un arxiu
    %sense rotules, (clcul esttic)
    contRotula=0;
    dadesRotules=0;
    load(arxiu,'-mat') % Carrega les dades de nusos i barres.
    contnus=numel(nusos); % Nombre de nusos.
    contbarra=numel(barres); % Nombre de barres.
end
function [editalcrear,barraalcrearnus,fontnusos,tamanyfontnusos,fontcarregues,tamanyfontcarregues,factorzoom,tamanynus,distnumnus,precini,XLimini,YLimini,ZLimini,colormodificar,coloresborrar,colorcarregues,colorreaccions,colordeformada,colorN,colorTy,colorTz,colorMx,colorMy,colorMz,direst]=loadopcions
    % Carrega les variables amb les opcions del programa i les retorna.
    % Si no troba l'arxiu crida al dileg per editar les opcions. El dileg
    % no permet cancelar sense guardarles a l'arxiu. Finalment carrega les
    % dades.
    % Aquesta funci no pot estar dins de la funci principal del programa,
    % Matlab no permet carregar les variables a l'espai de treball, ha
    % d'estar aillada.
    
    if ~exist('opcions.mat','file') % Si no existeix l'arxiu d'opcions del programa obre la finestra d'edici de les opcions. No es pot sortir de la finestra d'opcions sense crear l'arxiu.
        dlgopcions % Crida al dileg d'edici de les opcions.
    end    
    load('opcions.mat') % Carrega les opcions.
end
